******************************************************************************
      subroutine addln1
      implicit none
*add lines to truncated list, using known line ratios, by Peter Martin
      include "nlines.par"
      include "sumlab.com"
      include "sum.com"
      include "sum2.com"
      include "called.com"
      include "IOqq.com"
*
*     local variables
      integer isave , i , inew , nline , j1 , j
      real sumnr , amatch
*
      isave=npxdd
*     H lines Case B Osterbrock tab 4.4 t=10**4 hden=10**6
*     line strength for normalizing line
      sumnr = amatch('TOTL',4861)
      if(sumnr.ne.0.) then
         call addln2('Halb',6563,sumnr*2.81)
         call addln2('Hgab',4340,sumnr*0.471)
         call addln2('Hdeb',4101,sumnr*0.262)
         call addln2('Hepb',3970,sumnr*0.163)
         call addln2('H08b',3889,sumnr*0.110)
         call addln2('H09b',3835,sumnr*0.0783)
         call addln2('H10b',3798,sumnr*0.0588)
         call addln2('H11b',3770,sumnr*0.0457)
         call addln2('H12b',3750,sumnr*0.0367)
         call addln2('H13b',3734,sumnr*0.0301)
         call addln2('H14b',3721,sumnr*0.0252)
         call addln2('H15b',3712,sumnr*0.0213)
         call addln2('H20b',3683,sumnr*0.0104)
      endif
*
* HeI lines case B Osterbrock tab 4.6 t=10**4, hden = 10**6
* lines with lambda gt 3550a and relative strength gt 0.02 of 4471
      sumnr=amatch('HE I',4471)
      if(sumnr.ne.0.) then
*        triplets 2 3p - n 3d
         call addln2('He1b',5876,sumnr*2.73)
         call addln2('He1b',4471,sumnr*1.)
         call addln2('He1b',4026,sumnr*0.476)
         call addln2('He1b',3820,sumnr*0.265)
         call addln2('He1b',3705,sumnr*0.163)
         call addln2('He1b',3634,sumnr*0.108)
         call addln2('He1b',3587,sumnr*0.076)
*        wavelength to short
*        triplets 2 3p - n 3s
         call addln2('He1b',7065,sumnr*0.325)
         call addln2('He1b',4713,sumnr*0.090)
         call addln2('He1b',4121,sumnr*0.037)
         call addln2('He1b',3867,sumnr*0.019)
*        too weak
*        triplets 2 3s - n 3p
         call addln2('He1b',10830,sumnr*4.41)
         call addln2('He1b',3889,sumnr*2.27)
         call addln2('He1b',3187,sumnr*0.920)
*        wavelength too short
*        singlets 2 1p - n 1d
         call addln2('He1b',6678,sumnr*0.780)
         call addln2('He1b',4922,sumnr*0.274)
         call addln2('He1b',4388,sumnr*0.129)
         call addln2('He1b',4144,sumnr*0.071)
         call addln2('He1b',4009,sumnr*0.044)
         call addln2('He1b',3927,sumnr*0.029)
         call addln2('He1b',3872,sumnr*0.020)
*        too weak
*        singlets 2 1s - n 1p
         call addln2('He1b',5016,sumnr*0.590)
         call addln2('He1b',3965,sumnr*0.235)
         call addln2('He1b',3614,sumnr*0.115)
*        wavelength too short
*        singlets 2 1p - n 1s
         call addln2('He1b',7281,sumnr*0.138)
         call addln2('He1b',5047,sumnr*0.039)
         call addln2('He1b',4437,sumnr*0.017)
      endif
*
* He2 case B Osterbrock tab 4.5 t=10**4, hden=10**6
* Pickering lines with relative strength gt 0.013 of 4686
      sumnr=amatch('HeII',4686)
      if(sumnr.ne.0.) then
         call addln2('He2b',10124, sumnr* 0.271 )
         call addln2('He2b', 6560, sumnr* 0.136 )
         call addln2('He2b', 5412, sumnr* 0.078 )
         call addln2('He2b', 4860, sumnr* 0.049 )
         call addln2('He2b', 4686, sumnr* 1.)
         call addln2('He2b', 4542, sumnr* 0.033 )
         call addln2('He2b', 4339, sumnr* 0.024 )
         call addln2('He2b', 4200, sumnr* 0.018 )
         call addln2('He2b', 4100, sumnr* 0.013 )
      endif
*
*     O II recombination lines scales from Kaler's nebulae
      sumnr=amatch('O  2',4651)
      if(sumnr.ne.0.) then
         call addln2('O r2', 4072 , sumnr* 0.32 )
         call addln2('O r2', 4130 , sumnr* 0.13 )
         call addln2('O r2', 4153 , sumnr* 0.13 )
         call addln2('O r2', 4190 , sumnr* 0.06 )
         call addln2('O r2', 4254 , sumnr* 0.05 )
         call addln2('O r2', 4294 , sumnr* 0.12 )
         call addln2('O r2', 4318 , sumnr* 0.13 )
         call addln2('O r2', 4349 , sumnr* 0.29 )
         call addln2('O r2', 4415 , sumnr* 0.12 )
         call addln2('O r2', 4595 , sumnr* 0.08 )
         call addln2('O r2', 4607 , sumnr* 0.05 )
         call addln2('O r2', 4676 , sumnr* 0.08 )
         call addln2('O r2', 4705 , sumnr* 0.06 )
         call addln2('O r2', 4620 , sumnr* 0.024)
      endif
*
*     O III recombination lines   a and b are case a and case b
      sumnr=amatch('O B3',3341)
      if(sumnr.ne.0.) then
         call addln2('Ora3',3341,sumnr*0.107)
         call addln2('Orb3',3047,sumnr*3.19 )
         call addln2('Ora3',3047,sumnr*0.37 )
         call addln2('Orb3',5592,sumnr*0.57 )
         call addln2('Ora3',5592,sumnr*0.069)
         sumnr=amatch('O B3',3760)
      endif
*
      if(sumnr.ne.0.) then
         call addln2('ora3',3760,sumnr*0.808)
      endif
*
*     O IV recombination (for whole multiplet multiply by 11.5/6.9)
      sumnr=amatch('O B4',3412)
      if(sumnr.ne.0.) then
*        burgess and seaton
         call addln2('Ora4',3412,sumnr*0.002)
*        from n7027
         call addln2('Or?4',3736,sumnr*0.27)
      endif
*
*      N II recombination lines   a and b are case a and case b
      sumnr=amatch('N B2',5047)
      if(sumnr.ne.0.) then
         call addln2('Nra2',5047,sumnr*0.107)
*        1/3 4606,4621,4631 RMT 5
         call addln2('Nrb2',4621,sumnr*3.19 )
         call addln2('Nra2',4621,sumnr*0.37 )
      endif
*
      sumnr=amatch('N B2',5680)
      if(sumnr.ne.0.) then
*        case a from case b
         call addln2('Nra2',5680,sumnr*0.808)
*        based on 0.3 of case a
         call addln2('N r2',5942,sumnr*0.25 )
      endif
*
*     N III recombination lines
      sumnr=amatch('N B3',4641)
      if(sumnr.ne.0.) then
*        burgess and seaton
         call addln2('Nra3',4641,sumnr*0.002)
      endif
*
*     C II recombination lines
      sumnr=amatch('C  2',4267)
      if(sumnr.ne.0.) then
         call addln2('C r2',4619,sumnr*0.05)
      endif
*
*     C III recombination
      sumnr=amatch('C  3',4187)
      if(sumnr.ne.0.) then
         call addln2('C r3', 4070, sumnr* 2.1 )
      endif
*
*     C IV recombination
      sumnr=amatch('C  4',4659)
      if(sumnr.ne.0.) then
*        includes reddening cor
         call addln2('C r4',5801,sumnr*1.25 )
      endif
*
*     ratios of many forbidden lines
      sumnr=amatch('Ne 3', 3869 )
      if(sumnr.ne.0.) then
         call addln2('NeR3', 3968 , sumnr* 0.30 )
      endif
*
      sumnr=amatch('Ne 5',3426)
      if(sumnr.ne.0.) then
         call addln2('NeR5', 3346, sumnr* 0.34)
      endif
*
      sumnr=amatch('N  2',6584)
      if(sumnr.ne.0.) then
         call addln2('N r2',6548, sumnr* 0.335)
      endif
*
      sumnr=amatch('O  3',5007)
      if(sumnr.ne.0.) then
         call addln2('O r3', 4959, sumnr* 0.336)
      endif
      sumnr=amatch('Ar 5',7007)
      if(sumnr.ne.0.) then
         call addln2('Arr5',6435, sumnr* 0.43 )
      endif
*
      sumnr=amatch('O  1',6300)
      if(sumnr.ne.0.) then
         call addln2('O r1',6363, sumnr* 0.33)
      endif
*
      sumnr=amatch('Ar 3',7136)
      if(sumnr.ne.0.) then
         call addln2('Arr3',7751, sumnr* 0.31)
      endif
*
      sumnr = amatch('S  3',9532)
      if(sumnr.ne.0.) then
         call addln2('S r3',9069, sumnr* 0.39)
      endif
*
*     no lines added
      if(npxdd.eq.isave .or. (.not.lgTalk) ) return
*
*     write new lines
      inew = npxdd - isave
      nline = (inew + 3) / 4
*
      do i=1,nline
        j1=isave+i
        write(qq,'(5x,3(1x,a4,i5,f7.3,f9.4,5x),1x,a4,i5,f7.3,f9.4)')
     1  (chALab(j),lin(j),asumli(j),scaled(j),j=j1,npxdd,nline)
      end do
*
      end
