******************************************************************************
      subroutine AddOpac( lgOK )
      implicit none
*derive total opacity for this position
      logical lgOK
      include "ndust.par"
      include "te1ryd.par"
      include "ncell.par"
      include "nopsv.par"
      include "nhe3lvl.par"
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "itrdim.par"
      include "limelm.par"
      include "opsv.com"
      include "ipair.com"
      include "iopcom.com"
      include "dstfac.com"
      include "gaunts.com"
      include "opac.com"
      include "OldOpac.com"
      include "rfield.com"
      include "ots.com"
      include "o3exc.com"
      include "dstop.com"
      include "scatop.com"
      include "corind.com"
      include "opacon.com"
      include "hemase.com"
      include "search.com"
      include "ircoil.com"
      include "trace.com"
      include "TePowers.com"
      include "hmi.com"
      include "phycon.com"
      include "he.com"
      include "phlevl.com"
      include "phe1lv.com"
      include "phe2lv.com"
      include "iphmin.com"
      include "h.com"
      include "ffsum.com"
      include "hmidep.com"
      include "heopfr.com"
*     include "hbn.com"
      include "ophf.com"
      include "stimax.com"
      include "he1bn.com"
      include "he2bn.com"
      include "he3bn.com"
      include "nh.com"
      include "nhe1.com"
      include "nhe2.com"
      include "he3n.com"
      include "iprayl.com"
      include "ipbrms.com"
      include "iphmra.com"
      include "iphmop.com"
      include "ioptri.com"
      include "iphop.com"
      include "iophe1.com"
      include "iophe2.com"
      include "h2ppnt.com"
      include "ZoneCnt.com"
      include "ca2ex.com"
      include "pca2ex.com"
      include "ffopac.com"
      include "IonFracs.com"
      include "ResetOTS.com"
      include "mgexc.com"
      include "TrConvg.com"
      include "iphl.com"
      include "nitexc.com"
      include "LevTrace.com"
      include "bit32.com"
      include "reason.com"
      include "badstp.com"
      include "NumUpper.com"
      include "IOqq.com"
*
*     local variables
      integer i, n , nd
      real sum,fac,fac1,heff,depcoe , oldhe3
      real hnold(lmhlvl) , fachmi , fachmi1 , depold(lmhlvl)
      double precision dfactor
      save hnold , depold , oldhe3
*
*     free statement numbers >= 44
*
      if( lgTrace .or. (lgTrConvg.and. nLevTrace.lt.2 ) ) then
        write(qq,'(''     AddOpac called'')')
      endif
*
*     this flag tells HEOPAC whether gas opacity has ever been evaluated
      lgOpacOn = .true.
*     opacz will zero out scattering and absorption opacities,
*     and set OldOpacSave to opac to save it
      call opacz
*
*     free electron scattering opacity, Compton recoil energy loss
      do i=1,ircoil-1
*       scattering part of total opacity
        scatop(i) = scatop(i) + OpacStack(i-1+iopcom) * eden
      end do
      do i=ircoil,nflux
*       scattering part of total opacity
*       at high energies Compton recoil is important, simply loose photons
*       since code not designed for Compton thick clouds
        fac = anu(i) / 7.512e4
        fac = fac/(1.+fac)
*       >>chng 97 apr 28, better treatment of loss due to compton recoil
        scatop(i) = scatop(i) + OpacStack(i-1+iopcom) * eden*(1.-fac)
        opac(i) = opac(i) + OpacStack(i-1+iopcom) * eden*fac
      end do
*
      do i=ircoil,nflux
*       add in bound hydrogen electron scattering, treated as absorption
        opac(i) = opac(i) + OpacStack(i-1+iopcom) * hi
      end do
*
*     bound helium electron scattering, treated as absorption
      do i=irche,nflux
        opac(i) = opac(i) + OpacStack(i-1+iopcom) * hei*2.
      end do
*
*     opacity due to pair production
      sum = hden + 4.*ahe
      call opacin(ioppr ,ippr ,nflux ,sum)
*
*     hydrogen, helium, heavy element brems (free-free) opacity,
*     assuming Hydrogen free-free gaunt factors
*     logic change June 4 95 to better treat h- absorption
*     FreeFreeOpacity is evaluated in ff heating routine, then added here
*     OPSV is missing factor of 1E-20 to avoid underflow
      fac = (eden/1e10) * ((hii+heii+4.*heiii+EdenFFSum)/1e10) / sqrte
      fac1 = fac * te1ryd / te
      fachmi = (eden/1e10) * (hii*hn(1)/1e10) / sqrte
      fachmi1 = fachmi * te1ryd / te
      do i=1,nflux
        if( ContBoltz(i).lt.0.995 ) then
*         use 1-exp(hn/kT)) only if exp is small
*         last term is scaled h minus brems free-free absorption
          dfactor = OpacStack(i-1+ipBrems) * (1.-ContBoltz(i))* gff(i)
          FreeFreeOpacity(i) = dfactor * fac
*         this is the H- part, opsv here is ratio of H- to ff
          FreeFreeOpacity(i) = FreeFreeOpacity(i) + dfactor * fachmi *
     1    OpacStack(i-1+iphmra)
        else
          dfactor = OpacStack(i-1+ipBrems) * anu(i)* gff(i)
          FreeFreeOpacity(i) = dfactor * fac1 
*         h- free free absorption
          FreeFreeOpacity(i) = FreeFreeOpacity(i) + dfactor * fachmi1 *
     1    OpacStack(i-1+iphmra)
        endif
        opac(i) = opac(i) + FreeFreeOpacity(i)
      end do
*
*     H minus absorption, with correction for stimulated emission
      do i=iphmin,min(nflux,nhe1(1))
        opac(i) = opac(i) + OpacStack(i-iphmin+iphmop) * hminus *
     1  (1. - ContBoltz(i)/hmidep )
      end do
*
*     H2P h2plus bound free opacity
      do i=ih2pnt(1),ih2pnt(2)
        opac(i) = opac(i) + h2plus * OpacStack(i-ih2pnt(1)+ih2pof)
      end do
*
      if( hbn(2).gt.1e-30 .and. .not.lgSearch) then
        stimax(2) = max( stimax(2) , ContBoltz(ipHn(2))/real(hbn(2)) )
      endif
*
*     get total population of hydrogen ground
      if( hii.le.0. ) then
        fac = hi
      else
        fac = hii * hn(1) 
      endif
*
*     Ly a damp wing opac (Rayleigh scattering)
      do i=1,ipHn(1)
        scatop(i) = scatop(i) + fac * OpacStack( i-1+ipRayScat )
      end do
*
*     approx correction for presence of molecules; 3 is ratio of cs
      if( hii.gt.0. ) then
        heff = hn(1)*hii + 3.*htwo
      else
*       when gas is totally neutral HN(1)*HII is zero
        heff = hi + 3.*htwo
      endif
*
*     hydrogen lyman continuum photoelectric opacity with corr for stim emission
      if( hn(1).gt.0. .and. .not.lgSearch) then
        if( hbn(1).gt.1e-30 ) then
          depcoe = hbn(1)
          stimax(1) = max( stimax(1) , ContBoltz(ipHn(1)) / depcoe )
        else
          depcoe = 0.
        endif
      else
         depcoe = 0.
      endif
*     this version of OPACIN has stimulated emission
*      >>chng 96 feb 15, had been explicit loop
      call opinb( iphop(1), ipHn(1) , nflux , heff , depcoe )
*
*     atomic hydrogen opacity
*     Balmer, Paschen, etc continuum
      if( nzone.le.1 ) then
        do n=2,nhlvl
          hnold(n) = hn(n)*hii
          depold(n) = hbn(n)
        end do
      endif
*
      hnold(1) = hn(1)*hii 
      depold(1) = hbn(1)
      do n=2,nhlvl
        if( .not.lgSearch .and. hbn(n).gt.1e-30 ) then
*       >>chng 96 may 15, departure coef saved
          depold(n) = depold(n)*0.75 + 0.25*real(hbn(n))
        else
          depold(n) = 0.
        endif
        hnold(n) = hn(n)*hii*0.25 + 0.75*hnold(n)
        call opinb( iphop(n), ipHn(n) , ipHn(1),hnold(n),depold(n))
      end do
*
*     generate current grain opacities since may be function of depth
      if( lgDustOn ) then
        do i=1,nupper
*         these are total absorption and scattering cross sections
          dstab(i) = 0.
          dstsc(i) = 0.
        end do
*       >>chng 97 july 17, grain abundance function of depth
        do nd=1,ndust
          if( lgDustOn1(nd) ) then
            do i=1,nupper
*             these are total absorption and scattering cross sections
              dstab(i) = dstab(i) + dstab1(i,nd) * dstAbund(nd)
              dstsc(i) = dstsc(i) + dstsc1(i,nd) * dstAbund(nd)
            end do
          endif
        end do
*
*       add dust grain opacity if dust present
        do i=1,nflux
          scatop(i) = scatop(i) + dstsc(i) * hden
          opac(i) = opac(i) + dstab(i) * hden
        end do
      endif
*
*     Helium singlets helium ion
      if( .not.lgSearch ) then
        if( he2bn(1).gt.0. ) then
          if( ContBoltz(nhe2(1))/he2bn(1).gt.1. ) lgHeMase = .true.
        endif
        if( he1bn(1).gt.0. ) then
          if( ContBoltz(nhe1(1))/he1bn(1).gt.1. ) lgHeMase = .true.
        endif
      endif
*
*     helium triplets hei
      if( lgSearch ) then
*       neglect stimulated emission corr if search underway
*       >>chng 96 feb 15, was 1
        depcoe = 0.
      else
        depcoe = he3bn(1)
      endif
*
      if( nzone.le.1 ) then
        oldhe3 = heii*he3n(1)
      endif
      oldhe3 = 0.75 * oldhe3 + 0.25 * heii*he3n(1)
*     this version of OPACIN has stimulated emission
      call opinb( ioptri, nhei3 , nhe1(1) , oldhe3 , depcoe )
*
*     helium singlets hei
*     ground special since it extends to high energy limit of code
      if( lgSearch ) then
*       neglect stimulated emission corr if search underway
*       >>chng 96 feb 15, was 1
        depcoe = 0.
      else
        depcoe = he1bn(1)
      endif
      call opinb( iophe1(1) , nhe1(1) , nflux , heii*he1n(1) , depcoe)
*
*     helium singlets hei, these only extend up to above
      do n=2,nhe1lvl
        if( lgSearch ) then
*         neglect stimulated emission corr if search underway
*       >>chng 96 feb 15, was 1
          depcoe = 0.
        else
          depcoe = he1bn(n)
        endif
        call opinb( iophe1(n), nhe1(n) , nhe1(1),he1n(n)*heii,depcoe)
      end do
*
*     ionized helium heii helium ion
*     ground special since extends up to high energy limit of code
      if( lgSearch ) then
*       neglect stimulated emission corr if search underway
        depcoe = 1.
      else
        depcoe = he2bn(1)
      endif
      call opinb( iophe2(1), nhe2(1) , nflux   , he2n(1)*heiii, depcoe )
      do n=2,nhe2lvl
        if( lgSearch ) then
*         neglect stimulated emission corr if search underway
          depcoe = 1.
        else
          depcoe = he2bn(n)
        endif
        call opinb( iophe2(n),nhe2(n) ,nhe2(1) ,he2n(n)*heiii,depcoe)
      end do
*
*     lithium opacity
      call PutOpacity( 3)
*
*     beryllium opacity
      call PutOpacity( 4)
*
*     boron opacity
      call PutOpacity( 5)
*
*     carbon opacity
      call PutOpacity( 6)
*
*     nitrogen opacity
      call PutOpacity( 7)
*     excited level of N+
      call opacin(in1(3),in1(1),in1(2),xIonFracs(7,1)*p2nit)
*
*     oxygen opacity
      call PutOpacity( 8)
*     excited level of Oo
      call opacin( ipo1exc(3),ipo1exc(1),ipo1exc(2),
     1 xIonFracs(8,1)*poiexc)
*     O2+ excited states
      call opacin( ipo3exc(3),ipo3exc(1),ipo3exc(2),
     1 xIonFracs(8,3)*poiii2)
      call opacin( ipo3exc3(3),ipo3exc3(1),ipo3exc3(2),
     1 xIonFracs(8,3)*poiii3)
*
*     fluorine opacity
      call PutOpacity( 9)
*
*     neon opacity
      call PutOpacity( 10)
*
*     sodium opacity
      call PutOpacity( 11)
*
*     magnesium opacity
      call PutOpacity( 12)
*     excited level of Mg+
      call opacin(ipOpMgEx,ipmgex,ipHn(1),xIonFracs(12,2)*popmg2)
*
*     aluminium opacity
      call PutOpacity( 13)
*
*     silicon opacity
      call PutOpacity( 14)
*
*     phosphorus opacity
      call PutOpacity( 15)
*
*     sulphur opacity
      call PutOpacity( 16)
*
*     clorine opacity
      call PutOpacity( 17)
*
*     Argon opacity
      call PutOpacity( 18)
*
*     potassium opacity
      call PutOpacity( 19)
*
*     calcium opacity
      call PutOpacity( 20)
*     photoionization of excited levels of Ca+
      call opacin( ica2op , ica2ex(1) , ica2ex(2) , pca2ex )
*
*     scandium opacity
      call PutOpacity( 21)
*
*     titanium opacity
      call PutOpacity( 22)
*
*     vanadium 
      call PutOpacity( 23)
*
*     chromium 
      call PutOpacity( 24)
*
*     manganese 
      call PutOpacity( 25)
*
*     iron
      call PutOpacity( 26)
*
*     cobalt
      call PutOpacity( 27)
*
*     nickel
      call PutOpacity( 28)
*
*     copper 
      call PutOpacity( 29)
*
*     zinc 
      call PutOpacity( 30)
*
*     total opacity now defined - now look at some ratios
*
      do n=1,nhe2lvl
*       if( opac(nhe2(n)).gt.0. ) then
*         ophe2f(n) = max(0.,
*    1    (opac(nhe2(n))-heiii*he2n(n)*OpacStack(iophe2(n)) )
*       else
*         ophe2f(n) = 0.
*       endif
*       now find ratio of .not.helium to total opacities
        if( opac(nhe2(n)).gt.0. ) then
          if( he2bn(n).gt.1e-30 .and.(.not.lgSearch) ) then
             fac= 1. / he2bn(n)
          else if(lgSearch) then
             fac = 0.
          else
             fac= 1.
          endif
          ophe2f(n) = ((opac(nhe2(n)) - heiii*he2n(n)*
     1    OpacStack(iophe2(n))*
     1    (1.-fac*ContBoltz(nhe2(n)) ) )/ opac(nhe2(n)) + ophe2f(n))/2.
          ophe2f(n) = max( 0., ophe2f(n) )
        else
          ophe2f(n) = 0.
        endif
      end do
*
      do n=1,nhe1lvl
        if( nhe1(n).lt.nflux .and. opac(nhe1(n)).gt.0. ) then
          if( he1bn(n).gt.1e-30.and. (.not.lgSearch) ) then
             fac= 1. / he1bn(n)
          else if(lgSearch) then
             fac = 0.
          else
             fac= 1.
          endif
          ophe1f(n) = ( (opac(nhe1(n)) - heii*he1n(n)*
     1    OpacStack(iophe1(n))*
     1    (1.-fac*ContBoltz(nhe1(n)) ) )/ opac(nhe1(n)) + ophe1f(n))/2.
          ophe1f(n) = max( 0., ophe1f(n) )
        else
          ophe1f(n) = 0.
        endif
      end do
*
      if( nzone.lt.1 ) then
        do n=1,nhlvl
          if( opac(ipHn(n)) .gt. 1e-30 ) then
            ophf(n) = 
     1      (opac(ipHn(n))  - hn(n)*hii*OpacStack(iphop(n))
     1       ) / opac(ipHn(n) )
          else
            ophf(n) = 0.
          endif
        end do
      endif
      do n=1,nhlvl
*       ratios of other to total opacity for H continua
*       same for Lyman, Balmer continua of hydrogen
        if( opac(ipHn(n) ).gt.0. ) then
          if( hbn(n).gt.1e-30 .and.(.not.lgSearch) ) then
             fac= 1. / hbn(n)
          else if(lgSearch) then
             fac = 0.
          else
             fac= 1.
          endif
*       >>chng 96 may 15, departure coef saved
          if( opac(ipHn(n)).gt.1e-30 ) then
            ophf(n) = ophf(n)*0.75 + 0.25*
     1      (opac(ipHn(n))  - hnold(n)*OpacStack(iphop(n))*(1.-fac*
     1      ContBoltz(ipHn(n) )) ) / opac(ipHn(n) )
          else
            ophf(n) = 0.
          endif
          ophf(n) = max( 0. , ophf(n) )
        else
          ophf(n) = 0.
        endif
      end do
*
*       >>chng 97 mar 8, zero out very small opacities, below precision on
*       current cpu.  done to stop ots fluxes from exploding at low densities
*       >>chng 97 may 6, decreased from 1e-30 to 1e-34, ldl.in did not work
      if( lgBit32 ) then
        do i=1,nflux
          if(opac(i).lt.1e-34 ) opac(i) = 0.
        end do
      endif
*
*     option to reset ots fields due to change in opacity
      if( lgResetOTS ) then
        do i=1,nflux
*         if( opac(i)*OldOpacSave(i) .gt.0. ) then
*         >>chng 97 mar 20, rescale if opac is greater than zero
*         >>chng 97 jul 7, from 1e-30 to 1e-29
*         >>chng 97 jul 9, from 1e-29 to 1e-28
*         >>chng 97 jul 11, from 1e-29 to 1e-30
          if( opac(i) .gt.1e-30 ) then
            otscon(i) = otscon(i) * (OldOpacSave(i)/opac(i))
            otslin(i) = otslin(i) * (OldOpacSave(i)/opac(i))
          else
*           >>chng 97 mar 8, zero it out if opac is zero
*           >>chng 97 jul 9, keep track of turned off lines so that
*           they are not turned
*           back on
            lgOTSOn(i) = .false.
            otscon(i) = 0.
            otslin(i) = 0.
          endif
        end do
*       must reset sums of these continua
        call SumContinuum
      endif
*
*     compute gas albedo here
      do i=1,nflux
        albedo(i) = scatop(i) / (scatop(i)+opac(i))
      end do
*
*begin sanity check
      sum = 0.
      do i=1,nflux
        sum = max( opac(i) , sum )
      end do
      lgOK = .true.
      if( sum.le.0. ) then
        write(qq,'('' AddOpac finds zero opacity - the density is '',
     1  ''probably too low for this cpu.'')')
        write(qq,'('' hydrogen density is '',1p,e10.2,
     1  ''and neutral density is '',e10.2)') hden, hn(1)*hden
        lgOK = .false.
*       say this was a bad stopping reason
        lgBadStop = .true.
        chReason = 'opacity scale undrflo'
      endif
*end sanity check
*
      if( lgTrace ) then
        write(qq,'(5x,''AddOpac returns; grd rec eff (opac)'',
     1  '' for Hn=1,4'',1P,4E10.2,'' HeI,II;'',2E10.2)') 
     2  ophf(1) ,ophf(2),ophf(3),ophf(4),ophe1f(1),ophe2f(1)
      end if
*
      end
