******************************************************************************
      subroutine AddOTSCon( ots , ip )
      implicit none
*add local destruction of continuum to ots field
      real ots
      integer ip
      include "ncell.par"
      include "opac.com"
      include "SummdCon.com"
      include "ots.com"
      include "rfield.com"
      include "zero0.com"
      include "occnum.com"
      include "OldOpac.com"
      include "IOqq.com"
*
*     local variables
      real a , b  , otsnew
*
*     routine called to add ots due to continuum destruction to
*     radiation field
*
*     check if outside bounds of this continuum source
      if( ip.gt.nflux .or. .not.lgOTSOn(ip) ) return
*begin sanity checks
      if(ots.lt.0. ) then
        a = 1.
        call ShowMe
        write(qq,'('' AddOTSCon called with negative ots flux.'')')
        write(qq,'('' I will divide by 0 to get trace.'')')
        a = a / ZeroNum
        write(qq,'('' 1/zero='',1p,e10.2)') a
        stop
      else if( ip.le.0 ) then
        b = 0.
        a = 1.
        call ShowMe
        write(qq,'('' AddOTSCon called with non-positive line pnt'')')
        write(qq,'('' I will divide by 0 to get trace.'')')
        a = a / ZeroNum
        stop
      else if( ip.gt.ncell ) then
        b = 0.
        a = 1.
        call ShowMe
        write(qq,'('' AddOTSCon called with too-large line pointer.'')')
        write(qq,'('' I will divide by 0 to get trace.'')')
        a = a / ZeroNum
        stop
      endif
*end sanity checks
*
*     add locally destroyed flux of photons to continuum OTS array
      if( opac(ip).gt.0. ) then
        otsnew = ots / opac(ip)
      else
        otsnew = 0.
      endif
*
*     update summed radiation fields
      otscon(ip) = otsnew
      SummedDif(ip) = otscon(ip)+otslin(ip)+outcon(ip)+outlin(ip)
      SummedCon(ip) = flux(ip)+SummedDif(ip)
      SummedOcc(ip) = SummedCon(ip) * convoc(ip)
*
      end
