******************************************************************************
      subroutine AddOTSLin( ots , ip ,damper )
      implicit none
*add local destruction of lines to ots field
      real ots , damper
      integer ip
      include "ncell.par"
      include "itrdim.par"
      include "opac.com"
      include "SummdCon.com"
      include "ots.com"
      include "rfield.com"
      include "zero0.com"
      include "occnum.com"
      include "ZoneCnt.com"
      include "OldOpac.com"
      include "IOqq.com"
*
*     local variables
      real a , b  , otsnew
*
*     add ots due to line destruction to radiation field
*     damper is fraction of new ots
*
*     check if outside bounds of this continuum source
      if( ip.gt.nflux .or. (.not.lgOTSOn(ip)) ) return
*begin sanity checks
      if(ots.lt.0. ) then
        a = 1.
        call ShowMe
        write(qq,'('' AddOTSLin called with negative ots flux.'')')
        write(qq,'('' I will divide by 0 to get trace.'')')
        a = a / ZeroNum
        write(qq,'('' 1/zero='',1p,e10.2)') a
        stop
      else if( ip.le.0 ) then
        b = 0.
        a = 1.
        call ShowMe
        write(qq,'('' AddOTSLin called with non-positive line pointer.''
     1)')
        write(qq,'('' I will divide by 0 to get trace.'')')
        a = a / ZeroNum
        stop
      else if( ip.gt.ncell ) then
        b = 0.
        a = 1.
        call ShowMe
        write(qq,'('' AddOTSLin called with too-large line pointer.'')')
        write(qq,'('' I will divide by 0 to get trace.'')')
        a = a / ZeroNum
        stop
      endif
*end sanity checks
*
*     add locally destroyed flux of photons to line OTS array
      if( opac(ip).gt.0. ) then
        otsnew = ots/opac(ip)
      else
        otsnew = 0.
      endif
*
*     update summed radiation fields
      if( nzone.gt.1 ) then
        otslin(ip) = otsnew*damper + otslin(ip)*(1.-damper)
      else
        otslin(ip) = otsnew
      endif
      SummedDif(ip) = otscon(ip)+otslin(ip)+outcon(ip)+outlin(ip)
      SummedCon(ip) = flux(ip)+SummedDif(ip)
      SummedOcc(ip) = SummedCon(ip) * convoc(ip)
*
      end
