******************************************************************************
      subroutine alumin
      implicit none
*ionization balance for aluminum
      include "limelm.par"
      include "trace.com"
      include "elmton.com"
      include "he.com"
      include "timed.com"
      include "TePowers.com"
      include "h.com"
      include "phycon.com"
      include "TrHeav.com"
      include "IonFracs.com"
      include "IOqq.com"
*
*     local variables
      integer i
      integer nelem , ndim
      parameter (nelem=13)
      parameter (ndim=14)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     REAL GRDEFF(13)  , yYIELD(11) , yYIELDL(3)
*     real CollidRate(nelem,2)
*
*     DATA GRDEFF/13*0.2/ , yYIELD/11*0./ , yYIELDL/3*0./
*
*     aluminium nelem=13
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
*     use silicon since not in shull + van steenberg
      data (cion(i,1),i=1,ndim-1)
     1 /3.92E-10,4.87E-11,2.32E-11,6.20E-12,4.86E-12,2.60E-12,
     1 1.65E-12,1.03E-12,6.02E-13,3.23E-13,1.95E-13,7.44E-15,3.09E-15/
      data (cion(i,2),i=1,ndim-1)
     1 /9.46E4,1.90E5,3.88E5,5.24E5,1.93E6,2.38E6,2.86E6,3.52E6,4.07E6,
     2 4.66E6,5.52E6,6.07E6,2.83E7/
*
*     rec coef from Aldrovandi and Pequignot Revista Bras de Fisica 4, 491.
      data rec , pl
     1/2.14E-10 , 1.05E-9 , 6.49E-9 , 1.09E-8 , 1.31E-8 , 2.54E-8 ,
     2  3.13E-8 , 8.85E-8 , 1.22E-7 , 7.15E-7 , 5.54E-7 , 4.12E-7 ,
     3 -0.659  , -0.713  , -0.840  , -0.784  , -0.742  , -0.752  ,
     4 -0.733  , -0.789  ,  -0.790  , -0.927  , -0.883 , -0.809  /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.13e-10 , -0.567/
*
      data (dicoef(i,1),i=1,ndim-1)
     1/5.5E-3 , 6.0E-3 , 7.5E-3 , 5.6E-3 , 1.2E-2 , 1.9E-2 , 1.6E-2
     1,1.7E-2 , 4.4E-2 , 1.7E-2 , 3.0E-1 , 3.4E-0 , 0./
      data (dite(i,1),i=1,ndim-1)
     2/9.0E4  , 7.5E4  , 8.5E5  , 5.0E5  , 4.4E5  , 3.8E5  , 3.4E5
     2,3.4E5  , 3.9E5  , 2.3E5  , 1.6E7  , 1.7E7  , 1E20/
      data ditcrt
     3/8.0E3  , 7.0E3  , 1.2E5  , 7.0E4  , 6.5E4  , 5.5E4  , 5.5E4
     3,5.5E4  , 5.8E4  , 4.0E4  , 2.9E6  , 5.5E6  , 1E20 /
      data (dicoef(i,2),i=1,ndim-1)/nelem*0./
      data (dite(i,2),i=1,ndim-1)/nelem*0./
*
*     from Nussbaumer and Storey, Mg, Al, Si: n.b., al1 uses table 2(b)
      data 
     1 aa/  0.0219 ,  0.7086 , 11*0./, 
     2 bb/ -0.4528 , -3.1083 , 11*0./, 
     3 cc/  2.5427 ,  7.0422 , 11*0./, 
     4 dd/ -0.1678 ,  0.5998 , 11*0./, 
     5 ff/  0.2276 ,  0.4194 , 0.1,10*0./
*
*     aluminium, atomic number 13
      if( .not.lgElmtOn(13) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt,
     2 aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      if(lgTrace.and.lgHeavyBug)then
        write(qq,'(5X,''ALUMIN returns; frac='',1P,10E10.3)')
     1  (xIonFracs(nelem,i)/xIonFracs(nelem,0),i=1,10)
      endif
*
      end
