******************************************************************************
      subroutine arcol
      implicit none
*compute argon cooling
      include "ipLnArry.par"
      include "nta.par"
      include "ndfst.par"
      include "limelm.par"
      include "dcool.com"
      include "coolar.com"
      include "TePowers.com"
      include "p2ovp1.com"
      include "phycon.com"
      include "TLineEXP.com"
      include "TauDmmy.com"
      include "IonFracs.com"
*
*     local variables
      real popexc,cs2s2p,cs2s3p , cs12 , cs , pop3,pop2,popn3
      real a12,cs13,a13,cs14,a14,cs15,a15,cs23,a23,cs24,a24,cs25,a25,
     1 cs34,a34,cs35,a35,cs45,a45
      real gAr4(5) , p(5) , exAr4(4)
      data gAr4/4.,4.,6.,2.,4./ , exAr4/21090.4, 128.9, 13636.2, 177.1/
*
*     Argon II 6.98 micron
*     trans prob from 
*     >>refer Nussbaumer, H., & Storey, P.J. 1988, A&A, 200, L25
*     Y(ik) from
*     >>refer  Pelan, J., & Berrington, K.A. 1995, A&A Suppl, 110, 209
      call PutCS( 3.1 , tAr7 )
      call level2( tAr7 )
*
*     A III 7136, 7751, 3109, 5192 CS
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
*     c7136 = popexc(4.825,9.,5.,0.403,1.955e4,xIonFracs(18,3))*2.7e-12
*     call coladd( 'Ar 3' , 7136 , C7136  )
*     >>chng 97 mar 19, break up into three level atom
      cs12 = 4.825
      cs13 = 0.841
      cs23 = min(  1.30  ,  3.296/(te10*te01/te001/te001)  )
      a12 = 0.3963
      a23 = 2.59
      a13 = 3.952
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      popn3 = pop3( 9.,5.,1.,cs12,cs13,cs23,a12 ,a13 ,a23 ,
     1 1.955e4,2.770e4 , pop2,xIonFracs(18,3) ,0.)
      c7136 = pop2*a12*2.7e-12
      c5192 = popn3*a23*3.83e-12
      c3109 = popn3*a13*6.40e-12
      call coladd( 'Ar 3' , 7136 , c7136  )
      dCooldT = dCooldT + c7136*1.955e4*tsq1
      call coladd( 'Ar 3' , 5192 , c5192  )
      call coladd( 'Ar 3' , 3109 , c3109  )
*
*     Ar III 21.8(J=0,1), 9.0 (J=1,2) mircon lines,
*     CS 
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
      call PutCS( 3.1, tAr9 )
      cs = min( 1.384, 3.110/(te10/te001*te001) )
      call PutCS( cs   , tAr22 )
      if( te.lt.1e4 ) then
        cs = 0.671
      else
        cs = min( 0.906 , 0.150*te20/te02/te02*te003 )
      endif
      call PutCS( cs , TauDummy )
      call level3(tAr9,tAr22,TauDummy)
*
*     Argon IV 4711+4740, 7335 lines (O II like)
*     CS from
*     >>refer Zeippen, C.J., Le Bourlot, J., Butler, K. 1987, A&A, 188, 251
*     expression is 1-3 by itself, convert to whole mult by *2.5
*     cs12 = min(3., 93.094/(sqrte/te10*te02) ) * 2.5
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
*     C7335 = POP3( 4.,10.,6., cs12 ,0.476,10.2 , 0.0103,1.7,1.16,
*    1 3.13e4 , 1.98e4 , pop2 ,xIonFracs(18,4),0.) * 1.16*2.75E-12
*     c4740 = pop2 * 0.0103 * 4.2e-12
*
*     >>chng 97 jan 31, increase to full 5 level atom
*     Ar IV, cs data from 
*     >>refer Ramsbottom, C.A., Bell., K.L., & Keenan, F.P., 1997,
*     >>refer MNRAS 284, 754
*     differs by 2-3x from older values
*     temp dependence form 
*     >>refer Ramsbottom, C.A., & Bell, K.L. 1997, ADNDT, 66, 65
      cs12 = min( 0.853 , max(0.761, 0.481*te05 ) )
      a12 = 2.23e-2
      cs13 = 1.16
      cs13 = min(1.3 , max(1.14,0.719*te05 ))
      a13 = 1.77e-3
      cs14 = min( 0.5 , max(0.39 , 0.108*te10*te02*te02 ) )
      a14 = 0.862
      cs15 = min( 1.0 , max(0.78 , 0.216 *te10*te02*te02 ) )
      a15 = 2.11
      cs23 = 7.06
      a23 = 2.30e-5
      cs24 = min(1.96, max(1.53,0.346*te10*te05 ) )
      a24 = 0.603
      cs25 = min( 2.65 , max(2.18, 0.664*te10*te02 ) )
      a25 = 0.789
      cs34 = min(1.89 , max(1.56 , 0.475*te10*te02 ) )
      a34 = 0.119
      cs35 = min( 5.03 , max(4.01, 1.00*te10*te02*te02 ) )
      a35 = 0.598
      cs45 = 0.0359 * te20*te20*te02*te02
      a45 = 4.94e-5
*     FIVEL( G(1-5) , ex(wn,1-5), cs12,cs13,14,15,23,24,25,34,35,45,
*            A21,31,41,51,32,42,52,43,53,54, pop(1-5), abund)
      call fivel(gAr4, exAr4 ,
     1 cs12 , cs13 , cs14 , cs15 , cs23 , cs24 , cs25 ,
     2 cs34 ,cs35 ,cs45 ,
     3 a12,a13,a14,a15,a23,a24,a25,a34,a35,a45,
     3 p , xIonFracs(18,4) )
      Ar4740 = p(2)*a12*4.20e-12
      Ar4711 = p(3)*a13*4.20e-12
      Ar2868 = p(4)*a14*6.94e-12
      Ar2854 = p(5)*a15*6.94e-12
      Ar7263 = p(4)*a24*2.74e-12
      Ar7171 = p(5)*a25*2.74e-12
      Ar7331 = p(4)*a34*2.74e-12
      Ar7237 = p(5)*a35*2.74e-12
      dCooldT = dCooldT + (Ar4740+Ar4711) * (3.04e4*tsq1 - halfte)
      dCooldT = dCooldT + (Ar2868+Ar2854+Ar7263+Ar7171+Ar7331+Ar7237)*
     1 (5.02e4*tsq1 - halfte)
      call coladd( 'Ar 4' , 7335 , Ar7263+Ar7171+Ar7331+Ar7237  )
      call coladd( 'Ar 4' , 4740 , Ar4740+Ar4711  )
      call coladd( 'Ar 4' , 2868 , Ar2868+Ar2854  )
*
*     Argon V 6435+7007, A from 
*     >>refer Mendoza, C., & Zeippen, C.J. 1982, MNRAS, 199, 1025
*     CS from 
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
*     POPEXC( O12,g1,g2,A21,excit,abund) ; result already*a21, excit in Kelvin
      if( te.lt.1e4 ) then
        cs = 3.09
      else
        cs = min(4.454, 0.634 * te20/te03*te001*te001)
      endif
      c7007 = popexc( cs,9.,5.,0.68,2.055e4,xIonFracs(18,5))*2.84E-12
      call coladd( 'Ar 5' , 7007 , c7007  )
*
*     Ar V 3P fine structure lines , A from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     cs=
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
*     >>chng 96 july 16, bug upward change in collision strengths from 
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
      cs = min(3.26, 26.27 /(te20*te03*te01*te003))
      call PutCS( cs , tAr13 )
      cs = min(8.47, 44.31 / (te20/te003/te003))
      call PutCS( cs , tAr8 )
      cs = min(1.95, 7.280 / (te10*te05*te005))
      call PutCS( cs , TauDummy )
      call level3(tAr13,tAr8,TauDummy)
*
*     [Ar VI] 4.53 micron, cs from 
*     >>refer Saraph, H.E., & Storey, P.J. A&AS, 115, 151
*     call PutCS( .8 , Ar06453 )
*     >>chng 96 Dec 11, cs should have been 6.33, caught by Simon Casassus
      call PutCS( 6.33 , Ar06453 )
      call level2( Ar06453 )
*     fs4p5 = popexc( 0.8, 2.,4., 9.7e-2, 3174.3,xIonFracs(18,6))
*    1 * 4.39E-13
*     call coladd( 'Ar 6' , 4 , FS4P5  )
*
*     [ArX] 5533.4A, cs 
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      cs = min( 0.573 , 20.05/(te30*te03*te005 ) )
      call PutCS( cs , Ar1055 )
      call level2( Ar1055 )
*
*     [Ar XI] 2.60, microns, 6917A
      cs = max(0.09 , min(0.207,2.685e-3*te20*te20*te001*te001 ) )
      call PutCS( cs , Ar1126 )
      cs = max(0.25 , min(0.64,0.0127 *te30*te05*te001*te001 ) )
      call PutCS( cs , Ar1178 )
      cs = max(0.06 , min(0.17,2.789e-3 *te30*te05*te02/te003 ) )
      call PutCS( cs , TauDummy )
      call level3( Ar1126 , Ar1178 , TauDummy )
*
*     Ar X IV 4413, wavelength+a from 
*     >>refer Froese Fischer, C. 1983, JPhB, 16, 157
*     cs is guess
      fs4413 = popexc(0.2,2.,4.,105.,3.259e4,xIonFracs(18,14))*4.51e-12
      call coladd( 'Ar14' , 4413 , fs4413  )
*
*     Ar 15 409A, Be seq interpolated lambda, cs, A.
      c409 = popexc(0.1,1.,9.,1.1e6,3.52e5,xIonFracs(18,15))*4.86e-11
      call coladd( 'Ar15' , 409 , c409  )
*
*     Ar 16 365, 25, Li Seq
*     >>refer Cochrane, D.M., & McWhirter, R.W.P. 1983, PhyS, 28, 25
      call ligbar( 18 , t354, t25, cs2s2p , cs2s3p )
*
      call PutCS( cs2s2p , t354 )
      call level2( t354 )
*
*     funny factor (should have been 0.5) due to energy change
      call PutCS( cs2s2p*0.454 , t389 )
      call level2( t389 )
*
      call PutCS( cs2s3p , t25 )
      call level2( t25 )
*
      end
