******************************************************************************
      subroutine argoni
      implicit none
*compute ionization balance of argon
      include "limelm.par"
      include "elmton.com"
      include "he.com"
      include "h.com"
      include "TePowers.com"
      include "timed.com"
      include "chargt.com"
      include "phycon.com"
      include "IOqq.com"
      include "PhotRate.com"
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=19)
      parameter (nelem=18)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2) 
*     REAL GRDEFF(18)  , yYIELD(16) , yYIELDL(8)
*     real CollidRate(nelem,2)
*
*     DATA GRDEFF/18*0.2/ , yYIELD/16*0./ , yYIELDL/8*0./
*
*     argon nelem=18
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /2.20E-10,1.20E-10,3.50E-11,3.80E-11,6.47E-12,1.72E-12,
     1 2.20E-12,6.95E-13,7.57E-13,4.75E-13,3.45E-13,2.48E-13,1.57E-13,
     2 9.10E-14,6.05E-14,2.62E-14,2.60E-15,1.13E-15/
      data (cion(i,2),i=1,ndim-1)
     1 /1.83E5,3.21E5,4.75E5,6.94E5,8.70E5,1.06E6,1.44E6,1.66E6,4.90E6,
     2 5.56E6,6.25E6,7.17E6,7.96E6,8.77E6,9.92E6,1.07E7,4.78E7,5.14E7/
*
*     rec from +15, 16, 17 from Arnauld et al 85
      data rec , pl
     1/3.67E-11 , 1.16E-9 , 4.1E-9  , 6.3E-9  , 8.5E-9 , 1.15E-8,
     1 1.42E-8  , 6.71E-8 , 4.99E-8 , 6.5E-8  , 5.7E-8 , 5.1E-8 ,
     1 7.6E-8   , 8.3E-8  , 5.80E-7 , 1.14E-6 , 9.45E-7,
     2 -0.497   , -0.694  , -0.778  , -0.756  , -0.724 , -0.706,
     2 -0.676   , -0.830  , -0.750  , -0.755  , -0.707, -0.647,
     2 -0.694   , -0.682  , -0.819  , -0.854  , -0.803/
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/2*0./
*
      data (dicoef(i,1),i=1,ndim-1)
     1/1.00E-3, 1.10E-2, 3.40E-2, 6.85E-2, 9.00E-2, 6.35E-2,
     2 2.60E-2, 1.70E-2, 2.10E-2, 3.50E-2, 4.30E-2, 7.13E-2,
     3 9.60E-2, 8.50E-2, 1.70E-2, .476, .297, 0./
      data (dicoef(i,2),i=1,ndim-1)
     1/.005, .045, .057, .087, .0769, .140, .120, .1, 1.92, 1.66,
     2 1.67, 1.40, 1.31, 1.02, .245, .294, .277, 0./
      data (dite(i,1),i=1,ndim-1)
     1 / 3.20E+5, 2.90E+5, 2.39E+5, 2.56E+5, 2.50E+5, 2.10E+5, 1.80E+5,
     1 2.70E+6, 8.30E+5, 6.95E+5, 6.05E+5, 6.68E+5, 6.50E+5, 5.30E+5,
     1 3.55E+5, 3.01E+7, 3.13E+7, 0./
      data (dite(i,2),i=1,ndim-1)
     1 / 3.10E+5, 5.50E+5, 6.00E+5, 3.81E+5, 3.30E+5, 2.15E+5, 2.15E+5,
     2 3.30E+6, 3.50E+6, 3.60E+6, 3.80E+6, 2.90E+6, 3.60E+6, 2.80E+6,
     3 1.10E+6, 6.05E+6, 6.54E+6, 0./
      data ditcrt
     3/2.5E4  , 3.0E4  , 2.5E4  , 2.5E4  , 1.8E4  , 1.8E4  , 2.2E4
     3,5.0E5  , 1.6E5  , 1.5E5  , 1.5E5  , 1.3E5  , 1.3E5  , 1.1E5
     3,7.6E4  , 6.5E6  , 1.4E7  , 1E20  /
*
      data aa/18*0./,bb/18*0./,cc/18*0./,dd/18*0./,ff/18*0./
*
*     argon, atomic number 18
      if( .not.lgElmtOn(18) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*666  call PrtGamma(ipArgon(2,5,1) ,ipArgon(2,5,2) ,
*    1 ipArgon(2,5,3),
*    1 qq,  photorate(nelem,2,5,1) ,photorate(nelem,2,5,1)*0.05 )
*     write(qq,'('' Ar 1'',1p,8e10.2)') (photorate(nelem,1,i,1),i=1,7)
*     write(qq,'('' Ar 2'',1p,8e10.2)') (photorate(nelem,2,i,1),i=1,7)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
*     CHARGE EXCHANGE, ALL RATES FROM BUTLER AND DALGARNO 1980B
*     A+2 => A+
*     CTHeavy(2,2) = CTHeavy(2,2) + 1E-14 * HI + HEI * 1.3E-10
*     >>chng 96 Oct 1, move H ct into bidiag
      CTHeavy(2,2) = CTHeavy(2,2) + hei * 1.3E-10
*     A+ => A+2
      CTHeavy(2,1) = CTHeavy(2,1) + heii * 1.1E-10
*     T = MIN( SQRTE , 200. )
*     A+3 => A+2
*     >>chng 96 Oct 1, move H ct into bidiag
*     CTHeavy(3,2) = CTHeavy(3,2) + 4.4E-11*min(sqrte,200.)*hi
*     >>chng 96 Oct 1, move H ct into bidiag
*     CTHeavy(4,2) = CTHeavy(4,2) + 6.3E-9 * hi
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
