******************************************************************************
      subroutine boroni
      implicit none
*ionization balance for boron
      include "limelm.par"
      include "elmton.com"
      include "timed.com"
      include "trace.com"
      include "TePowers.com"
      include "h.com"
      include "phycon.com"
      include "TrHeav.com"
      include "IonFracs.com"
      include "IOqq.com"
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=6)
      parameter (nelem=5)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2) 
*
*     boron nelem=5
*     data are for carbon
*
*     real CollidRate(nelem,2)
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.44E-10,4.20E-11,1.92E-11,5.32E-12,2.87E-13/
      data (cion(i,2),i=1,ndim-1)
     2 /1.31E5,2.83E5,5.56E5,7.48E5,4.55E6/
*     DATA GRDEFF/0.10,0.10,0.10,0.053,0.10/
*     GRDEFF is fraction of recombinations to ground state, used for
*     outward diffuse fields
*
*     rec from +3, +4 from Arnaud et al Ast Ap Sup 60 425. (1985)
*     rec from fully ionized uses Seaton '79 in ionrat
      data rec , pl/
     1 1.47E-10 , 8.74E-10 , 7.98E-9 , 1.34E-8 ,
     2  -0.624  , -0.645   , -0.803  , -0.791 /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/1.44e-10 , -0.621/
*
      data (dicoef(i,1),i=1,ndim-1)
     1/2.54E-3 , 6.15E-3 , 1.62E-3 , 4.78E-2 , 0./
      data (dicoef(i,2),i=1,ndim-1)
     1/4.42E-2 , 5.88E-2 , 0.343 , 0.362 , 0./
      data (dite(i,1),i=1,ndim-1)
     2/1.57E+5 , 1.41E+5 , 8.19E+4 , 3.44E+6 , 0./
      data (dite(i,2),i=1,ndim-1)
     2 /3.74E5 , 1.41E5 , 1.59E5 , 5.87E5 , 0./
      data ditcrt
     3/1.2E+4 , 1.2E+4 , 1.1E+4 , 4.4E+5 ,  1E20/
*
      data aa/  .0108  ,1.8267 ,2.3196  ,0. ,0./
     1  ,  bb/-0.1075  ,4.1012 ,10.7328 ,0. ,0./
     1,    cc/  .2810  ,4.8443 ,6.8830  ,0. ,0./
     2,    dd/-0.0193  ,.2261  ,-0.1824 ,0. ,0./
     3,    ff/ 0.001   ,0.5960 ,0.4101  ,0.1,0./
*
      IF( .NOT.lgElmtOn(nelem) ) THEN
        return
      endif
*
*     zero out ionization balance arrays
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2 aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
* 
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      if( lgTrace.and.lgHeavyBug ) then
        write(qq,'(5X,''Boroni returns; frac='',1P,7E10.3)')
     1  (xIonFracs(nelem,i)/xIonFracs(nelem,0),i=1,nelem+1)
      endif
*
      end
