******************************************************************************
      subroutine calcol
      implicit none
*compute calcium cooling
      include "ndfst.par"
      include "limelm.par"
      include "nhlvl.par"
      include "ncell.par"
      include "ipLnArry.par"
      include "dcool.com"
      include "coolca.com"
      include "h.com"
      include "IonFracs.com"
      include "hmi.com"
      include "ca2mly.com"
      include "nta.par"
      include "TLineEXP.com"
      include "TePowers.com"
      include "p2ovp1.com"
      include "DoppVel.com"
      include "phycon.com"
      include "dcala.com"
*     include "fcakh.com"
      include "caline.com"
      include "phlevl.com"
      include "nh.com"
      include "iphl.com"
      include "ots.com"
      include "opac.com"
      include "edsqte.com"
      include "pca2ex.com"
      include "pmpcah.com"
      include "oldcla.com"
      include "TauDmmy.com"
*
*     local variables
      real Ca2pop(5)
      real gCa2(5) , exCa2(4)
      save opCax , opCay , opCaz
      real opCax,opCay,opCaz,a21,a31,a41,a51,a42,a52,a53,opcxyz,
     1 d52,d53,d42,opckh,op51,op41,d51,d41,r21,r31,r41,r51,r42,r52,
     2 p51,p41,p31,p21,pop3,p2,p3,cs2s2p,cs2s3p,r53,cs14,cs15,
     3 hlgam,c21 , cs , cs01 , cs02 , cs12
      data gCa2/2.,4.,6.,2.,4./ , exCa2/13650.2,60.7,11480.6,222.9/ ,
     2 opCax , opCay , opCaz /3*0./
*
*     Ca I 4228
      call MakeCS( CaI4228 )
      call level2( CaI4228 )
*
*     photoionization of evcited levels by Ly-alpha
      hlgam = otslin( iphl(2,1) ) 
      p51 = 1.7e-18 * hlgam
      p41 = 8.4e-19 * hlgam
      p31 = 7.0e-18 * hlgam
      p21 = 4.8e-18 * hlgam
*     spontaneous decays
*     frist two trans prob from 
*     >>refer Zeippen, C.J. 1990, A&A, 229, 248
      a21 = 1.02 * t7324(ipLnEscP)
      a31 = 1.05 * t7291(ipLnEscP)
      a41 = 1.4e8 * t3969(ipLnEscP)
      a51 = 1.4e8 * t3934(ipLnEscP)
      a42 = 7.9e6 * t8662(ipLnEscP)
      a52 = 8.2e5 * t8498(ipLnEscP)
      a53 = 7.48e6 * t8542(ipLnEscP)
*     destruction of IR triplet by continuous opacities
      opcxyz = opac(int(t7324(ipLnIpCont)))
*     opcxyz = opac(icaxyz)
      if( opcxyz .gt. 0. ) then
        d52 = 5.6 * opcxyz / (opcxyz + opCax) * (1.-t8498(ipLnEscP))
        d53 = 5.6 * opcxyz / (opcxyz + opCay) * (1.-t8542(ipLnEscP))
        d42 = 5.6 * opcxyz / (opcxyz + opCaz) * (1.-t8662(ipLnEscP))
      else
        d52 = 0.
        d53 = 0.
        d42 = 0.
      endif
*     near UV dest of KH by background continuum
      opckh = opac(int(t3969(ipLnIpCont)))
*     opckh = opac(icakh)
      if( opckh .gt. 0. ) then
        op51 = xIonFracs(20,2) * 3.89e-7 / doppler(20)
        d51 = 5.6 * opckh / (opckh + op51 )
        op41 = xIonFracs(20,2) * 1.96e-7 / doppler(20)
        d41 = 5.6 * opckh / (opckh + op41 )
      else
        op51 = 0.
        d51 = 0.
        op41 = 0.
        d41 = 0.
      endif
*     net rates
      r21 = p21 + a21
      r31 = p31 + a31
      r41 = a41 + p41 + d41
      r51 = a51 + p51 + d51
      r42 = a42 + d42
      r52 = a52 + d52
      r53 = a53 + d53
      cs14 = 0.923*te10*te10
      cs15 = cs14 * 2.
      t3969(ipLnCS) = cs14
      t3934(ipLnCS) = cs15
*     following used to correct rec contribution
*     fcakh = a51 / ( a51 + eden*1.5e-5 / sqrte ) 
*     cs 1-2 from 
*     >>refer Saraph, H.E. 1970, JPhB, 3, 952
*     other 
*     >>refer Chidichimo, M.C. 1981, JPhB, 14, 4149
      call fivel( gCa2 , exCa2 ,
     1 5.8 , 8.6 , cs14 , cs15 , 20.6 , 22.9 , 9.8 , 3.4 , 44.4 , 1.0 ,
     2 r21 , r31 , r41 , r51 , 0. , r42 , r52 , 0. ,
     3 r53 , 0., Ca2pop , xIonFracs(20,2) )
*     CDSQTE = 8.629E-6*EDEN/SQRTE
      c21 = 5.8 / 4. * cdsqte
*     remember largest ratio of Ly-al removal to total
      if(xIonFracs(20,2).gt.0.) then
        Ca2RmLya = max( Ca2RmLya , p21 / ( p21 + a21 + c21 ) )
      endif
      Cak = Ca2pop(5) * a51 * 5.06e-12
      Cah = Ca2pop(4) * a41 * 5.01e-12
      Cax = Ca2pop(5) * a52 * 2.34e-12
      Cay = Ca2pop(5) * a53 * 2.33e-12
      Caz = Ca2pop(4) * a42 * 2.30e-12
      Caf1 = Ca2pop(3)* a31 * 2.73e-12
      Caf2 = Ca2pop(2)* a21 * 2.72e-12
      pca2ex = Ca2pop(2) + Ca2pop(3) + Ca2pop(4) + Ca2pop(5)
      Cair = Cax + Cay + Caz
      c7306 = Caf1 + Caf2
      Cakh = Cak + Cah
      call coladd( 'Ca 2' , 7306 , c7306  )
      call coladd( 'Ca 2' , 8400 , Cair  )
      call coladd( 'Ca 2' , 3800 , Cakh  )
      dstCala = Ca2pop(5)*p51 + Ca2pop(4)*p41
      dCakh = dstCala * 5.03e-12
      dCaf12 = ( Ca2pop(3)*p31 + Ca2pop(2)*p21 ) * 2.31e-12
      opCax = Ca2pop(2) * 1.13e-8 / doppler(20)
      opCay = Ca2pop(3) * 6.87e-8 / doppler(20)
      opCaz = Ca2pop(2) * 5.74e-8 / doppler(20)
*     total rate Lalpha destroys CaII
      if( xIonFracs(20,2).gt.0. ) then
        dstCala = ( dstCala + dCaf12 / 2.31e-12 ) / xIonFracs(20,2)
        dstCala = (dstCala + oldcla) / 2.
        oldcla = dstCala
      else
        dstCala = 0.
      endif
      Ca3d = Ca2pop(2) + Ca2pop(3)
      Ca4p = Ca2pop(4) + Ca2pop(5)
*     incl stimulated emission for Calcium II 5-level atom
      t3934(ipLnPopOpc) = Ca2pop(1)-Ca2pop(5)/2.
      t3934(ipLnPopu) = Ca2pop(5)
      t3934(ipLnPopl) = Ca2pop(1)
      t3969(ipLnPopOpc) = Ca2pop(1)-Ca2pop(4)
      t3969(ipLnPopu) = Ca2pop(4)
      t3969(ipLnPopl) = Ca2pop(1)
      tpcah(1) = t3969(1)
      t8498(ipLnPopOpc) = Ca2pop(2)-Ca2pop(5)
      t8498(ipLnPopu) = Ca2pop(5)
      t8498(ipLnPopl) = Ca2pop(2)
      t8542(ipLnPopOpc) = Ca2pop(3)-Ca2pop(5)*1.5
      t8542(ipLnPopu) = Ca2pop(5)
      t8542(ipLnPopl) = Ca2pop(3)
      t8662(ipLnPopOpc) = Ca2pop(2)-Ca2pop(4)*2.
      t8662(ipLnPopu) = Ca2pop(4)
      t8662(ipLnPopl) = Ca2pop(2)
      t7291(ipLnPopOpc) = xIonFracs(20,2)
      t7291(ipLnPopu) = 0.
      t7291(ipLnPopl) = xIonFracs(20,2)
      t7324(ipLnPopOpc) = xIonFracs(20,2)
      t7324(ipLnPopu) = 0.
      t7324(ipLnPopl) = xIonFracs(20,2)
*
*     Ca IV 3.2 micron; data from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     Y(ik) from 
*     >>refer Pelan, J., & Berrington, K.A. 1995, A&A Suppl, 110, 209
      if( te.le.1e5 ) then
        cs = max( 1.0 , 8.854e-3 *sqrte )
      else if( te.lt.2.512e5 ) then
        cs = 2.8
      else
        cs = 641.1 / (te30*te10*te02*te02/te003)
      endif
      call PutCS( cs , tCa3 )
      call level2( tCa3 )
*
*     [Ca V] IR 4.16, 11.47 micron; A from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     cs from 
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
*     >>chng 96 july 16, big changes in cs
      cs = max(2.2, min(3.3, 0.392 * te20/te005/te003))
      call PutCS( cs , tCa4 )
*     >>chng 96 aug 02, following had error in te dep in ver 90.01
      cs = max(0.67, min(0.93, 0.162 * te10*te05*te003*te001))
      call PutCS( cs , tCa12 )
      cs = max(0.60, min(0.97, 0.0894 * te20*te01*te005))
      call PutCS( cs , TauDummy )
      call level3(tCa4,tCa12,TauDummy)
*
*     Ca V lines from 1d, 1s; A from 
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     cs from 
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      cs01 = max(2.8, min(4.1, 0.533 * te20/te01))
      cs02 = min(0.87, 5.22e-03 * sqrte)
      p3 = pop3(9.,5.,1.,cs01 ,cs02 ,1.35,2.326,23.2,3.73,2.57e4,
     1 3.60e4,p2,xIonFracs(20,5) , 0. ) 
      c3997 = p3 * 3.73 * 4.98e-12
      c2414 = p3 * 23.1 * 8.245e-12
      Ca6087 = p2 * 0.426 * 3.268e-12
      c5311 = p2 * 1.90 * 3.747e-12
      call coladd( 'Ca 5' , 3997 , c3997  )
      call coladd( 'Ca 5' , 2414 , c2414  )
      call coladd( 'Ca 5' , 6087 , Ca6087  )
      call coladd( 'Ca 5' , 5311 , c5311  )
*
*     Ca VII lines from 1d, 1s
*     all cs from 
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      cs01 = max(3.5, min(4.4, 22.25 /(te20/te02/te02) ) )
      cs12 = max( 0.62,min( 1.20,0.303*te30*te03 ) )
      cs02 = max( 0.50,min( 0.959,7.889/(te20*te05/te01 ) ) )
      p3 = pop3(9.,5.,1.,cs01 ,cs02 ,cs12 ,3.124 ,30.4 ,6.81 ,2.91e4 ,
     1 3.90e4 ,p2 ,xIonFracs(20,7) , 0. ) 
      Ca3688 = p3 * 6.81 * 5.40e-12
      Ca2112 = p3 * 30.4 * 9.42e-12
      Ca5620 = p2 * 2.15 * 3.548e-12
      Ca4941 = p2 * 0.974* 4.037e-12
      call coladd( 'Ca 7' , 3688 , Ca3688  )
      call coladd( 'Ca 7' , 2112 , Ca2112  )
      call coladd( 'Ca 7' , 5620 , Ca5620  )
      call coladd( 'Ca 7' , 4941 , Ca4941  )
*
*     all cs from 
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
*     [Ca VII] 4.09, 6.15 mic 3P lines
      cs = max(3.702,min(5.354,0.406*te20*te03*te01 ) )
      call PutCS( cs , Ca0741 )
      cs = max(1.153,min(1.59,0.183*te20 ) )
      call PutCS( cs , Ca0761 )
      cs = max(1.005,min(1.497,0.0917*te20*te05*te01 ) )
      call PutCS( cs , TauDummy )
*     level3(  t10,t21,t20)
      call level3( Ca0761 , Ca0741 , TauDummy )
*
*     [Ca VIII]  2.32 microns, cs 
*     >>refer Saraph, H.E., & Storey, P.J. A&AS, 115, 151
      cs = min( 6.75 , 22.04/(te10*te02*te005) )
      call PutCS( cs , Ca08232 )
      call level2( Ca08232 )
*
*     [Ca 12] 3328.78A, cs from 
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      cs = max( 0.10, min(0.172,0.0118*te20*te01))
      call PutCS( cs , Ca12333 )
      call level2( Ca12333 )
*
*     Li seq 2s2p 2s3p, 2s2p as two separate lines
*     >>refer Cochrane, D.M., & McWhirter, R.W.P. 1983, PhyS, 28, 25
      call ligbar( 20 , tCa302, tCa19, cs2s2p , cs2s3p )
*
      call PutCS( cs2s2p , tCa302 )
      call level2( tCa302 )
*
*     funny factor (should have been 0.5) due to energy change
      call PutCS( cs2s2p*0.439 , tCa345 )
      call level2( tCa345 )
*
      call PutCS( cs2s3p , tCa19 )
      call level2( tCa19 )
*
      end
