******************************************************************************
      subroutine carbon
      implicit none
*compute ionization balance for carbon
      include "limelm.par"
      include "itrdim.par"
      include "heating.com"
      include "pmp2s.com"
      include "chrex.com"
      include "logte.com"
      include "shullc.com"
      include "timed.com"
      include "carbug.com"
      include "trace.com"
      include "elmton.com"
      include "TePowers.com"
      include "h.com"
      include "hvmolEXP.com"
      include "chargt.com"
      include "phycon.com"
      include "coatom.com"
      include "he.com"
      include "DoPhoto.com"
      include "PhotRate.com"
      include "DestCrt.com"
      include "ZoneCnt.com"
      include "IonFracs.com"
      include "RecomRate.com"
      include "IOqq.com"
*
*     local variables
      real OldPRate , OldRRate
      save OldPRate , OldRRate
      integer i 
      integer ndim
      parameter (ndim=7)
      integer nelem
      parameter (nelem=6)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),save,
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2) 
      integer nzUsed
      save nzUsed
*
*     carbon nelem=6
*
*     real CollidRate(nelem,2)
*
      data nzUsed/0/ , OldPRate/0./
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.44E-10,4.20E-11,1.92E-11,5.32E-12,2.87E-13,9.16E-14/
      data (cion(i,2),i=1,ndim-1)
     2 /1.31E5,2.83E5,5.56E5,7.48E5,4.55E6,5.68E6/
*
*     rec from +3, +4 from Arnaud et al Ast Ap Sup 60 425. (1985)
*     rec from fully ionized uses Seaton '79 in ionrat
      data rec , pl/
     1 1.47E-10 , 8.74E-10 , 7.98E-9 , 1.34E-8 , 1.30E-8 ,
     2  -0.624  , -0.645   , -0.803  , -0.791  , -0.721  /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/1.44e-10 , -0.621/
*
      data (dicoef(i,1),i=1,ndim-1)
     1/2.54E-3 , 6.15E-3 , 1.62E-3 , 4.78E-2 , 3.22E-2 , 0./
      data (dicoef(i,2),i=1,ndim-1)
     1/4.42E-2 , 5.88E-2 , 0.343 , 0.362 , 0.315,0./
      data (dite(i,1),i=1,ndim-1)
     2/1.57E+5 , 1.41E+5 , 8.19E+4 , 3.44E+6 , 4.06E+6 , 0./
      data (dite(i,2),i=1,ndim-1)
     2 /3.74E5 , 1.41E5 , 1.59E5 , 5.87E5 , 8.31E5,0./
      data ditcrt
     3/1.2E+4 , 1.2E+4 , 1.1E+4 , 4.4E+5 , 7.0E+5 , 1E20/
*
      data aa/  .0108  ,1.8267 ,2.3196  ,0. ,0. ,0./
     1  ,  bb/-0.1075  ,4.1012 ,10.7328 ,0. ,0. ,0./
     1,    cc/  .2810  ,4.8443 ,6.8830  ,0. ,0. ,0./
     2,    dd/-0.0193  ,.2261  ,-0.1824 ,0. ,0. ,0./
     3,    ff/ 0.000  ,0.5960 ,0.4101  ,0.1,0.1,0./
*     in above, ff(1) has been reset to 0 since NS fit diverges at very low t
*     better to use mean background diel
*
      if( lgTrace .and. lgCarBug ) write(qq,'(5x,''carbon called.'')')
*
      if( .not.lgElmtOn(6) ) then
        p1909 = 0.
        p2326 = 0.
        catmic = 0.
        heating(6,10) = 0.
        return
      endif
*
*     zero out ionization balance arrays
      call ionzer(nelem)
*
      call PhotoIonize(nelem )
*     call PrtGamma(ipCarbon(1,3,1) ,ipCarbon(1,3,2) ,
*    1 ipCarbon(1,3,3),
*    1 qq,  photorate(nelem,1,3,1) ,photorate(nelem,1,3,1)*0.05 )
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2 aa , bb , cc , dd , ff , nelem , tlow)
*
      if( nzone.gt.1 .and. OldPRate.gt.0. ) then
        if( nzone.ne.nzUsed .and. lgDoPhoto) then
*         damp out pdr oscillations
          PhotoRate(6,1,3,1) = (PhotoRate(6,1,3,1) + OldPRate)/2.
          OldPRate = PhotoRate(6,1,3,1)
          OldRRate = (RecombinRate(nelem,1) + OldRRate) / 2.
*     >>chng 96 may 15 only 1 eval per zone to stop Lyman ots oscil
          nzUsed = nzone
        else
          PhotoRate(6,1,3,1) = OldPRate
          RecombinRate(nelem,1) = OldRRate 
        endif
      else
        OldPRate = PhotoRate(nelem,1,3,1)
        OldRRate = RecombinRate(nelem,1)
      endif
*
*     Photoproduction of 3P
      p1909 = PhotoRate(6,2,2,1)
*
*     photoproduction of C II] 2326
      p2326 =  PhotoRate(6,1,2,1)
*
*     charge transfer
*     C+ + H0 => H+ + C0, rate from Butler and Dalgarno (1980A)
*     >>chng 96 Oct 1, all H ct moved to bidiag
*     CTHeavy(1,2) = CTHeavy(1,2) + HI*1.4E-17 
*     >>chng 96 Oct 1, all H ct moved to bidiag
*     CTHeavy(1,1) = CTHeavy(1,1) + HII*2.8E-20*TE 
*     write(6,*) 2.8e-20*te*hii , HCTIon(1,6)*hii
*     C+2 => C+ Butler Heil Dalgarno 1980
*     CTHeavy(2,2) = CTHeavy(2,2) + 1.2E-12 * HI 
*     C+3 => C+ Butler Heil Dalgarno 1980
*     CTHeavy(3,2) = CTHeavy(3,2) + 4.3E-10*TE10*TE10*TE03 * HI 
*     C+4 => C+3 Butler and Dalgarno 1980B
*     CTHeavy(4,2) = CTHeavy(4,2) + 7.6E-16 * MIN(TE32,1E7) * HI 
*     >>chng 96 aug 9, added following ct reaction
*     He+ + C => He + C+, Kimura et al, ApJ 417, 812, 1993.
      CTHeavy(1,1) = CTHeavy(1,1) + heii*4.17e-17*(te/te03)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
* 
*     this is atomic carbon abundance, removing CO
      catmic = xIonFracs(6,0) * max(1e-7,(1.-co/xIonFracs(6,0)))
*
*     solve for ionization balance
*     last var is option to print stuff
      save = xIonFracs(6,0)
*     must trick BiDiag into conserving C
      xIonFracs(6,0) = catmic
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
      xIonFracs(6,0) = save
*
*     rate will be cm-3 s-1, into triplets only
*     >>chng 96 nov 22, rid of carb()
      p1909 = p1909 * xIonFracs(6,2) * 0.62
      p2326 = p2326 * xIonFracs(6,1) * 0.15
*
*     charge exchange rates (s-1) for hydrogen
*     >>chng 96 nov 22, rid of carb()
      CTHionAgnt(1) = xIonFracs(6,2) * 1.4E-17
      CTHion(1) = CTHion(1) + CTHionAgnt(1)
      CTHrec(1) = CTHrec(1) + xIonFracs(6,1) * 2.18E-20 * te
*
      if( lgTrace ) then
        write(qq,'(5X,''CARBON returns; CO=,''1p,e10.3,'' fracs='',
     1  7e10.3)') co/xIonFracs(6,0),
     2  (xIonFracs(6,i)/xIonFracs(6,0),i=1,7)
      endif
*
      end
