******************************************************************************
      subroutine cobalt
      implicit none
*do ionization balance for cobalt
      include "limelm.par"
      include "elmton.com"
      include "TePowers.com"
      include "timed.com"
      include "phycon.com"
      include "h.com"
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=28)
      parameter (nelem=27)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2) 
*     real GRDEFF(27)
*
*     cobalt nelem=27
*
*     real CollidRate(nelem,2)
*
*     REAL yYIELD(25) , yYIELDL(17)
*     DATA yYIELD/25*0./ , yYIELDL/17*0./
*     rates for ni from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1  /6.38E-10,1.51E-10,5.43E-11,2.46E-11,1.00E-11,
     1 5.29E-11,2.67E-12,1.26E-12,4.66E-13,1.36E-12,9.44E-13,6.35E-13,
     2 3.80E-13,2.17E-13,5.74E-14,1.03E-13,3.88E-14,5.65E-14,4.02E-14,
     3 3.25E-14,2.65E-14,1.83E-14,1.15E-15,8.39E-15,3.84E-15,4.21E-16,
     4 1.91E-16/
      data (cion(i,2),i=1,ndim-1)
     1 /2.11E5,4.08E5,6.37E5,8.76E5,1.25E6,1.54E6,1.88E6,2.24E6,
     2 2.60E6,3.73E6,4.09E6,4.46E6,4.99E6,5.39E6,5.79E6,6.63E6,
     3 7.04E6,1.80E7,1.91E7,2.04E7,2.20E7,2.33E7,2.47E7,2.66E7,2.78E7,
     4 1.19E8,1.25E8/
*
*     DATA FYIELD/1*.34,2*.35,.36,2*.37,.38,.39,.40,.41,.42,.43,.44,
*    4.45,.46,2*.47,2*.48,2*.49, .11,.75,5*0./
*     above fluorescent yields quoted in Krolik+Kallman Ap.J.(Let) 320, L5.
*     they are correct for iron, not ni
*
*     GRDEFF is fraction of recombinations to ground state, used for
*     DATA GRDEFF/27*0.2/
*
*     all rates from Shull and Van Steenberg apj sup 48, 95. for Ni
*     assumed to have same cs per stage of ionization
      data rec/2.27e-10, 6.31e-10, 8.83e-10, 1.01e-09, 3.71e-09,
     1         4.84E-09, 1.09E-08, 2.48E-08, 9.68E-08, 1.72E-07,
     2         2.61E-07, 3.95E-07, 4.70E-07, 5.70E-07, 6.98E-07,
     3         8.32E-07, 9.76E-07, 1.19E-06, 1.16E-06, 1.14E-06,
     4         1.17E-06, 1.24E-06, 1.35E-06, 1.38E-06, 6.64E-07,
     5         4.67E-07/
      data pl/ -0.7, -0.7, -0.7, -0.7, -0.746, -0.682, -0.699, -0.728,
     1 -0.759, -0.79, -0.81, -0.829, -0.828, -0.834, -0.836, -0.84,
     2 -0.846, -0.85, -0.836, -0.824, -0.816, -0.811, -0.808, -0.8,
     3 -0.718, -0.677/
*
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.81e-10 , -0.681 /
*
      data (dicoef(i,1),i=1,ndim-1)
     1/ 5.2E-3  , 1.38E-3 , 2.3E-2  , 4.19E-2 , 6.83E-2
     2, 0.122   , 0.30    , 0.15    , 0.697   , 0.709   , 0.644
     3, 0.525   , 0.446   , 0.363   , 0.302   , 0.102   , 0.270
     4, 0.0467  , 0.0835  , 0.0996  , 0.199   , 0.240   , 0.115
     5, 0.0316   , 0.803  , 0.575   ,  0.  /
      data (dite(i,1),i=1,ndim-1)
     1/ 2.01E5  , 3.05E5  , 4.20E5  , 5.56E5  , 6.72E5
     2, 7.93E5  , 9.00E5  , 1.00E6  , 7.81E5  , 7.64E5  , 7.44E5
     3, 6.65E5  , 5.97E5  , 5.24E5  , 4.96E5  , 4.46E5  , 8.49E6
     4, 1.36E6  , 1.23E6  , 1.06E6  , 1.25E6  , 1.23E6  , 3.32E5
     5, 6.45E5  , 6.65E7 , 6.81E7 , 0./
      data ditcrt
     1/ 2E4     , 4E4     , 5E4     , 7E4     , 8E4
     2, 8E4     , 3E4     , 3E4     , 3E4     , 3E4     , 9E4
     3, 4E4     , 5E4     , 3E4     , 9E5     , 2E5     , 2E5
     4, 2E5     , 2E5     , 1E5     , 7E4     , 4E4     , 6E6
     5, 6E6     , 1E20    , 1E20 , 1E20 /
      data (dicoef(i,2),i=1,ndim-1)/nelem*0./
      data (dite(i,2),i=1,ndim-1)/nelem*0./
      data aa/27*0./,bb/27*0./,cc/27*0./,dd/27*0./,ff/27*0./
*
*     free statement numbers >= 7
*
*     cobalt, atomic number 27
      if( .not.lgElmtOn(27) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
