******************************************************************************
      subroutine codriv
      implicit none
*main driver for heavy molecular equilibrium routines
      include "itrdim.par"
      include "limelm.par"
      include "hvmolEXP.com"
      include "ZoneCnt.com"
      include "lotsco.com"
      include "comneg.com"
      include "colimt.com"
      include "IonFracs.com"
      include "IOqq.com"
*
*     local variables
      logical lgNegPop , lgZerPop 
      integer loop , lupmax 
      real ohold , coToler
*
      save loop , ohold
      parameter (coToler=0.10 , lupmax=10)
*
      ohold = oh
      call comole( lgNegPop , lgZerPop )
      call molav( 1 )
*     >>chng 97 july 29, turn on flag for too much CO here too, there were
*     models in which this test never took place since oh went zero
      if( oh.eq.0. ) then
        if( co/xIonFracs(6,0).gt.COLimit ) lgLotsCO = .true.
        return
      endif
      loop = 1
      do while((abs(ohold/oh-1.).gt.coToler .or. lgNegPop) .and.
     1 (loop.lt.lupmax) .and. (co/xIonFracs(6,0).lt.COLimit)  ) 
         call molav(2)
         ohold = oh
         call comole( lgNegPop , lgZerPop )
         if( oh.eq.0. ) return
         loop = loop + 1
      end do
*
      if( co/xIonFracs(6,0).gt.COLimit ) then
        lgLotsCO = .true.
      else if( lgNegPop ) then
        lgLotsCO = .true.
        write(qq,'('' CODRIV failed to converge, zone='',I4,
     1  '', CO/C='',1P,E10.2,'' negpop?'',L1)')nzone,
     2  co/xIonFracs(6,0),lgNegPop
        lgNegPop = .false.
      else if( loop.eq.lupmax ) then
        write(qq,'('' CODRIV failed to converge, zone='',I4,
     1  '', CO/C='',1P,E10.2,'' negpop?'',L1)')nzone,
     2  co/xIonFracs(6,0),lgNegPop
      endif
*
      if( lgNegPop ) lgComNeg = .true.
*
      end
