******************************************************************************
      subroutine CollidIonize( nelem , cion )
      implicit none
*fill in collisional ionization rates, and resulting cooling
      integer nelem
      real cion(nelem,2)
      include "ncell.par"
      include "limelm.par"
      include "bltzman.par"
      include "rfield.com"
      include "shullc.com"
      include "phycon.com"
      include "TePowers.com"
      include "IonRange.com"
      include "CollIonRate.com"
      include "IOqq.com"
*
*     local variables
      integer i
      logical lgInsane
      real crate , DimaRate
*
*     compute collisional ionization rate
*
*     CollidRate(nelem,ion , 1) is collisional ionization rate, s-1
*     CollidRate(nelem,ion , 2) is collisional ionization cooling, erg/s
*
      do i=1,IonLow(nelem)-1
        CollidRate(nelem,i,1) = 0.
        CollidRate(nelem,i,2) = 0.
      end do
*
      do i=IonLow(nelem),IonHigh(nelem)-1
*       real sexp
*       collisional ionization by thermal electrons
*       crate = cion(i,1)/(1.+0.1*te/cion(i,2)) * sqrte * eden*
*    1  sexp(cion(i,2)/te)
*       call Dima's master set of fits
*       call colfit( nelem , nelem-i+1,0,te,DimaRate )
*     >>chng 97 mar 19, to Dima's new routine using Voronov '97, ADNDT 65, 1
*error 666 this returns 0 for nelem=29, 30
        call cfit( nelem , nelem-i+1,te,DimaRate )
        crate = DimaRate * eden
*       write(6,'(2i3,1p,2e10.2)') nelem,i,DimaRate,csupra
        CollidRate(nelem,i,1) = crate + csupra
*       cooling due to collisional ionization
        CollidRate(nelem,i,2) = crate * cion(i,2)*Boltzmann
      end do
*
      do i=IonHigh(nelem),nelem
        CollidRate(nelem,i,1) = 0.
        CollidRate(nelem,i,2) = 0.
      end do
*
*begin sanity check
      lgInsane = .false.
      do i=1,nelem
*       there can be no negative rates
        if( CollidRate(nelem,i,1).lt.0. ) then
          write(qq,'('' CollidIonize finds insane coll ionize rate'',
     1    1p,e10.2,'' nelem, ion='',2i3,'' csupra='',e10.2,'' te='',
     2    e12.4)') CollidRate(nelem,i,1),nelem,i,csupra,te
          lgInsane = .true.
        endif
      end do
      if( lgInsane ) then
        write(qq,'('' Insanity has occurred.'')')
        call ShowMe
        stop
      endif
*end sanity check
*
      end
