******************************************************************************
      real function ColStrGBar(tarray)
      implicit none
*generate g-bar collision strengths for level 2 line2
      include "nta.par"
      real tarray(nta)
      include "ipLnArry.par"
      include "MeweCoef.com"
      include "phycon.com"
      include "TePowers.com"
      include "IOqq.com"
*
* Calculation of the collision strengths of multiplets.
* Neutrals are recalculated from Fisher et al. (1996)
* Gaetz & Salpeter (1983, ApJS 52, 155) and Mewe (1972, A&A 20, 215) fits 
* for ions.
*
*     local variables
      double precision xx,yy
      real y, e1, sexp, gb, a, b, c, d, x, ttype
      integer i, j
*
*     which type of transition is this?
      ttype = tarray(ipLnCS1)
      if(ttype.lt.0.05) then
         write(qq,'('' ColStrGBar called with insane ipLnCS1'')')
         stop
      endif
*     excitation energy over kT
      y = tarray(ipLnBolt)/te
      if(ttype.lt.1.5)then
         xx=-log10(y)
         if(ttype.lt.0.5)then
            yy=(1.398813573838321+xx*(0.02943050869177121+
     1xx*(-0.4439783893114510+xx*(0.2316073358577902+
     1xx*(0.001870493481643103+xx*(-0.008227246351067403))))))/
     1(1.0+xx*(-0.6064792600526370+xx*(0.1958559534507252+
     1xx*(-0.02110452007196644+xx*(0.01348743933722316+
     1xx*(-0.0001944731334371711))))))
         else
            yy=(1.359675968512206+xx*(0.04636500015069853+
     1xx*(-0.4491620298246676+xx*(0.2498199231048967+
     1xx*(0.005053803073345794+xx*(-0.01015647880244268))))))/
     1(1.0+xx*(-0.5904799485819767+xx*(0.1877833737815317+
     1xx*(-0.01536634911179847+xx*(0.01530712091180953+
     1xx*(-0.0001909176790831023))))))
         endif
         ColStrGBar = 10**yy*tarray(ipLnGF)/(tarray(ipLnRyd)*13.6)
      else
         i = ttype
*
         if(i.lt.26)then
            e1 = log(1.0+1.0/y)-0.4/(y+1.0)**2
            a=g(1,i)
            b=g(2,i)
            c=g(3,i)
            d=g(4,i)
            x=tarray(ipLnNelem)-3.0
            if(i.eq.14)then
               a=a*(1.0-0.5/x)
               b=1.0-0.8/x
               c=c*(1.0-1.0/x)
            else if(i.eq.16)then
               a=a*(1.0-0.9/x)
               b=b*(1.0-1.7/x)
               c=c*(1.0-2.1/x)
            else if(i.eq.18)then
               a=a*(1.0+2.0/x)
               b=b*(1.0-0.7/x)
            endif
            gb=a+(b*y-c*y*y+d)*e1+c*y
*        ipLnRyd is exciation energy in Rydbergs
            ColStrGBar = 14.510395*tarray(ipLnGF)*gb/tarray(ipLnRyd)
*     following i>=26
         else
            if(i.lt.999)then
               j=int(g(4,i))
               if(j.eq.1)then
                  ColStrGBar=tarray(ipLnGl)*g(1,i)*
     &                 (te/10**g(3,i))**g(2,i)        
               else
                  ColStrGBar = tarray(ipLnGl)*g(1,i)*
     1                 sexp(g(2,i)*(10**g(3,i)/te))
               endif
            else
c This is for AlII 1670 line only!
*              ColStrGBar=0.0125*te**0.603
               ColStrGBar=0.0125*sqrte*te10*te003
            endif
         endif
      endif
*
*
*     following to make sure that negative values not returned
      ColStrGBar = max( ColStrGBar , 1e-10 )
*
      end
