******************************************************************************
      subroutine compil(chCard)
      implicit none
*compile werner or kurucz model atmospheres into cloudy format, by K Volk
      character chCard*80
      include "StarBad.com"
      include "IOqq.com"
*
*     local variables
      logical lgMatch
*
*     original version of this sub written by Kevin Volk
*
* this subroutine is intended to convert a sequential version of the klaus 
* werner or kurucz model values (assumed to come with the program) into a 
* direct access version for faster access.  the original file is assumed to 
* be named in *.ASC, and the new direct access file is assumed to be named
* in *.MOD.  if either cannot be openned the subroutine exits.
*
* ierr is returned as 1 if an error is encountered in this process.  the new
* input file is left open for the program to use.
*
*     possible we only want to copy over the Rauch atmospheres
      if( lgMatch('RAUC',chCard ).and. lgMatch('INIT',chCard ) ) then
        call ConcatRauch
        stop
      endif
*
*     generate frequency array
      lgStarBad = .false.
      call SetPoint

	if( lgMatch('ONLY',chCard ) ) then
	  if( lgMatch('WERN' , chCard ) ) then
*         do werner hot stars - do first since fast
          call GetWerner
	  else if( lgMatch('RAUC' , chCard ) ) then
*         do the rauch hot stars
          call GetRauch
	  else if( lgMatch('ATLA' , chCard ) ) then
*         do all work with atlas
          call GetAtlas
	  endif
	else
*       do werner hot stars - do first since fast
        call GetWerner
*       do all work with atlas
        call GetAtlas
*       do the rauch hot stars
        call GetRauch
	endif
*
      if( lgStarBad ) then
        write(qq,'('' '')')
        write(qq,'(5(''WARNING!!''))')
        write(qq,'(''Something has gone wrong with the compilation.'')')
        write(qq,'(''Errors have gone to the file problems.out'')')
        write(qq,'('' '')')
        write(qq,'(''The compilation was not successful.'')')
        write(qq,'(5(''WARNING!!''))')
        close(66)
      else
        write(qq,'('' '')')
        write(qq,'('' The compilation was successful!'')')
        write(qq,'('' The portable files kurucz.ascii, kurucz.list, '',
     1  ''rauch.ascii, and werner.ascii are no longer needed and '',
     1  ''may be deleted to save space.'')')
        write(qq,'('' Do not forget to set the path when running in '',
     1  ''other directories.'')')
        write(qq,'('' '')')
        write(qq,'('' Good Luck!!'')')
        write(qq,'('' '')')
        write(qq,'('' '')')
      endif
      stop
      end
