******************************************************************************
      subroutine compos( chCard , lgDSet )
      implicit none
*parse and read in composition as set by abundances command
      character chCard*80
      logical lgDSet
*
      include "limelm.par"
      include "ndust.par"
      include "ipSolar.com"
      include "solar.com"
      include "solars.com"
      include "dstfac.com"
      include "called.com"
      include "IOqq.com"
      include "elmton.com"
      include "ElmntSym.com"
*
*     local variables
      logical lgEOL , lgMatch , lgLog , lgEOF
      real absav(limelm)
      integer i , j , nd
      real fread  , chk
*
*     free statement labels, >=25
      j = 5
      absav(1) = fread( chCard , j , 76 , lgEOL )
*     check whether it scanned off end of line on first try
*     >>chng 97 june 8, get rid of go to
*     if( lgEOL ) go to10
      if( .not.lgEOL ) then
        absav(2) = fread( chCard , j , 76 , lgEOL )
        if( lgEOL .and.lgMatch(' ALL',chCard)) then
*         special option, all abundances will be this number
          if( absav(1).le.0. ) then
            absav(1) = 10. ** absav(1)
          endif
          do i=2,limelm
            solar(i) = absav(1)
          end do
          return
*     >>chng 97 june 8, get rid of go to
*        else if( lgEOL ) then
*         only one number, but not key ' all', so go to special sets
*          go to10
        endif
*
*     >>chng 95 july 14, get rid of go to's
        if( .not. lgEOL ) then
*         do this is there was a second number
          do i=3,npSolar
            absav(i) = fread( chCard , j , 76 , lgEOL )
            if( lgEOL ) then
*             read CONTINUE line if J scanned off end before reading all abund
              call readar( chCard , lgEOF )
              if( lgEOF ) then
                write(qq,'('' There MUST be'',I3,'' abundances entered''
     1          ,'', there were only'',I3,''.  Sorry.'')') npSolar, i-1
                stop
              endif
*             option to ignore all lines starting with #, *, or %.
              do while ( chCard(1:1).eq.'#' .or. chCard(1:1).eq.'*' .or.
     1        chCard(1:1).eq.'%')
                if( lgEOF ) then
                  write(qq,'('' There MUST be'',I3,'' abundances ''
     1            ,''entered, there were only'',I3,''.  Sorry.'')') 
     1            npSolar, i-1
                  stop
                endif
                call readar( chCard , lgEOF )
              end do
*
              if(lgTalk) write(qq,'(23X,''*'',1X,A80,''*'')') chCard
              call caps( chCard )
              if( chCard(1:4).ne.'CONT' ) then 
                write(qq,'('' There MUST be'',I3,'' abundances entered''
     1          ,'', there were only'',I3,''.  Sorry.'')') npSolar, i-1
                stop
              else
                j = 1
                absav(i) = fread( chCard , j , 76 , lgEOL )
                if( lgEOF ) then
                  write(qq,'('' There MUST be'',I3,'' abundances ''
     1            ,''entered, there were only'',I3,''.  Sorry.'')') 
     2            npSolar, i-1
                  stop
                endif
              endif
            endif
          end do
*
*         fell through to here after reading in abundances
*         check that there are no more - could mean typo further upstream
          chk = fread( chCard , j , 76 , lgEOL )
          if(.not.lgEOL ) then
*           got another number, not lgEOL, so too many numbers
            write(qq,'('' There were more than '',I3,'' abundances '',
     1      ''entered'')') npSolar
            write(qq,'('' Could there have been a typo somewhere?'')')
          endif
*
*         are numbers scale factors, or log of abund rel to H??
          lgLog = .false.
          do i=1,npSolar
            if( absav(i).lt.0. ) lgLog = .true.
          end do
          if( lgLog ) then
*           entered as log of number rel to hydrogen
            do i=1,npSolar
              solar(ipSolar(i)) = 10.**absav(i)
            end do
          else
*           scale factors relative to solar
            do i=1,npSolar
              solar(ipSolar(i)) = solar(ipSolar(i)) * absav(i)
            end do
          endif
*
*         check whether the abundances are reasonable
          if( solar(2).gt.0.2 ) write(qq,'('' Is an abundance of'',1P,
     1    E10.3,'' for '',A2,'' reasonable?'')') solar(2),
     2    chElementSym(2)
          do i=3,limelm
            if( solar(i).gt.0.1 ) write(qq,'('' Is an abundance of'',1P,
     1      E10.3,'' for '',A2,'' reasonable?'')') solar(i),
     1      chElementSym(i)
          end do
          return
        endif
      endif
*
*     no numbers on line if it got this far
* 10   continue
*
*     enter std abundances for various objects
      if( lgMatch('PLAN',chCard) ) then
*       planetary nebular abundances
        if( .not.lgMatch('O GR',chCard) ) then
*         turn on grains if not already done
          if( .not.lgDSet ) then
            lgDustOn = .true.
            do nd=1,ndust
              dstfactor(nd) = 1.
*     >>chng 96 nov 29, loop setting false, followed by two set true
              lgDustOn1(nd) = .false.
            end do
            lgDustOn1(1) = .true.
            lgDustOn1(7) = .true.
          endif
        endif
        do i=1,limelm
          solar(i) = apn(i)
        end do
*
      else if( lgMatch('HII ',chCard).or.lgMatch('H II',chCard) 
     1 .or.lgMatch('ORIO',chCard) ) then
*       H II region abundances
        if( .not.lgMatch('O GR',chCard) ) then
*         option to turn on grains
          if( .not.lgDSet ) then
            lgDustOn = .true.
            do nd=1,ndust
              dstfactor(nd) = 1.
*     >>chng 96 nov 29, loop setting false, followed by two set true
              lgDustOn1(nd) = .false.
            end do
*           orion grains
            lgDustOn1(3) = .true.
            lgDustOn1(4) = .true.
          endif
        endif
        do i=1,limelm
          solar(i) = ahii(i)
        end do
*
      else if( lgMatch('ISM ',chCard).or.lgMatch(' ISM',chCard) ) then
*       ISM abundances from Cowie and Songaila Ann Rev '86
        if( .not.lgMatch('O GR',chCard) ) then
          if( .not.lgDSet ) then
            lgDustOn = .true.
            do nd=1,ndust
              dstfactor(nd) = 1.
              lgDustOn1(nd) = .false.
*     >>chng 96 nov 29, loop setting false, followed by two set true
            end do
*           ism grains
            lgDustOn1(1) = .true.
            lgDustOn1(2) = .true.
          endif
        endif
        do i=1,limelm
          solar(i) = aism(i)
        end do
*
      else if( lgMatch('NOVA',chCard) ) then
*       Nova Cyg abundances
        do i=1,limelm
          solar(i) = anova(i)
        end do
*
      else if( lgMatch('STAR',chCard) ) then
*       Fred Hamonn's starburst galaxy mixture
        call strbst( chCard )
*
      else if( lgMatch('PRIM',chCard) ) then
*       roughly primordial abundances: He/H=.072
        do i=1,limelm
          solar(i) = aprim(i)
        end do
*       now turn off the heavy elements
        do i=5,limelm
          lgElmtOn(i) = .false.
        end do
*
      else if( lgMatch('CAME',chCard) ) then
*       mix from Cameron 1982, "Essays on Nuclear Astrophysics"
        do i=1,limelm
          solar(i) = camern(i)
        end do
*
      else
        write(qq,'('' ABUND must have PLAN, H II, CAMERON, NOVA, NLR,''
     1  ,'' ALL, STARBURST or PRIMORDIAL.  Sorry.'')')
        stop
      endif
*
      end
