****************************************************************
      subroutine ConvFe2
      implicit none
*generate needed opacity data for Katya's FeII atom
      include "nta.par"
      include "limelm.par"
      include "ipLnArry.par"
      include "nFe2LevN.par"
      include "Fe2LevN.com"
      include "KatyaDat.com"
      include "FeIIAtom.com"
      include "IOqq.com"
*
*     local variables
      integer ihi , low
      real glow, gup, a , energy , cs1
      logical lgFirst
      save lgFirst
*
      data lgFirst/.true./
*
*     this routine is called only one time when cloudy is init
*     for the very first time.  It converts the fe2 data stored
*     in Katya's arrays into the array storage needed by cloudy
*     for its line optical depth arrays
*
*     NB NB NB NB NB - this routine MUST be called first since
*     it checks whether Katya's data has been linked in
*
      if( nFe2LevN.le.1 ) then
*       this forces Katya's Fe2 atom off - data not linked in
        lgKatyaData = .false.
        return
      else
        lgKatyaData = .true.
      endif
*
*     only do this one time
      if( .not.lgFirst .and. chFeIIAtom.ne.'Verner' ) then
        return
      endif
      lgFirst = .false.
*
*     convert Katya's line arrays into standard heavy el ar
      do low=1,nFe2LevN-1
        do ihi=low+1,nFe2LevN
*         pull information out of existing data arrays
            glow = Fe2LevN( 1,ihi,low )
            gup = Fe2LevN( 2,ihi,low )
               a = Fe2LevN( 3,ihi,low )
          energy = Fe2LevN( 4,ihi,low )
          cs1 = Fe2LevN( 5,ihi,low )
*begin sanity check
          if( energy.le.0. ) then
            write(qq,'('' ConvFeWnd: insane energy for Fe2LevN.'')')
            stop
          endif
*end sanity check
*         now put into standard internal line format
          Fe2LevN(ipLnAul,ihi,low) = a
          Fe2LevN(ipLnWlAng,ihi,low) = 1.e8/energy
          Fe2LevN(ipLnGl,ihi,low) = glow
          Fe2LevN(ipLnGu,ihi,low) = gup
*         generate gf from A
          Fe2LevN(ipLnGF,ihi,low) = a*gup*1.4992e-8*(1e4/energy)**2
          Fe2LevN(ipLnEnrWN,ihi,low) = energy
          Fe2LevN(ipLnIonStg,ihi,low) = 2.
          Fe2LevN(ipLnNelem,ihi,low) = 26.
          Fe2LevN(ipLnRedis,ihi,low) = 1.
          Fe2LevN(ipLnCS1,ihi,low) = cs1
        end do
      end do
*
      end
