****************************************************************
      subroutine ConvWind
      implicit none
*convert level 2 line parameters and pointers into internal form used by code
      include "nta.par"
      include "limelm.par"
      include "ipLnArry.par"
      include "nwindline.par"
      include "WindData.com"
      include "WindEtc.com"
      include "IOqq.com"
*
*     local variables
      integer i 
      real glow, gup, energy , gf,zed,xion, xMewe
      character chIonLbl*4
      logical lgFirst
      save lgFirst
*
*     this routine takes the line parameters in the wind block data and sorts
*     them into what is needed for the actual line optical depth arrays
*
      data lgFirst/.true./
*
*     only do this one time
      if( .not.lgFirst ) return
      lgFirst = .false.
*
*     these are the massive set of op lines, with g-bar approx cs
*
*begin sanity check
*     confirm that block data linked in
      if( WindLine(1,1).eq.0. ) then
        write(qq,'('' The block data blckwind does not appear to '',
     1  ''have been linked in.  Was it compiled and linked ok?'')')
        call insane
        stop
      endif
*end sanity check
*
      do i=1,NWINDLINE
*       pull information out of existing data arrays
           zed = WindLine( 1,i)
          xion = WindLine( 2,i)
          glow = WindLine( 3,i)
           gup = WindLine( 4,i)
*          this is gf if positive, A if negative
            gf = WindLine( 5,i)
        energy = WindLine( 6,i)
*       following two in WindEtc common, used in level2
        ipWindIon(i) = xion + 0.0001
        ipWindNelem(i) = zed + 0.0001
        if(gf.lt.0. ) then
*         convert A (=-gf) into real gf
          gf = -gf * gup * 1.499e-8 *(1e4/energy)**2
        endif
        xMewe = WindLine( 7,i)
*begin sanity check
*       negative zed indicated line is to be ignored
        if( zed.eq.0.or. zed.gt.limelm ) then
          write(qq,'('' ConvWind: insane nelem for WindLine.  zed='',
     1    f5.1)') zed
          write(qq,'('' ConvWind: line number is'',i4)') i
          stop
        endif
        if( energy.le.0. ) then
          write(qq,'('' ConvWind: insane energy for WindLine. energy=''
     1    ,1p,e10.2)') energy
          stop
        endif
*       WindLine now has 0.1 for neutral, so foat non-zero but int zero
        if( xMewe.le.0  ) then
          write(qq,'('' ConvWind: insane xMewe type for WindLine.'')')
          stop
        endif
*end sanity check
*       now put into standard format
        WindLine(ipLnWlAng,i) = 1.e8/energy
        WindLine(ipLnGl,i) = glow
        WindLine(ipLnGu,i) = gup
        WindLine(ipLnGF,i) = gf
        WindLine(ipLnPopl,i) = 0.
        WindLine(ipLnPopu,i) = 0.
        WindLine(ipLnEnrWN,i) = energy
        WindLine(ipLnIonStg,i) = xion
        WindLine(ipLnNelem,i) = zed
        WindLine(ipLnRedis,i) = 1.
        WindLine(ipLnCS1,i) = xMewe
*       this will be used by level2
        chWinLab(i) = chIonLbl( WindLine(1,i) )
      end do
      do i=1,NWINDLINE
        if( WindLine(ipLnNelem,i).le.0. .or.
     1    WindLine(ipLnIonStg,i).le.0. ) then
*         >>chng 97 aug 30, this is not used any more
          write(qq,'('' level 2 lines have non-positive ipLnNelem'')')
          stop
*         totally kill of any lines with negative nelem
*         WindLine(ipLnPopl,i) = 0.
*         WindLine(ipLnPopu,i) = 0.
*         WindLine(ipLnPopOpc,i) = 0.
*         WindLine(ipLnInten,i) = 0.
*         WindLine(ipLnCool,i) = 0.
*         WindLine(ipLnNPhots,i) = 0.
*         WindLine(ipLnOTS,i) = 0.
*         WindLine(ipLnAovTOT,i) = 0.
*         WindLine(ipLnColovTOT,i) = 0.
*         WindLine(ipLnHeat,i) = 0.
        endif
      end do
*
      end
