******************************************************************************
      subroutine coronl( chCard , nqh , ar1 )
      implicit none
*parse parameters off coronal equilibrium command
      integer nqh
      real ar1
      character chCard*80
*
      include "limspc.par"
      include "spec.com"
      include "sptype.com"
      include "forcte.com"
      include "sdrmin.com"
      include "tseton.com"
      include "itrdim.par"
      include "ZoneCnt.com"
      include "tauend.com"
      include "radius.com"
      include "spnorm.com"
      include "rdfalt.com"
      include "IOqq.com"
*     include "zonset.com"
*
*     local variables
      logical lgEOL , lgMatch
      integer i
      real a , fread
*
*     coronal equilibrium; set constant temperature to number on line
      lgTSetOn = .true.
      i = 5
      a = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
        write(qq,'('' There should be a temperature on this line.'')')
        stop
      endif
*
*     numbers less than or equal to 10 are the log of the temperature
      if( a.le.10. .and. .not.lgMatch('LINE',chCard) ) then
        ForceTemp = 10.**a
      else
        ForceTemp = a
      endif
      if( ForceTemp.lt.3. ) then
        write(qq,'('' TE<3K, reset to 3K.'')')
        ForceTemp = 3.
      endif
*
*     now simulate a BREMS line
      nspec = nspec + 1
      if( nspec.gt.limspc )then
*       too many continua were entered
        write(qq,'('' Too many continua entered; increase LIMSPC'')')
        stop
      endif
      chSpType(nspec) = 'BREMS'
      slope(nspec) = 1e8
      cutoff(nspec,1) = 0.
      cutoff(nspec,2) = 0.
*     simulate an ionization parameter line
      nqh = nqh + 1
      if( nqh.gt.limspc )then
*       too many continua were entered
        write(qq,'('' Too many continua entered; increase LIMSPC'')')
        stop
      endif
      chRSpec(nqh) = 'SQCM'
      chSpNorm(nqh) = 'IONI'
*     >>chng 96 June 17, to stop mole network from crashing
      totpow(nqh) = -10.
*     set R to large value if U specified but R is not
      if( radius.eq.0. ) then
         ar1 = rdfalt
         radius = 10.** ar1
      endif
*
      end
