**************************************************************************
      subroutine dcolid( dcheat , dccool , nd )
      implicit none
*compute grains collisional heating cooling
      real dcheat , dccool
      integer nd
*
      include "ndust.par"
      include "limcrs.par"
      include "en1ryd.par"
      include "bltzman.par"
*     include "dareff.com"
      include "TePowers.com"
      include "evryd.par"
      include "GrainPot.com"
      include "tedust.com"
      include "phycon.com"
      include "h.com"
      include "limelm.par"
      include "DoppVel.com"
      include "dstfac.com"
      include "dust.com"
      include "IonFracs.com"
*
*     local variables
      integer ion
      real vnz(4)
      integer nelem , i
      real heat , cool , psi , z , xi , eta , sexp
*
*     this subroutine evaluates the gas heating-cooling rate
*     (erg cm^-3 s^-1) due to grain gas collisions.
*     the net effect can be positive or negative,
*     depending on whether the grains or gas are hotter
*
*     this array is set of charges striking the grain surface
*     vnz(1) are neutrals, vnz(2) are single ions, etc
*     each population is weighted by the PROJECTED velocity
*
      do ion=1,4
        vnz(ion) = 0.
        do nelem=1,limelm
          vnz(ion) = vnz(ion) + xIonFracs(nelem,ion)*doppler(nelem)
        end do
      end do
*
*     following loop sums up collisions between these nuclei
*     electrons are done later
*     HEAT will be rate collisions heat the grain
*     COOL will be rate collisions cool the gas
      heat = 0.
      cool = 0.
      do i=1,4
         z = i - 1.
         psi = z * dstpot(nd)*evryd / (8.617e-5*te)
         if( psi.le.0. ) then
            eta = 1. - psi
            xi = 1. - psi/2.
         else
            eta = sexp(psi)
            xi = (1.+psi/2.) * eta
         endif
*        factor of two makes VNZ(I) arrival rate, not projected velocity
         heat = heat + vnz(i)*2.* Boltzmann* 
     1   ( 2.*te*xi - eta*(
     3   z *dstpot(nd)*evryd*1.6022e-12 -
     4   z*z *en1ryd + 2.*tedust(nd) ) )
*
*        rate kinetic energy lost from gas - gas cooling
         cool = cool + vnz(i)*2.* Boltzmann*
     1    ( 2.*te*xi - eta*2.*tedust(nd) )
      end do
*
*     heating due to electrons
      z = - 1.
      psi = z * dstpot(nd)*evryd / (8.617e-5*te)
      if( psi.le.0. ) then
         eta = 1. - psi
         xi = 1. - psi/2.
      else
         eta = sexp(psi)
         xi = (1.+psi/2.) * eta
      endif
*     electron arrival rate
      vnz(1) = sqrte * 6.2124e5 * eden
      heat = heat + vnz(1)* 2.*1.38062e-16*te*xi
*     heat = heat + vnz(1)* ( 2.*1.38062e-16*te*xi -
*    1eta*z *dstpot(nd)*evryd*1.6022e-12 )
*
      cool = cool + vnz(1)* 2.*1.38062e-16*te*xi
*
      dcheat = heat * ( hden*darea(nd)*dstAbund(nd)/4. )
*     cooling is per projected area
      dccool = cool * ( hden*darea(nd)*dstAbund(nd)/4. )
*
      end
