******************************************************************************
      subroutine driver( chCard )
      implicit none
*parse the drive command - drive calls to various subs
      character chCard*80
      include "nta.par"
      include "PltTrace.com"
      include "moldrv.com"
      include "limelm.par"
      include "solar.com"
      include "TauDmmy.com"
      include "IOqq.com"
*
      real fread
      logical lgEOL , lgMatch
*
*     local variables
      integer i , ierror
      real zed , fac , conpmp
*
*     option to drive cloudy, which one?
      if( lgMatch( 'FREA' , chCard ) ) then
        ierror = 0
        write(qq,'('' FREAD driver entered.  Enter number.'')')
        do while( ierror.eq.0 )
          read(5,'(a80)',iostat=ierror ) chCard
*         drive function FREAD
          if( ierror.eq.0 ) then
            i = 1
            fac = fread( chCard , i , 76 , lgEOL )
            if( lgEOL ) then
              write(qq,'('' FREAD hit the EOL with no value, return='',
     1        1P,e10.2)')fac
              ierror = 1
            else
              write(qq,'('' FREAD returned with value'',1P,E11.4)') fac
            endif
            write(qq,'('' Enter 0 to stop, or another value.'')')
          endif
        end do
        write(qq,'('' FREAD driver exits.'')')
*
      else if( lgMatch( 'ESCA' , chCard ) ) then
*        option to drive escape probability routines
         call descap( chCard )
*
      else if( lgMatch( 'HYAS' , chCard ) ) then
*        option to drive Jason's hydrogen transition probabilities
         call DrvHyas( chCard )
*
      else if( lgMatch( 'GAUN' , chCard ) ) then
*        drive gaunt factor routine
         call dgaunt( chCard )
*
      else if( lgMatch( 'POIN' , chCard ) ) then
*        later on, check cell pointers, centers, widths
         write(qq,'('' Define entire model first, later I will ask '',
     1   ''for energies.'')')
         lgPtrace = .true.
*
      else if( lgMatch( 'MOLE' , chCard ) ) then
*        option to test molecule subroutine
         write(qq,'('' Define entire model first, later I will ask '',
     1   ''for molecule abundances.'')')
         lgDriveMole = .true.
*
      else if( lgMatch( 'PUMP' , chCard ) ) then
        ierror = 0
        write(qq,'('' Continuum pump driver entered - Enter log tau'')')
        do while( ierror.eq.0 )
          read(5,'(a80)',iostat=ierror ) chCard
*         get tau
          if( ierror.eq.0 ) then
            i = 1
            fac = fread( chCard , i , 76 , lgEOL )
            if(lgEOL) ierror = 1
            fac = 10.** fac
            write(qq,'('' Tau ='',1P,E11.4)') fac
            TauDummy(1) = fac
            fac = conpmp( TauDummy )
            write(qq,'('' conpmp ='',1P,E11.4)') fac
            write(qq,'('' Enter null to stop, or another value.'')')
          endif
        end do
        write(qq,'('' ConPmp driver exits.'')')
*
      else if( lgMatch( 'STAR' , chCard ) ) then
*        get starburst abundances
         do i=1,40
           zed = float(i) / 4. + 0.01
           write(chCard,'(''starburst, zed='',f10.4)') zed
           call strbst(chCard)
           write(qq,'(1p,31e8.1)') zed,solar
         end do
      else
        write(qq,'('' Unrecognized key; keys are FREAD, GAUNT, '',
     1  ''HYAS, POINT, MOLE, STAR, and ESCApe.  Sorry.'')')
        stop
      endif
*
      end
