********************************************************************
      subroutine dtempr
      implicit none
*compute grains temperature, heating
      include "ndems.par"
      include "limcrs.par"
      include "ndust.par"
      include "en1ryd.par"
      include "ncell.par"
      include "nhlvl.par"
      include "itrdim.par"
      include "limelm.par"
      include "nqgrid.par"
      include "GrainPot.com"
      include "heat.com"
      include "dnu.com"
      include "yn.com"
      include "trace.com"
      include "dstbug.com"
      include "ZoneCnt.com"
      include "tgrmax.com"
      include "tedust.com"
      include "dust.com"
      include "TePowers.com"
      include "ipdpot.com"
      include "rfield.com"
      include "ots.com"
      include "yhat.com"
      include "dstop.com"
      include "dustems.com"
      include "dhla.com"
      include "iphl.com"
      include "heating.com"
      include "dheton.com"
      include "dustheat.com"
      include "phycon.com"
      include "dclgas.com"
      include "tcool.com"
      include "dstfac.com"
      include "SummdCon.com"
*     >>chng 96 nov 30, add quantum heating from Kevin Volk
      include "qheat.com"
      include "qheat2.com"
      include "IOqq.com"
*
*     local variables
      integer nd , i
      real hcon , hots,dtherm,phi,hla,dcheat,dccool,x,y,sum1
      real eyhat(ncell,ndust) , ted1, qtmax0, tqhout
*
      DustCoolGas = 0.
      do nd=1,ndust
         if( lgDustOn1(nd) ) then
*        find heating
*        add on fractional bit
         hcon = 0.
         hots = 0.
*        integrate over incident continuum for non-ionizing energies
         do i=1,ipdpot(nd)-1
*          direct heating by incident continuum
           hcon = hcon + flux(i) * anu(i) * dstab1(i,nd)
           hots = hots + SummedDif(i) * anu(i) * dstab1(i,nd)
         end do
*        hcon is radiative heating by NON-ionizing radiation
         hcon = hcon * en1ryd * hden * dstAbund(nd)
         hots = hots * dstAbund(nd)
*
*        integrate over ionizing continuum; energy goes to dust and gas
*        dheat is what heats the gas
         dheat(nd) = 0.
*        dtherm is part of h.nu-IP which heats dust before ejection
         dtherm = 0.
         do i=ipdpot(nd) ,nflux
           eyhat(i,nd) = 0.5 * yn(i,nd) * min( DustPhotoE(i,nd)  ,
     1     max(0., DustPhotoE(i,nd)**2 - (dstpot(nd))**2) /
     2     DustPhotoE(i,nd))
*          this is inciident continuum heating
           phi = flux(i) * dstab1(i,nd) * dstAbund(nd)
*          dtherm is part of h.nu-IP which heats dust before ejection
           dtherm = dtherm + phi * ( anu(i) - eyhat(i,nd) )
*          this is heating by all diffuse fields:
*          SummedDif has all continua and lines
           sum1 = SummedDif(i) * dstab1(i,nd) * dstAbund(nd)
           hots = hots + sum1 * (anu(i) -eyhat(i,nd))
*          dheat is rate grain photoionization heats the gas
           yhat(i,nd) = yn(i,nd) * min(1.,
     1     max(0.,1. - dstpot(nd)/DustPhotoE(i,nd) ) )
           dheat(nd) = dheat(nd) +
     1     SummedCon(i)*dstab1(i,nd) * dstAbund(nd) *
     1     (eyhat(i,nd) - dstpot(nd)*yhat(i,nd) )
         end do
*        write(68,'('' nzone='',i5)') nzone
*        do i=1,nflux
*          if( SummedDif(i)*dstab1(i,nd)*anu(i).gt.0.004*hots )
*    1     write(68,'(1p,10e10.2)') anu(i),
*    1     SummedDif(i)*dstab1(i,nd)*anu(i)/hots
*        end do
*        hots is total heating of the grain by diffuse fields
         hots = hots * en1ryd * hden
*        write(67,'(i4,1p,10e10.2)') nzone,hots, hla
*        dtherm is part of h.nu-IP which heats dust before ejection
         dtherm = dtherm * hden * en1ryd
*        dheat is what heats the gas
         if(lgDHetOn) then
           dheat(nd) = dheat(nd) * hden * en1ryd
           heating(1,14) = heating(1,14) + dheat(nd)
         else
           heating(1,14) = 0.
           dheat(nd) = 0.
         endif
*
*        find power absorbed by dust and resulting temperature
*        DustHeatLya - total heating by LA in this zone, erg cm-3 s-1, only here
*             for eventual printout, hots is total ots line heating
*        DTOTLA - integrated destroyed LA, erg s-1
*
*        heating by Ly A on dust in this zone, and total LA heating
*        only used for printout; Ly-a is already in OTS fields
         hla = otslin(iphl(2,1)) * dstab1(iphl(2,1),nd)*0.75*en1ryd*
     1   hden * dstAbund(nd)
         DustHeatLya = DustHeatLya + hla
*        if( hla.gt.0. ) write(67,'(i4,1p,10e10.2)') nzone,
*    1   otscon(iphl(2,1))*dstab1(iphl(2,1),nd)*0.75*en1ryd*hden/hla,
*    1   otslin(iphl(2,1))*dstab1(iphl(2,1),nd)*0.75*en1ryd*hden/hla,
*    2   outcon(iphl(2,1))*dstab1(iphl(2,1),nd)*0.75*en1ryd*hden/hla,
*    1   outlin(iphl(2,1))*dstab1(iphl(2,1),nd)*0.75*en1ryd*hden/hla
*        hoth was heating due to all other cooling lines in LINDST
*        >>chng 96 apr 26, this with line heating twice,
*        since already in SummedCon
*        hoth = dstoth * dstab1(iphl(3,2),nd)/dstab(iphl(3,2))
*
*        heating by thermal collisions with gas does work
*        factor of 1e8 is sqrt(8k/pi m_H)2k/4*1e20
*        DCHEAT is grain collisional heating by gas
*        DCCOOL is gas cooling due to collisions with grains
*        they should wqual each other
         call dcolid( dcheat , dccool , nd )
*
*        this will be total collisional heating, for printing in lines
         dhcol = dhcol + dcheat
*
*        dust often hotter than gas during initial TE search
         if( nzone.le.2 ) dcheat = max( 0. , dcheat )
*
*        hcon is heating from incident continuum by non-ionizing radiation
*        hots is heating from ots continua and lines
*        dcheat is grain collisional heating by gas
*        dtherm is part of h.nu-IP which heats dust before ejection,
*           this is only direct heating by ionizing radiation
*
*        dstsum is total heating of this grain type, to be balanced by cooling
*        dstsum is the grain heat input - this is the actual number entering
*        the energy balance
         dstsum = hcon + hots + dcheat + dtherm
*        if( dstsum.gt.0. )write(66,'(i4,1p,10e10.2)') nzone,
*    1   hcon/dstsum , hots/dstsum , dcheat/dstsum , dtherm/dstsum
*
*        following used to keep track of heating agents in printout
*        no physics done with dincon
*        dust heating by incident continuum, and elec friction before ejection
         dincon = dincon + hcon + dtherm
         HDustDif = HDustDif + hots
*
*        dstotl is total heating of all grain types in this zone,
*        will be carried by total cooling, only used in lines to print tot heat
*        printed as entry "GraT    0 "
         dstotl = dstotl + dstsum
*        remember total heating by diffuse fields, for printout
         HDustDif = HDustDif + dcheat
*
*        >>chng 96 nov 30, add Kevin Volk's quantum heating
*        (K Volk) added calculation of QTCOL here
         if(lgQHeat(nd)) then
           if (dcheat.gt.0.) then
             qcu1=dcheat*4.5911e+10*4.
*            QCU1 is the total grain collisional heating rate
*            in rydberg/s/H atom
*            DCHEAT is in erg/s/H atom; factor 4 for the entire surface, factor
*            4.5911e+10 to convert to rydberg energy units
*            change, 97 july 17, div by dstAbund due to variable abundances
             x = log10(dcheat/hden/dstAbund(nd))
             if( x.lt.dstems(1,nd) ) then
               qtcol = 10.**dsttmp(1)
               qcu1 = hden*(10.**dstems(1,nd))*4.5911e+10*4. *
     1         dstAbund(nd)
*              correct qtcol and qcu1 to the minimum values
*              if the collisional heating rate is very low;
*              otherwise the quantum heating routines fail since some of the
*              temperature bins are out of range of the dstems array.
*              This will produce erroneous results if both the
*              collisional and quantum heating rates are very low.
             else if( x.gt.dsttmp(ndems) ) then
               qtcol = 10.**dsttmp(ndems)
             else
               call splint( dstems(1,nd),dsttmp,dstslp(1,nd),ndems,x,y)
               qtcol = 10.**y
             endif
           else
             qtcol=1.0
           end if
         end if
*        End of changes here (K Volk)
*
*        now find temperature, dstsum is sum of total heating of grain
*        >>chng 97 july 17, divide by abundance here
         x = log10( max(1e-37, dstsum/hden/dstAbund(nd) ) )
         if( x.lt.dstems(1,nd) ) then
           tedust(nd) = 10.**dsttmp(1)
*          >>chng 96 apr 27, as per Peter van Hoof comment
         else if( x.gt.dstems(ndems,nd) ) then
           tedust(nd) = 10.**dsttmp(ndems)
         else
           call splint( dstems(1,nd) , dsttmp , dstslp(1,nd),ndems,x,y)
           tedust(nd) = 10.**y
         endif
*       >>chng 96 nov 30, add Kevin Volk quantum heating
*       Save the equilibrium temperature for possible print-out when the
*       quantum heating is asked for. (K Volk)
         tequil1(nd)=tedust(nd)
*
*        if qheat is set do the quantum heating calculation.
*        test qtmax first, and adjust if needed.
         if (lgQHeat(nd)) then
            ted1=tedust(nd)
*           use this value if something strange happens in qheat1
            if (qtmax.lt.5.*tedust(nd)) then
                qtmax0=qtmax
                qtmax=min(20.*tedust(nd),5000.)
                call qheat1(nd,tqhout,ted1)
                qtmax=qtmax0
            else
                call qheat1(nd,tqhout,ted1)
            end if
            tedust(nd)=tqhout
         end if
*        end of changes here (K Volk)
*        save for latter possible printout
         tgrmax(nd) = max( tgrmax(nd) , tedust(nd) )
*        rate dust cools gas by collisions
         if( lgDColOn ) then
*          dccool is gas cooling due to collisions with grains
           DustCoolGas = DustCoolGas + dccool
         endif
*
         if( lgTrace.and.lgDustBug ) then
           write(qq,'(1x,''DTEMPR finds'',I2,'' Tdst'',1p,e9.2,
     1     '' totHeat'',e9.2,'' Cont;'',e9.2,'' OTS;'',e9.2,
     2     '' HIIcol:'',e9.2,'' pho ej;'',e9.2,'' dheat'',e9.2)')
     3     nd , tedust(nd) , dstsum , hcon/dstsum ,
     4     hots/dstsum , dcheat/dstsum,dtherm/dstsum , dheat(nd)
           if( lgQHeat(nd) ) write(qq,'('' DTEMPR: QHEAT1 found'',
     1     '' tqhout, ted1='',1p,2e10.2)') tqhout , ted1
         endif
         endif
      end do
*
*     if grains hotter than gas then collisions with gas act
*     to heat the gas, add this in here
*     a symmetric statement appears in COOLR, where cooling is added on
      if(lgDHetOn) then
        heating(1,15) = max(0.,-DustCoolGas )
      else
        heating(1,15) = 0.
      endif
*
      end
