******************************************************************************
      real function EinstA(lower,iupper)
      implicit none
*calculates Einstein A's from the oscillator strengths
*     (lower,upper) of Johnson 1972.  
*
*     local variables
      integer lower,iupper
      real ryd,xmicron,xl,xu
      real fosc
*
      xl = float(min(iupper,lower))
      xu = float(max(iupper,lower))
      ryd = (1./xl**2 - 1./xu**2) 
      xmicron = 1./(ryd*10.9737312) 
      EinstA = fosc(xl,xu)/(1.499e-8) / (xmicron**2) * xl*xl/xu/xu
*
      end
