******************************************************************************
      Real function esa0k2( taume )
      implicit none
*derive Hummer's K2 escape probability for Doppler core only
      real taume
      include "sqrtpi.par"
      real a(5) , b(6) , c(5) , d(6)
      real tau,suma,sumb,arg,sumc,sumd
*
*     local variables
      real escmase
*
      data a/1.00, -0.1117897 , -0.1249099917 , -9.136358767e-3 ,
     1 -3.370280896E-4/
      data b/1.00, 0.1566124168, 9.013261660e-3 , 1.908481163E-4,
     1 -1.547417750E-7 , -6.657439727E-9 /
      data c/1.000, 19.15049608, 100.7986843 , 129.5307533 ,
     1 -31.43372468 /
      data d/ 1.00 , 19.68910391 , 110.2576321 , 169.4911399 ,
     1 -16.69969409 , -36.664480000/
*
*     compute Hummer's K2 escape probability function for a=0
*     using approx from JQRST 26, 187.
*
*     convert to David's opacity
      tau = taume * sqrtpi
*
      if( tau.lt.0. ) then
*       the line mased
        esa0k2 = escmase(taume)
*
      else if( tau.lt.0.01 ) then
        esa0k2 = 1. - 2. * tau
*
      else if( tau.le.11. ) then
        suma = a(1) + tau*(a(2) + tau*(a(3) + tau*(a(4)+a(5)*tau)))
        sumb = b(1) + tau*(b(2) + tau*(b(3) + tau*(b(4)+tau*(b(5)+
     1  b(6)*tau))))
        esa0k2 = tau / 2.5066283 * log( tau/sqrtpi ) +
     1  suma/sumb
*
      else
*       large optical depth limit
        arg = 1. / log(tau/sqrtpi )
        sumc = c(1) + arg*(c(2) + arg*(c(3) + arg*(c(4)+c(5)*arg)))
        sumd = d(1) + arg*(d(2) + arg*(d(3) + arg*(d(4)+arg*(d(5)+
     1  d(6)*arg))))
        esa0k2 = ( sumc / sumd ) /
     1  ( 2.*tau*sqrt( log(tau/sqrtpi ) ) )
      endif
*
      end
