******************************************************************************
      real function esccom( tau , a )
      implicit none
*fundamental escape probability radiative transfer routine, for complete redistribution
      real tau , a
      include "escdst.com"
      include "IOqq.com"
*
*     local variables
      real atau , b , esa0k2 , escmase
*
*     this is one of the three fundamental escape probability routines
*     the three are esccom, escinc, and escla
*     it computes esc prob for complete redistribution
*     computes escape prob for complete redistribution in one direction
*
      if( tau.lt.0. ) then
*       line mased
        esccom = escmase( tau )
        return
      endif
*
      if( chEscFun.EQ.'SIMP' ) then
*       this set with "escape simple" command, used for debugging
        esccom = 1. / (1. + tau )
        return
      endif
*
*     chEscFun is the escape prob function, usually k2
*
      if( chEscFun.EQ.'INCO' ) then
        if( tau.lt.10. ) then
          esccom = 1. / (1. + 1.6*tau )
          return
        endif
*
*       first find coeficient b(tau)
        atau = a * tau
        if( atau.gt.1. ) then
          b = 1.6 + ( 3.*(2.*a)**(-0.12) ) / (1. + atau )
        else
          b = 1.6 + ( 3.*(2.*a)**(-0.12) ) / (1. + 1./sqrt(atau) )
        endif
        b = min( 6. , b )
*
        esccom = 1. / ( 1. + b*tau ) + 0.25*sqrt(a/tau)
*
      else if( chEscFun.EQ.'  K2' ) then
*       this is the usual case, Hummer's k2 function
* error! what happens if negative tau?
        esccom = esa0k2( tau )
      else
        write(qq,'('' Unknown escape probability function='',A4)')
     1  chEscFun
        stop
      endif
*
      end
