******************************************************************************
      real function escgrd( tau , tout , damp ,ipCont )
      implicit none
*escape probability radiative transfer for incomplete redistribution
      real tau , tout , damp
      integer ipCont
      include "touton.com"
      include "twoway.com"
      include "IOqq.com"
*
*     local variables
      real scale , tt , escinc
      parameter (scale=2.)
*
*     find escape prob for incomp redis, average of two 1-sided probs
*
*     >>chng 97 june 26, added ipCont
*begin sanity check
      if( ipCont.lt.1 ) then
        write(qq,'('' escgrd called with insane continuum pointer='',
     1  i6)') ipCont
        stop
      endif
*end sanity check
*
      if( lgTauOutOn ) then
*        outward optical depth if defined
         tt = (tout - tau)
*        help convergence by not letting tau go to zero at back edge of
*        when there was a bad guess for the total optical depth
*note that this test is seldom hit since makestatrt does check for overrun
         if( tt.lt.0. ) tt = tau / scale
         wayin = escinc(tau,damp) 
         wayout = escinc(tt,damp) 
         fracin = wayin / (wayin + wayout )
         escgrd = 0.5 * ( wayin + wayout )
      else
*        outward optical depth not defined, dont estimate fraction out
         fracin = 0.
         wayout = 1.
         escgrd = escinc( tau ,damp)
         wayin = escgrd
      endif
*
*begin sanity check
      if( escgrd.le.0. ) then
        write(qq,'('' escgrd finds insane escape probability,'',1p,
     1  e10.2)') escgrd
        write(qq,'('' tau, tout, damp='',1p,3e10.2)') tau , tout , damp 
        call ShowMe
        stop
      endif
*end sanity check
*
      end
