******************************************************************************
      real function escinc(tau,a)
      implicit none
*fundamental escape probability radiative transfer routine for incomplete redistribution
      real tau , a
      include "escdst.com"
*
*     local variables
      real atau , b , escmase
*
*     this is one of the three fundamental escape probability routines
*     the three are esccom, escinc, and escla
*     it computes esc prob for incomplete redistribution
*
      if( chEscFun.eq.'SIMP' ) then
*       this set with "escape simple" command, used for debugging
        escinc = 1. / (1. + tau )
        return
      endif
*
      if( tau.lt.0. ) then
*       line mased
        escinc = escmase( tau )
      else if( tau.lt.10. ) then
*       linear part of doppler core
        escinc = 1. / (1. + 1.6*tau )
      else
*       first find coeficient b(tau)
        atau = a * tau
        if( atau.gt.1. ) then
          b = 1.6 + ( 3.*(2.*a)**(-0.12) ) / (1. + atau )
        else
          b = 1.6 + ( 3.*(2.*a)**(-0.12) ) / (1. + 1./sqrt(atau) )
        endif
        b = min( 6. , b )
*
        escinc = 1. / ( 1.+b*tau )
      endif
*
      end
