******************************************************************************
      real function escmase(tau)
      implicit none
*escape probability for negative (masing) optical depths
      real tau
      include "IOqq.com"
*
*     local variables
      real zero , a
      data zero/0./
*
*     this is the only routine that computes maser escape proba
*begin sanity check
      if( tau.gt.0. ) then
        write(qq,'('' escmase called with positive tau!!'')')
        write(qq,'('' Tau ='',1p,e10.2)') tau
        stop
      endif
*end sanity check
      if( tau.gt.-0.1 ) then
        escmase = 1. - tau*(0.5 + tau/6.) 
      else if( tau.gt.-30. ) then
        escmase = (1.- exp(-tau) ) / tau
      else
        write(qq,'('' escmase called with 2big tau''1p,e10.2)')tau
        call FindNeg
        write(qq,'('' will now div by 0 to get trace'')')
        a = 1. / zero
        write(qq,'(1p,e10.2)') a
        stop
      endif
*
*begin sanity check
      if( escmase.lt.1.0 ) then
        write(qq,'('' escmase finds P<1!!'')')
        write(qq,'('' escmase, Tau ='',1p,2e10.2)') escmase,tau
        stop
      endif
*end sanity check
*
      end
