******************************************************************************
      real function eshe2l( esin )
      implicit none
*do radiative transfer for all helium ion lines
      real esin
      include "nhe2lvl.par"
      include "limelm.par"
      include "DoppVel.com"
      include "iphe2l.com"
      include "he2tau.com"
      include "he2nxt.com"
      include "redis.com"
      include "twoway.com"
      include "IOqq.com"
*
*     local variables
      real damp , escgrd , escsub
*
*     evaluate esc prob for HeII LA
*     optical depth in outer direction always defined
*
      damp = 606.7 / doppler(2)
      if( chRedis.eq.'INCO' ) then
*       incomplete redistribution
        eshe2l = escgrd( he2nxt(2,1) , he2lim(2,1) , damp ,
     1  iphe2l(2,1) )
        esin = wayin
      else
*       wind or complete redis
        eshe2l = escsub( he2nxt(2,1) , he2lim(2,1) , damp )
        esin = wayin
      endif
*
      if( eshe2l.lt.0. ) then
        write(qq,'('' ESHE2L returns a negative value, of'',1P,E10.2)')
     1  eshe2l
        write(qq,'('' ESHE2L: the redistribution type was '',A4)')
     1  chRedis
        write(qq,'('' The optical depths are '',1P,2E10.2)') 
     1     he2nxt(2,1) , he2lim(2,1)
        call ShowMe
        stop
      endif
*
      end
