******************************************************************************
      real function fabden ( radius , depth )
      implicit none
*called by dlaw command, returns density for any density law
      double precision radius , depth
      include "dlaw.com"
      include "IOqq.com"
*
*     this routine is called when the DLAW command is given,
*     and must return the hydrogen density at the current radius.
*     RADIUS is the radius, the distance from the center of symmetry.
*     DEPTH is the depth into the cloud, from the illuminated face
*     both are in cm
*     the values of RADIUS and DEPTH in the call are not always equal
*     to their current values in the cmmn block
*
*     RADIUS, DEPTH, and the array DensityLaw are double precision, although
*     the value returned by FABDEN itself is not
*
*     this is one way to generate a density
      fabden = radius * depth
*
*     this is the way to do it using the numbers on the dlaw command
*     in hazy vol 1 DensityLaw() is called dlaw()
      fabden = DensityLaw(1) + radius * DensityLaw(2)
*
*     all following code must be removed if this sub is to be used
      write(qq,'('' the old version of FABDEN must be deleted,'',
     1'' and a new one put in place.  Sorry.'')')
      fabden = 0.
      if( fabden.eq.0. ) then
        stop
      else
        return
      endif
*
      end
