      subroutine Fe4Lev12
      implicit none
*compute populations and cooling due to 12 level Fe IV ion
      include "limelm.par"
      include "limLevelN.par"
      include "bltzman.par"
      include "IonFracs.com"
*     include "PopLevls.com"
      include "dcool.com"
      include "fe4cool.com"
      include "IOqq.com"
*
*     local variables
*     number of levels in model ion
      integer nlfe4
      parameter (nlfe4=12)
*
      real gfe4(nlfe4) , ex(nlfe4) , popfe4(nlfe4) , data(nlfe4,nlfe4),
     1 dest(nlfe4,nlfe4) , pump(nlfe4,nlfe4) , Fe4A(nlfe4,nlfe4) ,
     2 Fe4CS(nlfe4,nlfe4)
      real dfe4dt
      logical lgNegPop
      integer ipdest(nlfe4,nlfe4) , i , j , nFe4Neg
      data gfe4/6.,12.,10.,6.,8.,6.,4.,2.,8.,2.,6.,4./
*     these are in wavenumbers
*     data ex/ 0., 32245.5, 32293., 32301.2, 
*    1  32306., 35254., 35333., 35407., 38779., 38897., 38935.,
*    2  38938./ 
*     excitation energies in Kelvin
      data ex/ 0., 46395.8, 46464., 46475.6, 
     1  46483., 50725., 50838., 50945., 55796., 55966., 56021.,
     2  56025./ 
*
*     A's are from Garstang, R.H., MNRAS 118, 572 (1958).
*     each set is for a lower level indicated by second element in array,
*     index runs over upper level
*     A's are saved into arrays as data(up,lo)
      data (Fe4A(j,1), j = 1,nlfe4)/
     1 0.,0., 0., 1.E-5, 0., 1.368, .89, 0., 1.3E-3, 1.8E-4, .056, .028/
      data (Fe4A(j,2), j = 1,nlfe4)/
     2 0.,0., 2.6E-8, 5*0., 1.7E-7, 3*0./
      data (Fe4A(j,3), j = 1,nlfe4)/
     3 3*0., 0., 3.5E-7, 6.4E-10, 0., 0., 6.315E-4, 0., 6.7E-7, 0./
      data (Fe4A(j,4), j = 1,nlfe4)/
     4 4*0.,1.1E-6,6.8E-5,8.6E-6,3.4E-10,7.6E-5,1.E-7,5.8E-4,2.8E-4/
      data (Fe4A(j,5), j = 1,nlfe4)/
     5 5*0., 1.5E-5, 1.3E-9, 0., 7.6E-4, 0., 1.1E-6, 6.0E-7/
      data (Fe4A(j,6), j = 1,nlfe4)/
     6 6*0., 1.1E-5, 1.2E-13, .038, 9.9E-7, .022, .018/
      data (Fe4A(j,7), j = 1,nlfe4)/
     7 7*0., 3.7E-5, 2.9E-6, .034, 3.5E-3, .039/
      data (Fe4A(j,8), j = 1,nlfe4)/
     8  8*0., 0., .058, 3.1E-6, 1.4E-3 /
      data (Fe4A(j,9), j = 1,nlfe4)/
     9 9*0., 0., 1.3E-4, 3.1E-14/
      data (Fe4A(j,10), j = 1,nlfe4)/
     1 10*0., 1.9E-19, 1.0E-5/
      data (Fe4A(j,11), j = 1,nlfe4)/
     1 11*0., 1.3E-7/ 
      data (Fe4A(j,12), j = 1,nlfe4)/nlfe4*0./
*
*     collision strengths from Berrington and Pelan  Ast Ap S 114, 367.
*     order is cs(low,up)
      data (Fe4CS(i,1), i = 1,nlfe4)/nlfe4*0./
      data (Fe4CS(i,2), i = 1,nlfe4) /0.98, 11*0./
      data (Fe4CS(i,3), i = 1,nlfe4)/
     3 0.8167, 3.72, 10*0./
      data (Fe4CS(i,4), i = 1,nlfe4)/
     4 0.49, 0.0475, 0.330, 9*0./
      data (Fe4CS(i,5), i = 1,nlfe4)/
     5 0.6533, 0.473, 2.26, 1.64, 8*0./
      data (Fe4CS(i,6), i = 1,nlfe4)/
     6 0.45, 0.686, 0.446, 0.106, 0.254, 7*0./
      data (Fe4CS(i,7), i = 1,nlfe4)/
     7 0.30, 0.392, 0.152, 0.269, 0.199, 0.605, 6*0./
      data (Fe4CS(i,8), i = 1,nlfe4)/
     8 0.15, 0.0207, 0.190, 0.0857, 0.166, 0.195, 0.327, 5*0./
      data (Fe4CS(i,9), i = 1,nlfe4)/
     9 0.512, 1.23, 0.733, 0.174, 0.398, 0.623, 0.335, 0.102, 4*0./
      data (Fe4CS(i,10), i = 1,nlfe4)/
     1 0.128, 0.0583, 0.185, 0.200, 0.188, 0.0835, 0.127, 0.0498,
     1 0.0787, 3*0./
      data (Fe4CS(i,11), i = 1,nlfe4)/
     1 0.384, 0.578, 0.534, 0.363, 0.417, 0.396, 0.210, 0.171,
     1 0.810, 0.101, 2*0./
      data (Fe4CS(i,12), i = 1,nlfe4)/
     2 0.256, 0.234, 0.306, 0.318, 0.403, 0.209, 0.195, 0.112,
     1 0.195, 0.458, 0.727,0./
*
*     all elements are used, and must be set to zero if zero
      do i=1,nlfe4
        do j=1,nlfe4
          data(i,j) = 1e33
          dest(i,j) = 0.
          pump(i,j) = 0.
          ipdest(i,j) = 0
        end do
        data(i,i) = 0.
        popfe4(i) = 0.
      end do
*
*     fill in einstein As and collision strengths
      do i=1,nlfe4
        do j=i+1,nlfe4
          data(j,i) = Fe4A(j,i)
          data(i,j) = Fe4CS(i,j)
        end do
      end do
*     write(6,*)' collision strengths'
*     do i=nlfe4,2,-1
*666    write(6,'(i3,1p,12e8.1)')i,(data(j,i),j=1,i-1)
*     end do
*     write(6,*)' A s'
*     do i=nlfe4,2,-1
*665    write(6,'(i3,1p,12e8.1)')i,(data(i,j),j=1,i-1)
*     end do
*     stop
*
*     leveln itself is well-protected against zero abundances,
*     low temperatures
      call LevelN(nlfe4,nlfe4,xIonFracs(26,4),gfe4,ex ,
     1 popfe4,data,dest,pump,ipdest,
     1 Fe4CoolTot,dfe4dt,'FeIV', lgNegPop)
*     write(6,'(1p,6e11.3)') popfe4
*
      if( lgNegPop ) nFe4Neg = nFe4Neg + 1
      call coladd( 'Fe 4' , 0 , Fe4CoolTot )
      dCooldT = dCooldT + dfe4dt
*
*     three transitions hst can observe
*     4 -1 3095.9A and 5 -1 3095.9A
      fe40401 = (popfe4(4)*Fe4A(4,1) + popfe4(5)*Fe4A(5,1) )* 6.42e-12
      fe42836 = popfe4(6)* Fe4A(6,1) * 7.02e-12
      fe42829 = popfe4(7)* Fe4A(7,1) * 7.03e-12
      fe42567 = (popfe4(11)* Fe4A(11,1)+popfe4(12)* Fe4A(12,1)) * 
     1 7.752e-12
      fe41207 = popfe4(12)*Fe4A(12,07)*(ex(12)-ex(07))*Boltzmann
      fe41206 = popfe4(12)*Fe4A(12,06)*(ex(12)-ex(06))*Boltzmann
      fe41106 = popfe4(11)*Fe4A(11,06)*(ex(11)-ex(06))*Boltzmann
      fe41007 = popfe4(10)*Fe4A(10,07)*(ex(10)-ex(07))*Boltzmann
      fe41008 = popfe4(10)*Fe4A(10,08)*(ex(10)-ex(08))*Boltzmann
      fe40906 = popfe4(09)*Fe4A(09,06)*(ex(09)-ex(06))*Boltzmann
*
      end
