******************************************************************************
      subroutine fiddle( ipnt , exact )
      implicit none
*adjust energy bounds of certain cells so that match ionization edges exactly
      integer ipnt
      real exact
      include "ncell.par"
      include "rfield.com"
      include "widflx.com"
      include "IOqq.com"
*
*     local variables
      real bhi , blo, extra , anuold
*
*     make low edge of cell exact for photo integrals
*begin sanity checks
      if(ipnt.lt.1 .or. ipnt.gt.ncell ) then
        write(qq,'('' fiddle called with insane ipnt'',i5)')ipnt
        stop
      endif
      bhi = anu(ipnt+1) - widflx(ipnt+1)*0.5
      blo = exact
      extra = widflx(ipnt) - (bhi-blo)
      anu(ipnt-1) = anu(ipnt-1) + extra*0.5
      widflx(ipnt-1) = widflx(ipnt-1) + extra
      widflx(ipnt) = bhi - blo
      anuold = anu(ipnt)
      anu(ipnt) = (bhi + blo) / 2.
      if( widflx(ipnt).le.0. ) then
         write(qq,'('' logic error in FIDDLE; EXACT, IPNT='',1P,E10.2,
     1   0p,i5)') exact,ipnt
         write(qq,'('' anu(ipnt)='',1p,e11.3)') anuold
         stop
      endif
*
      end
