******************************************************************************
      subroutine fivel(g,ex,cs12,cs13,cs14,cs15,
     1 cs23,cs24,cs25,cs34,cs35,cs45, a21,a31,a41,a51, a32,a42,a52,
     2 a43,a53,a54, p,abund)
      implicit none
*do five level atom population and cooling
      real g(5) , p(5) , ex(4)
      real cs12,cs13,cs14,cs15,
     1 cs23,cs24,cs25,cs34,cs35,cs45, a21,a31,a41,a51, a32,a42,a52,
     2 a43,a53,a54, abund
*
      double precision zz(6,6) , dmax
      include "WavNKelv.par"
      include "TePowers.com"
      include "edsqte.com"
      include "phycon.com"
      include "called.com"
      include "IOqq.com"
*
      real tf,e12,e23,e34,e45,e13,e15,e14,e24,e25,e35 ,
     1 c21,c12,c31,c13,c41,c14,c51,c15,c23,c32,c42,c24,
     2 c52,c25,c43,c34,c53,c35,c54,c45,sexp
      integer i , j , ner
*
*     tf = 1.438 / te
      tf = WavNKelv / te
      if( abund.le.0. ) then
         p(1) = 0.
         p(2) = 0.
         p(3) = 0.
         p(4) = 0.
         p(5) = 0.
         return
      endif
*
      e12 = sexp( ex(1)*tf )
      e23 = sexp( ex(2)*tf )
      e34 = sexp( ex(3)*tf )
      e45 = sexp( ex(4)*tf )
      e13 = e12 * e23
      e14 = e13 * e34
      e15 = e14 * e45
      e24 = e23 * e34
      e25 = e24 * e45
      e35 = e34 * e45
*
      if( e15.eq.0. ) then
         p(1) = 0.
         p(2) = 0.
         p(3) = 0.
         p(4) = 0.
         p(5) = 0.
         return
      endif
*
*     cdsqte IS 8.629e-6 / sqrte * eden
      c21 = cdsqte * cs12/g(2)
      c12 = c21 * g(2)/g(1) * e12
*
      c31 = cdsqte * cs13 / g(3)
      c13 = c31 * g(3)/g(1) * e13
*
      c41 = cdsqte * cs14 / g(4)
      c14 = c41 * g(4)/g(1) * e14
*
      c51 = cdsqte * cs15 / g(5)
      c15 = c51 * g(5) / g(1) * e15
*
      c32 = cdsqte * cs23 / g(3)
      c23 = c32 * g(3)/g(2) * e23
*
      c42 = cdsqte*cs24/g(4)
      c24 = c42*g(4)/g(2)*e24
*
      c52 = cdsqte * cs25/g(5)
      c25 = c52 * g(5) / g(2) * e25
*
      c43 = cdsqte * cs34/g(4)
      c34 = c43 * g(4)/g(3)*e34
*
      c53 = cdsqte*cs35/g(5)
      c35 = c53*g(5)/g(3)*e35
*
      c54 = cdsqte * cs45/g(5)
      c45 = c54 *g(5)/g(4) * e45
*
*     rate equations equal zero
      do i=1,5
        zz(5,i) = 1.0
        zz(i,6) = 0.
      end do
      zz(5,6) = abund
*
*     level one balance equation
      zz(1,1) = c12+c13+c14+c15
      zz(1,2) = -a21 - c21
      zz(1,3) = -a31 - c31
      zz(1,4) = -a41 - c41
      zz(1,5) = -a51 - c51
*
*     level two balance equation
      zz(2,1) = -c12
      zz(2,2) = c21+a21+c23+c24+c25
      zz(2,3) = -c32 - a32
      zz(2,4) = -c42 - a42
      zz(2,5) = -c52 - a52
*
*     level three balance equation
      zz(3,1) = -c13
      zz(3,2) = -c23
      zz(3,3) = a31+a32+c31+c32+c34+c35
      zz(3,4) = -c43-a43
      zz(3,5) = -c53 - a53
*
*     level four balance equation
      zz(4,1) = -c14
      zz(4,2) = -c24
      zz(4,3) = -c34
      zz(4,4) = a41+c41+a42+c42+a43+c43+c45
      zz(4,5) = -c54 - a54
*
*     divide both sides of equation by largest number to stop overflow
      dmax = -1d0
      do i=1,6
        do j=1,5
          dmax = max( zz(j,i) , dmax )
        end do
      end do
*
      do i=1,6
        do j=1,5
          zz(j,i) = zz(j,i) / dmax
        end do
      end do
*
      call matin1( zz,6,5,1,ner)
      if( ner.ne.0 ) then
        if( lgTalk ) write(qq,'('' 5-level matrix error.'')')
        if( lgCalled ) then
          lgBusted = .true.
           return
        else
          stop
        endif
      endif
*
* 666 error! p(5) was very slightly negative (1e-40) for SII in dqher.in
      p(2) = max(0.d0,zz(2,6) )
      p(3) = max(0.d0,zz(3,6) )
      p(4) = max(0.d0,zz(4,6) )
      p(5) = max(0.d0,zz(5,6) )
      p(1) = abund - p(2)-p(3)-p(4)-p(5)
*
      end
