******************************************************************************
      subroutine flucol
      implicit none
*evaluate total cooling due to fluorine
      include "ipLnArry.par"
      include "nta.par"
      include "limelm.par"
      include "dcool.com"
      include "TLineEXP.com"
      include "TePowers.com"
      include "p2ovp1.com"
      include "phycon.com"
      include "logte.com"
      include "IonFracs.com"
      include "TauDmmy.com"
*
*     local variables
      real cs
*
*     [F II] 29.33 micron, 67.2 micron
*     collision strength transition prob
*     >>refer Galavis, M.E., et al. 1997, A&AS 123, 159
*     >>refer Buttler, K., & Zeippen, C.J., 1994, A&AS 108, 1
      call PutCS( 0.60  , F0229 )
      call PutCS( 0.206 , F0267 )
      call PutCS( 0.160 , TauDummy )
*     subroutine level3( t10,t21,t20)
      call level3( F0229 , F0267 , TauDummy )
*
*     collision strength 
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
*     [F IV] 44.07 microns
      cs = min(0.711 , 0.1245*te10*te05*te01*te001*te001 )
      call PutCS( cs , F444 )
*     [F IV] 25.83 microns
      cs = min( 1.89 , 0.2023*te20*te003*te003 )
      call PutCS( cs , F425 )
      cs = min( 0.451 , 0.02922*te20*te05 )
      call PutCS( cs , TauDummy )
*     subroutine level3( t10,t21,t20)
      call level3( F444 , F425 , TauDummy )
*
      end
