******************************************************************************
      subroutine fluorinei
      implicit none
*compute ionization balance for fluorine
      include "limelm.par"
      include "elmton.com"
      include "trace.com"
      include "h.com"
      include "TePowers.com"
      include "timed.com"
      include "phycon.com"
      include "TrHeav.com"
      include "IOqq.com"
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=10)
      parameter (nelem=9)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     real grdeff(10) 
*
*     fluorine, nelem=9
*     rec data from neon
*
*     real CollidRate(nelem,2)
*
*     DATA GRDEFF/10*0.2/ 
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /3.03E-11,1.79E-11,1.61E-11,9.76E-12,4.48E-12,2.03E-12,
     1 1.02E-12,3.84E-13,3.05E-14/
      data (cion(i,2),i=1,ndim-1)
     1/2.50E5,4.76E5,7.37E5,1.13E6,1.47E6,1.83E6,2.40E6,2.77E6,1.39E7/
*
*     rec from +7, +8 fro Arnaud et al 85
      data rec , pl
     1/3.07E-10, 8.87E-10, 2.21E-9, 4.28E-9, 8.17E-9, 1.51E-8, 3.21E-8
     1, 9.29E-8,
     2 -0.759  , -0.693  , -0.675 , -0.668 , -0.684 , -0.704 ,-0.742 ,
     2 -0.803 /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/2*0./
*
      data 
     1 aa/0., 0.0129, 3.6781,-0.0254,-0.0141, 19.9280,3*0./
     1,bb/0.,-0.1779,14.1481, 5.5365,33.8479,235.0536,3*0./
     1,cc/0., 0.9353,17.1175,17.0727,43.1608,152.5096,3*0./
     1,dd/0.,-0.0682,-0.5017,-0.7225,-1.6072,  9.1413,3*0./
     1,ff/0.,0.4516, 0.2313, 0.1702, 0.1942,  0.1282,3*0./
*
      data (dicoef(i,1),i=1,ndim-1)
     1/9.77E-4 , 2.65E-3 , 3.69E-3 , 1.12E-2 , 2.44E-2 , 3.02E-2
     2,6.10E-3 , 2.52E-1 , 0./
      data (dicoef(i,2),i=1,ndim-1)
     1 /.073, .242, 1.01, .391, 2.52, .445, .254, .304,0./
      data (dite(i,1),i=1,ndim-1)
     3/3.11E5  , 2.84E5  , 2.24E5  , 2.7E5  , 3.09E5  , 2.83E5
     4,1.68E5  , 1.4E7  , 0./
      data (dite(i,2),i=1,ndim-1)
     1 /2.06e5, 3.07e5, 2.94e5, 5.50e5, 9.91e5, 1.73e6, 6.13e5, 1.80e6,
     2 0./
      data ditcrt
     5/3.0E4  , 3.3E4  , 3.3E4  , 3.5E4  , 3.6E4  , 3.6E4
     6,2.9E4  , 1.5E6  , 1E20  /
*
*     fluorine, atomic number 9
      if( .not.lgElmtOn(nelem) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
