******************************************************************************
      subroutine freeht
      implicit none
*evaluate free-free heating due to incident continuum
      include "en1ryd.par"
      include "te1ryd.par"
      include "ncell.par"
      include "nopsv.par"
      include "nhlvl.par"
      include "itrdim.par"
      include "limelm.par"
      include "ffheat.com"
      include "heating.com"
      include "hmihet.com"
      include "SummdCon.com"
      include "freeon.com"
      include "gaunts.com"
      include "ipbrms.com"
      include "opsv.com"
      include "phycon.com"
      include "TePowers.com"
      include "he.com"
      include "rfield.com"
      include "widflx.com"
      include "ots.com"
      include "h.com"
      include "heat.com"
      include "corind.com"
      include "nh.com"
      include "tff.com"
      include "iphmra.com"
      include "phlevl.com"
      include "ffsum.com"
      include "ffopac.com"
      include "DoPhoto.com"
      include "ZoneCnt.com"
      include "IOqq.com"
*
*     local variables
      integer i
      real fac , fac1 , fachmi , fachmi1 , damper , oldfac
      double precision dfactor
      save oldfac
      data oldfac/0./
*
      if( .not. lgFreeOn ) then
        FreeFreeHeat = 0.
        return
      endif
*
*     must reevaluate if free free heating is important
      if( lgDoPhoto .or. FreeFreeHeat/htot.gt.0.05 ) then
        if( nzone.lt.1 ) then
          damper = 1.
        else
          damper = 0.5
        endif
*       OPSV is missing factor of 1E-20 to avoid underflow
        fac = (eden/1e10) * ((hii+heii+4.*heiii+EdenFFSum)/1e10) / sqrte
        fac1 = fac * te1ryd / te
*     >>chng 96 oct 30, put following after fac1 defn
        fac = damper*fac + oldfac*(1.-damper)
        fachmi = (eden/1e10) * (hii*hn(1)/1e10) / sqrte
        fachmi1 = fachmi * te1ryd / te
        do i=1,nflux
          if( ContBoltz(i).lt.0.995 ) then
*           use 1-exp(hn/kT)) only if exp is small
*           last term is scaled h minus brems free-free absorption
            dfactor = OpacStack(i-1+ipBrems) * (1.-ContBoltz(i))* gff(i)
            FreeFreeOpacity(i) = dfactor * fac
*           this is the H- part, opsv here is ratio of H- to ff
            FreeFreeOpacity(i) = FreeFreeOpacity(i) + dfactor * fachmi *
     1      OpacStack(i-1+iphmra)
          else
            dfactor = OpacStack(i-1+ipBrems) * anu(i)* gff(i)
            FreeFreeOpacity(i) = dfactor * fac1 
*           h- free free absorption
            FreeFreeOpacity(i) = FreeFreeOpacity(i) + dfactor * fachmi1*
     1      OpacStack(i-1+iphmra)
          endif
        end do
        oldfac = fac
*       now integrate over this
        FreeFreeHeat = 0.
        do i=1,nflux
*         FreeFreeHeat = FreeFreeHeat + FreeFreeOpacity(i) *
*    1    SummedCon(i)*anu(i)
          FreeFreeHeat = FreeFreeHeat + FreeFreeOpacity(i) *
     1    flux(i)*anu(i)
        end do
        FreeFreeHeat = FreeFreeHeat * en1ryd
      endif
*
      end
