******************************************************************************
      real function gamfun(n1,n2,ip)
      implicit none
*evaluate photoionization rate for single species
      integer n1 , n2 , ip
*
      include "ncell.par"
      include "shullc.com"
      include "nopsv.par"
      include "opsv.com"
      include "ots.com"
      include "rfield.com"
      include "SummdCon.com"
      include "heat.com"
      include "en1ryd.par"
*
      integer k , iup  , i
      real g , thres , phisig
*
*     evaluate photoioinzation rate and photoelectric heating
*     returns photoionization rate as GAMFUN, heating is H
*     N1 and N2 are pointers within frequency array to upper and
*     lower bounds of evaluation
*     IP is offset to map onto OPSV
*
      h = 0.
      if(n1 .ge. nflux) then
        gamfun = 0.
        return
      endif
*
      g = 0.
      k = n1
      iup = min( n2 , nflux )
      thres = anu( n1 )
*
*     first do theshold point
*     do not include otscon, which may contain diffuse continuum
      i = n1
      phisig = (flux(i)+otslin(i)) * OpacStack(i-n1+ip)
      g = phisig
      h = phisig * anu(i)
*
      do i=n1+1,iup
        phisig = SummedCon(i) *OpacStack(i-n1+ip)
        g = g + phisig
        h = h + phisig * anu(i)
      end do
      gamfun = g
*
*     heating in Rydbergs, uncorrected for secondary ionization
      h = ( h - g*thres )
*
      if( anu(iup).gt.8. ) then
*       number of secondary ionizations, defined IN NOCKON
        secion = h * efionz
*
*       number of LA excitations
        secla = h * exctef * 1.3333
*
*       HEATEF is defined in NOCKON and =1 for fully ionized gas, less for
*       also convert RYD to ERG
        h = h * heatef * en1ryd
      else
        h = h * en1ryd
        secion = 0.
        secla = 0.
      endif
*
      end
