****************************************************************
      real function gamk(n1,n2,ipOpac,yield1)
      implicit none
*evaluate photoionization rate for single shell
      integer n1 , n2 , ipOpac
*     yield1 is fraction of ionizations that emit 1 electron only,
*     only used for energy balance
      real yield1
*
      include "ncell.par"
      include "shullc.com"
      include "nopsv.par"
      include "opsv.com"
      include "ots.com"
      include "rfield.com"
      include "SummdCon.com"
      include "heat.com"
      include "en1ryd.par"
      include "ipSecIon.com"
*
*     local variables
      integer iup , i , ilo , ipOffset
      real phisig , ht , eauger , HeatHi , GamHi
*
*     code spends roughly 20% of its time in this sub
*
*
*     evaluate photoioinzation rate and photoelectric heating
*     returns photoionization rate as GAMK, heating is H
*     N1 and N2 are pointers within frequency array to upper and
*     lower bounds of evaluation
*     ipOpac is offset to map onto OPSV
*
*     this routine is a major pace setter for the code
*     carefully check anything put into the following do loop
*
*     if(n1 .ge. nflux .or.  OpacStack(ipOpac).eq.0. ) then
*     >>chng 96 sept 26, remove check on zero opacity, for partial shells
*     >>chng 99 Apr 02, above change introduced problem with non-existant
*     shells, such as 3d of ca+.  There are indicated by setting upper
*     limit below lower limit.  This test was missing, causing incorrect
*     photoionization rate for intense radio continua. 
      if(n1 .ge. nflux .or. n1.ge.n2 ) then
        secion = 0.
        secla = 0.
        gamk = 0.
        h = 0.
        return
      endif
*
      h = 0.
      iup = min( n2 , nflux )
*
      secion = 0.
      secla = 0.
*
*     anu(i) is threshold, assume each auger electron has this energy
*     less threshold energy, IP lost in initial photoionizaiton
*     yield1 is the fraction of photos that emit 1 electron
      eauger = anu(n1) * yield1
*
*     low energies where secondary ionization cannot occur
*     will do threshold point, n1, later
      gamk = 0.
      h = 0.
      ipOffset = ipOpac - n1
*     this loop only executed for energies than cannot sec ioniz
      do i=n1+1,min(iup,ipSecIon-1)
        phisig = SummedCon(i) * OpacStack(i+ipOffset)
        gamk = gamk + phisig
        h = h + phisig * anu(i)
      end do
*     correct heating for work function
      h = h - gamk * eauger
*
*     now do the threshold point
*     do not include otscon, which may contain diffuse continuum
      phisig = (flux(n1)+otslin(n1)) * OpacStack(ipOpac)
      gamk = gamk + phisig
      ht = phisig * ( anu(n1) - eauger )
      h = h + ht
*
*     now do part where secondary ionization possible
      HeatHi = 0.
      GamHi = 0.
*     make sure we don't count twice when ipSecIon = n1
      ilo = max( n1+1 , ipSecIon )
      do i=ilo,iup
*       produce of flux and cross section
        phisig = SummedCon(i) * OpacStack(i+ipOffset)
        GamHi = GamHi + phisig
        HeatHi = HeatHi + phisig * anu(i)
      end do
*
*     add on the high energy part
      gamk = gamk + GamHi
      HeatHi = HeatHi - GamHi*eauger
      h = h + HeatHi * heatef
      secion = HeatHi * efionz
      secla = HeatHi * exctef * 1.3333
*
*     final product is heating in erg
      h = h * en1ryd
*
      end
