******************************************************************
      subroutine gbar0(ex,g)
      implicit none
*compute g-bar gaunt factor for neutrals
      include "phycon.com"
      real ex , g
*
*     written by Dima Verner
*
* Calculation of the effective Gaunt-factor by use of 
* Van Regemorter (1962, ApJ 136, 906) fits for neutrals
*    Input parameters: 
* ex - energy ryd - now K
* t  - temperature in K
*    Output parameter:
* g  - effective Gaunt factor
*
*     local variables
      real y , a , b , c,d
*
*     y = ex*157813.7/te
      y = ex/te
      if(y.lt.0.01) then
         g = 0.29*(log(1.0+1.0/y)-0.4/(y+1.0)**2)/exp(y)
      else
         if(y.gt.10.0) then
            g=0.066/sqrt(y)
         else
            a=1.5819068e-02
            b=1.3018207e+00
            c=2.6896230e-03
            d=2.5486007e+00
            g=a+b*exp(-0.5*(log(y/c)/d)**2)
         endif
      endif
*
      end
