******************************************************************************
      subroutine GetAgn( chCard )
      implicit none
*parse parameters for the AGN continuum shape command
      character chCard*80
      include "IOqq.com"
      include "limspc.par"
      include "spec.com"
      include "sptype.com"
*
*     first parameter is temperature of big bump
*     second parameter is alpha ox
*
*     local variables
      real Ratio, xnu , BigBump , XRays
      logical lgEOL
      integer i
      real fread , sexp
*
*     power law with cutoff
      nspec = nspec + 1
      if( nspec.gt.limspc ) then
        write(qq,'('' Too many continua entered; increase LIMSPC'')')
        stop
      endif
*
      chSpType(nspec) = 'AGN  '
      i = 5
*     slope is first parameter is really temperature of bump
      slope(nspec) = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
        write(qq,'('' The big bump temperature should have been on '',
     1  ''this line.   Sorry.'')')
        stop
      endif
*
      if( slope(nspec).lE.0. ) then
        write(qq,'('' Non positive temperature not allowed'',
     1  ''.   Sorry.'')')
        stop
      endif
*
*     temps are log if first le 10
      if( slope(nspec).le.10.)slope(nspec)=10.** slope(nspec)
*
*     want cutoff in ryd not kelvin
      slope(nspec) = slope(nspec) / 1.5789e5 
*
*     cutoff is second parameter is really alpha ox
      cutoff(nspec,1) = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
        write(qq,'('' alpha ox should have been on this '',
     1  ''line.   Sorry.'')')
        stop
      endif
      if( cutoff(nspec,1).gt.3. .or. cutoff(nspec,1).lt.-3.)then
        write(qq,'('' An alpha ox of'',1p,e10.2,'' looks funny to me.'',
     1  ''  Check Hazy to make sure its ok.'')') cutoff(nspec,1)
      endif
*
      if(cutoff(nspec,1) .ge.0. ) then
        write(qq,'('' The sign of alpha ox is almost '',
     1  ''certainly incorrect.   Check Hazy.'')')
      endif
*
*     bb slope is third parameter
      cutoff(nspec,2) = fread( chCard , i , 76 , lgEOL )
      if(lgEOL) cutoff(nspec,2) = -0.5
*
*     slope of X-Ray component is last parameter
      cutoff(nspec,3) = fread( chCard , i , 76 , lgEOL )
      if(lgEOL) cutoff(nspec,3) = -1.0
*
*     403.3 is ratio of energies where alpha ox defined,
*     assumed to be 2500A and 2keV
      Ratio = 403.3**(cutoff(nspec,1)-1.)
*     following code must be kept parallel with ffun1
      xnu = 0.3645
      BigBump = xnu **(-1.+cutoff(nspec,2)) * sexp( xnu/slope(nspec) )
      xnu = 147.
*     XRays = xnu**(-2.)
      XRays = xnu**(cutoff(nspec,3)-1. )
      if(BigBump.le.0. ) then
        write(qq,'('' Big Bump had zero flux at .3645 Ryd.'')')
        stop
      endif
      cutoff(nspec,1) = Ratio/(XRays/BigBump)
*
      end
