******************************************************************************
      subroutine GetFluc( chCard )
      implicit none
*parse the fluctuations command
      character chCard*80
*
      include "limelm.par"
      include "fluct.com"
      include "phycon.com"
      include "cpres.com"
      include "IOqq.com"
*
*     local variables
      integer i
      logical lgEOL , lgMatch
      real fread , flmax , flmin , period , temp
*
*     rapid density fluctuations
*     first parameter is log of period, 2 is log den max, 3 log Nmin
*
      if( lgMatch( 'ABUN', chCard ) ) then
*       abundances varied
        lgDenFluc = .false.
      else
*       density is varied
        lgDenFluc = .true.
      endif
      i = 5
*     1st number log of period in centimeters
      period = 10.**fread( chCard , i , 76 , lgEOL )
      flong = 6.2831853 / period
      temp = fread( chCard , i , 76 , lgEOL )
*     2nd number log of max hydrogen density
      flmax = 10.**temp
*     3rd number log of min hydrogen density
      flmin = 10.**fread( chCard , i , 76 , lgEOL )
      if( flmax/flmin.gt.100. ) then
        write(qq,'(''This range of density probably will not work.'')')
      endif
      if( flmax.gt.1e15 ) then
        write(qq,'(''These parameters look funny to me.  Please '',
     1  ''check Hazy.'')')
      endif
      if( lgEOL .or. (flmin.gt.flmax) ) then
        write(qq,'(''There MUST be three numbers on this line.'')')
        write(qq,'(''These must be the period(cm), max, min '',
     1  ''densities, all logs, in that order.'')')
        stop
      endif
*
*     this is optional phase shift for the command
      flcPhase = fread( chCard , i , 76 , lgEOL )
*
*     FacAbunSav = (cfirst * cos( depth*flong+flcPhase ) + csecnd)
      cfirst = (flmax-flmin) / 2.
      csecnd = (flmax+flmin) / 2.
*     >>chng 96 july 13 moved depset to abnset fac
*     if( lgDenFluc ) then
*       this is a pressure law
*       chCPres = 'SINE'
*     else
*       this is the metallicity of the gas
*       do i=3,limelm
*         depset(i) = flmax
*       end do
*     endif
*
*     now get density if this is density option (not abundances)
      if(lgDenFluc) then
        chCPres = 'SINE'
*       depth is zero for first zone
        hden = (cfirst * cos( flcPhase ) + csecnd)
        hden = log10( hden )
      endif
*
      end
