******************************************************************************
      subroutine GetGrain( chCard, lgDset  )
      implicit none
*parse parameters on grains command
      logical lgDset
      character chCard*80
*
      include "ndust.par"
      include "nqgrid.par"
      include "dstfac.com"
      include "physok.com"
      include "dheton.com"
      include "qheat.com"
      include "qheat2.com"
      include "OrgCard.com"
      include "IOqq.com"
*
*     local variables
      logical lgEOL , lgMatch , lgLinSet , lgLogOn , lgEOL1 ,
     1 lgVaryAbun
      real dep,fread , dep1
      integer i , ipnt
*
*     grain model, numbers are logs of grain abundance rel to std
      lgDustOn = .true.
      lgDset = .true.
*
*     log - linear option for grains
      lgLogOn = .false.
      if( lgMatch(' LOG' , chCard ) ) then
        lgLogOn = .true.
        lgLinSet = .false.
      else if( lgMatch('LINE' , chCard ) ) then
        lgLogOn = .true.
        lgLinSet = .true.
      endif
*
*     check for keyword function
      if( lgMatch('FUNC' , chCard ) ) then
        lgVaryAbun = .true.
      else
        lgVaryAbun = .false.
      endif
*
      i = 5
      dep = fread( chCard , i , 76 , lgEOL )
      if( lgLogOn ) then
*       log or linear was specified, which was it
        if( lgLinSet ) then
*         linear quantity enterd, and we want a log
          if( dep.gt.0. ) then
            dep = log10( dep )
          else
            write(qq,'('' Impossible for linear negative abundance.'')')
            write(qq,'('' Abundance entered was'',1P,E10.2)')dep
            write(qq,'('' Sorry.'')')
            stop
          endif
        endif
      else
*       nothing specified, check sign
*       force it to be a log - linear if greater than 0
        if( dep.gt.0. ) dep = log10( dep )
      endif
*
*     >>chng 97 july 17, change to linear since will be used throughout code
      dep = 10.** dep
*
*     NB! lgDustOn1(nd) turns on grains for some species.  None of these
*     commands turn off other grains, so successive commands will turn on
*     more and more grains.  This is intended
*
      if( lgMatch('ORIO' , chCard ) ) then
*       optional keyword ORION to use orion curves for large R grains
*       >>chng 96 nov 30, into loop for extra K Volk grain types
        lgDustOn1(3) = .true.
        lgDustOn1(4) = .true.
        dstfactor(3) = dep
        dstfactor(4) = dep
*       option to have grain abundance depend on depth
        if( lgVaryAbun ) then
          lgDustVary(3) = .true.
          lgDustVary(4) = .true.
        endif 
      else if( lgMatch(' PAH' , chCard ) ) then
*       >>chng 97 mar 1, added this keyworkd
*       optional keyword  PAH to use two PAH grain species
        call broken
        lgDustOn1(9) = .true.
        lgDustOn1(10) = .true.
        dstfactor(9) = dep
        dstfactor(10) = dep
*       for PAH grains (only) there is a qheat option for quantum heating
        if (lgMatch('QHEA',chCard)) then
          lgQHeat(9)=.true.
          lgQHeat(10)=.true.
        endif
*       option to have grain abundance depend on depth
        if( lgVaryAbun ) then
          lgDustVary(9) = .true.
          lgDustVary(10) = .true.
        endif 
      else if( lgMatch('GRAY',chCard).or.lgMatch('GREY',chCard)) then
*       >>chng 97 mar 1, added this keyworkd, 97 july 18, second spelling
*       optional keyword GRAY to use gray grain, 0.1 micron
        lgDustOn1(8) = .true.
        dstfactor(8) = dep
*       option to have grain abundance depend on depth
        if( lgVaryAbun ) then
          lgDustVary(8) = .true.
        endif 
      else if( lgMatch(' AGB' , chCard ) .or. lgMatch('AGB ' , chCard ))
     1  then
*       key used to be planetary nebula, should be agb
*       planetary nebula - post agb, from Kevin Volk
*       Try to read the second depletion factor (K Volk)
        dep1 = fread(chCard,i,76,lgEOL1)
        if(lgEOL1) dep1 = dep
*       >>chng 97 july 17, linear dep1
*       if(dep1.gt.0.) dep1 = alog10(dep1)
        if(dep1.le.0.) dep1 = 10.**dep1
*       End of changes here (K Volk)
        lgDustOn1(1) = .true.
        lgDustOn1(7) = .true.
        dstfactor(1) = dep
*       >>chng 96 nov 30, as per K Volk second parameter
        dstfactor(7) = dep1
*       option to have grain abundance depend on depth
        if( lgVaryAbun ) then
          lgDustVary(1) = .true.
          lgDustVary(7) = .true.
        endif 
      else 
*        turn one type of dust on if second number present
         ipnt = fread( chCard , i , 76 , lgEOL )
         if( lgEOL ) then
*          no second number, use default ISM dust with optional depletion
*          Mathis et al. ISM grains
           lgDustOn1(1) = .true.
           lgDustOn1(2) = .true.
           dstfactor(1) = dep
           dstfactor(2) = dep
*          option to have grain abundance depend on depth
           if( lgVaryAbun ) then
             lgDustVary(1) = .true.
             lgDustVary(2) = .true.
           endif 
         else if( ipnt.lt.1 .or. ipnt.gt.ndust ) then
           write(qq,'('' Pointer to grain type bad.  Sorry.'')')
           stop
         else
*          this branch if grain number on line
           lgDustOn1(ipnt) = .true.
           dstfactor(ipnt) = dep
*          option to have grain abundance depend on depth
           if( lgVaryAbun ) then
             lgDustVary(ipnt) = .true.
           endif 
*          Changes to dust for other grains (K Volk)
*          this branch if grain species greater than 10 - we will
*          read in optical properties from ancillary file
           if (ipnt.gt.ndust-10) call rdfile(chOrgCard,i,ipnt)
*          reads in parameters for the grain from a file if the
*          number is >= 11, the current value of ndust being 20.
*
*          Add change for quantum heating, keeping track of depletions of grain
           qdep(ipnt)=qdep(ipnt)*(10.**dep)
*          Add qheat option
*          for grains set by number (only) there is a qheat option for
*          quantum heating
           if( lgMatch('QHEA',chCard)) lgQHeat(ipnt)=.true.
*           End of changes here (K Volk)
         endif
      endif
*
*     option to turn off photoelectric heating by grain, NO HEATING
      if( lgMatch( 'O HE' , chCard ) ) then
        lgPhysOK = .false.
        lgDHetOn = .false.
      endif
*
*     option to turn off gas cooling by grain, NO COOLING
      if( lgMatch( 'O CO' , chCard ) ) then
        lgPhysOK = .false.
        lgDColOn = .false.
      endif
*
      end
