******************************************************************************
      real function hdexct(ihigh,ilow)
      implicit none
*compute Vriens Smeets collisional deexcitation for H
      integer ihigh,ilow
      include "phycon.com"
*
*     local variables
      real p,n,s,tev,ryd,enp,eni,fosc,delta,bnp,anp,gamma,rate,bn
*
*     function written by Jason Ferguson to compute the Vriens and Smeets
*     rate coeff. for collisional dexcitation between any two levels of H.
*     valid for all ihigh, ilow
*
      p=float(ihigh)
      n=float(ilow)
      tev = 8.61716e-5 * te
      ryd = 13.60583
      s = abs(p - n)
      enp = -1./p/p + 1./n/n 
      eni =  1./n/n
      anp = 2. / enp * fosc(n,p) 
      bn = 1.4*alog(n)/n - .7/n - .51/n/n + 1.16/n/n/n - 0.55/n/n/n/n
      bnp = 4./p/p/p * (1./enp/enp + 4./3.*eni/enp**3 
     1     + bn*eni*eni/enp**4)
      delta = exp(-bnp/anp) + 0.06*s*s/p/n/n
      gamma = ryd*alog(1. + n**3 * tev/ryd) * (3. + 11.*(s/n)**2) /
     1  (6. + 1.6*p*s + .3/s/s + 0.8*(p**1.5)/(s**.5)*abs(s-0.6))
      rate = (1.6e-7)*sqrt(tev)*n*n/p/p/(tev + gamma) *
     1  (anp*alog(0.3*tev/ryd + delta) + bnp)
      hdexct = rate
*
      end
