******************************************************************************
      subroutine hdread( chCard )
      implicit none
*parse the hden command
      character chCard*80
      include "ninput.com"
      include "cpres.com"
      include "called.com"
      include "varon.com"
      include "phycon.com"
      include "denpow.com"
      include "nvary.com"
      include "limext.par"
      include "limpar.par"
      include "vformt.com"
      include "nvfpnt.com"
      include "vparm.com"
      include "IOqq.com"
*
*     local variables
      integer i
      real fread
      logical lgEOL , lgMatch
*
*     log of hydrogen density
      i = 5
      hden = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
        if(lgTalk)write(qq,
     1  '('' log(n) MUST be entered with this command. STOP'')')
        stop
      endif
*
*     check for further options
      if( lgMatch('LINE',chCard) ) then
*       linear option
        if( hden.le.0. ) then
          write(qq,'('' A negative density is not physical.'')')
          stop
        else
          hden = log10( hden )
        endif
      endif
*
*     check if exponent entered
      DensityPower = fread( chCard , i , 76 , lgEOL )
      den0 = 10.**hden
      if( .not.lgEOL ) then
*        not constant density
*        some sort of power law density distribution
         if( lgMatch('COLU',chCard) ) then
*           density will depend on column density to a power
*           number entered is col den, convert to scale radius
*           at this point HDEN is log10 of hydrogen density
            rscale = 10.**fread( chCard , i , 76 , lgEOL )
            if( lgEOL ) then
               write(qq,'('' The column density MUST be set if the'',
     1         '' col den option is to be used.'')')
               stop
            endif
            chCPres = 'POWC'
         else if( lgMatch('DEPT',chCard) ) then
*           depth option, sets scale radius, log cm
            rscale = 10.**fread( chCard , i , 76 , lgEOL )
            if( lgEOL ) then
               write(qq,'('' The scale depth MUST be set if the'',
     1         '' depth option is to be used.'')')
               stop
            endif
            chCPres = 'POWD'
         else
*           radius option, will be relative to inner radius
            chCPres = 'POWR'
         endif
      endif
*     vary option
      if( lgVarOn ) then
         nparm = nparm + 1
*        pointer to where to write
         nvfpnt(nparm) = nRead
         vparm(nparm,1) = hden
         vincr(nparm) = 1.
         if( chCPres.eq.'CDEN' .or.chCPres.eq.'CPRE' ) then
            chVarFmt(nparm) = '(''HDEN='',F9.5)'
            nvarxt(nparm) = 1
         else if( chCPres.eq.'POWR' ) then
            chVarFmt(nparm) = '(''HDEN='',F9.5,'' power='',F9.5)'
            vparm(nparm,2) = DensityPower
            nvarxt(nparm) = 2
         else if( chCPres.eq.'POWC' ) then
            chVarFmt(nparm) =
     1      '(''HDEN='',F9.5,'' power='',F9.5,'' column='',F9.5)'
            nvarxt(nparm) = 3
            vparm(nparm,2) = DensityPower
            vparm(nparm,3) = log10( rscale )
         else if( chCPres.eq.'POWD' ) then
            chVarFmt(nparm) =
     1      '(''HDEN='',F9.5,'' power='',F9.5,'' depth='',F9.5)'
            nvarxt(nparm) = 3
            vparm(nparm,2) = DensityPower
            vparm(nparm,3) = log10( rscale )
         else
            write(qq,'('' Internal error in HDEN'')')
            stop
         endif
      endif
*
      end
