******************************************************************************
      subroutine he2rad
      implicit none
*evaluate radiative rates for model helium ion
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "itrdim.par"
      include "newion.com"
      include "he2tau.com"
      include "hebug.com"
      include "trace.com"
      include "otsmin.com"
      include "touton.com"
      include "TePowers.com"
      include "phycon.com"
      include "phe2lv.com"
      include "he2rsp.com"
      include "logte.com"
      include "he2str.com"
      include "he2esc.com"
      include "he2nxt.com"
      include "he2as.com"
      include "he2cbr.com"
      include "he2stat.com"
      include "heopfr.com"
      include "he2rb.com"
      include "phlevl.com"
      include "tusedcom.com"
      include "nhe2.com"
      include "he2net.com"
      include "search.com"
      include "ZoneCnt.com"
      include "caseb.com"
      include "IOqq.com"
*
*     local variables
      real a , b , c , recf,t12old,t23old,receff,alogtz,tz,x,
     1 he2jbr
      integer i,j , n
*
      data t12old,t23old/2*0./
*
      recf(a,b,c) = a + b * (alogtz-c)**2
*
*     free statement numbers >=8
*
*     evaluate rec coef for H,
*     he2rec(i,1) is rad rec
*     he2rec(i,2) is recomb efficiency,
*     he2rec(i,3) is escape probability
*
      if( lgNewIon ) then
        do n=1,nhe2lvl
          he2rec(n,3) = receff( nhe2(n) )
        end do
      endif
*
      if( lgCaseb ) then
        he2rec(1,3) = 1e-10
      endif
*
      do n=1,nhe2lvl
        he2rec(n,3) = max( he2rec(n,3) , otsmin )
*       last factor accounts for metal absorption of HeII diffuse
*       fields, computed in AddOpac, this is counted as recombination
        he2rec(n,2) = min(1.,he2rec(n,3)+(1.-he2rec(n,3))*
     1  ophe2f(n))
      end do
      he2rec(nhe2lvl+1,2) = he2rec(2,2) 
      he2rec(nhe2lvl+1,3) = he2rec(2,3) 
*
      if( lgTrace.and.lgHe2Bug ) then
        write(qq,'(7X,''HE2RAD geo recomb effic'',1P,9E10.3)')
     1  (he2rec(i,3),i=1,nhe2lvl)
        write(qq,'(7X,''HE2RAD net recomb effic'',1P,9E10.3)')
     1  (he2rec(i,2),i=1,nhe2lvl)
      endif
*
      tz = te / 4.
      if( abs(he2tus-te)/he2tus.gt. 0.002 ) then
        he2tus = te
        if( tz.gt.1e5 ) then
          he2rec(1,1) = 2.*1.52e-9 * 3.580 / te * te10 /te01/te01
        else if( tz.gt.2.6e4 ) then
          he2rec(1,1) = 2.*5.55e-11*2.395/ (te70/te10*te03)
        else if( tz.gt.2500. ) then
          he2rec(1,1) = 2.*2.08e-11*2.085 / (  sqrte*te03  )
        else
*         low te rec from Martin (1988)
          he2rec(1,1) = 2.*1.64e-11 *2. / sqrte
        endif
*
        x = 157900. / te
*       this is trick temp for hydrogenic recomb
        alogtz = alogte - 0.60206
*
        he2r2s =   0.92*2. * 10.** (-recf(8.9776,.06256,7.2302)) / tz
        he2r2p =   0.92*2. * 10.** (-recf(9.1508,.12667,4.9748)) / tz
        he2rec(2,1) = he2r2p
        he2rec(nhe2lvl+1,1) = he2r2s
        he2rec(3,1) = 2.*10.** (-recf( 9.2150 , .12898  , 4.9933 ))/tz
        he2rec(4,1) = 2.*10.** (-recf( 9.4583 , .12236  , 4.7567 ))/tz
        he2rec(5,1) = 2.*10.** (-recf( 9.6516 , .11481  , 4.5614 ))/tz
        he2rec(6,1) = 2.*10.** (-recf( 9.8112 , .10747  , 4.3913 ))/tz
        he2rec(7,1) = 2.*10.** (-recf( 9.4942 , .093811 , 4.0473 ))/tz
        he2rec(8,1) = 2.*10.** (-recf( 9.5858 , .070572 , 3.2727 ))/tz
        he2rec(9,1) = 2.*10.** (-recf( 9.5028 , .045593 , 1.4592 ))/tz
*
*       >>chng 96 june 5, big jump in rec coef at level7 (old cota level)
*causes maser in 7 -6 - don't let this happen, add extro to top level
* 666 error! change this to true levels, like Jason's hydrogen
*       b factor is amount rec coef should decrease
        b = 0.75
        do i=7,nhe2lvl-1
          a = he2rec(i,1) - he2rec(i-1,1)*b
*         amount we will subtract from here, then add to highest n
          he2rec(i,1) = he2rec(i,1) - a
          he2rec(nhe2lvl,1) = he2rec(nhe2lvl,1) + a
        end do
*
        he2rtt = he2rec(1,1)*he2rec(1,2)
        he2rb = 0.
        do i=2,nhe2lvl
          he2rtt = he2rtt + he2rec(i,1)*he2rec(i,2)
          he2rb = he2rb + he2rec(i,1)
        end do
        if( lgTrace.and.lgHe2Bug ) then
          write(qq,'(7X,''HE2RAD eval rec cof'',1P,9E10.3)') 
     1    (he2rec(i,1),i=1,nhe2lvl)
          write(qq,'(7X,''HE2RAD total effective recombination coef'',
     1    1p,e10.3,'' Case B, A='',2E10.3)')
     2    he2rtt , he2rb , he2rb+he2rec(1,1)
        endif
      else
        he2rtt = he2rec(1,1)*he2rec(1,2)
        he2rb = 0.
        do i=2,nhe2lvl
          he2rtt = he2rtt + he2rec(i,1)*he2rec(i,2)
          he2rb = he2rb + he2rec(i,1)
        end do
        if( lgTrace.and.lgHe2Bug ) then
          write(qq,'(7X,''HE2RAD not reevel rec ''
     1    ,''cof, total effective recombination coef is '',1P,E10.3)') 
     2    he2rtt
        end if
      endif
*
*     >>chng 97 feb 10, killed following, which prevented needed updates in pumping
*     skip optical depths if this is >second try on this zone
*     search is true if initial search is on
*     if( t12old.eq.he2nxt(2,1) .and. t23old.eq.he2nxt(3,2).and.
*    1  .not.lgSearch ) then
*       if(lgTrace.and.lgHe2Bug)write(qq,'(7X,''HE2RAD does NOT reeval As''
*    1  )')
*       return
*     else
*       if(lgTrace.and.lgHe2Bug) write(qq,'(7X,''HE2RAD eval As'')')
*     endif
*
      t12old = he2nxt(2,1)
      t23old = he2nxt(3,2)
*
      do j=1,nhe2lvl-1
        do i=j+1,nhe2lvl
*         >>chng 96 may 13, cap of 1 prevented maser emission
*         he2mis(i,j) = he2as(i,j)*min(1.,(he2esc(i,j)+peshe2(i,j)))
          he2mis(i,j) = he2as(i,j)*(he2esc(i,j)+peshe2(i,j))
          he2net(i,j) = he2mis(i,j) + he2dst(i,j)
        end do
      end do
*
*     these are used in HLEVEL - total decay rates
      he2radn(2) = he2net(2,1)
      he2radn(10) = (8.23*16.)
      he2radn(3) = he2net(3,1) + he2net(3,2)
      he2radn(4) = he2net(4,1) + he2net(4,2) + he2net(4,3)
      he2radn(5) = he2net(5,1) + he2net(5,2) + he2net(5,3) + he2net(5,4)
      he2radn(6) = he2net(6,1) + he2net(6,2) + he2net(6,3) +he2net(6,4)+
     1 he2net(6,5)
      he2radn(7) = he2net(7,1) + he2net(7,2) + he2net(7,3) +he2net(7,4)+
     1 he2net(7,5) + he2net(7,6)
      he2radn(8) = he2net(8,1) + he2net(8,2) + he2net(8,3) +he2net(8,4)+
     1 he2net(8,5) + he2net(8,6) + he2net(8,7)
      he2radn(9) = he2net(9,1) + he2net(9,2) + he2net(9,3) +he2net(9,4)+
     1 he2net(9,5) + he2net(9,6) + he2net(9,7) + he2net(9,8)
*
*     >>chng 97 feb 10, underflow caused neg level pops, other problems
      if( he2con(2,1).lt.1e-12*he2radn(2) ) then
        do i=2,nhe2lvl
          he2con(i,1) = 0.
        end do
      endif
*
*     total rates out of level due to induced processes
      he2bul(1) = (he2con(2,1)*he2stat(2) + he2con(3,1)*he2stat(3) + 
     1 he2con(4,1)*he2stat(4) + he2con(5,1)*he2stat(5) + he2con(6,1)*
     1 he2stat(6) + he2con(7,1)*he2stat(7)+ he2con(8,1)*he2stat(8)+
     2 he2con(9,1)*he2stat(9) ) / he2stat(1)
*
*     if( he2bul(1).gt.)
*    1  write(6,'(''>>>bul1'',1p,10e9.1)')
*    1  he2con(2,1)*he2stat(2)/(he2stat(1)*he2bul(1)) ,
*    1  he2con(3,1)*he2stat(3)/(he2stat(1)*he2bul(1)) ,
*    1  he2con(4,1)*he2stat(4)/(he2stat(1)*he2bul(1)) ,
*    1  he2con(5,1)*he2stat(5)/(he2stat(1)*he2bul(1)) ,
*    1  he2con(6,1)*he2stat(6)/(he2stat(1)*he2bul(1)) ,
*    1  he2con(7,1)*he2stat(7)/(he2stat(1)*he2bul(1)) ,
*    1  he2con(8,1)*he2stat(8)/(he2stat(1)*he2bul(1)) ,
*    2  he2con(9,1)*he2stat(9)/(he2stat(1)*he2bul(1))
*     write(6,'(''>>>con1'',1p,10e9.1)')(he2con(i,1),i=2,9)
*
      he2bul(2) = (he2con(3,2)*he2stat(3) + he2con(4,2)*he2stat(4)
     1 + he2con(5,2)*he2stat(5) + he2con(6,2)*he2stat(6) +he2con(7,2)*
     1  he2stat(7) + he2con(8,2)*he2stat(8) + he2con(9,2)*he2stat(9))
     2 / ( he2stat(2) + he2stat(10) )
      he2bul(3) = he2con(3,1) + he2con(3,2) + ( he2con(4,3)*he2stat(4) +
     1 he2con(5,3)*he2stat(5) + he2con(6,3)*he2stat(6) + he2con(7,3)*
     1 he2stat(7) + he2con(8,3)*he2stat(8) + he2con(9,3)*he2stat(9))/
     2 he2stat(3)
      he2bul(4) = he2con(4,1) +he2con(4,2) +he2con(4,3)+
     1 (he2con(5,4)*he2stat(5) + he2con(6,4)*he2stat(6) +
     2 he2con(7,4)*he2stat(7)+he2con(8,4)*he2stat(8)+
     3 he2con(9,4)*he2stat(9)) / he2stat(4)
      he2bul(5) = he2con(5,1) + he2con(5,2) + he2con(5,3) + he2con(5,4)+
     1( he2con(6,5)*he2stat(6) + he2con(7,5)*he2stat(7) +
     2 he2con(8,5)*he2stat(8)+he2con(9,5)*he2stat(9) ) / he2stat(5)
      he2bul(6) = he2con(6,1) + he2con(6,2) + he2con(6,3) + he2con(6,4)+
     1 he2con(6,5) + (he2con(7,6)*he2stat(7) +he2con(8,6)*he2stat(8)
     2 + he2con(9,6)*he2stat(9) ) / he2stat(6)
      he2bul(7) = he2con(7,1) + he2con(7,2) + he2con(7,3) + he2con(7,4)+
     1 he2con(7,5) + he2con(7,6) +
     2 (he2con(8,7)*he2stat(8)+he2con(9,7)*he2stat(9) ) /he2stat(7)
      he2bul(8) = he2con(8,1)+he2con(8,2)+he2con(8,3)+he2con(8,4)+
     1 he2con(8,5)+he2con(8,6)+he2con(8,7)+
     2 he2con(9,8)*he2stat(9)/he2stat(8)
      he2bul(9) = he2con(9,1)+he2con(9,2)+he2con(9,3)+he2con(9,4)+
     1 he2con(9,5)+he2con(9,6)+he2con(9,7)+he2con(9,8)
*
      if( lgTrace.and.lgHe2Bug ) then
        write(qq,'(7X,''HE2RAD finds arrays, with optical depths defi''
     1  ,''ned? '',L1)') lgTauOutOn
        do i=2,nhe2lvl
          write(qq,'(6X,''up:'',I2,10I10)') i,(j,j=1,i-1)
          write(qq,'(9X,''A*esc'',1P,8E10.2)') (he2mis(i,j)  ,j=1,i-1)
          write(qq,'(9X,''A-net'',1P,8E10.2)') (he2net(i,j)  ,j=1,i-1)
          write(qq,'(9X,''A*Dst'',1P,8E10.2)') (he2dst(i,j)  ,j=1,i-1)
          write(qq,'(9X,''tauin'',1P,8E10.2)') (he2nxt(i,j)  ,j=1,i-1)
          write(qq,'(9X,''t tot'',1P,8E10.2)') (he2lim(i,j)  ,j=1,i-1)
          write(qq,'(9X,''Esc  '',1P,8E10.2)') (he2esc(i,j)  ,j=1,i-1)
          write(qq,'(9X,''StrkE'',1P,8E10.2)') (peshe2(i,j)  ,j=1,i-1)
          write(qq,'(9X,''B(ul)'',1P,8E10.2)') (he2con(i,j)  ,j=1,i-1)
          write(qq,'(9X,''OccNm'',1P,8E10.2)') (he2jbr(i,j)  ,j=1,i-1)
          write(qq,'(9X,''C(ul)'',1P,8E10.2)')(he2cll(i,j)*eden,j=1,i-1)
        end do
*
        write(qq,'(14X,10I9)') (i,i=1,10)
        write(qq,'(7X,''HE2RAD  rad'',1P,10E9.2)') 
     1  (he2radn(i),i=1,10)
        write(qq,'(7X,''HE2RAD  bul'',1P,10E9.2)') 
     1  (he2bul(i),i=1,10)
      endif
*
      end
