******************************************************************************
      real function hmiopc( freq )
      implicit none
*derive total H- H minus opacity
      real freq
      integer ncrs
      parameter (ncrs=33)
      real y2(ncrs)
      real ener(ncrs) , crs(ncrs) , x , y ,
     1 energy
      logical lgFirst
      save lgFirst , ener , crs , y2
*
*     bound free cross section (x10**-17 cm^2) from Doughty et al
*     1966, MNRAS 132, 255; good agreement with Wishart MNRAS 187, 59p.
      data crs/0.    ,0.124 ,0.398 ,0.708 ,1.054 ,1.437 ,1.805 ,2.176
     1 ,2.518 ,2.842 ,3.126 ,3.377 ,3.580 ,3.741 ,3.851 ,3.913 ,3.925
     2 ,3.887 ,3.805 ,3.676 ,3.511 ,3.306 ,3.071 ,2.810 ,2.523 ,2.219
     3 ,1.898 ,1.567 ,1.233 ,.912 ,.629 ,.39 ,.19/
*
*     photoelectron energy, add 0.05552 to get incoming energy (Ryd)
      data ener/ 0.,  0.001459 ,0.003296 ,0.005256 ,0.007351 ,0.009595
     1 ,0.01201 ,0.01460 ,0.01741 ,0.02044 ,0.02375 ,0.02735 ,0.03129
     2 ,0.03563 ,0.04043 ,0.04576 ,0.05171 ,0.05841 ,0.06601 ,0.07469
     3 ,0.08470 ,0.09638 ,0.1102 ,0.1268 ,0.1470 ,0.1723 ,0.2049 ,0.2483
     4 ,0.3090 ,0.4001 ,0.5520 ,0.8557 , 1.7669 /
*
      data lgFirst/.true./
*
      if( lgFirst ) then
*       set up coefficients for spline
        call spline( ener , crs , ncrs , 2e31,2e31, y2 )
        lgFirst = .false.
      endif
*
      energy = freq - 0.05552
      if( energy.lt.ener(1) .or. energy.gt.ener(ncrs) ) then
        hmiopc = 0.
      else
        x = energy
        call splint( ener , crs , y2 , ncrs , x , y )      
        hmiopc = y * 1e-17
      endif
*
      end
