******************************************************************************
      real function hmrate( a , b , c )
      implicit none
*compile molecular rates using Hollenback and Mckee fits
      real a , b , c
      include "phycon.com"
*
*     local variables
      real cfac , bfac
*
*     function to evaluate Hollenbach and McKee ApJ 342, 306.
*     A is leading coef, B is power temp depen, and C is exponential
*     rate = a * (te/300K)^b * exp(-c/te)
*
      if( c/te.gt.50. ) then
         hmrate = 0.
         return
      endif
*
      if( c.eq.0. ) then
         cfac = 1.
      else
         cfac = exp( -c/te )
      endif
*
      if( b.eq.0. ) then
         bfac = 1.
      else
         bfac = (te/300.) ** b
      endif
*
      hmrate = a * bfac * cfac
*
      end
