      subroutine ipShells( nelem )
      implicit none
*assign continuum energy pointers to shells for all atoms
      integer nelem
*
      include "evryd.par"
      include "limelm.par"
      include "ncell.par"
      include "rfield.com"
      include "Heavy.com"
      include "NumUpper.com"
      include "photo.com"
      include "pntbug.com"
      include "trace.com"
*     include "Valence.com"
      include "ElmntSym.com"
      include "KshllEnr.com"
      include "IonStage.com"
      include "LineLabl.com"
      include "nsShells.com"
      include "ipElement.com"
      include "Shell.com"
      include "IOqq.com"
* 
*     local variables
      character chLab*4
      integer ion , nelec,nshell,imax,ig0,ig1,ipoint,LimitSh,ns,
     1 ipConSafe , ipLinSafe
      real thresh
      integer nnuc
      parameter (nnuc=30)
*     character chShell(7)*2
*     remember data last
*     data chShell/'1s', '2s', '2p', '3s', '3p', '3d', '4s'/
*
*     fills in pointers to valence shell ionization threshold
*     ip(nelem) is array of pointers
*     nelem is element number
*     PH1(a,b,c,d)
*     a=1 => thresh, others fitting parameters
*     b atomic number
*     c number of electrons
*     d shell number 7-1
*
*     check within array bounds
      if( nelem.gt.nnuc ) then
        write(qq,*)' ipshell called with too large an element number'
        stop
      endif
*
*     threshold in Ryd
*     ion=1 for atom, up to nelem for hydrogenic
      do ion=1,nelem
*       number of bound electrons
        nelec = nelem - ion + 1
        call outer(nelem,nelec,imax,ig0,ig1)
*       subroutine outer(iz,in,imax,ig0,ig1)
*       iz - atomic number from 1 to 30 (integer) 
*       in - number of electrons from 1 to iz (integer)
*       Output: imax - number of the outer shell
*
*       nsShells(nelem,ion) is outer shell number for ion with nelec electrons
        nsShells(nelem,ion) = imax
*       loop on all inner shells, valence shell
        do nshell=1,imax
          thresh = PH1(1,nelem,nelec,nshell) / evryd
          if( thresh.le.0.1 ) then
*           negative ip shell does not exist, set upper limit
*           to less than lower limit so this never looped upon
*           these are used as flags by LimitSh to check whether
*           this is a real shell - if 1 or 2 is changed - change LimitSh!!
            ipElement(nelem,ion,nshell,1) = 2
            ipElement(nelem,ion,nshell,2) = 1
          else
*           this is lower limit to range
            ipElement(nelem,ion,nshell,1) = ipoint( thresh )
*           this is upper limit to range
*           LimitSh is an integer function, returns pointer
*           to threshold of next major shell.  For k-shell it
*           returns the values KshellLimit, default=7.35e4
*           >>chng 96 sep 26, had been below, result zero cross sec at 
*           many energies where opacity project did not produce broken 
*           out cross section
            ipElement(nelem,ion,nshell,2) = LimitSh( ion ,
     1      nshell , nelem ) 
          endif
        end do
*       this is valence pointer
*       generate label for ionization stage
        chLab(1:2) = chElementSym(nelem)
        chLab(3:4) = chIonStage(ion)
        ipElement(nelem,ion,imax,1) = ipConSafe( thresh , chLab )
*       pointer to valence electron ionization potential
*       ipValence(nelem,ion) = ipElement(nelem,ion,imax,1)
*       write(66,'(1p,6e11.3)') thresh
*       write(66,'(a4,1p,6e11.3)') chLab,thresh,anu(ipVal(ion)),
*    1  anu( ipElem(ion,imax,1) ) , (anu(ipVal(ion))-thresh)/thresh
        ipHeavy(nelem,ion) = ipElement(nelem,ion,imax,1)
*       this is set of 3/4 of valence shell IP, this is important
*       source of ots deep in cloud
        ipLyHeavy(nelem,ion) = ipLinSafe( thresh *0.75 ,chLab )
      end do
*
*     this is for backwards compatability with cambridge code
*
      if(lgTrace.and.lgPointBug ) then
        do ion=1,nelem
          write(qq,'(''Ion:'',2i3,1x,2a2,'' total shells:'',i3)')
     1    nelem,ion,chElementSym(nelem), chIonStage(ion),
     2    nsShells(nelem,ion)
          do ns=1,nsShells(nelem,ion)
            write(qq,'('' shell'',i3,1p,1x,a2,
     1      '' range eV'',10(e9.2,''-'',e8.2))')
     2      ns, chShell(ns),
     1      anu(ipElement(nelem,ion,ns,1))*evryd,
     2      anu(ipElement(nelem,ion,ns,2))*evryd
          end do
        end do
      endif
*
      end
