******************************************************************************
      subroutine linadd(xInten , lam , chLab , chInfo)
      implicit none
*enter lines into the line storage array, called once per zone
*     xInten - local emissivity per unit vol, no fill fac
*     lam integer wavelength
*     chLab character label for ion
*     chInfo - type of entry for line - given below
      real xInten
      integer lam
      character chLab*4 , chInfo*1
*
      include "nlines.par"
      include "sumlab.com"
      include "sum.com"
      include "linsum.com"
      include "dRdVeff.com"
      include "IOqq.com"
      include "called.com"
*
*     main routine to actually enter lines into the line storage array
*     called at top level within routine lines
*     called series of times in routine PutLine for lines transferred
*
*     chInfo is char variable indicating type of line this is
*     'c' cooling
*     'h' heating
*     'i' information only
*     'r' recombination line
*
      nsum = nsum + 1
      if( ipass .ne. 0) then
*       not first pass, sum lines only
*       total emission from vol
        sumlin(nsum) = sumlin(nsum) + xInten * dVeff
*       local emissivity in line
        emslin(nsum) = xInten
      else
*       check if number of lines in arrays exceeded
        if( nsum.gt.NLINES) then
          write(qq,'(I5,'' lines is too many for LINADD.''
     1    )') nsum
          write(qq,'(1x,a4,i6)') chLab , lam
          write(qq,'('' Increase the value of NLINES everywhere '',
     1    ''in the code.'')')
          stop
        endif
*
        if( chInfo.ne.'c' .and. chInfo.ne.'h' .and. chInfo.ne.'i'.AND.
     1    chInfo.ne.'r' ) then
          write(qq,'('' Type label for line'',I5,A4,'' is '',a1,
     1    '' which I do not understand.'')') lam,chLab,chInfo
        endif
        chSumTyp(nsum) = chInfo
*       number of lines ok, set parameters for first pass
        sumlin(nsum) = 0.
        lin(nsum) = lam
        chALab(nsum) = chLab
      endif
*
      end
