      block data LineData
      implicit none
*block data with atomic data for all level 1 lines
*
      include "nta.par"
      include "ipLnArry.par"
      include "TLineEXP.com"
      include "TauDmmy.com"
*
*     Kirk went over all the level 1 line 96 Feb 7, updated to
*     be parallel to Dima's data
*
*     ipLnWlAng REALLY is wl in angstroms, 1micron = 1e4 ang
*     either a gf or an Aul must be entered.  gf is the
*     preferred value, in which case nothing need be 
*     entered for ipLnAul.  If the ipLnAul is given then the
*     cell t(ipLnGu) must be set to zero here.
*
*     a dummy line optical dpeth array
      data TauDummy(ipLnWlAng)/0./,TauDummy(ipLnGl)/0./,
     1  TauDummy(ipLnGu)/0./, TauDummy(ipLnGF)/0./, 
     2  TauDummy(ipLnEnrWN)/0./ ,TauDummy(ipLnIonStg)/0./,
     2  TauDummy(ipLnNelem)/0./ TauDummy(ipLnRedis)/0./,
     1  TauDummy(ipLnAul)/0./
*
*     carbon line optical depth data
*     arrays all explained above, where commons first occur
      data t1656(ipLnWlAng)/1656./,t1656(ipLnGl)/9./,
     1  t1656(ipLnGu)/9./, t1656(ipLnGF)/1.332/,
     2  t1656(ipLnEnrWN)/60343./ ,t1656(ipLnIonStg)/1./ ,
     3  t1656(ipLnNelem)/6./ , t1656(ipLnRedis)/1./
*
      data t9830(ipLnWlAng)/9830./,t9830(ipLnGl)/9./, 
     1  t9830(ipLnGu)/5./ , t9830(ipLnGF)/2.36e-11/,
     2  t9830(ipLnEnrWN)/10159./,t9830(ipLnIonStg)/1./, 
     3  t9830(ipLnNelem)/6./ , t9830(ipLnRedis)/1./
*
      data t8727(ipLnWlAng)/8727./, t8727(ipLnGl)/5./, 
     1  t8727(ipLnGu)/1./, t8727(ipLnGF)/6.05e-9/,
     2  t8727(ipLnEnrWN)/11454.7/, t8727(ipLnIonStg)/1./,
     3  t8727(ipLnNelem)/6./ , t8727(ipLnRedis)/1./ 
*
      data t2326(ipLnWlAng)/2326./, t2326(ipLnGl)/6./, 
     1  t2326(ipLnGu)/12./, t2326(ipLnGF)/5.56e-7/,
     2  t2326(ipLnEnrWN)/42990./,t2326(ipLnIonStg)/2./, 
     3  t2326(ipLnNelem)/6./ , t2326(ipLnRedis)/1./ 
*
      data t1335(ipLnWlAng)/1335./,t1335(ipLnGl)/6./, 
     1  t1335(ipLnGu)/10./, t1335(ipLnGF)/0.75/,
     2  t1335(ipLnEnrWN)/74889./,t1335(ipLnIonStg)/2./, 
     3  t1335(ipLnNelem)/6./, t1335(ipLnRedis)/1./
*
*     A's 
*     >>refer Fleming, J., Bell, K.L, Hibbert, A., Vaeck, N., Godefroid, M.R.
*     >>refer 1996, MNRAS, 279, 1289
      data t1909(ipLnWlAng)/1910./,t1909(ipLnGl)/1./, 
     1  t1909(ipLnGu)/3./, t1909(ipLnGF)/0./,
     2  t1909(ipLnEnrWN)/52338./,t1909(ipLnIonStg)/3./, 
     3  t1909(ipLnNelem)/6./, t1909(ipLnRedis)/1./,
     1  t1909(ipLnAul)/103.8/
*
      data t977(ipLnWlAng)/977./,t977(ipLnGl)/1./,
     1  t977(ipLnGu)/3./,t977(ipLnGF)/0.767/,
     1  t977(ipLnEnrWN)/102351./ ,t977(ipLnIonStg)/3./, 
     2  t977(ipLnNelem)/6./, t977(ipLnRedis)/1./
*
      data t1550(ipLnWlAng)/1551./ ,t1550(ipLnGl)/2./,
     1  t1550(ipLnGu)/2./, t1550(ipLnGF)/0.1904/,
     2  t1550(ipLnEnrWN)/64484./ ,t1550(ipLnIonStg)/4./, 
     3  t1550(ipLnNelem)/6./, t1550(ipLnRedis)/1./
*
      data t1548(ipLnWlAng)/1548./ ,t1548(ipLnGl)/2./,
     1  t1548(ipLnGu)/4./, t1548(ipLnGF)/0.380/,
     2  t1548(ipLnEnrWN)/64591./ ,t1548(ipLnIonStg)/4./, 
     3  t1548(ipLnNelem)/6./, t1548(ipLnRedis)/1./
*
      data t386(ipLnWlAng)/386./,t386(ipLnGl)/1./,
     1  t386(ipLnGu)/3./, t386(ipLnGF)/0.232/,
     2  t386(ipLnEnrWN)/258931./,t386(ipLnIonStg)/3./,
     3  t386(ipLnNelem)/6./, t386(ipLnRedis)/1./
*
      data t310(ipLnWlAng)/310./,t310(ipLnGl)/1./,
     1  t310(ipLnGu)/3./, t310(ipLnGF)/0.0284/,
     1  t310(ipLnEnrWN)/322402.8/,t310(ipLnIonStg)/3./,
     3  t310(ipLnNelem)/6./, t310(ipLnRedis)/1./
*
*     CIII* 1175, lower level = upper level of 1909
      data c31175(ipLnWlAng)/1176./,c31175(ipLnGl)/9./, 
     1  c31175(ipLnGu)/9./, c31175(ipLnGF)/0./,
     2  c31175(ipLnEnrWN)/85055.71/,c31175(ipLnIonStg)/3./, 
     3  c31175(ipLnNelem)/6./, c31175(ipLnRedis)/1./,
     1  c31175(ipLnAul)/1.33e9/
*
      data t291(ipLnWlAng)/291./,t291(ipLnGl)/1./,
     1  t291(ipLnGu)/3./, t291(ipLnGF)/0.045/,
     1  t291(ipLnEnrWN)/343258./,t291(ipLnIonStg)/3./, 
     3  t291(ipLnNelem)/6./, t291(ipLnRedis)/1./
*
      data t280(ipLnWlAng)/280./,t280(ipLnGl)/1./,
     1  t280(ipLnGu)/3./, t280(ipLnGF)/0.016/,
     2  t280(ipLnEnrWN)/357092./,t280(ipLnIonStg)/3./, 
     3  t280(ipLnNelem)/6./, t280(ipLnRedis)/1./
*
      data t274(ipLnWlAng)/274./,t274(ipLnGl)/1./,
     1  t274(ipLnGu)/3./, t274(ipLnGF)/0.011/,
     2  t274(ipLnEnrWN)/364896.9/,t274(ipLnIonStg)/3./, 
     3  t274(ipLnNelem)/6./, t274(ipLnRedis)/1./
*
      data t270(ipLnWlAng)/270./,t270(ipLnGl)/1./,
     1  t270(ipLnGu)/3./, t270(ipLnGF)/0.0077/,
     2  t270(ipLnEnrWN)/369931.9/,t270(ipLnIonStg)/3./, 
     3  t270(ipLnNelem)/6./, t270(ipLnRedis)/1./
*
      data t312(ipLnWlAng)/312./,t312(ipLnGl)/2./,
     1  t312(ipLnGu)/6./, t312(ipLnGF)/0.4056/,
     2  t312(ipLnEnrWN)/320071./,t312(ipLnIonStg)/4./ ,
     3  t312(ipLnNelem)/6./, t312(ipLnRedis)/1./
*
*     carbon fine structure lines added by Jim Kingdon
      data t610(ipLnWlAng)/6.094e6/,t610(ipLnGl)/1./,
     1  t610(ipLnGu)/3./, t610(ipLnGF)/1.33e-9/,
     2  t610(ipLnEnrWN)/16.41/ ,t610(ipLnIonStg)/1./ ,
     3  t610(ipLnNelem)/6./, t610(ipLnRedis)/-1./
*
      data t370(ipLnWlAng)/3.697e6/,t370(ipLnGl)/3./,
     1  t370(ipLnGu)/5./, t370(ipLnGF)/2.75e-9/,
     2  t370(ipLnEnrWN)/27.05/ ,t370(ipLnIonStg)/1./ ,
     3  t370(ipLnNelem)/6./, t370(ipLnRedis)/-1./
*
      data t157(ipLnWlAng)/1.57e6/,t157(ipLnGl)/2./,
     1  t157(ipLnGu)/4./, t157(ipLnGF)/3.33e-9/,
     2  t157(ipLnEnrWN)/63.42/ ,t157(ipLnIonStg)/2./ ,
     3  t157(ipLnNelem)/6./, t157(ipLnRedis)/-1./
*
*     nitrogen line optical depth data
      data t1085(ipLnWlAng)/1085./ ,t1085(ipLnGl)/9./,
     1  t1085(ipLnGu)/15./, t1085(ipLnGF)/0.981/,
     2  t1085(ipLnEnrWN)/92155.7/ ,t1085(ipLnIonStg)/2./, 
     3  t1085(ipLnNelem)/7./, t1085(ipLnRedis)/1./
*
*     ref A 
*     >>refer Brage, T., Froese-Fischer, C., Judge, P.G. 1995,
*     >>refer ApJ 445, 457
      data t1750(ipLnWlAng)/1750./ ,t1750(ipLnGl)/6./,
     1  t1750(ipLnGu)/12./, t1750(ipLnGF)/0./,
     2  t1750(ipLnEnrWN)/57129./ ,t1750(ipLnIonStg)/3./, 
     3  t1750(ipLnNelem)/7./, t1750(ipLnRedis)/1./ ,
     4  t1750(ipLnAul)/288./
*
      data t990(ipLnWlAng)/990./ ,t990(ipLnGl)/6./,
     1  t990(ipLnGu)/10./, t990(ipLnGF)/0.732/,
     2  t990(ipLnEnrWN)/100910.7/ ,t990(ipLnIonStg)/3./, 
     3  t990(ipLnNelem)/7./, t990(ipLnRedis)/1./
*
*     A 
*     >>refer Fleming, J., Brage, T., Bell, K.L., Vaeck, N.,
*     >>refer Hibbert, A., Godefroid, M.R., Froese-Fischer, C. 1995, ApJ,
*     >>refer 455, 758
*     >>refer Froese Fischer, C. 1995, ApJ 455, 758
      data t1486(ipLnWlAng)/1488./ ,t1486(ipLnGl)/1./,
     1  t1486(ipLnGu)/3./,t1486(ipLnGF)/0./,
     2  t1486(ipLnEnrWN)/67273./ ,t1486(ipLnIonStg)/4./, 
     3  t1486(ipLnNelem)/7./, t1486(ipLnRedis)/1./,
     1  t1486(ipLnAul)/580./
*
      data t765(ipLnWlAng)/765./ ,t765(ipLnGl)/1./,
     1  t765(ipLnGu)/3./, t765(ipLnGF)/0.616/,
     2  t765(ipLnEnrWN)/130695./ ,t765(ipLnIonStg)/4./, 
     3  t765(ipLnNelem)/7./, t765(ipLnRedis)/1./
*
      data t1243(ipLnWlAng)/1243./ ,t1243(ipLnGl)/2./,
     1  t1243(ipLnGu)/2./, t1243(ipLnGF)/0.156/,
     2  t1243(ipLnEnrWN)/80464./ ,t1243(ipLnIonStg)/5./, 
     3  t1243(ipLnNelem)/7./, t1243(ipLnRedis)/1./
*
      data t1239(ipLnWlAng)/1239./ ,t1239(ipLnGl)/2./,
     1  t1239(ipLnGu)/4./, t1239(ipLnGF)/0.314/,
     2  t1239(ipLnEnrWN)/80722./ ,t1239(ipLnIonStg)/5./, 
     3  t1239(ipLnNelem)/7./, t1239(ipLnRedis)/1./
*
      data t374g(ipLnWlAng)/373./ ,t374g(ipLnGl)/2./,
     1  t374g(ipLnGu)/4./, t374g(ipLnGF)/0.882/,
     2  t374g(ipLnEnrWN)/267238.4/ ,t374g(ipLnIonStg)/3./, 
     3  t374g(ipLnNelem)/7./, t374g(ipLnRedis)/1./
*
*     this is the stronger of the two lines
      data t374x(ipLnWlAng)/374./ ,t374x(ipLnGl)/4./,
     1  t374x(ipLnGu)/6./, t374x(ipLnGF)/1.588/,
     2  t374x(ipLnEnrWN)/267244.0/ ,t374x(ipLnIonStg)/3./, 
     3  t374x(ipLnNelem)/7./, t374x(ipLnRedis)/1./
*
      data t1200(ipLnWlAng)/1200./,t1200(ipLnGl)/4./,
     1  t1200(ipLnGu)/12./, t1200(ipLnGF)/1.3/,
     2  t1200(ipLnEnrWN)/83335.6/,t1200(ipLnIonStg)/1./, 
     3  t1200(ipLnNelem)/7./, t1200(ipLnRedis)/1./
*
*     A=180.2 from 
*     >>refer Calamai, A.G., & Johnson, C.E., 1991, Phys Rev A,
*     >>refer 44, 218
*     revised to 189.6 from 
*     >>refer Brage, T., Hibbert, A., Leckrone, D.S. 1997, ApJ, 478, 423
      data t2140(ipLnWlAng)/2140./,t2140(ipLnGl)/9./,
     1  t2140(ipLnGu)/5./,t2140(ipLnGF)/0./ ,
     2  t2140(ipLnEnrWN)/46700./ ,t2140(ipLnIonStg)/2./, 
     3  t2140(ipLnNelem)/7./, t2140(ipLnRedis)/1./ ,
     1  t2140(ipLnAul)/189.6/
*
      data t671(ipLnWlAng)/671./,t671(ipLnGl)/9./, 
     1  t671(ipLnGu)/9./, t671(ipLnGF)/0.69/,
     2  t671(ipLnEnrWN)/148923.7/,t671(ipLnIonStg)/2./, 
     3  t671(ipLnNelem)/7./ , t671(ipLnRedis)/1./ 
*
      data t315(ipLnWlAng)/315./ ,t315(ipLnGl)/6./,
     1  t315(ipLnGu)/10./,t315(ipLnGF)/1.1686/,
     2  t315(ipLnEnrWN)/317401/ ,t315(ipLnIonStg)/3./, 
     3  t315(ipLnNelem)/7./, t315(ipLnRedis)/1./
*
      data t324(ipLnWlAng)/324./ ,t324(ipLnGl)/6./,
     1  t324(ipLnGu)/6./,t324(ipLnGF)/0.3129/,
     2  t324(ipLnEnrWN)/308805/ ,t324(ipLnIonStg)/3./, 
     3  t324(ipLnNelem)/7./, t324(ipLnRedis)/1./
*
      data t333(ipLnWlAng)/333./ ,t333(ipLnGl)/6./,
     1  t333(ipLnGu)/2./,t333(ipLnGF)/0.0369/,
     2  t333(ipLnEnrWN)/300735/ ,t333(ipLnIonStg)/3./, 
     3  t333(ipLnNelem)/7./, t333(ipLnRedis)/1./
*
      data t209(ipLnWlAng)/209./ ,t209(ipLnGl)/2./,
     1  t209(ipLnGu)/6./, t209(ipLnGF)/0.477/,
     2  t209(ipLnEnrWN)/477817./ ,t209(ipLnIonStg)/5./, 
     3  t209(ipLnNelem)/7./, t209(ipLnRedis)/1./
*
*     fine structure lines 
*     [N II] 121.8
      data t122(ipLnWlAng)/1.218e6/ ,t122(ipLnGl)/3./,
     1  t122(ipLnGu)/5./, t122(ipLnGF)/0./,
     2  t122(ipLnEnrWN)/82.13/ ,t122(ipLnIonStg)/2./, 
     3  t122(ipLnNelem)/7./, t122(ipLnRedis)/-1./,
     4  t122(ipLnAul)/7.40e-6/
*
*     [N II] 205.5
      data t205(ipLnWlAng)/2.055e6/ ,t205(ipLnGl)/1./,
     1  t205(ipLnGu)/3./, t205(ipLnGF)/3.93e-9/,
     2  t205(ipLnEnrWN)/48.67/ ,t205(ipLnIonStg)/2./, 
     3  t205(ipLnNelem)/7./, t205(ipLnRedis)/-1./,
     4  t205(ipLnAul)/2.07e-6/
*
*     big disagreement in A for this line, other val is 2x larger
*     see review in DEO Seaton 70th birthday
      data t57(ipLnWlAng)/5.7e5/ ,t57(ipLnGl)/2./,
     1  t57(ipLnGu)/4./, t57(ipLnGF)/9.35e-9/,
     2  t57(ipLnEnrWN)/174.76/ ,t57(ipLnIonStg)/3./, 
     3  t57(ipLnNelem)/7./, t57(ipLnRedis)/-1./
*
*     oxygen line optical depth data
*     [OI] A's from 
*     >>refer Baluja, K.L., & Zeippen, C.J. 1988, J Phys B 21, 1455
      data t6300(ipLnWlAng)/6300./,t6300(ipLnGl)/5./, 
     1  t6300(ipLnGu)/5./, t6300(ipLnGF)/0./,
     2  t6300(ipLnEnrWN)/15867./,t6300(ipLnIonStg)/1./, 
     3  t6300(ipLnNelem)/8./, t6300(ipLnRedis)/1./,
     4  t6300(ipLnAul)/5.65e-3/
*
      data t6363(ipLnWlAng)/6363./,t6363(ipLnGl)/3./, 
     1  t6363(ipLnGu)/5./, t6363(ipLnGF)/0./,
     2  t6363(ipLnEnrWN)/15709./,t6363(ipLnIonStg)/1./, 
     3  t6363(ipLnNelem)/8./, t6363(ipLnRedis)/1./,
     4  t6363(ipLnAul)/1.82e-3/
*
*     A from NISt 96
      data t5577(ipLnWlAng)/5577./ ,t5577(ipLnGl)/5./, 
     1  t5577(ipLnGu)/1./, t5577(ipLnGF)/0./,
     2  t5577(ipLnEnrWN)/17924.7/ ,t5577(ipLnIonStg)/1./, 
     3  t5577(ipLnNelem)/8./, t5577(ipLnRedis)/1./ ,
     4  t5577(ipLnAul)/1.26/
*
      data t834(ipLnWlAng)/834./ ,t834(ipLnGl)/4./, 
     1  t834(ipLnGu)/12./, t834(ipLnGF)/1.064/,
     2  t834(ipLnEnrWN)/119932.56/ ,t834(ipLnIonStg)/2./, 
     3  t834(ipLnNelem)/8./, t834(ipLnRedis)/1./
*
*     split into doublet by KtK 3/95; gf from 
*     >>refer Nussbaumer, H., & Storey, P. J. 1981, AA, 99, 177
      data t1661(ipLnWlAng)/1661./ ,t1661(ipLnGl)/3./,
     1  t1661(ipLnGu)/5./,t1661(ipLnGF)/4.38e-7/ ,
     2  t1661(ipLnEnrWN)/60211.8/ ,t1661(ipLnIonStg)/3./, 
     3  t1661(ipLnNelem)/8./,  t1661(ipLnRedis)/1./
*
      data t1666(ipLnWlAng)/1666./ ,t1666(ipLnGl)/5./,
     1  t1666(ipLnGu)/5./,t1666(ipLnGF)/1.09e-6/ ,
     2  t1666(ipLnEnrWN)/60018.4/ ,t1666(ipLnIonStg)/3./, 
     3  t1666(ipLnNelem)/8./, t1666(ipLnRedis)/1./
*
      data t835(ipLnWlAng)/835./,t835(ipLnGl)/9./, 
     1  t835(ipLnGu)/15./, t835(ipLnGF)/0.963/,
     2  t835(ipLnEnrWN)/119833./,t835(ipLnIonStg)/3./, 
     3  t835(ipLnNelem)/8./, t835(ipLnRedis)/1./
*
*     A from NISt 96, A from
*     >>refer Brage, T., Judge, P.G., & Brekke, P., 1996, ApJ 464, 1030
      data t1402(ipLnWlAng)/1402./,t1402(ipLnGl)/6./,
     1  t1402(ipLnGu)/12./,t1402(ipLnGF)/0./ ,
     2  t1402(ipLnEnrWN)/71500./,t1402(ipLnIonStg)/4./, 
     3  t1402(ipLnNelem)/8./, t1402(ipLnRedis)/1./ ,
     4  t1402(ipLnAul)/ 1179./
*
*     split into quintuplet by KtK 3/95
*     gf from 
*     >>refer Merkelis, G., Vilkas, M.J., Gaigalas, G., & Kisielius, R. 1994,
*     >>refer priviate communication
*     via Pradhan & Preng (1994 Seaton and Osterbrock Emission Line meeting
*     at StScI 5/94)
*     data tO1400(ipLnWlAng)/1400./,tO1400(ipLnGl)/2./,
*    1  tO1400(ipLnGu)/2./,tO1400(ipLnGF)/1.06E-06/ ,
*    2  tO1400(ipLnEnrWN)/71439.8/,tO1400(ipLnIonStg)/4./, 
*    3  tO1400(ipLnNelem)/8./, tO1400(ipLnRedis)/1./
* 666 error! replace first entry with these five
*     data tO1397(ipLnWlAng)/1397./,tO1397(ipLnGl)/2./,
*    1  tO1397(ipLnGu)/4./,tO1397(ipLnGF)/2.67e-8/
*    2  tO1397(ipLnEnrWN)/71570.1/,tO1397(ipLnIonStg)/4./, 
*    3  tO1397(ipLnNelem)/8./, tO1397(ipLnRedis)/1./
*      
*    data tO1407(ipLnWlAng)/1407./,tO1407(ipLnGl)/4./,
*    1  tO1407(ipLnGu)/2./,tO1407(ipLnGF)/1.05e-6/,
*    2  tO1407(ipLnEnrWN)/71053.9/,tO1407(ipLnIonStg)/4./, 
*    3  tO1407(ipLnNelem)/8./, tO1407(ipLnRedis)/1./
*      
*    data tO1405(ipLnWlAng)/1405./,tO1405(ipLnGl)/4./,
*    1  tO1405(ipLnGu)/4./,tO1405(ipLnGF)/3.88e-7/,
*    2  tO1405(ipLnEnrWN)/71184.2/,tO1405(ipLnIonStg)/4./, 
*    3  tO1405(ipLnNelem)/8./, tO1405(ipLnRedis)/1./
*      
*    data tO1401(ipLnWlAng)/1401./,tO1401(ipLnGl)/4./,
*    1  tO1401(ipLnGu)/6./,tO1401(ipLnGF)/1.84e-6/ ,
*    2  tO1401(ipLnEnrWN)/71369.6/,tO1401(ipLnIonStg)/4./, 
*    3  tO1401(ipLnNelem)/8./, tO1401(ipLnRedis)/1./
*
      data t789(ipLnWlAng)/789./ ,t789(ipLnGl)/6./, 
     1  t789(ipLnGu)/10./, t789(ipLnGF)/0.66/,
     2  t789(ipLnEnrWN)/126684.3/ ,t789(ipLnIonStg)/4./, 
     3  t789(ipLnNelem)/8./, t789(ipLnRedis)/1./
*
      data t630(ipLnWlAng)/630./ ,t630(ipLnGl)/1./, 
     1  t630(ipLnGu)/3./, t630(ipLnGF)/0.515/,
     2  t630(ipLnEnrWN)/158798./ ,t630(ipLnIonStg)/5./, 
     3  t630(ipLnNelem)/8./, t630(ipLnRedis)/1./
*
*     6 level model OI atom, with Ly beta pump
*     gf's from tOPBASE, Dima Verner, 96 Feb 6
      data t1304(ipLnWlAng)/1304./,t1304(ipLnGl)/9./, 
     1  t1304(ipLnGu)/3./, t1304(ipLnGF)/0.45/ ,
     2  t1304(ipLnEnrWN)/76716./,t1304(ipLnIonStg)/1./, 
     3  t1304(ipLnNelem)/8./ , t1304(ipLnRedis)/1./
*
      data t1039(ipLnWlAng)/1039./,t1039(ipLnGl)/9./, 
     1  t1039(ipLnGu)/3./, t1039(ipLnGF)/0.0813/,
     2  t1039(ipLnEnrWN)/96147.1/,t1039(ipLnIonStg)/1./, 
     3  t1039(ipLnNelem)/8./, t1039(ipLnRedis)/1./
*
      data t8446(ipLnWlAng)/8446./,t8446(ipLnGl)/3./, 
     1  t8446(ipLnGu)/9./, t8446(ipLnGF)/3.27/,
     2  t8446(ipLnEnrWN)/11836./,t8446(ipLnIonStg)/1./, 
     3  t8446(ipLnNelem)/8./, t8446(ipLnRedis)/1./
*
      data t4368(ipLnWlAng)/4368./,t4368(ipLnGl)/3./, 
     1  t4368(ipLnGu)/9./, t4368(ipLnGF)/0.0237/ ,
     2  t4368(ipLnEnrWN)/22885./,t4368(ipLnIonStg)/1./, 
     3  t4368(ipLnNelem)/8./, t4368(ipLnRedis)/1./
*
      data tOI13(ipLnWlAng)/13200./,tOI13(ipLnGl)/9./, 
     1  tOI13(ipLnGu)/3./,tOI13(ipLnGF)/1.69/ ,
     2  tOI13(ipLnEnrWN)/7596.5/,tOI13(ipLnIonStg)/1./, 
     3  tOI13(ipLnNelem)/8./, tOI13(ipLnRedis)/1./
*
      data tOI11(ipLnWlAng)/11300./,tOI11(ipLnGl)/9./,
     1  tOI11(ipLnGu)/15./,tOI11(ipLnGF)/8.93/ ,
     2  tOI11(ipLnEnrWN)/8847./,tOI11(ipLnIonStg)/1./, 
     3  tOI11(ipLnNelem)/8./, tOI11(ipLnRedis)/1./
*
      data tOI29(ipLnWlAng)/29000./,tOI29(ipLnGl)/3./, 
     1  tOI29(ipLnGu)/9./,tOI29(ipLnGF)/4.51/ ,
     2  tOI29(ipLnEnrWN)/3454.9/,tOI29(ipLnIonStg)/1./, 
     3  tOI29(ipLnNelem)/8./, tOI29(ipLnRedis)/1./
*
      data tOI46(ipLnWlAng)/46000./ ,tOI46(ipLnGl)/15./, 
     1  tOI46(ipLnGu)/9./, tOI46(ipLnGF)/2.63/,
     2  tOI46(ipLnEnrWN)/2192.26/ ,tOI46(ipLnIonStg)/1./, 
     3  tOI46(ipLnNelem)/8./ , tOI46(ipLnRedis)/1./ 
*
      data tO1025(ipLnWlAng)/1025./,tO1025(ipLnGl)/9./,
     1  tO1025(ipLnGu)/15./, tO1025(ipLnGF)/0.169/,
     2  tO1025(ipLnEnrWN)/97410.5/,tO1025(ipLnIonStg)/1./, 
     3  tO1025(ipLnNelem)/8./, tO1025(ipLnRedis)/1./
*
*     end of OI 6 level atom
*
      data t304(ipLnWlAng)/304./,t304(ipLnGl)/9./, 
     1  t304(ipLnGu)/9./, t304(ipLnGF)/4.23/,
     2  t304(ipLnEnrWN)/327095.2/,t304(ipLnIonStg)/3./, 
     3  t304(ipLnNelem)/8./, t304(ipLnRedis)/1./
*
*     gf from 
*     >>refer Allard, N., Artru, M.-C., Lanz, T., & Le Dournef, M. 1990,
*     >>refer A&AS, 84, 563
*     A's 
*     >>refer Fleming, J., Bell, K.L, Hibbert, A., Vaeck, N., Godefroid, M.R.
*     >>refer 1996, MNRAS, 279, 1289
      data t1214(ipLnWlAng)/1218./,t1214(ipLnGl)/1./, 
     1  t1214(ipLnGu)/3./,t1214(ipLnGF)/0./ ,
     2  t1214(ipLnEnrWN)/82280./,t1214(ipLnIonStg)/5./, 
     3  t1214(ipLnNelem)/8./, t1214(ipLnRedis)/1./,
     1  t1214(ipLnAul)/2280.2/
*
      data t150(ipLnWlAng)/150./,t150(ipLnGl)/2./, 
     1  t150(ipLnGu)/6./, t150(ipLnGF)/0.5308/,
     2  t150(ipLnEnrWN)/666218./,t150(ipLnIonStg)/6./, 
     3  t150(ipLnNelem)/8./, t150(ipLnRedis)/1./
*
*     fine structure lines
*     [O I] 146 microns
      data t146(ipLnWlAng)/1.4553e6/,t146(ipLnGl)/3./, 
     1  t146(ipLnGu)/1./, t146(ipLnGF)/0.00/,
     2  t146(ipLnEnrWN)/68.712/,t146(ipLnIonStg)/1./, 
     3  t146(ipLnNelem)/8./, t146(ipLnRedis)/-1./,
     4  t146(ipLnAul)/1.75e-5/
*
*     [O I] 63 microns
      data t63(ipLnWlAng)/6.3185e5/,t63(ipLnGl)/5./, 
     1  t63(ipLnGu)/3./, t63(ipLnGF)/0.00/,
     2  t63(ipLnEnrWN)/158.265/,t63(ipLnIonStg)/1./, 
     3  t63(ipLnNelem)/8./, t63(ipLnRedis)/-1./,
     4  t63(ipLnAul)/8.91e-5/
*
*     [O III] 88.3564 m
      data tO88(ipLnWlAng)/8.8356e5/,tO88(ipLnGl)/1./, 
     1  tO88(ipLnGu)/3./, tO88(ipLnGF)/9.12e-9/,
     2  tO88(ipLnEnrWN)/113.178/,tO88(ipLnIonStg)/3./, 
     3  tO88(ipLnNelem)/8./, tO88(ipLnRedis)/-1./
*
*     [O III] 51.8145
      data t52(ipLnWlAng)/5.1814e5/,t52(ipLnGl)/3./, 
     1  t52(ipLnGu)/5./, t52(ipLnGF)/1.95e-8/,
     2  t52(ipLnEnrWN)/192.996/,t52(ipLnIonStg)/3./, 
     3  t52(ipLnNelem)/8./, t52(ipLnRedis)/-1./
*
*     [O IV] 25.89mic, A from
*     >>refer Brage, T., Judge, P.G., & Brekke, P., 1996, ApJ 464, 1030
      data t26(ipLnWlAng)/2.589e5/,t26(ipLnGl)/2./, 
     1  t26(ipLnGu)/4./, t26(ipLnGF)/0.00/,
     2  t26(ipLnEnrWN)/386.25/,t26(ipLnIonStg)/4./, 
     3  t26(ipLnNelem)/8./, t26(ipLnRedis)/-1./ ,
     4  t26(ipLnAul)/5.19e-4/
*
      data t1032(ipLnWlAng)/1032./,t1032(ipLnGl)/2./, 
     1  t1032(ipLnGu)/4./, t1032(ipLnGF)/0.266/,
     2  t1032(ipLnEnrWN)/96906.2/,t1032(ipLnIonStg)/6./, 
     3  t1032(ipLnNelem)/8./, t1032(ipLnRedis)/1./
*
      data t1037(ipLnWlAng)/1037./,t1037(ipLnGl)/2./, 
     1  t1037(ipLnGu)/2./, t1037(ipLnGF)/0.1322/,
     2  t1037(ipLnEnrWN)/96374.7/,t1037(ipLnIonStg)/6./, 
     3  t1037(ipLnNelem)/8./, t1037(ipLnRedis)/1./
*
*     fluorine
*     f ii 29.33 mic
      data F0229(ipLnWlAng)/29.33e4/,F0229(ipLnGl)/5./,
     1  F0229(ipLnGu)/3./, F0229(ipLnGF)/0./,
     2  F0229(ipLnEnrWN)/340.9/,F0229(ipLnIonStg)/2./, 
     3  F0229(ipLnNelem)/9./, F0229(ipLnRedis)/-1./,
     4  F0229(ipLnAul)/8.912e-4/
*
*     f ii 67.2 mic
      data F0267(ipLnWlAng)/67.2e4/,F0267(ipLnGl)/3./,
     1  F0267(ipLnGu)/1./, F0267(ipLnGF)/0./,
     2  F0267(ipLnEnrWN)/148.8/,F0267(ipLnIonStg)/2./, 
     3  F0267(ipLnNelem)/9./, F0267(ipLnRedis)/-1./,
     4  F0267(ipLnAul)/1.784e-4/
*
*     f iv 44.07 mic
      data F444(ipLnWlAng)/44.07e4/,F444(ipLnGl)/1./,
     1  F444(ipLnGu)/3./, F444(ipLnGF)/0./,
     2  F444(ipLnEnrWN)/226.9/,F444(ipLnIonStg)/4./, 
     3  F444(ipLnNelem)/9./, F444(ipLnRedis)/-1./,
     4  F444(ipLnAul)/2.10e-4/
*
*     f iv 25.83 mic
      data F425(ipLnWlAng)/25.83e4/,F425(ipLnGl)/3./,
     1  F425(ipLnGu)/5./, F425(ipLnGF)/0./,
     2  F425(ipLnEnrWN)/387.14/,F425(ipLnIonStg)/4./, 
     3  F425(ipLnNelem)/9./, F425(ipLnRedis)/-1./,
     4  F425(ipLnAul)/7.82e-4/
*
*     neon
      data t770(ipLnWlAng)/770./ ,t770(ipLnGl)/2./, 
     1  t770(ipLnGu)/4./, t770(ipLnGF)/.206/,
     2  t770(ipLnEnrWN)/129802./ ,t770(ipLnIonStg)/8./, 
     3  t770(ipLnNelem)/10./, t770(ipLnRedis)/1./
*
      data t780(ipLnWlAng)/780./ ,t780(ipLnGl)/2./, 
     1  t780(ipLnGu)/2./, t780(ipLnGF)/.101/,
     2  t780(ipLnEnrWN)/128151.9/ ,t780(ipLnIonStg)/8./, 
     3  t780(ipLnNelem)/10./, t780(ipLnRedis)/1./
*
*     [Ne VI] 7.652 micron
      data xNe0676(ipLnWlAng)/7.652e4/,xNe0676(ipLnGl)/2./,
     1  xNe0676(ipLnGu)/4./, xNe0676(ipLnGF)/0./,
     2  xNe0676(ipLnEnrWN)/1306.78/,xNe0676(ipLnIonStg)/6./, 
     3  xNe0676(ipLnNelem)/10./, xNe0676(ipLnRedis)/-1./,
     4  xNe0676(ipLnAul)/1.9e-2/
*
*     A's 
*     >>refer Fleming, J., Bell, K.L, Hibbert, A., Vaeck, N., Godefroid, M.R.
*     >>refer 1996, MNRAS, 279, 1289
      data t895(ipLnWlAng)/895./ ,t895(ipLnGl)/1./, 
     1  t895(ipLnGu)/3./, t895(ipLnGF)/0./,
     2  t895(ipLnEnrWN)/111732./ ,t895(ipLnIonStg)/7./, 
     3  t895(ipLnNelem)/10./, t895(ipLnRedis)/1./,
     1  t895(ipLnAul)/19204.4/
*
      data t88(ipLnWlAng)/88./ ,t88(ipLnGl)/2./, 
     1  t88(ipLnGu)/6./, t88(ipLnGF)/.602/,
     2  t88(ipLnEnrWN)/1135177./ ,t88(ipLnIonStg)/8./, 
     3  t88(ipLnNelem)/10./, t88(ipLnRedis)/1./
*
*     fine structure lines 
*     [Ne II] 12.8
      data tNe13(ipLnWlAng)/1.28e5/,tNe13(ipLnGl)/4./, 
     1  tNe13(ipLnGu)/2./, tNe13(ipLnGF)/0./,
     2  tNe13(ipLnEnrWN)/780.34/,tNe13(ipLnIonStg)/2./, 
     3  tNe13(ipLnNelem)/10./, tNe13(ipLnRedis)/-1./,
     4  tNe13(ipLnAul)/8.55e-3/
*
*     [Ne III] 36.013 m
      data tNe36(ipLnWlAng)/3.6014e5/,tNe36(ipLnGl)/3./, 
     1  tNe36(ipLnGu)/1./, tNe36(ipLnGF)/2.23e-8/,
     2  tNe36(ipLnEnrWN)/277.674/,tNe36(ipLnIonStg)/3./, 
     3  tNe36(ipLnNelem)/10./, tNe36(ipLnRedis)/-1./
*
*     [Ne III] 15.56 m
      data tNe16(ipLnWlAng)/1.56e5/,tNe16(ipLnGl)/5./, 
     1  tNe16(ipLnGu)/3./, tNe16(ipLnGF)/6.49e-8/,
     2  tNe16(ipLnEnrWN)/642.88/,tNe16(ipLnIonStg)/3./, 
     3  tNe16(ipLnNelem)/10./, tNe16(ipLnRedis)/-1./
*
*     [Ne V] 14.32 m
      data tNe14(ipLnWlAng)/1.432e5/,tNe14(ipLnGl)/3./, 
     1  tNe14(ipLnGu)/5./, tNe14(ipLnGF)/6.65e-8/,
     2  tNe14(ipLnEnrWN)/698.24/,tNe14(ipLnIonStg)/5./, 
     3  tNe14(ipLnNelem)/10./, tNe14(ipLnRedis)/-1./
*
*     [Ne V] 24.318 m
      data tNe24(ipLnWlAng)/2.4318e5/,tNe24(ipLnGl)/1./, 
     1  tNe24(ipLnGu)/3./, tNe24(ipLnGF)/3.12e-8/,
     2  tNe24(ipLnEnrWN)/411.226/,tNe24(ipLnIonStg)/5./, 
     3  tNe24(ipLnNelem)/10./, tNe24(ipLnRedis)/-1./
*
*     sodium line optical depth data
      data t5895(ipLnWlAng)/5895./,t5895(ipLnGl)/2./, 
     1  t5895(ipLnGu)/6./, t5895(ipLnGF)/1.94/,
     2  t5895(ipLnEnrWN)/16967.646/,t5895(ipLnIonStg)/1./, 
     3  t5895(ipLnNelem)/11./, t5895(ipLnRedis)/1./
*
*     [Na III] 7.3177mic
      data fsNa373(ipLnWlAng)/7.32e4/,fsNa373(ipLnGl)/4./,
     1  fsNa373(ipLnGu)/2./, fsNa373(ipLnGF)/0./,
     2  fsNa373(ipLnEnrWN)/1366.54/,fsNa373(ipLnIonStg)/3./, 
     3  fsNa373(ipLnNelem)/11./, fsNa373(ipLnRedis)/-1./,
     4  fsNa373(ipLnAul)/4.59e-2/
*
*     [Na IV] 9.039 mic
      data fsNa490(ipLnWlAng)/9.039e4/,fsNa490(ipLnGl)/5./,
     1  fsNa490(ipLnGu)/3./, fsNa490(ipLnGF)/0./,
     2  fsNa490(ipLnEnrWN)/1106.3/,fsNa490(ipLnIonStg)/4./, 
     3  fsNa490(ipLnNelem)/11./, fsNa490(ipLnRedis)/-1./,
     4  fsNa490(ipLnAul)/2.91e-2/
*
*     [Na IV] 21.29 mic
      data fsNa421(ipLnWlAng)/2.129e5/,fsNa421(ipLnGl)/3./,
     1  fsNa421(ipLnGu)/1./, fsNa421(ipLnGF)/0./,
     2  fsNa421(ipLnEnrWN)/ 469.7/,fsNa421(ipLnIonStg)/4./, 
     3  fsNa421(ipLnNelem)/11./, fsNa421(ipLnRedis)/-1./,
     4  fsNa421(ipLnAul)/5.31e-3/
*
*     [Na VI] 14.40 mic
      data xNa6143(ipLnWlAng)/1.44e5/,xNa6143(ipLnGl)/1./,
     1  xNa6143(ipLnGu)/3./, xNa6143(ipLnGF)/0./,
     2  xNa6143(ipLnEnrWN)/ 694.62/,xNa6143(ipLnIonStg)/6./, 
     3  xNa6143(ipLnNelem)/11./, xNa6143(ipLnRedis)/-1./,
     4  xNa6143(ipLnAul)/6.14e-3/
*
*     [Na VI] 8.611 mic
      data xNa6862(ipLnWlAng)/8.611e4/,xNa6862(ipLnGl)/3./,
     1  xNa6862(ipLnGu)/5./, xNa6862(ipLnGF)/0./,
     2  xNa6862(ipLnEnrWN)/1161.36/,xNa6862(ipLnIonStg)/6./, 
     3  xNa6862(ipLnNelem)/11./, xNa6862(ipLnRedis)/-1./,
     4  xNa6862(ipLnAul)/2.11e-2/
*
*     [Na VII] 4.68 micron
      data xNa0746(ipLnWlAng)/4.68e4/,xNa0746(ipLnGl)/2./,
     1  xNa0746(ipLnGu)/4./, xNa0746(ipLnGF)/0./,
     2  xNa0746(ipLnEnrWN)/2134.60/,xNa0746(ipLnIonStg)/7./, 
     3  xNa0746(ipLnNelem)/11./, xNa0746(ipLnRedis)/-1./,
     4  xNa0746(ipLnAul)/.088/
*
*     magnesium line optical depth data
      data MgI2853(ipLnWlAng)/2853./,MgI2853(ipLnGl)/ 1./,
     1  MgI2853(ipLnGu)/ 3./,MgI2853(ipLnGF)/1.73E+00/,
     2  MgI2853(ipLnEnrWN)/35051.264/,MgI2853(ipLnIonStg)/1./,
     3  MgI2853(ipLnNelem)/12./,MgI2853(ipLnRedis)/1./
     4  MgI2853(ipLnAul)/0./
*
      data MgI2026(ipLnWlAng)/2026./,MgI2026(ipLnGl)/ 1./,
     1  MgI2026(ipLnGu)/ 3./,MgI2026(ipLnGF)/1.22E-01/,
     2  MgI2026(ipLnEnrWN)/49346.729/,MgI2026(ipLnIonStg)/1./,
     3  MgI2026(ipLnNelem)/12./,MgI2026(ipLnRedis)/1./
     4  MgI2026(ipLnAul)/0./
*
      data t2796(ipLnWlAng)/2796./ ,t2796(ipLnGl)/2./, 
     1  t2796(ipLnGu)/4./, t2796(ipLnGF)/1.258/,
     2  t2796(ipLnEnrWN)/35760.88/ ,t2796(ipLnIonStg)/2./, 
     3   t2796(ipLnNelem)/12./, t2796(ipLnRedis)/1./
*
      data t2804(ipLnWlAng)/2804./ ,t2804(ipLnGl)/2./, 
     1  t2804(ipLnGu)/2./, t2804(ipLnGF)/0.628/,
     2  t2804(ipLnEnrWN)/35669.304/ ,t2804(ipLnIonStg)/2./, 
     3   t2804(ipLnNelem)/12./, t2804(ipLnRedis)/1./
*
*     upper level split into 3, wide energy sep, really should separate out
*     A's 
*     >>refer Fleming, J., Bell, K.L, Hibbert, A., Vaeck, N., Godefroid, M.R.
*     >>refer 1996, MNRAS, 279, 1289
*     NB following A is not real A but mult average, with 0 for other line
*     real A is 97242
      data t705(ipLnWlAng)/705./,t705(ipLnGl)/1./, 
     1  t705(ipLnGu)/3./, t705(ipLnGF)/1.93e-5/,
     2  t705(ipLnEnrWN)/143192.22/,t705(ipLnIonStg)/9./, 
     3  t705(ipLnNelem)/12./, t705(ipLnRedis)/1./,
     4  t705(ipLnAul)/32414./
*
      data t4561(ipLnWlAng)/4561./,t4561(ipLnGl)/1./, 
     1  t4561(ipLnGu)/9./,t4561(ipLnGF)/2.05e-6/ ,
     2  t4561(ipLnEnrWN)/21890.816/,t4561(ipLnIonStg)/1./, 
     3  t4561(ipLnNelem)/12./, t4561(ipLnRedis)/1./
*
*     [Mg V] 1325, 3-1 in three level atom
      data xMg51325(ipLnWlAng)/1325./,xMg51325(ipLnGl)/9./, 
     1  xMg51325(ipLnGu)/1./,xMg51325(ipLnGF)/0./ ,
     2  xMg51325(ipLnEnrWN)/75496./,xMg51325(ipLnIonStg)/5./, 
     3  xMg51325(ipLnNelem)/12./, xMg51325(ipLnRedis)/-1./ ,
     4  xMg51325(ipLnAul)/27.9/
*
*     [Mg V] 2417, 3-2 in three level atom
      data xMg52417(ipLnWlAng)/2417./,xMg52417(ipLnGl)/5./, 
     1  xMg52417(ipLnGu)/1./,xMg52417(ipLnGF)/0./ ,
     2  xMg52417(ipLnEnrWN)/41353./,xMg52417(ipLnIonStg)/5./, 
     3  xMg52417(ipLnNelem)/12./, xMg52417(ipLnRedis)/-1./ ,
     4  xMg52417(ipLnAul)/6.59/
*
*     [Mg V] 2855, 2-1 in three level atom, really 2928, 2782
      data xMg52855(ipLnWlAng)/2855./,xMg52855(ipLnGl)/9./, 
     1  xMg52855(ipLnGu)/5./,xMg52855(ipLnGF)/0./ ,
     2  xMg52855(ipLnEnrWN)/34143./,xMg52855(ipLnIonStg)/5./, 
     3  xMg52855(ipLnNelem)/12./, xMg52855(ipLnRedis)/-1./ ,
     4  xMg52855(ipLnAul)/2.481/
*
*     [Mg VII] 1325, 3-1 in three level atom
      data xMg71190(ipLnWlAng)/1190./,xMg71190(ipLnGl)/9./, 
     1  xMg71190(ipLnGu)/1./,xMg71190(ipLnGF)/0./ ,
     2  xMg71190(ipLnEnrWN)/84046./,xMg71190(ipLnIonStg)/7./, 
     3  xMg71190(ipLnNelem)/12./, xMg71190(ipLnRedis)/-1./ ,
     4  xMg71190(ipLnAul)/45.8/
*
*     [Mg VII] 2261, 3-2 in three level atom
      data xMg72261(ipLnWlAng)/2261./,xMg72261(ipLnGl)/5./, 
     1  xMg72261(ipLnGu)/1./,xMg72261(ipLnGF)/0./ ,
     2  xMg72261(ipLnEnrWN)/44218./,xMg72261(ipLnIonStg)/7./, 
     3  xMg72261(ipLnNelem)/12./, xMg72261(ipLnRedis)/-1./ ,
     4  xMg72261(ipLnAul)/6.61/
*
*     [Mg VII] 2569, 2-1 in three level atom, really 2509, 2629
      data xMg72569(ipLnWlAng)/2569./,xMg72569(ipLnGl)/9./, 
     1  xMg72569(ipLnGu)/5./,xMg72569(ipLnGF)/0./ ,
     2  xMg72569(ipLnEnrWN)/39828./,xMg72569(ipLnIonStg)/7./, 
     3  xMg72569(ipLnNelem)/12./, xMg72569(ipLnRedis)/-1./ ,
     4  xMg72569(ipLnAul)/4.531/
*
*     [Mg VIII] 3.03 micron
      data xMg08303(ipLnWlAng)/3.03e4/,xMg08303(ipLnGl)/2./,
     1  xMg08303(ipLnGu)/4./, xMg08303(ipLnGF)/0./,
     2  xMg08303(ipLnEnrWN)/3302.56/,xMg08303(ipLnIonStg)/8./, 
     3  xMg08303(ipLnNelem)/12./, xMg08303(ipLnRedis)/-1./,
     4  xMg08303(ipLnAul)/.324/
*
*     the Mg X 615 li seq doublet
      data tMg610(ipLnWlAng)/610./ ,tMg610(ipLnGl)/2./, 
     1  tMg610(ipLnGu)/4./, tMg610(ipLnGF)/.1684/,
     2  tMg610(ipLnEnrWN)/163990./ ,tMg610(ipLnIonStg)/10./, 
     3  tMg610(ipLnNelem)/12./, tMg610(ipLnRedis)/1./
*
      data tMg625(ipLnWlAng)/625./ ,tMg625(ipLnGl)/2./, 
     1  tMg625(ipLnGu)/2./, tMg625(ipLnGF)/.0820/,
     2  tMg625(ipLnEnrWN)/160015./ ,tMg625(ipLnIonStg)/10./, 
     3  tMg625(ipLnNelem)/12./, tMg625(ipLnRedis)/1./
*
      data t58(ipLnWlAng)/58./ ,t58(ipLnGl)/2./, 
     1  t58(ipLnGu)/6./, t58(ipLnGF)/.652/,
     2  t58(ipLnEnrWN)/1727393./ ,t58(ipLnIonStg)/10./, 
     3  t58(ipLnNelem)/12./, t58(ipLnRedis)/1./
*
*     Mg IV 4.487m
      data tMg4(ipLnWlAng)/4.487e4/,tMg4(ipLnGl)/4./,
     1  tMg4(ipLnGu)/2./, tMg4(ipLnGF)/0./,
     2  tMg4(ipLnEnrWN)/2228.82/,tMg4(ipLnIonStg)/4./, 
     3  tMg4(ipLnNelem)/12./, tMg4(ipLnRedis)/-1./ ,
     4  tMg4(ipLnAul)/0.199/
*
*     [Mg V] 13.52
      data tMg14(ipLnWlAng)/1.352e5/,tMg14(ipLnGl)/3./,
     1  tMg14(ipLnGu)/1./, tMg14(ipLnGF)/5.95e-8/,
     2  tMg14(ipLnEnrWN)/739.58/,tMg14(ipLnIonStg)/5./, 
     3  tMg14(ipLnNelem)/12./, tMg14(ipLnRedis)/-1./
*
*     [Mg V] 5.610
      data tMg6(ipLnWlAng)/5.610e4/,tMg6(ipLnGl)/5./,
     1  tMg6(ipLnGu)/3./, tMg6(ipLnGF)/1.80e-7/,
     2  tMg6(ipLnEnrWN)/1782.58/,tMg6(ipLnIonStg)/5./, 
     3  tMg6(ipLnNelem)/12./, tMg6(ipLnRedis)/-1./
*
*     [Mg VII] 9.033 mic
      data fsMg790(ipLnWlAng)/9.033e4/,fsMg790(ipLnGl)/1./,
     1  fsMg790(ipLnGu)/3./, fsMg790(ipLnGF)/0./,
     2  fsMg790(ipLnEnrWN)/1107./,fsMg790(ipLnIonStg)/7./, 
     3  fsMg790(ipLnNelem)/12./, fsMg790(ipLnRedis)/-1./,
     4  fsMg790(ipLnAul)/2.44e-2/
*
*     [Mg VII] 5.503 mic
      data fsMg755(ipLnWlAng)/5.503e4/,fsMg755(ipLnGl)/3./,
     1  fsMg755(ipLnGu)/5./, fsMg755(ipLnGF)/0./,
     2  fsMg755(ipLnEnrWN)/1817.10/,fsMg755(ipLnIonStg)/7./, 
     3  fsMg755(ipLnNelem)/12./, fsMg755(ipLnRedis)/-1./,
     4  fsMg755(ipLnAul)/8.09e-2/
*
*     aluminum line optical depth data
      data AlI3957(ipLnWlAng)/3957./,AlI3957(ipLnGl)/ 6./,
     1  AlI3957(ipLnGu)/ 2./,AlI3957(ipLnGF)/7.32E-01/,
     2  AlI3957(ipLnEnrWN)/25273.049/,AlI3957(ipLnIonStg)/1./,
     3  AlI3957(ipLnNelem)/13./,AlI3957(ipLnRedis)/1./
     4  AlI3957(ipLnAul)/0./
*
*     this line back in level 2
*     data al1671(ipLnWlAng)/1671./,al1671(ipLnGl)/ 1./,
*    1  al1671(ipLnGu)/3./,al1671(ipLnGF)/1.81/,
*    2  al1671(ipLnEnrWN)/59852.03 /,al1671(ipLnIonStg)/2./,
*    3  al1671(ipLnNelem)/13./,al1671(ipLnRedis)/1./
*    4  al1671(ipLnAul)/0./
*
      data AlI3090(ipLnWlAng)/3090./,AlI3090(ipLnGl)/ 6./,
     1  AlI3090(ipLnGu)/10./,AlI3090(ipLnGF)/9.66E-01/,
     2  AlI3090(ipLnEnrWN)/32361.552/,AlI3090(ipLnIonStg)/1./,
     3  AlI3090(ipLnNelem)/13./,AlI3090(ipLnRedis)/1./
     4  AlI3090(ipLnAul)/0./
*
      data t1855(ipLnWlAng)/1855./ ,t1855(ipLnGl)/2./, 
     1  t1855(ipLnGu)/4./, t1855(ipLnGF)/1.15/ ,
     2  t1855(ipLnEnrWN)/53916.60/ ,t1855(ipLnIonStg)/3./, 
     3  t1855(ipLnNelem)/13./, t1855(ipLnRedis)/1./
*
      data t1863(ipLnWlAng)/1863./ ,t1863(ipLnGl)/2./, 
     1  t1863(ipLnGu)/2./, t1863(ipLnGF)/0.572/ ,
     2  t1863(ipLnEnrWN)/53682.93/ ,t1863(ipLnIonStg)/3./, 
     3  t1863(ipLnNelem)/13./, t1863(ipLnRedis)/1./
*
      data t2670(ipLnWlAng)/2670./ ,t2670(ipLnGl)/1./,
     1  t2670(ipLnGu)/3./,t2670(ipLnGF)/1.07e-5/ ,
     2  t2670(ipLnEnrWN)/37516.656/ ,t2670(ipLnIonStg)/2./, 
     3  t2670(ipLnNelem)/13./, t2670(ipLnRedis)/1./
*
*     [Al V] 2.905 mic
      data Al529(ipLnWlAng)/29052./,Al529(ipLnGl)/4./, 
     1  Al529(ipLnGu)/2./, Al529(ipLnGF)/0./ ,
     2  Al529(ipLnEnrWN)/3442.1/,Al529(ipLnIonStg)/5./, 
     3  Al529(ipLnNelem)/13./, Al529(ipLnRedis)/-1./,
     4  Al529(ipLnAul)/0.734/
*
*     [Al VI] 3.66 mic
      data Al6366(ipLnWlAng)/36600./,Al6366(ipLnGl)/5./, 
     1  Al6366(ipLnGu)/3./, Al6366(ipLnGF)/0./ ,
     2  Al6366(ipLnEnrWN)/2732./,Al6366(ipLnIonStg)/6./, 
     3  Al6366(ipLnNelem)/13./, Al6366(ipLnRedis)/-1./,
     4  Al6366(ipLnAul)/0.458/
*
*     [Al VI] 9.116 mic
      data Al6912(ipLnWlAng)/91160./,Al6912(ipLnGl)/3./, 
     1  Al6912(ipLnGu)/5./, Al6912(ipLnGF)/0./ ,
     2  Al6912(ipLnEnrWN)/1097./,Al6912(ipLnIonStg)/6./, 
     3  Al6912(ipLnNelem)/13./, Al6912(ipLnRedis)/-1./,
     4  Al6912(ipLnAul)/0.0710/
*
*     [Al VIII] 5.848 mic
      data Al8575(ipLnWlAng)/58480./,Al8575(ipLnGl)/1./, 
     1  Al8575(ipLnGu)/3./, Al8575(ipLnGF)/0./ ,
     2  Al8575(ipLnEnrWN)/1710./,Al8575(ipLnIonStg)/8./, 
     3  Al8575(ipLnNelem)/13./, Al8575(ipLnRedis)/-1./,
     4  Al8575(ipLnAul)/8.96e-2/
*
*     [Al VIII] 3.69 mic
      data Al8370(ipLnWlAng)/36900./,Al8370(ipLnGl)/3./, 
     1  Al8370(ipLnGu)/5./, Al8370(ipLnGF)/0./ ,
     2  Al8370(ipLnEnrWN)/2710./,Al8370(ipLnIonStg)/8./, 
     3  Al8370(ipLnNelem)/13./, Al8370(ipLnRedis)/-1./,
     4  Al8370(ipLnAul)/2.68e-1/
*
*     [Al IX] 2.04 micron
      data Al09204(ipLnWlAng)/2.04e4/,Al09204(ipLnGl)/2./,
     1  Al09204(ipLnGu)/4./, Al09204(ipLnGF)/0./,
     2  Al09204(ipLnEnrWN)/4890./,Al09204(ipLnIonStg)/9./, 
     3  Al09204(ipLnNelem)/13./, Al09204(ipLnRedis)/-1./,
     4  Al09204(ipLnAul)/1.05/
*
      data t639(ipLnWlAng)/639./,t639(ipLnGl)/1./, 
     1  t639(ipLnGu)/3./, t639(ipLnGF)/3.17e-5/ ,
     2  t639(ipLnEnrWN)/158385.563/,t639(ipLnIonStg)/10./, 
     3  t639(ipLnNelem)/13./, t639(ipLnRedis)/1./
*
*     Al XI 550, 568 Li seq doublet
      data tAl550(ipLnWlAng)/550./ ,tAl550(ipLnGl)/2./,
     1  tAl550(ipLnGu)/4./, tAl550(ipLnGF)/0.1546/,
     2  tAl550(ipLnEnrWN)/181807.9/ ,tAl550(ipLnIonStg)/11./, 
     3  tAl550(ipLnNelem)/13./, tAl550(ipLnRedis)/1./
*
      data tAl568(ipLnWlAng)/568./ ,tAl568(ipLnGl)/2./,
     1  tAl568(ipLnGu)/2./, tAl568(ipLnGF)/0.0750/,
     2  tAl568(ipLnEnrWN)/176019.2/ ,tAl568(ipLnIonStg)/11./, 
     3  tAl568(ipLnNelem)/13./, tAl568(ipLnRedis)/1./
*
      data tAl48(ipLnWlAng)/48./ ,tAl48(ipLnGl)/2./,
     1  tAl48(ipLnGu)/6./, tAl48(ipLnGF)/0.67/,
     2  tAl48(ipLnEnrWN)/2.069935E+06/ ,tAl48(ipLnIonStg)/11./, 
     3  tAl48(ipLnNelem)/13./, tAl48(ipLnRedis)/1./
*
*     silicon line optical depth data
      data Sii2518(ipLnWlAng)/2518./,Sii2518(ipLnGl)/ 9./,
     1  Sii2518(ipLnGu)/ 9./,Sii2518(ipLnGF)/2.12E+00/,
     2  Sii2518(ipLnEnrWN)/39710.239/,Sii2518(ipLnIonStg)/1./,
     3  Sii2518(ipLnNelem)/14./,Sii2518(ipLnRedis)/1./
     4  Sii2518(ipLnAul)/0./
*
      data Sii2215(ipLnWlAng)/2215./,Sii2215(ipLnGl)/ 9./,
     1  Sii2215(ipLnGu)/15./,Sii2215(ipLnGF)/4.68E-01/,
     2  Sii2215(ipLnEnrWN)/45153.629/,Sii2215(ipLnIonStg)/1./,
     3  Sii2215(ipLnNelem)/14./,Sii2215(ipLnRedis)/1./
     4  Sii2215(ipLnAul)/0./
*
*     new A from 
*     >>refer Calamai, A.G., Smith, P.L., Bergeson, S.D. 1993, ApJ, 415, L59
      data t2335(ipLnWlAng)/2335./,t2335(ipLnGl)/6./,
     1  t2335(ipLnGu)/12./,t2335(ipLnGF)/0./ ,
     2  t2335(ipLnEnrWN)/44067.881/,t2335(ipLnIonStg)/2./, 
     3  t2335(ipLnNelem)/14./, t2335(ipLnRedis)/1./ ,
     4  t2335(ipLnAul)/3241.7/
*
      data t1808(ipLnWlAng)/1808./,t1808(ipLnGl)/6./, 
     1  t1808(ipLnGu)/10./,t1808(ipLnGF)/0.0153/ ,
     2  t1808(ipLnEnrWN)/55127.143/,t1808(ipLnIonStg)/2./, 
     3  t1808(ipLnNelem)/14./, t1808(ipLnRedis)/1./
*
      data t1207(ipLnWlAng)/1207./,t1207(ipLnGl)/1./, 
     1  t1207(ipLnGu)/3./, t1207(ipLnGF)/1.68/ ,
     2  t1207(ipLnEnrWN)/82883.0/,t1207(ipLnIonStg)/3./, 
     3  t1207(ipLnNelem)/14./, t1207(ipLnRedis)/1./
*
      data t1895(ipLnWlAng)/1892./,t1895(ipLnGl)/1./, 
     1  t1895(ipLnGu)/3./,t1895(ipLnGF)/2.69e-5/ ,
     2  t1895(ipLnEnrWN)/52888.777/,t1895(ipLnIonStg)/3./, 
     3  t1895(ipLnNelem)/14./, t1895(ipLnRedis)/1./
*
      data t1394(ipLnWlAng)/1394./,t1394(ipLnGl)/2./, 
     1  t1394(ipLnGu)/4./, t1394(ipLnGF)/1.048/ ,
     2  t1394(ipLnEnrWN)/71748.621/,t1394(ipLnIonStg)/4./, 
     3  t1394(ipLnNelem)/14./, t1394(ipLnRedis)/1./
*
      data t1403(ipLnWlAng)/1403./,t1403(ipLnGl)/2./, 
     1  t1403(ipLnGu)/2./, t1403(ipLnGF)/0.520/ ,
     2  t1403(ipLnEnrWN)/71287.523/,t1403(ipLnIonStg)/4./, 
     3  t1403(ipLnNelem)/14./, t1403(ipLnRedis)/1./
*
      data t1527(ipLnWlAng)/1527./,t1527(ipLnGl)/6./, 
     1  t1527(ipLnGu)/2./, t1527(ipLnGF)/0.786/ ,
     2  t1527(ipLnEnrWN)/65309.747/,t1527(ipLnIonStg)/2./, 
     3  t1527(ipLnNelem)/14./, t1527(ipLnRedis)/1./
*
      data t1305(ipLnWlAng)/1305./,t1305(ipLnGl)/6./, 
     1  t1305(ipLnGu)/2./, t1305(ipLnGF)/0.5208/ ,
     2  t1305(ipLnEnrWN)/76472.567/,t1305(ipLnIonStg)/2./, 
     3  t1305(ipLnNelem)/14./, t1305(ipLnRedis)/1./
*
      data t1260(ipLnWlAng)/1260./,t1260(ipLnGl)/6./, 
     1  t1260(ipLnGu)/10./, t1260(ipLnGF)/7.084/ ,
     2  t1260(ipLnEnrWN)/79156.519/,t1260(ipLnIonStg)/2./, 
     3  t1260(ipLnNelem)/14./, t1260(ipLnRedis)/1./
*
*     [Si VI] 1.9641mic
      data Si619(ipLnWlAng)/19631./,Si619(ipLnGl)/4./, 
     1  Si619(ipLnGu)/2./, Si619(ipLnGF)/0./ ,
     2  Si619(ipLnEnrWN)/5093.19/,Si619(ipLnIonStg)/6./, 
     3  Si619(ipLnNelem)/14./, Si619(ipLnRedis)/-1./,
     4  Si619(ipLnAul)/2.37/
*
*     [Si X] 1.43 micron
      data Si10143(ipLnWlAng)/1.43e4/,Si10143(ipLnGl)/2./,
     1  Si10143(ipLnGu)/4./, Si10143(ipLnGF)/0./,
     2  Si10143(ipLnEnrWN)/6990./,Si10143(ipLnIonStg)/10./, 
     3  Si10143(ipLnNelem)/14./, Si10143(ipLnRedis)/-1./,
     4  Si10143(ipLnAul)/3.07/
*
      data tSi499(ipLnWlAng)/499./ ,tSi499(ipLnGl)/2./,
     1 tSi499(ipLnGu)/4./, tSi499(ipLnGF)/0.1438/, 
     2 tSi499(ipLnEnrWN)/200237.9/ ,tSi499(ipLnIonStg)/12./,
     3 tSi499(ipLnNelem)/14./ , tSi499(ipLnRedis)/1./
*
      data tSi521(ipLnWlAng)/521./ ,tSi521(ipLnGl)/2./,
     1 tSi521(ipLnGu)/2./, tSi521(ipLnGF)/0.0690/, 
     2 tSi521(ipLnEnrWN)/192062.1/ ,tSi521(ipLnIonStg)/12./,
     3 tSi521(ipLnNelem)/14./ , tSi521(ipLnRedis)/1./
*
      data tSi41(ipLnWlAng)/41./ ,tSi41(ipLnGl)/2./,
     1  tSi41(ipLnGu)/6./, tSi41(ipLnGF)/0.686/,
     2  tSi41(ipLnEnrWN)/2.443793E+06/ ,tSi41(ipLnIonStg)/12./, 
     3  tSi41(ipLnNelem)/14./, tSi41(ipLnRedis)/1./
*
*     [Si II] 34.8 mic
      data tSi35(ipLnWlAng)/3.4815e5/,tSi35(ipLnGl)/2./,
     1  tSi35(ipLnGu)/4./, tSi35(ipLnGF)/1.58e-8/,
     2  tSi35(ipLnEnrWN)/287.231/,tSi35(ipLnIonStg)/2./, 
     3  tSi35(ipLnNelem)/14./, tSi35(ipLnRedis)/-1./
*
*     [Si VII] 2.481
      data tSi25(ipLnWlAng)/2.481e4/,tSi25(ipLnGl)/5./,
     1  tSi25(ipLnGu)/3./, tSi25(ipLnGF)/4.01e-7/,
     2  tSi25(ipLnEnrWN)/4026.84/,tSi25(ipLnIonStg)/7./, 
     3  tSi25(ipLnNelem)/14./, tSi25(ipLnRedis)/-1./
*
*     [Si VII] 6.4922
      data tSi65(ipLnWlAng)/6.492e4/,tSi65(ipLnGl)/3./,
     1  tSi65(ipLnGu)/1./, tSi65(ipLnGF)/1.22e-7/,
     2  tSi65(ipLnEnrWN)/1540.29/,tSi65(ipLnIonStg)/7./, 
     3  tSi65(ipLnNelem)/14./, tSi65(ipLnRedis)/-1./
*
*     [Si IX] 2.585 mic
      data tSi3(ipLnWlAng)/2.584e4/,tSi3(ipLnGl)/3./,
     1  tSi3(ipLnGu)/5./, tSi3(ipLnGF)/3.79e-7/,
     2  tSi3(ipLnEnrWN)/3869.6/,tSi3(ipLnIonStg)/9./, 
     3  tSi3(ipLnNelem)/14./, tSi3(ipLnRedis)/-1./
*
*     [Si IX] 3.929 mic
      data tSi4(ipLnWlAng)/3.929e4/,tSi4(ipLnGl)/1./,
     1  tSi4(ipLnGu)/3./, tSi4(ipLnGF)/1.89e-7/,
     2  tSi4(ipLnEnrWN)/2545./,tSi4(ipLnIonStg)/9./, 
     3  tSi4(ipLnNelem)/14./, tSi4(ipLnRedis)/-1./
*
*     phosphorus line data
*     P II 60.64 mic
      data P0260(ipLnWlAng)/60.64e4/,P0260(ipLnGl)/1./, 
     1  P0260(ipLnGu)/3./, P0260(ipLnGF)/0./ ,
     2  P0260(ipLnEnrWN)/164.9/,P0260(ipLnIonStg)/2./, 
     3  P0260(ipLnNelem)/15./, P0260(ipLnRedis)/-1./,
     4  P0260(ipLnAul)/8.31e-5/
*
*     P II 32.87 mic
      data P0233(ipLnWlAng)/32.87e4/,P0233(ipLnGl)/3./, 
     1  P0233(ipLnGu)/5./, P0233(ipLnGF)/0./ ,
     2  P0233(ipLnEnrWN)/304.2/,P0233(ipLnIonStg)/2./, 
     3  P0233(ipLnNelem)/15./, P0233(ipLnRedis)/-1./,
     4  P0233(ipLnAul)/3.78e-4/
*
*     P III 17.885 mic
      data P0318(ipLnWlAng)/17.885e4/,P0318(ipLnGl)/2./, 
     1  P0318(ipLnGu)/4./, P0318(ipLnGF)/0./ ,
     2  P0318(ipLnEnrWN)/559.1/,P0318(ipLnIonStg)/3./, 
     3  P0318(ipLnNelem)/15./, P0318(ipLnRedis)/-1./,
     4  P0318(ipLnAul)/1.57e-3/
*
*     P VII 1.3745 mic
      data P713(ipLnWlAng)/13745./,P713(ipLnGl)/4./, 
     1  P713(ipLnGu)/2./, P713(ipLnGF)/0./ ,
     2  P713(ipLnEnrWN)/7275./,P713(ipLnIonStg)/7./, 
     3  P713(ipLnNelem)/15./, P713(ipLnRedis)/-1./,
     4  P713(ipLnAul)/6.92/
*
*     P VIII 4.85 mic
      data P848(ipLnWlAng)/4.85e4/,P848(ipLnGl)/3./,
     1  P848(ipLnGu)/1./, P848(ipLnGF)/0./,
     2  P848(ipLnEnrWN)/2061.8/,P848(ipLnIonStg)/8./, 
     3  P848(ipLnNelem)/15./, P848(ipLnRedis)/-1./,
     4  P848(ipLnAul)/0.470/
*
*     P VIII 1.735 mic
      data P817(ipLnWlAng)/1.735e4/,P817(ipLnGl)/5./,
     1  P817(ipLnGu)/3./, P817(ipLnGF)/0./,
     2  P817(ipLnEnrWN)/5763.7/,P817(ipLnIonStg)/8./, 
     3  P817(ipLnNelem)/15./, P817(ipLnRedis)/-1./,
     4  P817(ipLnAul)/4.28/
*
*     P X 2.708 mic
      data P1027(ipLnWlAng)/2.708e4/,P1027(ipLnGl)/1./,
     1  P1027(ipLnGu)/3./, P1027(ipLnGF)/0./,
     2  P1027(ipLnEnrWN)/3692.7/,P1027(ipLnIonStg)/10./, 
     3  P1027(ipLnNelem)/15./, P1027(ipLnRedis)/-1./,
     4  P1027(ipLnAul)/0.899/
*
*     P X 1.868
      data P1018(ipLnWlAng)/1.868e4/,P1018(ipLnGl)/3./,
     1  P1018(ipLnGu)/5./, P1018(ipLnGF)/0./,
     2  P1018(ipLnEnrWN)/5353.3/,P1018(ipLnIonStg)/10./, 
     3  P1018(ipLnNelem)/15./, P1018(ipLnRedis)/-1./,
     4  P1018(ipLnAul)/2.05/
*
*     sulphur line optical depth data
      data t1256(ipLnWlAng)/1256./ ,t1256(ipLnGl)/4./, 
     1 t1256(ipLnGu)/12./,t1256(ipLnGF)/0.124/ ,
     2 t1256(ipLnEnrWN)/79610.367/ ,t1256(ipLnIonStg)/2./, 
     3 t1256(ipLnNelem)/16./, t1256(ipLnRedis)/1./
*
      data t1194(ipLnWlAng)/1194./ ,t1194(ipLnGl)/9./, 
     1  t1194(ipLnGu)/15./,t1194(ipLnGF)/0.226/ ,
     2  t1194(ipLnEnrWN)/83503.413/ ,t1194(ipLnIonStg)/3./, 
     3  t1194(ipLnNelem)/16./, t1194(ipLnRedis)/1./
*
*     Heise et al. 1995 Ap.J. 451, 241. for A
      data tS1720(ipLnWlAng)/1720./ ,tS1720(ipLnGl)/9./, 
     1  tS1720(ipLnGu)/5./,tS1720(ipLnGF)/0./ ,
     2  tS1720(ipLnEnrWN)/58139.5/ ,tS1720(ipLnIonStg)/3./, 
     3  tS1720(ipLnNelem)/16./, tS1720(ipLnRedis)/1./,
     4  tS1720(ipLnAul)/20800./
*
*     A from 
*     >>refer Dufton, P.L., Hibbert, A., Kingston, A.E., & Doschek, G.A.
*     >>refer 1982, ApJ, 257, 338
      data t1406(ipLnWlAng)/1406./,t1406(ipLnGl)/6./,
     1  t1406(ipLnGu)/12./,t1406(ipLnGF)/2.35e-4/ ,
     2  t1406(ipLnEnrWN)/71766.697/,t1406(ipLnIonStg)/4./, 
     3  t1406(ipLnNelem)/16./, t1406(ipLnRedis)/1./
*
      data t1198(ipLnWlAng)/1198./,t1198(ipLnGl)/1./,
     1  t1198(ipLnGu)/3./,t1198(ipLnGF)/1.06e-4/ ,
     2  t1198(ipLnEnrWN)/83433./,t1198(ipLnIonStg)/5./, 
     3  t1198(ipLnNelem)/16./, t1198(ipLnRedis)/-1./
*
      data t786(ipLnWlAng)/786./ ,t786(ipLnGl)/1./, 
     1  t786(ipLnGu)/3./, t786(ipLnGF)/1.42/ ,
     2  t786(ipLnEnrWN)/127150./ ,t786(ipLnIonStg)/5./, 
     3  t786(ipLnNelem)/16./, t786(ipLnRedis)/1./
*
      data t933(ipLnWlAng)/933./,t933(ipLnGl)/2./, 
     1  t933(ipLnGu)/4./, t933(ipLnGF)/0.89/ ,
     2  t933(ipLnEnrWN)/107137.7/,t933(ipLnIonStg)/6./, 
     3  t933(ipLnNelem)/16./, t933(ipLnRedis)/1./
*
      data t944(ipLnWlAng)/944./,t944(ipLnGl)/2./, 
     1  t944(ipLnGu)/2./, t944(ipLnGF)/0.44/ ,
     2  t944(ipLnEnrWN)/105873.6/,t944(ipLnIonStg)/6./, 
     3  t944(ipLnNelem)/16./, t944(ipLnRedis)/1./
*
*     [S VIII] 9913
      data fsS810(ipLnWlAng)/9913./,fsS810(ipLnGl)/4./, 
     1  fsS810(ipLnGu)/2./, fsS810(ipLnGF)/0./ ,
     2  fsS810(ipLnEnrWN)/10085.3/,fsS810(ipLnIonStg)/8./, 
     3  fsS810(ipLnNelem)/16./, fsS810(ipLnRedis)/-1./ ,
     4  fsS810(ipLnAul)/18.4/
*
*     [S IX] 1.252 mic
      data fsS912(ipLnWlAng)/1.252e4/,fsS912(ipLnGl)/5./, 
     1  fsS912(ipLnGu)/3./, fsS912(ipLnGF)/0./ ,
     2  fsS912(ipLnEnrWN)/7985./,fsS912(ipLnIonStg)/9./, 
     3  fsS912(ipLnNelem)/16./, fsS912(ipLnRedis)/-1./ ,
     4  fsS912(ipLnAul)/11.4/
*
*     [S IX] 3.755 mic
      data fsS938(ipLnWlAng)/3.755e4/,fsS938(ipLnGl)/3./, 
     1  fsS938(ipLnGu)/1./, fsS938(ipLnGF)/0./ ,
     2  fsS938(ipLnEnrWN)/2663./,fsS938(ipLnIonStg)/9./, 
     3  fsS938(ipLnNelem)/16./, fsS938(ipLnRedis)/-1./ ,
     4  fsS938(ipLnAul)/1.01/
*
*     [S XI] 1.9201 mic
      data fsS1119(ipLnWlAng)/1.9201e4/,fsS1119(ipLnGl)/1./, 
     1  fsS1119(ipLnGu)/3./, fsS1119(ipLnGF)/0./ ,
     2  fsS1119(ipLnEnrWN)/5208./,fsS1119(ipLnIonStg)/11./, 
     3  fsS1119(ipLnNelem)/16./, fsS1119(ipLnRedis)/-1./ ,
     4  fsS1119(ipLnAul)/2.51/
*
*     [S XI] 1.3927 mic
      data fsS1114(ipLnWlAng)/1.3927e4/,fsS1114(ipLnGl)/3./, 
     1  fsS1114(ipLnGu)/5./, fsS1114(ipLnGF)/0./ ,
     2  fsS1114(ipLnEnrWN)/7180.1/,fsS1114(ipLnIonStg)/11./, 
     3  fsS1114(ipLnNelem)/16./, fsS1114(ipLnRedis)/-1./ ,
     4  fsS1114(ipLnAul)/4.94/
*
*     S XII 7536
*     this is a vacuum wavelength
      data fsS1207(ipLnWlAng)/7611.2/,fsS1207(ipLnGl)/2./, 
     1  fsS1207(ipLnGu)/4./, fsS1207(ipLnGF)/0./ ,
     2  fsS1207(ipLnEnrWN)/13135.3/,fsS1207(ipLnIonStg)/12./, 
     3  fsS1207(ipLnNelem)/16./, fsS1207(ipLnRedis)/-1./ ,
     4  fsS1207(ipLnAul)/20.4/
*
      data tSu418(ipLnWlAng)/418./ ,tSu418(ipLnGl)/2./,
     1 tSu418(ipLnGu)/4./, tSu418(ipLnGF)/0.1278/, 
     2 tSu418(ipLnEnrWN)/239429.2/ ,tSu418(ipLnIonStg)/14./,
     2 tSu418(ipLnNelem)/16./ , tSu418(ipLnRedis)/1./
*
      data tSu446(ipLnWlAng)/446./ ,tSu446(ipLnGl)/2./,
     1 tSu446(ipLnGu)/2./, tSu446(ipLnGF)/0.0598/, 
     2 tSu446(ipLnEnrWN)/224330.9/ ,tSu446(ipLnIonStg)/14./,
     2 tSu446(ipLnNelem)/16./ , tSu446(ipLnRedis)/1./
*
      data tSu30(ipLnWlAng)/30./ ,tSu30(ipLnGl)/2./,
     1 tSu30(ipLnGu)/6./, tSu30(ipLnGF)/0.712/,
     2 tSu30(ipLnEnrWN)/3.285043E+06/ ,tSu30(ipLnIonStg)/14./, 
     3 tSu30(ipLnNelem)/16./, tSu30(ipLnRedis)/1./
*
*     fine structure lines added in by Jim Kingdon
      data tS19(ipLnWlAng)/1.87e5/,tS19(ipLnGl)/3./, 
     1  tS19(ipLnGu)/5./, tS19(ipLnGF)/5.41e-8/,
     2  tS19(ipLnEnrWN)/535.33/,tS19(ipLnIonStg)/3./, 
     3  tS19(ipLnNelem)/16./, tS19(ipLnRedis)/-1./
*
*     [S III] 33.48
      data tS34(ipLnWlAng)/3.348e5/,tS34(ipLnGl)/1./, 
     1  tS34(ipLnGu)/3./, tS34(ipLnGF)/2.40e-8/,
     2  tS34(ipLnEnrWN)/298.677/,tS34(ipLnIonStg)/3./, 
     3  tS34(ipLnNelem)/16./, tS34(ipLnRedis)/-1./
*
      data tS11(ipLnWlAng)/1.053e5/,tS11(ipLnGl)/2./, 
     1  tS11(ipLnGu)/4./, tS11(ipLnGF)/5.13e-8/,
     2  tS11(ipLnEnrWN)/951.43/,tS11(ipLnIonStg)/4./, 
     3  tS11(ipLnNelem)/16./, tS11(ipLnRedis)/-1./
*
*     chlorine line optical depth data
*
*     Cl II 14.3678 mic
      data fsCl214(ipLnWlAng)/1.44e5/,fsCl214(ipLnGl)/5./,
     1  fsCl214(ipLnGu)/3./, fsCl214(ipLnGF)/0./,
     2  fsCl214(ipLnEnrWN)/697./,fsCl214(ipLnIonStg)/2./, 
     3  fsCl214(ipLnNelem)/17./, fsCl214(ipLnRedis)/-1./,
     4  fsCl214(ipLnAul)/7.57e-3/
*
*     Cl II 33.281 mic
      data fsCl233(ipLnWlAng)/3.33e5/,fsCl233(ipLnGl)/3./,
     1  fsCl233(ipLnGu)/1./, fsCl233(ipLnGF)/0./,
     2  fsCl233(ipLnEnrWN)/299.0/,fsCl233(ipLnIonStg)/2./, 
     3  fsCl233(ipLnNelem)/17./, fsCl233(ipLnRedis)/-1./,
     4  fsCl233(ipLnAul)/1.46e-3/
*
*     [Cl 4] 20.354 mic
      data Cl04203(ipLnWlAng)/2.04e5/,Cl04203(ipLnGl)/1./,
     1  Cl04203(ipLnGu)/3./, Cl04203(ipLnGF)/0./,
     2  Cl04203(ipLnEnrWN)/491.3/,Cl04203(ipLnIonStg)/4./, 
     3  Cl04203(ipLnNelem)/17./, Cl04203(ipLnRedis)/-1./,
     4  Cl04203(ipLnAul)/2.13e-3/
*
*     [Cl 4] 11.741 mic
      data Cl04117(ipLnWlAng)/1.17e5/,Cl04117(ipLnGl)/3./,
     1  Cl04117(ipLnGu)/5./, Cl04117(ipLnGF)/0./,
     2  Cl04117(ipLnEnrWN)/851.72/,Cl04117(ipLnIonStg)/4./, 
     3  Cl04117(ipLnNelem)/17./, Cl04117(ipLnRedis)/-1./,
     4  Cl04117(ipLnAul)/8.32e-3/
*
*     Cl IX 7334A
      data Cl973(ipLnWlAng)/7334./,Cl973(ipLnGl)/4./, 
     1  Cl973(ipLnGu)/2./, Cl973(ipLnGF)/0./ ,
     2  Cl973(ipLnEnrWN)/1.3635e4/,Cl973(ipLnIonStg)/9./, 
     3  Cl973(ipLnNelem)/17./, Cl973(ipLnRedis)/-1./,
     4  Cl973(ipLnAul)/45.5/
*
*     Cl X 3.05 mic
      data Cl1030(ipLnWlAng)/3.05e4/,Cl1030(ipLnGl)/3./,
     1  Cl1030(ipLnGu)/1./, Cl1030(ipLnGF)/0./,
     2  Cl1030(ipLnEnrWN)/3278.7/,Cl1030(ipLnIonStg)/10./, 
     3  Cl1030(ipLnNelem)/17./, Cl1030(ipLnRedis)/-1./,
     4  Cl1030(ipLnAul)/1.87/
*
*     Cl X 9332
      data Cl1092(ipLnWlAng)/9332./,Cl1092(ipLnGl)/5./,
     1  Cl1092(ipLnGu)/3./, Cl1092(ipLnGF)/0./,
     2  Cl1092(ipLnEnrWN)/10715.8/,Cl1092(ipLnIonStg)/10./, 
     3  Cl1092(ipLnNelem)/17./, Cl1092(ipLnRedis)/-1./,
     4  Cl1092(ipLnAul)/28.3/
*
*     argon line optical depth data
*     Ar XVI
      data t354(ipLnWlAng)/354./ ,t354(ipLnGl)/2./, 
     1  t354(ipLnGu)/4./, t354(ipLnGF)/.1158/,
     2  t354(ipLnEnrWN)/282549./ ,t354(ipLnIonStg)/16./, 
     3  t354(ipLnNelem)/18./ , t354(ipLnRedis)/1./ 
*
*     Ar XVI
      data t389(ipLnWlAng)/389./ ,t389(ipLnGl)/2./, 
     1  t389(ipLnGu)/2./, t389(ipLnGF)/.0526/,
     2  t389(ipLnEnrWN)/256976./ ,t389(ipLnIonStg)/16./, 
     3  t389(ipLnNelem)/18./ , t389(ipLnRedis)/1./ 
*
*     Ar XVI
      data t25(ipLnWlAng)/25.53/ ,t25(ipLnGl)/2./, 
     1  t25(ipLnGu)/6./, t25(ipLnGF)/.736/,
     2  t25(ipLnEnrWN)/3.916960E6/ ,t25(ipLnIonStg)/16./, 
     3  t25(ipLnNelem)/18./ , t25(ipLnRedis)/1./ 
*
*     argon fine structure lines
*     [Ar II]
      data tAr7(ipLnWlAng)/6.98e4/,tAr7(ipLnGl)/4./, 
     1  tAr7(ipLnGu)/2./, tAr7(ipLnGF)/7.71e-8/,
     2  tAr7(ipLnEnrWN)/1430.46/,tAr7(ipLnIonStg)/2./, 
     3  tAr7(ipLnNelem)/18./, tAr7(ipLnRedis)/-1./
*
*     [Ar III] 9.0 mic
      data tAr9(ipLnWlAng)/9.0e4/,tAr9(ipLnGl)/5./, 
     1  tAr9(ipLnGu)/3./, tAr9(ipLnGF)/1.12e-7/,
     2  tAr9(ipLnEnrWN)/1112.66/,tAr9(ipLnIonStg)/3./, 
     3  tAr9(ipLnNelem)/18./, tAr9(ipLnRedis)/-1./
*
*     [Ar III] 21.83 mic
      data tAr22(ipLnWlAng)/2.183e5/,tAr22(ipLnGl)/3./, 
     1  tAr22(ipLnGu)/1./, tAr22(ipLnGF)/3.69e-8/,
     2  tAr22(ipLnEnrWN)/458.10/,tAr22(ipLnIonStg)/3./, 
     3  tAr22(ipLnNelem)/18./, tAr22(ipLnRedis)/-1./
*
*     [Ar V] 13.1 mic
      data tAr13(ipLnWlAng)/1.31e5/,tAr13(ipLnGl)/1./, 
     1  tAr13(ipLnGu)/3./, tAr13(ipLnGF)/6.14e-8/,
     2  tAr13(ipLnEnrWN)/763.23/,tAr13(ipLnIonStg)/5./, 
     3  tAr13(ipLnNelem)/18./, tAr13(ipLnRedis)/-1./
*
*     [Ar V] 8.0 mic
      data tAr8(ipLnWlAng)/8.0e4/,tAr8(ipLnGl)/3./, 
     1  tAr8(ipLnGu)/5./, tAr8(ipLnGF)/1.27e-7/,
     2  tAr8(ipLnEnrWN)/1265.30/,tAr8(ipLnIonStg)/5./, 
     3  tAr8(ipLnNelem)/18./, tAr8(ipLnRedis)/-1./
*
*     [Ar VI] 4.53 micron
      data Ar06453(ipLnWlAng)/4.53e4/,Ar06453(ipLnGl)/2./,
     1  Ar06453(ipLnGu)/4./, Ar06453(ipLnGF)/0./,
     2  Ar06453(ipLnEnrWN)/2207.74/,Ar06453(ipLnIonStg)/6./, 
     3  Ar06453(ipLnNelem)/18./, Ar06453(ipLnRedis)/-1./,
     4  Ar06453(ipLnAul)/0.097/
*
*     Ar X 5533
      data Ar1055(ipLnWlAng)/5533./,Ar1055(ipLnGl)/4./, 
     1  Ar1055(ipLnGu)/2./, Ar1055(ipLnGF)/0./ ,
     2  Ar1055(ipLnEnrWN)/1.8063e4/,Ar1055(ipLnIonStg)/10./,
     3  Ar1055(ipLnNelem)/18./, Ar1055(ipLnRedis)/-1./,
     4  Ar1055(ipLnAul)/106./
*
*     [Ar XI] 2.619 mic
      data Ar1126(ipLnWlAng)/2.619e4/,Ar1126(ipLnGl)/1./,
     1  Ar1126(ipLnGu)/3./, Ar1126(ipLnGF)/0./,
     2  Ar1126(ipLnEnrWN)/3818.0/,Ar1126(ipLnIonStg)/11./, 
     3  Ar1126(ipLnNelem)/18./, Ar1126(ipLnRedis)/-1./,
     4  Ar1126(ipLnAul)/3./
*
*     [Ar XI] 6917.5
      data Ar1178(ipLnWlAng)/6917.5/,Ar1178(ipLnGl)/3./,
     1  Ar1178(ipLnGu)/5./, Ar1178(ipLnGF)/0./,
     2  Ar1178(ipLnEnrWN)/1.44556e4/,Ar1178(ipLnIonStg)/11./, 
     3  Ar1178(ipLnNelem)/18./, Ar1178(ipLnRedis)/-1./,
     4  Ar1178(ipLnAul)/66.3/
*
*     potasium - really should split into two
      data KI7745(ipLnWlAng)/7745./,KI7745(ipLnGl)/ 2./,
     1  KI7745(ipLnGu)/ 6./,KI7745(ipLnGF)/2.04E+00/,
     2  KI7745(ipLnEnrWN)/13023.641/,KI7745(ipLnIonStg)/1./,
     3  KI7745(ipLnNelem)/19./,KI7745(ipLnRedis)/1./
     4  KI7745(ipLnAul)/0./
*
*     [K III] 4.62 micron
      data xK03462(ipLnWlAng)/4.62e4/,xK03462(ipLnGl)/4./,
     1  xK03462(ipLnGu)/2./, xK03462(ipLnGF)/0./,
     2  xK03462(ipLnEnrWN)/2165.43/,xK03462(ipLnIonStg)/3./, 
     3  xK03462(ipLnNelem)/19./, xK03462(ipLnRedis)/-1./,
     4  xK03462(ipLnAul)/0.183/
*
*     [K IV] 5.982 micron
      data xK04598(ipLnWlAng)/5.98e4/,xK04598(ipLnGl)/5./,
     1  xK04598(ipLnGu)/3./, xK04598(ipLnGF)/0./,
     2  xK04598(ipLnEnrWN)/1671.68/,xK04598(ipLnIonStg)/4./, 
     3  xK04598(ipLnNelem)/19./, xK04598(ipLnRedis)/-1./,
     4  xK04598(ipLnAul)/0.104/
*
*     [K IV] 15.39 micron
      data xK04154(ipLnWlAng)/15.39e4/,xK04154(ipLnGl)/3./,
     1  xK04154(ipLnGu)/1./, xK04154(ipLnGF)/0./,
     2  xK04154(ipLnEnrWN)/649.8/,xK04154(ipLnIonStg)/4./, 
     3  xK04154(ipLnNelem)/19./, xK04154(ipLnRedis)/-1./,
     4  xK04154(ipLnAul)/0.0151/
*
*     [K VI] 8.823 micron
      data xK06882(ipLnWlAng)/8.82e4/,xK06882(ipLnGl)/1./,
     1  xK06882(ipLnGu)/3./, xK06882(ipLnGF)/0./,
     2  xK06882(ipLnEnrWN)/1133.4/,xK06882(ipLnIonStg)/6./, 
     3  xK06882(ipLnNelem)/19./, xK06882(ipLnRedis)/-1./,
     4  xK06882(ipLnAul)/0.0261/
*
*     [K VI] 5.575 micron
      data xK06557(ipLnWlAng)/5.57e4/,xK06557(ipLnGl)/3./,
     1  xK06557(ipLnGu)/5./, xK06557(ipLnGF)/0./,
     2  xK06557(ipLnEnrWN)/1793.8/,xK06557(ipLnIonStg)/6./, 
     3  xK06557(ipLnNelem)/19./, xK06557(ipLnRedis)/-1./,
     4  xK06557(ipLnAul)/0.0774/
*
*     [K VII] 3.19 micron
      data xK07319(ipLnWlAng)/3.1905e4/,xK07319(ipLnGl)/2./,
     1  xK07319(ipLnGu)/4./, xK07319(ipLnGF)/0./,
     2  xK07319(ipLnEnrWN)/3134.28/,xK07319(ipLnIonStg)/7./, 
     3  xK07319(ipLnNelem)/19./, xK07319(ipLnRedis)/-1./,
     4  xK07319(ipLnAul)/0.277/
*
*     [K XI] 4249.99 A 
*     >>refer Kaufman, V., & Sugar, J. 1986, J Phys Chem Ref Dat, 15, 321
*     energies 
*     >>refer Sugar, J., & Corliss, C 1985 J Phys Chem Ref Dat, vol 14
      data xK11425(ipLnWlAng)/4250./,xK11425(ipLnGl)/4./,
     1  xK11425(ipLnGu)/2./, xK11425(ipLnGF)/0./,
     2  xK11425(ipLnEnrWN)/23530./,xK11425(ipLnIonStg)/11./, 
     3  xK11425(ipLnNelem)/19./, xK11425(ipLnRedis)/-1./,
     4  xK11425(ipLnAul)/234./
*
*     calcium line optical depth data
      data CaI4228(ipLnWlAng)/4228./,CaI4228(ipLnGl)/ 1./,
     1  CaI4228(ipLnGu)/ 3./,CaI4228(ipLnGF)/1.94E+00/,
     2  CaI4228(ipLnEnrWN)/23652.304/,CaI4228(ipLnIonStg)/1./,
     3  CaI4228(ipLnNelem)/20./,CaI4228(ipLnRedis)/1./
     4  CaI4228(ipLnAul)/0./
*
      data t3934(ipLnWlAng)/3934./,t3934(ipLnGl)/2./, 
     1  t3934(ipLnGu)/4./, t3934(ipLnGF)/1.30/ ,
     2  t3934(ipLnEnrWN)/25414.427/,t3934(ipLnIonStg)/2./, 
     3  t3934(ipLnNelem)/20./, t3934(ipLnRedis)/1./
*
      data t3969(ipLnWlAng)/3969./,t3969(ipLnGl)/2./, 
     1  t3969(ipLnGu)/2./, t3969(ipLnGF)/.644/ ,
     2  t3969(ipLnEnrWN)/25191.541/,t3969(ipLnIonStg)/2./, 
     3  t3969(ipLnNelem)/20./, t3969(ipLnRedis)/1./
*
      data t8498(ipLnWlAng)/8498./,t8498(ipLnGl)/4./, 
     1  t8498(ipLnGu)/4./, t8498(ipLnGF)/3.56E-2/,
     2  t8498(ipLnEnrWN)/11764.215/,t8498(ipLnIonStg)/2./, 
     3  t8498(ipLnNelem)/20./ , t8498(ipLnRedis)/1./ 
*
      data t8542(ipLnWlAng)/8542./,t8542(ipLnGl)/6./, 
     1  t8542(ipLnGu)/4./, t8542(ipLnGF)/0.327/,
     2  t8542(ipLnEnrWN)/11703.526/,t8542(ipLnIonStg)/2./, 
     3  t8542(ipLnNelem)/20./, t8542(ipLnRedis)/1./
*
      data t8662(ipLnWlAng)/8662./,t8662(ipLnGl)/4./,
     1  t8662(ipLnGu)/2./, t8662(ipLnGF)/.178/,
     2  t8662(ipLnEnrWN)/11541.329/,t8662(ipLnIonStg)/2./, 
     3  t8662(ipLnNelem)/20./, t8662(ipLnRedis)/1./
*
      data t7291(ipLnWlAng)/7291./,t7291(ipLnGl)/2./, 
     1  t7291(ipLnGu)/6./,t7291(ipLnGF)/4.76E-8/ ,
     2  t7291(ipLnEnrWN)/13710.901/,t7291(ipLnIonStg)/2./, 
     3  t7291(ipLnNelem)/20./, t7291(ipLnRedis)/1./
*
      data t7324(ipLnWlAng)/7324./,t7324(ipLnGl)/2./, 
     1  t7324(ipLnGu)/4./,t7324(ipLnGF)/3.23E-8/ ,
     2  t7324(ipLnEnrWN)/13650.212/,t7324(ipLnIonStg)/2./, 
     3  t7324(ipLnNelem)/20./, t7324(ipLnRedis)/1./
*
      data tCa302(ipLnWlAng)/302./ ,tCa302(ipLnGl)/2./,
     1 tCa302(ipLnGu)/4./, tCa302(ipLnGF)/0.1076/, 
     2 tCa302(ipLnEnrWN)/330917.6/ ,tCa302(ipLnIonStg)/18./,
     3 tCa302(ipLnNelem)/20./ , tCa302(ipLnRedis)/1./
*
      data tCa345(ipLnWlAng)/345./ ,tCa345(ipLnGl)/2./,
     1  tCa345(ipLnGu)/2./, tCa345(ipLnGF)/0.0472/, 
     2  tCa345(ipLnEnrWN)/290056.9/ ,tCa345(ipLnIonStg)/18./,
     2  tCa345(ipLnNelem)/20./ , tCa345(ipLnRedis)/1./
*
      data tCa19(ipLnWlAng)/19./ ,tCa19(ipLnGl)/2./,
     1  tCa19(ipLnGu)/6./, tCa19(ipLnGF)/0.746/,
     2  tCa19(ipLnEnrWN)/5.346164E+06/ ,tCa19(ipLnIonStg)/18./, 
     3  tCa19(ipLnNelem)/20./, tCa19(ipLnRedis)/1./
*
*     Jim Kingdon added these fs lines
*     [Ca IV] 3.21 min
      data tCa3(ipLnWlAng)/3.21e4/,tCa3(ipLnGl)/4./, 
     1  tCa3(ipLnGu)/2./, tCa3(ipLnGF)/1.68e-7/,
     2  tCa3(ipLnEnrWN)/3118.46/,tCa3(ipLnIonStg)/4./, 
     3  tCa3(ipLnNelem)/20./, tCa3(ipLnRedis)/-1./
*
      data tCa12(ipLnWlAng)/1.14e5/,tCa12(ipLnGl)/3./, 
     1  tCa12(ipLnGu)/1./, tCa12(ipLnGF)/7.01e-8/,
     2  tCa12(ipLnEnrWN)/870.93/,tCa12(ipLnIonStg)/5./, 
     3  tCa12(ipLnNelem)/20./, tCa12(ipLnRedis)/-1./
*
      data tCa4(ipLnWlAng)/4.15e4/,tCa4(ipLnGl)/5./, 
     1  tCa4(ipLnGu)/3./, tCa4(ipLnGF)/2.41e-7/,
     2  tCa4(ipLnEnrWN)/2404.66/,tCa4(ipLnIonStg)/5./, 
     3  tCa4(ipLnNelem)/20./, tCa4(ipLnRedis)/-1./
*
*     [Ca VII] 4.09 micron
      data Ca0741(ipLnWlAng)/4.09e4/,Ca0741(ipLnGl)/3./,
     1  Ca0741(ipLnGu)/5./, Ca0741(ipLnGF)/0./,
     2  Ca0741(ipLnEnrWN)/2446.5/,Ca0741(ipLnIonStg)/7./, 
     3  Ca0741(ipLnNelem)/20./, Ca0741(ipLnRedis)/-1./,
     4  Ca0741(ipLnAul)/0.196/
*
*     [Ca VII] 6.15 micron
      data Ca0761(ipLnWlAng)/6.15e4/,Ca0761(ipLnGl)/1./,
     1  Ca0761(ipLnGu)/3./, Ca0761(ipLnGF)/0./,
     2  Ca0761(ipLnEnrWN)/1624.9/,Ca0761(ipLnIonStg)/7./, 
     3  Ca0761(ipLnNelem)/20./, Ca0761(ipLnRedis)/-1./,
     4  Ca0761(ipLnAul)/0.0767/
*
*     [Ca VIII] 2.32 micron
      data Ca08232(ipLnWlAng)/2.32e4/,Ca08232(ipLnGl)/2./,
     1  Ca08232(ipLnGu)/4./, Ca08232(ipLnGF)/0./,
     2  Ca08232(ipLnEnrWN)/4306.55/,Ca08232(ipLnIonStg)/8./, 
     3  Ca08232(ipLnNelem)/20./, Ca08232(ipLnRedis)/-1./,
     4  Ca08232(ipLnAul)/0.72/
*
*     [Ca 12] 3328.78 A 
*     >>refer Kaufman, V., & Sugar, J. 1986, J Phys Chem Ref Dat, 15, 321
*     energies 
*     >>refer Sugar, J., & Corliss, C 1985 J Phys Chem Ref Dat, vol 14
      data Ca12333(ipLnWlAng)/3329./,Ca12333(ipLnGl)/4./,
     1  Ca12333(ipLnGu)/2./, Ca12333(ipLnGF)/0./,
     2  Ca12333(ipLnEnrWN)/30041./,Ca12333(ipLnIonStg)/12./, 
     3  Ca12333(ipLnNelem)/20./, Ca12333(ipLnRedis)/-1./,
     4  Ca12333(ipLnAul)/487./
*
*     scandium data
*     [Sc V] 2.31 micron
      data Sc05231(ipLnWlAng)/2.31e4/,Sc05231(ipLnGl)/4./,
     1  Sc05231(ipLnGu)/2./, Sc05231(ipLnGF)/0./,
     2  Sc05231(ipLnEnrWN)/4326.8/,Sc05231(ipLnIonStg)/5./, 
     3  Sc05231(ipLnNelem)/21./, Sc05231(ipLnRedis)/-1./,
     4  Sc05231(ipLnAul)/1.46/
*
*     [Sc 13] 2637.97 A 
*     >>refer Kaufman, V., & Sugar, J. 1986, J Phys Chem Ref Dat, 15, 321
*     energies
*     >>refer Sugar, J., & Corliss, C 1985 J Phys Chem Ref Dat, vol 14
      data Sc13264(ipLnWlAng)/2638./,Sc13264(ipLnGl)/4./,
     1  Sc13264(ipLnGu)/2./, Sc13264(ipLnGF)/0./,
     2  Sc13264(ipLnEnrWN)/37908./,Sc13264(ipLnIonStg)/13./, 
     3  Sc13264(ipLnNelem)/21./, Sc13264(ipLnRedis)/-1./,
     4  Sc13264(ipLnAul)/978./
*
*     Titanium data
*     [Ti VI] 1.72 micron
      data Ti06172(ipLnWlAng)/1.72e4/,Ti06172(ipLnGl)/4./,
     1  Ti06172(ipLnGu)/2./, Ti06172(ipLnGF)/0./,
     2  Ti06172(ipLnEnrWN)/5830.9/,Ti06172(ipLnIonStg)/6./, 
     3  Ti06172(ipLnNelem)/22./, Ti06172(ipLnRedis)/-1./,
     4  Ti06172(ipLnAul)/3.56/
*
*     [Ti 14] 2117.79 A 
*     >>refer Kaufman, V., & Sugar, J. 1986, J Phys Chem Ref Dat, 15, 321
*     energies 
*     >>refer Sugar, J., & Corliss, C 1985 J Phys Chem Ref Dat, vol 14
      data Ti14212(ipLnWlAng)/2118./,Ti14212(ipLnGl)/4./,
     1  Ti14212(ipLnGu)/2./, Ti14212(ipLnGF)/0./,
     2  Ti14212(ipLnEnrWN)/47219./,Ti14212(ipLnIonStg)/14./, 
     3  Ti14212(ipLnNelem)/22./, Ti14212(ipLnRedis)/-1./,
     4  Ti14212(ipLnAul)/1890./
*
*     Vanadium data
*     [V VII] 1.30 micron
      data Va07130(ipLnWlAng)/1.30e4/,Va07130(ipLnGl)/4./,
     1  Va07130(ipLnGu)/2./, Va07130(ipLnGF)/0./,
     2  Va07130(ipLnEnrWN)/7669.9/,Va07130(ipLnIonStg)/7./, 
     3  Va07130(ipLnNelem)/23./, Va07130(ipLnRedis)/-1./,
     4  Va07130(ipLnAul)/8.11/
*
*     [V 15] 1721.38 A 
*     >>refer Kaufman, V., & Sugar, J. 1986, J Phys Chem Ref Dat, 15, 321
*     energies 
*     >>refer Sugar, J., & Corliss, C 1985 J Phys Chem Ref Dat, vol 14
      data Va15172(ipLnWlAng)/1721./,Va15172(ipLnGl)/4./,
     1  Va15172(ipLnGu)/2./, Va15172(ipLnGF)/0./,
     2  Va15172(ipLnEnrWN)/58093./,Va15172(ipLnIonStg)/15./, 
     3  Va15172(ipLnNelem)/23./, Va15172(ipLnRedis)/-1./,
     4  Va15172(ipLnAul)/3520./
*
*     Chromium data
*     [Cr VIII] 1.01 micron
      data Cr08101(ipLnWlAng)/1.01e4/,Cr08101(ipLnGl)/4./,
     1  Cr08101(ipLnGu)/2./, Cr08101(ipLnGF)/0./,
     2  Cr08101(ipLnEnrWN)/9895.1/,Cr08101(ipLnIonStg)/8./, 
     3  Cr08101(ipLnNelem)/24./, Cr08101(ipLnRedis)/-1./,
     4  Cr08101(ipLnAul)/17.4/
*
*     [Cr 16] 1410.60 A
*     >>refer Kaufman, V., & Sugar, J. 1986, J Phys Chem Ref Dat, 15, 321
*     energies 
*     >>refer Sugar, J., & Corliss, C 1985 J Phys Chem Ref Dat, vol 14
      data Cr16141(ipLnWlAng)/1411./,Cr16141(ipLnGl)/4./,
     1  Cr16141(ipLnGu)/2./, Cr16141(ipLnGF)/0./,
     2  Cr16141(ipLnEnrWN)/70892./,Cr16141(ipLnIonStg)/16./, 
     3  Cr16141(ipLnNelem)/24./, Cr16141(ipLnRedis)/-1./,
     4  Cr16141(ipLnAul)/6390./
*
*     Manganese data
*     [Mn IX] 7968.5A
      data xMn0979(ipLnWlAng)/7968.5/,xMn0979(ipLnGl)/4./,
     1  xMn0979(ipLnGu)/2./, xMn0979(ipLnGF)/0./,
     2  xMn0979(ipLnEnrWN)/12549.4/,xMn0979(ipLnIonStg)/9./, 
     3  xMn0979(ipLnNelem)/25./, xMn0979(ipLnRedis)/-1./,
     4  xMn0979(ipLnAul)/35.5/
*
*     [Mn 17] 1169.59 A 
*     >>refer Kaufman, V., & Sugar, J. 1986, J Phys Chem Ref Dat, 15, 321
*     energies 
*     >>refer Sugar, J., & Corliss, C 1985 J Phys Chem Ref Dat, vol 14
      data xMn1712(ipLnWlAng)/1170./,xMn1712(ipLnGl)/4./,
     1  xMn1712(ipLnGu)/2./, xMn1712(ipLnGF)/0./,
     2  xMn1712(ipLnEnrWN)/85500./,xMn1712(ipLnIonStg)/17./, 
     3  xMn1712(ipLnNelem)/25./, xMn1712(ipLnRedis)/-1./,
     4  xMn1712(ipLnAul)/11200./
*
*     iron Fe line optical depth data
      data FeI3884(ipLnWlAng)/3884./,FeI3884(ipLnGl)/25./,
     1  FeI3884(ipLnGu)/25./,FeI3884(ipLnGF)/5.65E-01/,
     2  FeI3884(ipLnEnrWN)/25748.000/,FeI3884(ipLnIonStg)/1./,
     3  FeI3884(ipLnNelem)/26./,FeI3884(ipLnRedis)/1./
     4  FeI3884(ipLnAul)/0./
*
      data FeI3729(ipLnWlAng)/3729./,FeI3729(ipLnGl)/25./,
     1  FeI3729(ipLnGu)/35./,FeI3729(ipLnGF)/1.18E+00/,
     2  FeI3729(ipLnEnrWN)/26817.000/,FeI3729(ipLnIonStg)/1./,
     3  FeI3729(ipLnNelem)/26./,FeI3729(ipLnRedis)/1./
     4  FeI3729(ipLnAul)/0./
*
      data FeI3457(ipLnWlAng)/3457./,FeI3457(ipLnGl)/25./,
     1  FeI3457(ipLnGu)/15./,FeI3457(ipLnGF)/6.00E-01/,
     2  FeI3457(ipLnEnrWN)/28926.000/,FeI3457(ipLnIonStg)/1./,
     3  FeI3457(ipLnNelem)/26./,FeI3457(ipLnRedis)/1./
     4  FeI3457(ipLnAul)/0./
*
      data FeI3021(ipLnWlAng)/3021./,FeI3021(ipLnGl)/25./,
     1  FeI3021(ipLnGu)/25./,FeI3021(ipLnGF)/3.50E+00/,
     2  FeI3021(ipLnEnrWN)/33101.000/,FeI3021(ipLnIonStg)/1./,
     3  FeI3021(ipLnNelem)/26./,FeI3021(ipLnRedis)/1./
     4  FeI3021(ipLnAul)/0./
*
      data FeI2966(ipLnWlAng)/2966./,FeI2966(ipLnGl)/25./,
     1  FeI2966(ipLnGu)/35./,FeI2966(ipLnGF)/1.20E+00/,
     2  FeI2966(ipLnEnrWN)/33715.000/,FeI2966(ipLnIonStg)/1./,
     3  FeI2966(ipLnNelem)/26./,FeI2966(ipLnRedis)/1./
     4  FeI2966(ipLnAul)/0./
*
      data tuv3(ipLnWlAng)/2360./,tuv3(ipLnGl)/1./, 
     1  tuv3(ipLnGu)/1./, tuv3(ipLnGF)/0.500/ ,
     2  tuv3(ipLnEnrWN)/42372.881/,tuv3(ipLnIonStg)/2./, 
     3  tuv3(ipLnNelem)/26./, tuv3(ipLnRedis)/-1./ 
*
      data tr48(ipLnWlAng)/6200./,tr48(ipLnGl)/1./, 
     1  tr48(ipLnGu)/1./, tr48(ipLnGF)/3.98E-4/ ,
     2  tr48(ipLnEnrWN)/20000./,tr48(ipLnIonStg)/2./, 
     3  tr48(ipLnNelem)/26./, tr48(ipLnRedis)/-1./
*
      data tFe16(ipLnWlAng)/1080./,tFe16(ipLnGl)/1./,
     1  tFe16(ipLnGu)/1./,tFe16(ipLnGF)/7.0E-3/ ,
     2  tFe16(ipLnEnrWN)/90900./,tFe16(ipLnIonStg)/2./, 
     3  tFe16(ipLnNelem)/26./, tFe16(ipLnRedis)/-1./
*
      data tFe26(ipLnWlAng)/1500./,tFe26(ipLnGl)/1./,
     1  tFe26(ipLnGu)/1./,tFe26(ipLnGF)/0.00337/ ,
     2  tFe26(ipLnEnrWN)/66670./,tFe26(ipLnIonStg)/2./, 
     3  tFe26(ipLnNelem)/26./, tFe26(ipLnRedis)/-1./
*
      data tFe34(ipLnWlAng)/11500./,tFe34(ipLnGl)/1./,
     1  tFe34(ipLnGu)/1./,tFe34(ipLnGF)/5.9E-4/ ,
     2  tFe34(ipLnEnrWN)/8850./,tFe34(ipLnIonStg)/2./, 
     3  tFe34(ipLnNelem)/26./, tFe34(ipLnRedis)/-1./
*
      data tFe35(ipLnWlAng)/2500./,tFe35(ipLnGl)/1./,
     1  tFe35(ipLnGu)/1./,tFe35(ipLnGF)/0.2/ ,
     2  tFe35(ipLnEnrWN)/40000./,tFe35(ipLnIonStg)/2./, 
     3  tFe35(ipLnNelem)/26./, tFe35(ipLnRedis)/-1./
*
      data tFe46(ipLnWlAng)/2300./,tFe46(ipLnGl)/1./,
     1  tFe46(ipLnGu)/1./,tFe46(ipLnGF)/0.0158/ ,
     2  tFe46(ipLnEnrWN)/43470./,tFe46(ipLnIonStg)/2./, 
     3  tFe46(ipLnNelem)/26./, tFe46(ipLnRedis)/-1./
*
      data tFe56(ipLnWlAng)/8900./,tFe56(ipLnGl)/1./,
     1  tFe56(ipLnGu)/1./,tFe56(ipLnGF)/.47/ ,
     2  tFe56(ipLnEnrWN)/11236./,tFe56(ipLnIonStg)/2./, 
     3  tFe56(ipLnNelem)/26./, tFe56(ipLnRedis)/-1./
*
      data t1122(ipLnWlAng)/1122./,t1122(ipLnGl)/25./, 
     1  t1122(ipLnGu)/15./, t1122(ipLnGF)/1.9875/ ,
     2  t1122(ipLnEnrWN)/88826.495/,t1122(ipLnIonStg)/3./, 
     3  t1122(ipLnNelem)/26./, t1122(ipLnRedis)/1./
*
*     [Fe VII] 9.53 mic, A 
*     >>refer Nussbaumer, H., & Storey, P.J. 1982, A&A, 113, 21
      data Fe0795(ipLnWlAng)/9.51e4/,Fe0795(ipLnGl)/5./, 
     1  Fe0795(ipLnGu)/7./, Fe0795(ipLnGF)/0./ ,
     2  Fe0795(ipLnEnrWN)/1049.68/,Fe0795(ipLnIonStg)/7./, 
     3  Fe0795(ipLnNelem)/26./, Fe0795(ipLnRedis)/1./ ,
     4  Fe0795(ipLnAul)/0.0298/
*
*     [Fe VII] 7.81 mic, A
*     >>refer Nussbaumer, H., & Storey, P.J. 1982, A&A, 113, 21
      data Fe0778(ipLnWlAng)/7.81e4/,Fe0778(ipLnGl)/7./, 
     1  Fe0778(ipLnGu)/9./, Fe0778(ipLnGF)/0./ ,
     2  Fe0778(ipLnEnrWN)/1279.67/,Fe0778(ipLnIonStg)/7./, 
     3  Fe0778(ipLnNelem)/26./, Fe0778(ipLnRedis)/1./ ,
     4  Fe0778(ipLnAul)/0.0424/
*
      data t245(ipLnWlAng)/245./,t245(ipLnGl)/1./, 
     1  t245(ipLnGu)/3./, t245(ipLnGF)/2.4e-4/ ,
     2  t245(ipLnEnrWN)/408163./,t245(ipLnIonStg)/9./, 
     3  t245(ipLnNelem)/26./, t245(ipLnRedis)/-1./
*
*     this is pump line for upper level of [FeX] 6375
      data t352(ipLnWlAng)/352./,t352(ipLnGl)/6./, 
     1  t352(ipLnGu)/2./, t352(ipLnGF)/0.169/ ,
     2  t352(ipLnEnrWN)/284021./,t352(ipLnIonStg)/10./, 
     3  t352(ipLnNelem)/26./, t352(ipLnRedis)/1./
*
*     [FeX] 6375 coronal line
*     A 
*     >>refer Bhatia, A.K., & Doscheck, G.A. 1995 ADNDT, 60, 9
      data Fe106375(ipLnWlAng)/6375./,Fe106375(ipLnGl)/4./, 
     1  Fe106375(ipLnGu)/2./, Fe106375(ipLnGF)/0./ ,
     2  Fe106375(ipLnEnrWN)/15686./,Fe106375(ipLnIonStg)/10./, 
     3  Fe106375(ipLnNelem)/26./, Fe106375(ipLnRedis)/1./ ,
     4  Fe106375(ipLnAul)/54.91/
*
*     actually three lines contributing here, important for coronal pump
*     following is whole multiplet average
      data t353(ipLnWlAng)/353./,t353(ipLnGl)/9./, 
     1  t353(ipLnGu)/9./, t353(ipLnGF)/0.553/ ,
     2  t353(ipLnEnrWN)/283286./,t353(ipLnIonStg)/11./, 
     3  t353(ipLnNelem)/26./, t353(ipLnRedis)/1./
*
*     [Fe XIII] 1.07 microns
      data Fe1310(ipLnWlAng)/1.07e4/,Fe1310(ipLnGl)/1./, 
     1  Fe1310(ipLnGu)/3./, Fe1310(ipLnGF)/0./ ,
     2  Fe1310(ipLnEnrWN)/9302.5/,Fe1310(ipLnIonStg)/13./, 
     3  Fe1310(ipLnNelem)/26./, Fe1310(ipLnRedis)/-1./ ,
     4  Fe1310(ipLnAul)/14.0/
*
*     [Fe XIII] 1.08 microns
      data Fe1311(ipLnWlAng)/1.08e4/,Fe1311(ipLnGl)/3./, 
     1  Fe1311(ipLnGu)/5./, Fe1311(ipLnGF)/0./ ,
     2  Fe1311(ipLnEnrWN)/9258.5/,Fe1311(ipLnIonStg)/13./, 
     3  Fe1311(ipLnNelem)/26./, Fe1311(ipLnRedis)/-1./,
     4  Fe1311(ipLnAul)/9.86/
*
      data t347(ipLnWlAng)/347./,t347(ipLnGl)/6./, 
     1  t347(ipLnGu)/10./, t347(ipLnGF)/0.4092/ ,
     2  t347(ipLnEnrWN)/288184./,t347(ipLnIonStg)/14./, 
     3  t347(ipLnNelem)/26./, t347(ipLnRedis)/1./
*
      data t192(ipLnWlAng)/192./ ,t192(ipLnGl)/2./, 
     1  t192(ipLnGu)/4./, t192(ipLnGF)/.0964/,
     2  t192(ipLnEnrWN)/520725./ ,t192(ipLnIonStg)/24./, 
     3  t192(ipLnNelem)/26./ , t192(ipLnRedis)/1./ 
*
      data t255(ipLnWlAng)/255./ ,t255(ipLnGl)/2./, 
     1  t255(ipLnGu)/2./, t255(ipLnGF)/.0362/,
     2  t255(ipLnEnrWN)/392003./ ,t255(ipLnIonStg)/24./, 
     3  t255(ipLnNelem)/26./ , t255(ipLnRedis)/1./ 
*
      data t11(ipLnWlAng)/11./ ,t11(ipLnGl)/2./, 
     1  t11(ipLnGu)/6./, t11(ipLnGF)/.784/,
     2  t11(ipLnEnrWN)/9.403799E+06/ ,t11(ipLnIonStg)/24./, 
     3  t11(ipLnNelem)/26./, t11(ipLnRedis)/1./
*
*     this transition from 
*     >>refer Johansson, S., Brage, T., Leckrone, D.S., Nave, G. & Wahlgren,
*     >>refer G.M. 1995, ApJ 446, 361
      data t191(ipLnWlAng)/1787./ ,t191(ipLnGl)/6./, 
     1  t191(ipLnGu)/22./, t191(ipLnGF)/9.3/,
     2  t191(ipLnEnrWN)/55978.9/ ,t191(ipLnIonStg)/2./, 
     3  t191(ipLnNelem)/26./, t191(ipLnRedis)/1./
*
*     Jim Kingdon added these fs lines
      data tFe07(ipLnWlAng)/7.892e3/,tFe07(ipLnGl)/5./, 
     1  tFe07(ipLnGu)/3./, tFe07(ipLnGF)/1.22e-6/,
     2  tFe07(ipLnEnrWN)/12691.24/,tFe07(ipLnIonStg)/11./, 
     3  tFe07(ipLnNelem)/26./, tFe07(ipLnRedis)/-1./
*
      data tFe61(ipLnWlAng)/6.1e4/,tFe61(ipLnGl)/3./, 
     1  tFe61(ipLnGu)/1./, tFe61(ipLnGF)/1.25e-7/,
     2  tFe61(ipLnEnrWN)/1775.38/,tFe61(ipLnIonStg)/11./, 
     3  tFe61(ipLnNelem)/26./, tFe61(ipLnRedis)/-1./
*
*     [Fe 18] 974.86 A
*     >>refer Kaufman, V., & Sugar, J. 1986, J Phys Chem Ref Dat, 15, 321
*     energies
*     >>refer Sugar, J., & Corliss, C 1985 J Phys Chem Ref Dat, vol 14
      data Fe18975(ipLnWlAng)/974.9/,Fe18975(ipLnGl)/4./,
     1  Fe18975(ipLnGu)/2./, Fe18975(ipLnGF)/0./,
     2  Fe18975(ipLnEnrWN)/102579./,Fe18975(ipLnIonStg)/18./, 
     3  Fe18975(ipLnNelem)/26./, Fe18975(ipLnRedis)/-1./,
     4  Fe18975(ipLnAul)/19300./
*
      data tFe23(ipLnWlAng)/2.299e3/,tFe23(ipLnGl)/3./, 
     1  tFe23(ipLnGu)/5./, tFe23(ipLnGF)/3.43e-6/,
     2  tFe23(ipLnEnrWN)/43503.51/,tFe23(ipLnIonStg)/21./, 
     3  tFe23(ipLnNelem)/26./, tFe23(ipLnRedis)/-1./
*
      data tFe13(ipLnWlAng)/1.354e3/,tFe13(ipLnGl)/1./, 
     1  tFe13(ipLnGu)/3./, tFe13(ipLnGF)/5.10e-6/,
     2  tFe13(ipLnEnrWN)/73850./,tFe13(ipLnIonStg)/21./, 
     3  tFe13(ipLnNelem)/26./, tFe13(ipLnRedis)/-1./
*
*     Cobalt data
*     [Co XI] 5168.A
      data Co11527(ipLnWlAng)/5168.0/,Co11527(ipLnGl)/4./,
     1  Co11527(ipLnGu)/2./, Co11527(ipLnGF)/0./,
     2  Co11527(ipLnEnrWN)/19350./,Co11527(ipLnIonStg)/11./, 
     3  Co11527(ipLnNelem)/27./, Co11527(ipLnRedis)/-1./,
     4  Co11527(ipLnAul)/130.0/
*
*     Nickel data
*     [Ni XII] 4230.8A
      data xNi1242(ipLnWlAng)/4230.8/,xNi1242(ipLnGl)/4./,
     1  xNi1242(ipLnGu)/2./, xNi1242(ipLnGF)/0./,
     2  xNi1242(ipLnEnrWN)/23635.6/,xNi1242(ipLnIonStg)/12./, 
     3  xNi1242(ipLnNelem)/28./, xNi1242(ipLnRedis)/-1./,
     4  xNi1242(ipLnAul)/237.0/
*
      end
