******************************************************************************
      subroutine magnes
      implicit none
*ionization balance for magnesium
      include "ncell.par"
      include "limelm.par"
      include "nhlvl.par"
      include "itrdim.par"
      include "trace.com"
      include "elmton.com"
      include "rfield.com"
      include "he.com"
      include "mgexc.com"
      include "h.com"
      include "timed.com"
      include "TePowers.com"
      include "chargt.com"
      include "phycon.com"
      include "PhotRate.com"
      include "nh.com"
      include "ZoneCnt.com"
      include "SummdCon.com"
      include "DoPhoto.com"
      include "DestCrt.com"
      include "TrHeav.com"
      include "IonRange.com"
      include "IonFracs.com"
      include "IOqq.com"
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=13)
      parameter (nelem=12)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
      real gamfun
*
*     magnesium nelem=12
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /8.90E-11,5.90E-11,1.10E-11,9.14E-12,5.02E-12,2.73E-12,
     1 1.47E-12,7.35E-13,4.11E-13,1.64E-13,1.42E-14,5.74E-15/
      data (cion(i,2),i=1,ndim-1)
     1 /8.87E4,1.74E5,9.30E5,1.26E6,1.64E6,2.17E6,2.61E6,
     2 3.09E6, 3.81E6,4.25E6,2.04E7,2.27E7/
*
*     rec from +9, +10, +11 from Arnauld et al '85
      data rec , pl
     1/ 6.86E-10, 3.04E-9, 3.02E-9, 5.73E-9, 1.02E-8, 1.38E-8, 1.86E-8,
     2  3.21E-8 , 7.84E-8, 2.34E-7, 4.15E-7,
     2  -0.855  , -0.838 , -0.734 , -0.718 , -0.716 , -0.695 , -0.691 ,
     3  -0.711  , -0.765 , -0.829 , -0.821  /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 2.01e-10 , -0.681/
*
      data (dicoef(i,1),i=1,ndim-1)
     1/4.49e-4, 1.95e-3, 5.12e-3, 7.74e-3, 1.17e-2, 3.69e-2,
     2 3.63e-2, 4.15e-2, 8.86e-3, .252, .144, 0./
      data (dicoef(i,2),i=1,ndim-1)
     1 /.021, .074, .323, .636, .807, .351, .548, .233, .318,
     2 .315, .291, 0./
      data (dite(i,1),i=1,ndim-1)
     1 /5.01e4, 6.06e5, 4.69e5, 3.74e5, 3.28e5, 4.80e5, 3.88e5,
     2 3.39e5, 2.11e5, 1.40e7, 1.50e7, 0./
      data (dite(i,2),i=1,ndim-1)
     1/2.81e4, 1.44e6, 7.55e5, 7.88e5, 1.02e6, 9.73e5, 7.38e5,
     2 3.82e5, 1.54e6, 2.64e6, 3.09e6, 0./
      data ditcrt
     5/4.0E3  , 7.4E4  , 6.6E4  , 5.5E4  , 4.4E4  , 4.5E4  ,
     6 4.5E4  , 5.0E5  , 3.4E4  , 2.4E6  , 4.0E6  , 1E20/
*
*     mg i from nuss+storey, who say that =>Mgii is very small
      data aa/1.2044 , 11*0./, bb/-4.6836 , 11*0./,
     1     cc/7.6620 , 11*0./, dd/-0.5930 , 11*0./,
     2     ff/1.6260 , 0.1,10*0./
*
*     magnesium, atomic number 12
      if( .not.lgElmtOn(12) ) then
        xMg2Max = 0.
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
*     charge exchange ionization, Allan et al. 1988, MNRAS 235, 1245.
*     >>chng 96 Oct 1, moved all H ct to bidiag
*     CTHeavy(1,1) = CTHeavy(1,1) + HII * 7.5E-19 * TE*TE*TE10
*     charge exchange, rates from Butler and Dalgarno 1980B
*     MG+2 => MG+
*     CTHeavy(2,2) = CTHeavy(2,2) + 9E-14 * HI
*     T = MIN( SQRTE , 200. )
*     MG+3 => MG+2
*     >>chng 96 Oct 1, moved all H ct to bidiag
*     CTHeavy(3,2) = CTHeavy(3,2) + 6.5E-11 * T*HI + HEI*7E-10
      CTHeavy(3,2) = CTHeavy(3,2) + hei*7e-10
*     MG+4 => MG+3
*     >>chng 96 Oct 1, moved all H ct to bidiag
*     CTHeavy(4,2) = CTHeavy(4,2) + 6.5E-11 * T * HI + HEI*3E-9
      CTHeavy(4,2) = CTHeavy(4,2) + hei*3E-9
*
      if( lgDoPhoto .and. IonLow(nelem).le.1 ) then
*       can only do this one time
*       photoionization from excited upper state of 2798
        rmg2l = gamfun(ipmgex, ipHn(1), ipOpMgEx )
        PhotoRate(nelem,2,4,1) = PhotoRate(nelem,2,4,1) + rmg2l*popmg2
        if( nzone.le.1 ) then
          xMg2Max = 0.
        else if( PhotoRate(nelem,2,4,1).gt.1e-30 )  then
*         remember max rel photo rate
          xMg2Max = max(xMg2Max, rmg2l*popmg2/PhotoRate(nelem,2,4,1) )
        endif
      else
        xMg2Max = 0.
      endif
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
*     write(88,'(1p,9e10.2)')(photorate(nelem,2,i,1),i=1,4)
*     call PrtGamma(ipMagnesium(2,4,1) ,ipMagnesium(2,4,2) ,
*    1 ipMagnesium(2,4,3),
*    1 qq,  photorate(nelem,2,4,1) ,photorate(nelem,2,4,1)*0.05 )
*
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      if(lgTrace.and.lgHeavyBug) then
        write(qq,'(5X,''MAGNES returns; frac='',1P,10E10.3)')
     1  (xIonFracs(nelem,i)/xIonFracs(nelem,0),i=1,10)
      endif
*
      end
