******************************************************************************
      subroutine MakeOpacity( nelem )
      implicit none
*generate ionic subshell opacities by calling phfit
      integer nelem
      include "nopsv.par"
      include "evryd.par"
      include "limelm.par"
      include "ncell.par"
      include "opsv.com"
      include "anusave.com"
      include "rfield.com"
      include "photo.com"
      include "noptot.com"
      include "PunPoint.com"
      include "nsShells.com"
      include "opac.com"
      include "KshllEnr.com"
      include "ipElement.com"
      include "PhFitOn.com"
      include "IOqq.com"
*
*     local variables
      integer nion , nshell,nelec,limit,need,low,ihi,ipop,ip
      real cs , energy
      logical lgOK
*
      do nion=1,nelem
*begin sanity check
        do ip=1,ncell
          opac(ip) = 0.
        end do
*end sanity check
*       number of bound electrons
        nelec = nelem - nion + 1
        do nshell=1,nsShells(nelem,nion)
          ipElement(nelem,nion,nshell,3) = noptot + 1
*         this is continuum pointer upper limit for energy range of this shell
          limit = ipElement(nelem,nion,nshell,2)
*         this is number of cells in continuum needed to store opacity
          need = limit - ipElement(nelem,nion,nshell,1) + 1
*
*         check that opsv will have enough frequeny cells
          if( noptot + need.gt.NOPSV ) then
            write(qq,'('' MakeOpacity needs more opacity cells than ''
     1      ,''NOPSV,  increase it.'')')
            write(qq,'('' element, Ion, are'',2i3)') nelem,nion
            stop
          endif
*
*         set lower and upper limits to this range
          low = ipElement(nelem,nion,nshell,1)
          ihi = ipElement(nelem,nion,nshell,2)
          ipop = ipElement(nelem,nion,nshell,3)
*         write(qq,'('' shell'',i3,'' opac offset'',i9,'' NuLo'',1p,
*    1    e9.1,'' Nuup'',e9.1)')
*    1     nshell,ipElement(nelem,nion,nshell,3),AnuOrg(low),AnuOrg(ihi)
*begin sanity check
          if( low.gt.ihi .and. low.gt.5 ) then
            write(qq,'('' MakeOpacity has insane pointers.'')')
            write(qq,'('' nelem,nion,shell'',9i10)')  nelem,nion,
     1      nshell,low,ihi
            call ShowMe
            stop
          endif
*end sanity check
          do ip=low,ihi
*     >>chng 96 oct 8 add min to ip, so never eval below threshold
            energy = max( AnuOrg(ip)*evryd,PH1(1,nelem,nelec,nshell) )
            call phfit( nelem, nelec , nshell , energy ,cs,lgPhFit)
            OpacStack(ip-low+ipop) = cs*1e-18
*begin sanity check
            opac(ip) = opac(ip) + cs
*end sanity check
          end do
          noptot = noptot + ihi - low + 1
*         punch pointers option
          if(lgPunPoint) then
            write(ipPoint,'(3i3,1p,4e10.2)')
     1      nelem,nion,nshell,anu(low),anu(ihi),OpacStack(ipop),
     2      OpacStack(ihi-low+ipop)
          endif
        end do
*begin sanity check
*       write(6,'('' checking el'',2i3,'' range'',1p,2e10.2)')
*    1  nelem,nion,anu(ipElement(nelem,nion,nsShells(nelem,nion),1)),
*    1  anu(KshellLimit)
        lgOK = .true.
        do ip=ipElement(nelem,nion,nsShells(nelem,nion),1),KshellLimit
          if( opac(ip).le.0. ) then
           lgOK = .false.
           write(qq,'('' MakeOpacity finds insane opacity, nelem, nu='',
     1     2i3,1p,2e10.2)') nelem, nion,anu(ip), opac(ip)
          endif
        end do
*end sanity check
      end do
      if( .not.lgOK ) then
        write(qq,'('' MakeOpacity: insanity has occurred.'')')
        call ShowMe
        stop
      endif
*
      end
