******************************************************************************
      subroutine MakeRecomb( rec,pl, dicoef,dite,ditcrt,aa,bb,cc,dd,ff,
     2 nelem,tlow)
      implicit none
*generate recombination coefficients for any species
      integer nelem
      real rec(nelem-1) , pl(nelem-1) , dicoef(nelem,2), 
     1 dite(nelem,2) , ditcrt(nelem) , aa(nelem) , bb(nelem) , 
     2 cc(nelem) , dd(nelem) , ff(nelem) , tlow(2)
*
      include "limelm.par"
      include "ncell.par"
      include "DiffHeav.com"
      include "RecomRate.com"
      include "nsbig.com"
      include "rcota.com"
      include "worksv.com"
      include "shullc.com"
      include "rfield.com"
      include "TePowers.com"
      include "heat.com"
      include "phycon.com"
      include "cludon.com"
      include "gionrc.com"
      include "supprs.com"
      include "vrrfit.com"
      include "IonRange.com"
      include "nsShells.com"
      include "ipElement.com"
      include "ioreco.com"
      include "ElmntSym.com"
      include "IOqq.com"
*
*     local variables
      integer i , iupper , NeBound
      real fac2 , t4m1,z,xlam,radrec,sexp , tefac
      real SaveRate(limelm,3)
      real cludge(4)
      data cludge/ 3e-13 , 3e-12 , 1.5e-11 , 2.5e-11/
*    
*     free statement labels >= 7
*
*     set up ionization balance matrix, C(I,1)=destruction, 2=creation
*     heating rates saved in array B(I) in same scrat block
*     factor is for Aldrovandi+Pequignot fit, FAC2 is for Nuss+Storey
*     fit for dielectronic recomb
*     GrnIonRec is rate ions recombine on grain surface, normally zero;
*     set in hmole, already has factor of hydrogen density
*
      if( IonLow(nelem).lt.1 .or. IonHigh(nelem).gt.nelem+1) then
        write(qq,'('' MakeRecom called with insane low,nstage'')')
        write(qq,*)' nelem, low, nstage=',nelem,IonLow(nelem),
     1  IonHigh(nelem)
        stop
      endif
      nsbig = max( IonHigh(nelem) , nsbig )
      t4m1 = 1e4 / te
      fac2 = 1e-14 * sqrte
*
*     zero out ionization, rec, heating save arrays
      do i=1,nelem
        RecombinRate(nelem,i) = 0.
        SaveRate(i,1) = 0.
        SaveRate(i,2) = 0.
        SaveRate(i,3) = 0.
      end do
*
*------------------------------------------------------------------
*
*     do h-like stage with Seaton '59 formula
*
      z = nelem
      if( IonHigh(nelem)-1.eq.nelem ) then
        xlam = 157890. * z * z / te
*
*       radiative recombination
        if( lgVrrFit ) then
          call rrfit( nelem , 1 , te , radrec )
        else
          radrec = ( 5.197e-14*z* sqrt(xlam) *
     1    (0.4288 + 0.5*log(xlam) + 0.469*(xlam**(-0.33333) )) ) 
        endif
        SaveRate(IonHigh(nelem)-1,1) = radrec +
     1  CotaRate(IonHigh(nelem)-1) + GrnIonRec/eden
*
*       three body, grain surface recombinations
        RecombinRate(nelem,IonHigh(nelem)-1) = eden *
     1  (CotaRate(IonHigh(nelem)-1)+radrec)+
     1  GrnIonRec
*       this is supposed to be the ground term of the recombination
        DiffusHeavy(nelem,IonHigh(nelem)-1) = radrec*eden / 10.
        xLyaHeavy(nelem,IonHigh(nelem)-1) = radrec*eden / 10.
*
*       work function
        worksv(IonHigh(nelem)-1) = RecombinRate(nelem,IonHigh(nelem)-1)* 
     1  anu( ipElement(nelem,IonHigh(nelem)-1,
     2  nsShells(nelem,IonHigh(nelem)-1),1) )
        iupper = IonHigh(nelem)-1 - 1
      else
        iupper = IonHigh(nelem)-1
      endif
*
*---------------------------------------------------------------------
*
      do i=IonLow(nelem),iupper
*       number of bound electrons of the ion
        NeBound = nelem - i
        if( lgVrrFit ) then
          call rrfit( nelem , nelem-i+1 , te , radrec )
        else
          if( te.gt.1e3 .or. i.gt.1 .or. tlow(1).eq.0. ) then
            radrec = rec(i)*te**pl(i)
          else
*           use special Pequignot and Aldrovandi fit for low temp
            radrec = tlow(1)*te**tlow(2)
          endif
        endif
        RecombinRate(nelem,i) = eden*( radrec + CotaRate(i) )
*       this is supposed to be the ground term of the recombination
*       >>chng 97 feb 17, following two did not have eden,
*       exposed bug when super low density models did not conserve energy
        DiffusHeavy(nelem,i ) = eden*radrec / 10.
        xLyaHeavy(nelem,i) = eden*radrec / 10.
*
*       recombinatinon on grain surface
        RecombinRate(nelem,i) = RecombinRate(nelem,i) + GrnIonRec
        SaveRate(i,1) = radrec + CotaRate(i) + GrnIonRec/eden
*
*       Burgess dielectronic recombination
        if(  te.gt.ditcrt(i)*.1 )  then
          SaveRate(i,2) = 
     1    supprs(i,1)/te32 * dicoef(i,1) * exp(-dite(i,1)/te)*
     3    (1.+dicoef(i,2)*sexp(dite(i,2)/te))
          RecombinRate(nelem,i) = RecombinRate(nelem,i) +
     1    SaveRate(i,2)*eden
        endif
*
*       Nussbaumer and Storey dielectronic recombination
*       do not ever do it for rec from
*       a closed shell, NeBound is number of bound electrons in ion
        if( NeBound.ne.2 .and. NeBound.ne.10 .and. NeBound.ne.18 )
     1    then
          tefac = ff(i)*t4m1
*         fac2 = 1e-14 * sqrte
          if( ff(i).ne.0. .and.abs(tefac).lt.30. ) then
            SaveRate(i,3) = 
     1      supprs(i,2) * fac2*max(0.,(((aa(i)*t4m1+
     1      bb(i))*t4m1+ cc(i))*t4m1+dd(i))*exp(-tefac))
          else if( te.gt.100..and.ff(i).eq.0. .and. i.le.4 ) then
            SaveRate(i,3) = 
     1      supprs(i,2) *cludge(i)*GuessDiel
          endif
          RecombinRate(nelem,i) = RecombinRate(nelem,i) +
     1    SaveRate(i,3)*eden
        endif
*
        worksv(i) = RecombinRate(nelem,i) *
     1  anu( ipElement(nelem,i,nsShells(nelem,i),1) )
      end do
*
*     option to punch rec coef
      if( ioreco.gt.0 )  then
        write(ioreco,'('' R '',1p,14e9.2)')(SaveRate(i,1),i=1,
     1  min(14,IonHigh(nelem)-1))
        write(ioreco,'('' B '',1p,14e9.2)')(SaveRate(i,2),i=1,
     1  min(14,IonHigh(nelem)-1))
        write(ioreco,'('' NS'',1p,14e9.2)')(SaveRate(i,3),i=1,
     1  min(14,IonHigh(nelem)-1))
        write(ioreco,'(1x,a2,1p,14e9.2)') chElementSym(nelem),
     1  (RecombinRate(nelem,i),i=1,min(14,IonHigh(nelem)-1))
        if( IonHigh(nelem)-1.gt.14 ) then
          write(ioreco,'('' R '',1p,14e9.2)')(SaveRate(i,1),i=15,
     1    min(29,IonHigh(nelem)-1))
          write(ioreco,'('' B '',1p,14e9.2)')(SaveRate(i,2),i=15,
     1    min(29,IonHigh(nelem)-1))
          write(ioreco,'('' NS'',1p,14e9.2)')(SaveRate(i,3),i=15,
     1    min(29,IonHigh(nelem)-1))
          write(ioreco,'(3x,1p,14e9.2)')
     1    (RecombinRate(nelem,i),i=15,IonHigh(nelem)-1)
        endif
      endif
*
*begin sanity check
      do i=IonLow(nelem),IonHigh(nelem)-1
        if( DiffusHeavy(nelem,i).le.0. ) then
          write(qq,'('' MakeRecomb finds insane DiffusHeavy rate,'',
     1    '' nelem='',i3,'' rates follow.'')')nelem
          write(qq,'(1p,10e9.1)') (DiffusHeavy(nelem,iupper),iupper=1,
     1    IonHigh(nelem))
          call ShowMe
          stop
        endif
        if( xLyaHeavy(nelem,i).le.0. ) then
          write(qq,'('' MakeRecomb finds insane xLyaHeavy rate,'',
     1    '' nelem='',i3,'' rates follow.'')')nelem
          write(qq,'(1p,10e9.1)') (xLyaHeavy(nelem,iupper),iupper=1,
     1    IonHigh(nelem))
          call ShowMe
          stop
        endif
        if( RecombinRate(nelem,i).le.0. ) then
          write(qq,'('' MakeRecomb finds insane recombination rate,'',
     1    '' nelem='',i3,'' rates follow.'')')nelem
          write(qq,'(1p,10e9.1)') (RecombinRate(nelem,iupper),iupper=1,
     1    IonHigh(nelem))
          call ShowMe
          stop
        endif
      end do
*end sanity check
      end
