******************************************************************************
      subroutine MakeWindRT( t )
      implicit none
*do line radiative transfer for wind geometry
      include "nta.par"
      real t(nta)
      include "ipLnArry.par"
      include "limelm.par"
      include "ncell.par"
      include "itrdim.par"
      include "ZoneCnt.com"
      include "wind.com"
      include "twoway.com"
      include "occnum.com"
      include "DoppVel.com"
      include "fluors.com"
      include "DstWght.com"
      include "IOqq.com"
*
*     this is the routine that computes much of the radiative transfer
*     physics for lines in wind case.  Lines diveded into two types,
*     high quality (ipLnCS1=0) and lower quality g-bar lines
*
*     local variables
      real velocity , damp , eovrlp , esccom
*     real conpmp
      integer nelem
*
*begin sanity check
      if( t(ipLnColovTOT) .gt.1. .or. t(ipLnColovTOT).lt.0. ) then
        write(qq,'('' MakeWindRT insane ipLnColovTOT='',1p,e10.2)')
     1  t(ipLnColovTOT)
      endif
*end sanity check
*
      nelem = t( ipLnNelem )
*begin sanity check
      if( nelem.lt. 1) then
*       this is non-existent line, but flag no longer exists
        write(qq,'('' MakeWindRT called with insane nelem='',i4)') nelem
        stop
      endif
*end sanity check
*
      velocity = doppler(nelem)
      damp = t(ipLnDampRel) / velocity
      t(ipLnDamp) = damp
*
*     use only one-sided escape probabilities
*     get escape probability, this gets fractions too
      t(ipLnEscP) = esccom( t(ipLnTauIn),damp)
*     inward fraction
      t(ipLnInwd) = 0.5
      if( t(ipLnCS1).eq.0. ) then
*       high quality line
*       destruction by overlapping continuum
*       >>chng 96 sep 4 to DestWght weighting
*       this this is 0th zone then use full destruction prob,
*       else use mean of old and new - NB must reset at end
        if( nzone.lt.1 ) DestWghtSave = 1.
        t(ipLnDesP) = (1.-DestWght)*t(ipLnDesP) + DestWght*
     1  eovrlp( t(ipLnPopOpc), t(ipLnTauIn),
     1  t(ipLnTauTot), damp, t(ipLnOpac), int(t(ipLnIpCont)),
     2  velocity,t(ipLnEscP),'  K2' )
*       reset weight
        DestWght = DestWghtSave
*       continuum pumping
        if( lgFluor ) then
          t(ipLnPump) = t(ipLnAul)*t(ipLnGu)/t(ipLnGl)*
     1    t(ipLnEscP) * occnum(  int(t(ipLnIpCont))  )
        else
          t(ipLnPump) = 0.
        endif
* 666 error! understand why conpmp does not work
*    1  conpmp(t) * occnum(  int(t(ipLnIpCont))  )
      else
*       low quality line
        t(ipLnDesP) = 0.
*       wayin was computed by escape prob reoutine, is inner esc
        if( lgFluor ) then
          t(ipLnPump) = t(ipLnAul)* t(ipLnGu)/t(ipLnGl)*
     1    t(ipLnEscP) * occnum(int(t(ipLnIpCont)))
        else
          t(ipLnPump) = 0.
        endif
      endif
*
      end
