***********************************************************************
*     POPEXC( O12,g1,g2,A21,excit,abund) ; result already*a21, excit in Kelvin
*     level2(  t10 )
*     level3(  t10,t21,t20)
*     tsq1 = 1. / (te**2)
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
*     beseq(cs23,cs24,cs34,tarray,a41)
*     FIVEL( G(1-5) , ex(wn,1-5), cs12,cs13,14,15,23,24,25,34,35,45,
*            A21,31,41,51,32,42,52,43,53,54, pop(1-5), abund)
*
******************************************************************************
      subroutine nacol
      implicit none
*compute sodium cooling
      include "ipLnArry.par"
      include "limelm.par"
      include "dcool.com"
      include "coolna.com"
      include "nta.par"
      include "TLineEXP.com"
      include "TePowers.com"
      include "p2ovp1.com"
      include "phycon.com"
      include "logte.com"
      include "TauDmmy.com"
      include "IonFracs.com"
*
*     local variables
      real cs , pop3 , p2 , cs13,cs23,a12,a13,a23, p3
*
*     NaD Na D Na1 Na 1 lines
*     transition is 3s-3p, ^2P^o - ^2P^o
*     change 26 Feb 96 cs to Verner's value
      cs = 2.12e-2 * (te70/te02)
      call PutCS( cs , t5895 )
      call level2( t5895 )
*
*     [NaIII] 7.319 microns
*     cs 
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      cs = max( 0.35 , min(0.40,0.198*te05*te01) )
      call PutCS( cs , fsNa373 )
      call level2( fsNa373 )
*
*     collision data from 
*     >>refer Butler, K., & Zeippen, C.J. 1994, A&AS, 108, 1
*     [NaIV] 9.048 microns
      call PutCS( 0.802 , fsNa490 )
*     [NaIV] 21.29 mic
      call PutCS( 0.273 , fsNa421 )
*     following from pradhan review
      call PutCS( .111 , TauDummy )
      call level3( fsNa490,fsNa421,TauDummy)
*
*     >>chng 97 mar 19, added NaV lines
*     NaV lines, collision data from 
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     A's from 
*     >>refer Kaufman, V., & Sugar, J. 1986, J Phys Chem Ref Dat, 15, 321
*     >>chng 97 july 25, cs had been 1, changed to Me
      cs = 0.919
      cs13 = 0.359
      cs23 = 1.915
      a12 = 8.16e-3
      a13 = 3.81
      a23 = 2.68
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      p3 = pop3(4.,10.,6., cs , cs13, cs23, a12 ,a13 ,a23 ,
     1 6.96e4 , 3.58e4 , p2,xIonFracs(11,5),0.)
      c1365 = p3 *a13 *1.46e-11
      c4017 = p3 * a23 * 4.95e-12
      c2067 = p2 * a12 * 9.63e-12
      call coladd( 'Na 5' , 1365 , c1365  )
      call coladd( 'Na 5' , 4017 , c4017  )
      call coladd( 'Na 5' , 2067 , c2067  )
*
*     [Na VI] 14.32 mic, 8.62 mic
      cs = min( 0.77 , 2.346/(te10*te02*te001) )
      call PutCS( cs , xNa6143 )
      cs = min( 2.15 , 6.934/(te10*te03/te001/te001) )
      call PutCS( cs , xNa6862 )
      cs = min( 0.53 , 1.518/(te10*te01*te003*te003) )
      call PutCS( cs , TauDummy )
      call level3( xNa6143,xNa6862,TauDummy)
*
*     [Na VI] UV lines, 2971.9, 2872.7 doublet, 2578.9, 1356.6
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      cs = max( 0.1, min(0.2876,2.603e-3/(sqrte/te10) ) )
      c2569 = pop3(9.,5.,1., 1.38 , 0.173, cs, 1.68,16.9,5.27,
     1 5.01e4 , 5.60e4 , p2,xIonFracs(11,6),0.)*5.27*6.70e-12
*>>>chng 98 dec 25, decimal points missing after last two wavelengths
      c1357 = c2569 * (16.9/5.27)*(2972./1357.)
      c2972 = p2 * 1.68 * 6.70e-12
      call coladd( 'Na 6' , 2569 , c2569  )
      call coladd( 'Na 6' , 1357 , c1357  )
      call coladd( 'Na 6' , 2972 , c2972  )
*
*     [Na VII] 4.675 microns, no CS (interpolated), A NIST
*     collision strength interpolated from 
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
      call PutCS( 1.5 , xNa0746 )
      call level2( xNa0746 )
*
      end
