******************************************************************************
      subroutine necol
      implicit none
*evaluate total cooling due to neon
      include "ipLnArry.par"
      include "limLevelN.par"
      include "nta.par"
      include "limelm.par"
      include "ndfst.par"
      include "dcool.com"
      include "coolne.com"
      include "TLineEXP.com"
      include "TePowers.com"
      include "p2ovp1.com"
      include "phycon.com"
      include "fslev.com"
      include "TauDmmy.com"
      include "embesq.com"
      include "PopLevls.com"
      include "IonFracs.com"
*
*     local variables
      real pop2 , pop3 , popexc, cs2s2p , cs2s3p,cs,
     1 a21,a31,a32
*
*     Neon II 12.8 micron
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      cs = max(0.272, min( 0.4 , 0.1294*te10/te02*te005 ) )
      call PutCS( cs , tNe13 )
      call level2( tNe13 )
*
*     Ne III fine structure lines
*     CS 
*     >>refer Butler, K., & Zeippen, C.J. 1994, A&AS, 108, 1
      call PutCS( 0.774 , tNe16 )
      call PutCS( 0.244 , tNe36 )
      call PutCS( 0.208 , TauDummy )
      call level3(tNe16,tNe36,TauDummy)
*
*     Ne III 3869+3968, 3343, A's 
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     CS 
*     >>refer Butler, K., & Zeippen, C.J. 1994, A&AS, 108, 1
      if( te.lt.1e4 ) then
        cs = 0.269
      else
        cs = min( 0.333, 0.1142*(te10/te003/te003/te001) )
      endif
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      c3343 = pop3( 9.,5.,1.,  1.348,0.151,cs, 0.209,2.052,2.677,
     1 3.583e4,4.301e4, pop2,xIonFracs(10,3),0.) * 2.677*5.954e-12
      c3869 = pop2 * 0.209 * 5.14e-12
      dCooldT = dCooldT + c3869 * ( 3.72e4*tsq1 - halfte )
      call coladd( 'Ne 3' , 3342 , c3343 )
      call coladd( 'Ne 3' , 3869 , c3869 )
      call coladd( 'Ne 3' , 1793 , c3343*1.38 )
*
*     Ne IV 2425.4+2422.8  A'S from 
*     >>refer Zeippen, C.J. 1982, MN 198 111
*     Ne IV CS from 
*     >>refer Giles, K. 1981, MNRAS, 195, 63
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      a21 = 2.46e-3
      a31 = 1.02
      a32 = 0.693
      c4720 = pop3( 4.,10.,6.,1.37,0.464,2.14, a21 ,a31 ,a32,
     1 5.94e4,3.05e4 ,pop2,xIonFracs(10,4),0.) *a32 * 4.22e-12
      c2424 = pop2 * 8.21e-12 * a21
      call coladd( 'Ne 4' , 2424 , c2424 )
      call coladd( 'Ne 4' , 4720 , c4720 )
      call coladd( 'Ne 4' , 1602 , c4720*4.1 )
*
*     Ne V 3426, CS data from 
*     >>refer Lennon, D.J. & Burke, V.M. 1991, MNRAS 251, 628
*     revised from 
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
*     A's from 
*     >>refer Baluja, K.L. 1985, JPhB, 18, L413
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      c2975 = pop3( 9.,5.,1., 2.18 ,0.254,0.688, 0.521,4.35,2.76,
     1 4.297e4,4.835e4, pop2 , xIonFracs(10,5),0.) * 2.76*6.69e-12
*     following are old values
*     C2975 = POP3( 9.,5.,1., 1.8,0.25,0.52, 0.521,4.34,2.76,
*    1 4.297E4,4.835E4, POP2 , ANEON(5),0.) * 2.76*6.69E-12
      c1565 = c2975 * 1.901 * 1.572
      c3426 = pop2 * 0.521 * 5.81e-12
      dCooldT = dCooldT + c3426 * ( 4.20e4*tsq1 - halfte ) +
     1 ( c2975 + c1565 ) * 9.132e4 * tsq1
      call coladd( 'Ne 5' , 2975 , c2975 )
      call coladd( 'Ne 5' , 1565 , c1565 )
      call coladd( 'Ne 5' , 3426 , c3426 )
*
*     Ne V 24.2, 14.3 micron
*     CS from 
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
*     A's from 
*     >>refer Baluja, K.L. 1985, JPhB, 18, L413
      cs = min( 1.84 , 21.12 /(te10*te10*te10/te003/te003 ) )
      call PutCS( cs , tNe24 )
      cs = min( 9.5 , 261.71 /(te10*te10*te10*te10*te01*te003) )
      call PutCS( cs , tNe14 )
      cs = min( 3.2 , 139.86 /(sqrte/te03*te003/te001) )
      call PutCS( cs , TauDummy )
      call level3(tNe24,tNe14,TauDummy)
*
*     Ne V 5S - 3P, CS 
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
*     A from 
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
* 666 error! transfer these lines
      c1134 = popexc( 11.9/(te10*te10*te03),9.,5.,4.67e3,1.273e5,
     1 xIonFracs(10,5)) * 1.767e-11
      call coladd( 'Ne 5' , 1134 , c1134 )
*
*     Ne VI 7.6 micron, A from 
*     >>refer Froese Fischer, C. 1983, JPhB, 16, 157
*     cs from 
*     >>refer Zhang, H.L., Graziani, M., Pradhan, A.K. 1994, A&A, 283, 319
*     >>chng 96 july 16 had been just constant 2.0 
      cs = min( 3.71 , 23.623 / (te20*te02/te003) )
      call PutCS( cs , xNe0676 )
      call level2( xNe0676 )
*     fs76 = popexc(0.37,2.,4.,1.9E-2,1.89E3,xIonFracs(10,6))*2.62E-13
*     dCooldT = dCooldT + fs76*(1890.*tsq1-halfte)
*     call coladd( 'Ne 6' , 76 , FS76 )
*
*     Ne VII col data from 
*     >>refer Berrington, K.A., Burke, P.G., Dufton, P.L., Kingston, A.E. 1985,
*     >>refer ADNDT, 33, 195
*     low te from 
*     >>refer Dufton, P.L., Doyle, J.G., Kingston, A.E. 1979, A&A, 78, 318
*     newer fit to 
*     >>refer Ramsbottom, C.A., Berrington, K.A., Bell, K.L. 1995,
*     >>refer ADNDT, 61, 105
      if( te.lt.4e4 ) then
        cs = 0.0352 *(te20/te03)
      else
        cs = 0.736 /( te10*te02/te003)
      endif
      call PutCS( cs , t895 )
*     BESEQ(CS23,CS24,CS34,tarray,A41)
*     c895 = beseq(.52,.61, 2.0,t895,.0578) * 2.223E-11
*     A's 
*     >>refer Fleming, J., Bell, K.L, Hibbert, A., Vaeck, N., Godefroid, M.R.
*     >>refer 1996, MNRAS, 279, 1289
      call beseq(.52,.61, 2.0,t895,.07066)
      em895 = PopLevels(3) * 0.0578 * 2.223e-11
*
*     Ne VIII 774, iso with 1549, extrapolation for omega
*     >>refer Cochrane, D.M., & McWhirter, R.W.P. 1983, PhyS, 28, 25
      call ligbar( 10 , t770, t88, cs2s2p , cs2s3p )
      call PutCS( cs2s2p , t770 )
      call PutCS( cs2s2p*0.5 , t780 )
      call PutCS(  1.0 , TauDummy )
      call level3( t780,TauDummy, t770)
*
      call PutCS( cs2s3p , t88 )
      call level2( t88 )
*
      end
