******************************************************************************
      subroutine negcon
      implicit none
*sanity check for negative continuum intensities
      include "ncell.par"
      include "rfield.com"
      include "ots.com"
      include "itrdim.par"
      include "ZoneCnt.com"
      include "phycon.com"
      include "IOqq.com"
      logical lgFNeg
      integer i
*
*     look for negative continuum points
      lgFNeg = .false.
      do i=1,nflux
        if( flux(i).lt.0. ) then
          write(qq,'('' FLUX negative, value, freq, pointer='',
     1    1p,2e10.2,i5)') flux(i) , anu(i) , i
          lgFNeg = .true.
        else if( otslin(i).lt.0. ) then
          write(qq,'('' OTSLIN negative, value, freq, pointer='',
     1    1p,2e10.2,i5)') otslin(i) , anu(i) , i
          lgFNeg = .true.
        else if( otscon(i).lt.0. ) then
          write(qq,'('' OTSCON negative, value, freq, pointer='',
     1    1p,2e10.2,i5)') otscon(i) , anu(i) , i
          lgFNeg = .true.
        else if( outcon(i).lt.0. ) then
          write(qq,'('' OUTCON negative, value, freq, pointer='',
     1    1p,2e10.2,i5)') outcon(i) , anu(i) , i
          lgFNeg = .true.
        else if( outlin(i).lt.0. ) then
          write(qq,'('' OUTLIN negative, value, freq, pointer='',
     1    1p,2e10.2,i5)') outlin(i) , anu(i) , i
          lgFNeg = .true.
        endif
      end do
*
      if(.not.lgFNeg) then
        write(qq,'('' No parts of the continuum were '',
     1  ''negative, the electron density was'',1p,e10.2,'' te='',
     2  e10.2)') eden,te
        write(qq,'('' This is zone number'',I4)') nzone
      endif
*
      end
