******************************************************************************
      subroutine NextDR
      implicit none
*use adaptive logic to find next zone thickness
      include "nhlvl.par"
      include "nhe3lvl.par"
      include "ndust.par"
      include "ncell.par"
      include "ipLnArry.par"
      include "nwindline.par"
      include "nta.par"
      include "limelm.par"
      include "itrdim.par"
      include "nzlim.par"
      include "htau.com"
      include "Angllum.com"
      include "presok.com"
      include "opac.com"
      include "tautot.com"
      include "globul.com"
      include "drmin.com"
      include "dcala.com"
      include "heating.com"
      include "sdrmin.com"
      include "drnxt.com"
      include "hmi.com"
      include "fluct.com"
      include "ZoneCnt.com"
      include "tauend.com"
      include "colend.com"
      include "cldnEXP.com"
      include "h2opac.com"
      include "toiii.com"
      include "IonFracs.com"
      include "he.com"
      include "heat.com"
      include "h.com"
      include "phycon.com"
      include "radius.com"
      include "drminu.com"
      include "trace.com"
      include "drbug.com"
      include "filfac.com"
      include "didz.com"
      include "dvdr.com"
      include "wind.com"
      include "ipdr.com"
      include "cpres.com"
      include "drneg.com"
      include "tfail.com"
      include "dstfac.com"
      include "hvmolEXP.com"
      include "ndroff.com"
      include "HMolLTE.com"
      include "TLineARR.com"
      include "WindData.com"
      include "nh.com"
      include "conprs.com"
      include "pinteg.com"
      include "PresInit.com"
      include "pwind.com"
      include "densty.com"
      include "IterCnt.com"
      include "SumOutInc.com"
      include "lastit.com"
      include "tseton.com"
      include "phlevl.com"
      include "hstat.com"
      include "dtMase.com"
      include "LineLabl.com"
      include "struc.com"
      include "toler.com"
      include "he3gams.com"
      include "IOqq.com"
*
*     local variables
      integer k, ipStrong , level , istage
      integer ioxystag , initstag , icarstag , iironstag
      real Strong , drLineHeat , drH2Band , drchk,coleff,dt,savedr,
     1 drmax, drFluc,winddr,factor, drConPres , drDepth , error,hdnew,
     3 fac2, GlobDr,dnew,fabden,SpecDr , drEden , drHMase, drTab,tabden
      character chLineLbl*10 , chLbl*10 , chDestAtom*8
*
*     used as big radius
      real BigRadius
*
      logical lgDoPun , lgOscil
      real OldTe , drHion , OHIIoHI , drHe1ion , OHe2oHe1
      real OldEden , dEden
      save OldEden , OldTe , OldHeat , OHIIoHI , OHe2oHe1
      real drdHdStep , dHdStep , OldHeat , SvHe2oHe1
*
      real x,z,dnglob , drInter , freqm, opacm , drFail , drSphere ,
     1 drPressure , dRTaue , TauInwd , TauDTau , dDestRate ,
     1 SaveOHIIoHI , dDRCarbon , dDRNitrogen , drDest , dDROxygen,
     1 dDRIron,dTdStep,
     1 drdTdStep , drOutFrac , Out2Tot , DrGrainHeat , grfreqm , gropacm
*
      parameter (z=1.0001 , dnglob=0.10 )
      data BigRadius/1e30/
*
*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
*
*     changes in logic
*     95 oct 19, drSphere now 3% of radius, was 2%, fewer zone
*     95 oct 19, subtracted grain opacity from total opacity used
*     to get thickness in routine ContRate
*
*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
*
*     free statement labels >= 13
*
*-----------------------------------------------------------------------
*
*     this sub determines the thickness of the next zone
*     if is called one time for each zone
*     flag lgNxtDROff is true if this is initialization of NextDR,
*     is false if we are to use logic to find dr
*
*-----------------------------------------------------------------------
*
      if( lgTrace ) write(qq,'(''   NextDR called'')')
*
*    1    '' NextDR keys from change in H ionization'',e11.3)')
*     check on change in hydrogen ionizaiton
      if( nzone.le.1 ) then
        if( hii.gt.0. .and. hi.gt.0. ) then
          OHIIoHI = hii / hi
        else
          OHIIoHI = 0.
        endif
        drHion = BigRadius
*     else if(hii.gt.0. .and. hi.gt.0. .and. OHIIoHI.gt.0. ) then
*     >>chng 97 july 9, for deep in PDR vastly now ionz H slowed down works
      else if(hii.gt.0. .and. hi.gt.0. .and. OHIIoHI.gt.1e-15 ) then
        x = (hii/hi) / OHIIoHI 
        if(x.lt.1. ) then
          x = 1. - x
*         >>chng 96 feb 23 from 0.7 to 0.3 because punched through H i-front
*         >>chng 97 may 5, from 0.3 to 0.2 since punched through H i-front
          drHion = drad * max( 0.2 , 0.2 /max(1e-10,x))
        else
          drHion = BigRadius
        endif
        SaveOHIIoHI = OHIIoHI
        OHIIoHI = hii / hi
      else
        SaveOHIIoHI = OHIIoHI
        if( hii.gt.0. .and. hi.gt.0. ) then
          OHIIoHI = hii / hi
        else
          OHIIoHI = 0.
        endif
        drHion = BigRadius
      endif
*
*     possible hydrogen maser action
      if( dTauMase .lt.-0.01 ) then
*       maser so powerful, must limit inc in tay
*       >>chng 96 aug8, from 0.3 to 0.1 due to large maser crash
        drHMase = drad * max( 0.1 , -0.2/dTauMase)
      else
        drHMase = BigRadius
      endif
*
*     '' NextDR keys from change in He1 ionization'',e11.3)')
*     check on change in HeI ionization
      SvHe2oHe1 = OHe2oHe1
      if( nzone.le.1 ) then
        if( heii.gt.0. .and. hei.gt.0. ) then
          OHe2oHe1 = heii / hei
        else
          OHe2oHe1 = 0.
        endif
        drHe1ion = BigRadius
      else if(heii.gt.0. .and. hei.gt.0. .and. OHe2oHe1.gt.0. ) then
*       >>chng 97 july 14, from 1e-2 to 1e-3
        if( (He3FrLya.gt.1e-3) .and. (heii/hei.le.1e-3) ) then
*       >>chng 97 jul 12, He mostly neutral but Lya photoionized,
*       oscillation could
*       take place - do not trigger dr from this oscillation
          drHe1ion = BigRadius
        else
          x = (heii/hei) / OHe2oHe1 
          if(x.lt.1. ) then
            x = 1. - x
*           >>chng 97 may 5, ran into i-fronts
            drHe1ion = drad * max( 0.2 , 0.2 /max(1e-10,x))
          else
            drHe1ion = BigRadius
          endif
        endif
        OHe2oHe1 = heii / hei
      else
        if( heii.gt.0. .and. hei.gt.0. ) then
          OHe2oHe1 = heii / hei
        else
          OHe2oHe1 = 0.
        endif
        drHe1ion = BigRadius
      endif
*666  write(11,'(1p,3e10.2)') OHe2oHe1 , He3FrLya
*
*     check on how much outward flux is being added relative to
*     attenuated incident beam
*    1    '' NextDR keys from ratio out2 tot continuua'',e9.1)')
      if( SumIncCon.gt.0. .and. SumOutCon.gt.0. .and. .not.lgTSetOn)then
*       evaluated in metdif
        Out2Tot = SumOutCon / SumIncCon
*       Out2HTot = SumHOutCon / SumHIncCon
*       try to keep outward frac less than 5% of total
        drOutFrac = drad * max( 0.7 , 0.05/max(1e-10,Out2Tot))
      else
        drOutFrac = BigRadius
      endif
*
*     check how heating is changing
*     '' NextDR keys from change in heating; current, delta='',
      if( nzone.le.1 .or. lgTSetOn ) then
        drdHdStep = BigRadius
      else
        dHdStep = abs( htot - OldHeat ) / htot
        if( dHdStep.gt. 0. ) then
          if(hden.ge.1e13 ) then
*           drdHdStep = drad * max( 0.8 , 0.05/dHdStep )
            drdHdStep = drad * max( 0.8 , 0.075/dHdStep )
          else if(hden.ge.1e11 ) then
*           drdHdStep = drad * max( 0.8 , 0.075/dHdStep )
            drdHdStep = drad * max( 0.8 , 0.100/dHdStep )
          else 
*           changed from .15 to .12 for outer edge of coolhii too steep dT
*           changed to .10 for symmetry, big change in some rates, 95nov14
*           changed from .10 to .125 since parispn seemed to waste zones
*           >>chng 96 may 21, from .125 to .15 since pn's still waste zones
            drdHdStep = drad * max( 0.8 , 0.15/dHdStep )
          endif
        else
          drdHdStep = BigRadius
        endif
      endif
      OldHeat = htot
*
*     pressure due to incident continuum if in eos
      if( chCPres.eq.'CPRE' .and. lgConPres ) then
        if( nzone.gt. 2. .and. pinzon.gt.0. ) then
*         pinzon is pressure from acceleration onto previos zone
*         want this less than some fraction of total pressure
          drConPres = 0.05 * PressureInit /
     1    (AccelTot*xMassDensity*FillFac)
        else
          drConPres = BigRadius
        endif
      else
        drConPres = BigRadius
      endif
*
*     check how temperature is changing
*    1    '' NextDR keys from change in temperature; current, delta='',
      if( nzone.le.1 ) then
        drdTdStep = BigRadius
      else
        dTdStep = abs( te - OldTe ) / te
        if( te.gt.1e4 ) then
*         >>chng 96 may 30, for high temps with flat cooling fcn,
*         do not want too fine a test
          x = 0.05
        else
*         >>chng 95 oct 13 from 0.05 to 0.03 for big te changes at
*         outer edges of pn's and hii regions
          x = 0.03
        endif
        if( dTdStep.gt. 0. ) then
*         >>chng 96 may 30, variable depending on temp
*         >>chng 96 may 31, allow 0.7 smaller, was 0.8
*         >>chng 97 may 5, from 0.7 to 0.5 stop from punching through thermal front
          drdTdStep = drad * max( 0.7 , x/dTdStep )
        else
          drdTdStep = BigRadius
        endif
      endif
      OldTe = te
*
*     find freq where opacity largest and interaction rate is fastest
*    1  '' NextDR keys from cont inter nu='',e9.2,
      call ContRate( freqm, opacm )
*     drChange is optical depth at max interaction energy
*     >>chng 96 june 6 was drChange=0.15 changed to 0.3 for high Z models
*     taking too many zones
*     drInter = drChange / max(1e-30,opacm*FillFac)
      drInter = 0.3 / max(1e-30,opacm*FillFac*AngleIllum)
*
*     check on changes in destruction rates for various atoms
*     call ChkRate( 1 , dDRHydro  ,istage )
*     call ChkRate( 2 , dDRHelium ,istage )
      call ChkRate( 6 , dDRCarbon ,icarstag )
      call ChkRate( 7 , dDRNitrogen ,initstag )
      call ChkRate( 8 , dDROxygen ,ioxystag )
      call ChkRate(26 , dDRIron ,iironstag )
      dDestRate = max( dDROxygen , dDRIron , dDRCarbon,dDRNitrogen)
      if( dDRCarbon.eq.dDestRate ) then
        dDestRate = dDRCarbon
        istage = icarstag
        chDestAtom = 'Carbon  '
      else if( dDRNitrogen.eq.dDestRate ) then
        dDestRate = dDRNitrogen
        istage = initstag
        chDestAtom = 'Nitrogen'
      else if( dDROxygen.eq.dDestRate ) then
        dDestRate = dDROxygen
        chDestAtom = 'Oxygen  '
        istage = ioxystag
      else if( dDRIron.eq.dDestRate ) then
        dDestRate = dDRIron
        istage = iironstag
        chDestAtom = 'Iron    '
      else
        write(qq,'('' insanity following ChkRate'')')
        call ShowMe
        stop
      endif
*    1    '' NextDR keys from change in dest rates, atom='',a8,i3)')
      if( dDestRate.gt. 0. ) then
*       if( te.gt.40 000. ) then
*         added different accuracy for hot gas since tend to jump over
*         big te range for small change in heat (intrinsically unstable)
*         drDest = drad * max( 0.5 , 0.10/dDestRate )
*       else
*         was drChange, changed to .15 for parishii go through HeII=HeI I front
*         drDest = drad * max( 0.5 , 0.15/dDestRate )
*         >>chng 95 dec 18 from above to below to stop oscillations
*         >>chng 95 dec 27 from min of .5 to .75 to stop zone size from changing rapidly
*         drDest = drad * max( 0.8 , 0.20 /dDestRate )
*         >>chng 96 jan 14 from .2 to .25 to use less zones
*         >>chng 96 may 30 from min of 0.8 to 0.5 to prevent crashing into He i-front
          drDest = drad * max( 0.5 , 0.20 /dDestRate )
*       endif
      else
        drDest = BigRadius
      endif
*
*     check whether change in wind velocity constrains DRAD
      if( windv.gt.0. ) then
        if( dVeldRad.ne.0. ) then
*         dVeldRad is D(vel)/vel / DRAD, computed in PRESUR
          winddr = 0.03 / dVeldRad
        else
          winddr = 1.1 * drad
        endif
      else
        winddr = BigRadius
      endif
*
*     inside out globule
      if( chCPres.eq.'GLOB' ) then
        if( glbdst.lt.0. ) then
          write(qq,'('' Globule distance is negative, internal '',
     1    ''overflow has occured,  sorry.'')')
          write(qq,'('' This is routine NextDR, GLBDST is'',1P,E10.2)')
     2    glbdst
          stop
        endif
        factor = glbden * (glbrad/glbdst)**glbpow
        fac2 = glbden * (glbrad/(glbdst-drad))**glbpow
        if( fac2/factor .gt. 1.+dnglob ) then
*         DNGLOB is relative change in density allowed this zone, 0.10
          GlobDr = drad * dnglob/(fac2/factor-1.)
        else
          GlobDr = BigRadius
        endif
*       GlobDr = GLBDST * DNGLOB * (GLBRAD/GLBDST)**(-GLBPOW) / GLBPOW
        GlobDr = min( GlobDr , glbdst /20. )
      else
        GlobDr = BigRadius
      endif
*
      if( chCPres(1:3).eq.'DLW' ) then
*       one of the special density laws, first get density at possible next dr
        if( chCPres.eq.'DLW1' ) then
          hdnew = fabden(radius+drad,depth+drad)
        else if( chCPres.eq.'DLW2' ) then
          hdnew = tabden(radius+drad,depth+drad)
        else 
          write(qq,'('' dlw insanity in NextDR'')')
          stop
        endif
        drTab = abs( hdnew - hden ) / max(hdnew,hden)
        drTab = drad * max( 0.2 , 0.10/max(0.01,drTab))
      else
        drTab = BigRadius
      endif
*
*     special density law
      if( chCPres.eq.'DLW1' ) then
        dnew = abs( fabden( radius+drad , depth+drad ) / hden - 1.)
*       DNGLOB is relative change in density allowed this zone, 0.10
        if( dnew.eq.0. ) then
          SpecDr = drad * 3.
        else if( dnew/dnglob.gt.1.0 ) then
          SpecDr = drad / ( dnew / dnglob )
        else
          SpecDr = BigRadius
        endif
      else
        SpecDr = BigRadius
      endif
*
*     check grain line heating dominates
*     this is important in PDR and HII region calculations
*     >>chng 97 july 3, added following check
      if( heating(1,14)/htot.gt.0.2 ) then
        call GrainRateDr( grfreqm, gropacm )
        DrGrainHeat = 1.0 / max(1e-30,gropacm*FillFac*AngleIllum)
      else
        DrGrainHeat = BigRadius
      endif
*
*     check if line heating dominates
*     this is important in high metallicity models
      if( heating(1,23)/htot.gt.0.2 ) then
        call FndLineHt( level , ipStrong , Strong )
        if( Strong/htot.gt.0.1 ) then 
          if( level .eq. 1 ) then
*           a level1 line was the heat source (usual case)
*           drLineHeat = max(1.0,TauLines(ipLnTauIn,ipStrong)*0.2) /
*    1      TauLines(ipLnDTau,ipStrong)
            TauInwd = TauLines(ipLnTauIn,ipStrong)
            TauDTau = TauLines(ipLnDTau,ipStrong)
          else if( level.eq.2 ) then
*           a level2 line was the heat source
*           (bad case since not as well treated)
*           drLineHeat = max(1.0,WindLine(ipLnTauIn,ipStrong)*0.2) /
*    1      WindLine(ipLnDTau,ipStrong)
            TauInwd = WindLine(ipLnTauIn,ipStrong)
            TauDTau = WindLine(ipLnDTau,ipStrong)
          else
*           this is insane, since Strong was set, but not level
            call insane
            write(qq,'('' NextDR Strong line heating set, but not '',
     1      ''level.'')')
            drLineHeat = BigRadius
            ipStrong = 1
            Strong = 0.
            stop
          endif
*         in following logic cannot use usual inverse opacity,
*         since line heating competes with escape probability,
*         so is effective at surprising optical depths
          if( TauDTau .gt.0. ) then
            drLineHeat = max(1.,TauInwd)*0.4 / TauDTau
          else
            drLineHeat = BigRadius
          endif
        else
          drLineHeat = BigRadius
          ipStrong = 1
          Strong = 0.
        endif
      else
        drLineHeat = BigRadius
        ipStrong = 1
        Strong = 0.
      endif
*666  write(6,*) 'drLineHeat=',TauLines(ipLnWlang,ipStrong)
*
*     Lyman band optical depth
*     second term total lyman band optical depth, do not check if thick
*     H2Opacity is opacity evaluated in hmole
      if( htwo*H2Opacity.gt.1e-20 .and. colh2*H2Opacity.lt.5. ) then
        if( colh2*H2Opacity.lt.2.) then
*         special extra 2 since H2 will change by this amount early on
          drH2Band = (drChange/2.) /(htwo*H2Opacity*FillFac)
        else
          drH2Band = drChange /(htwo*H2Opacity*FillFac)
        endif
      else
        drH2Band = BigRadius
      endif
*
*     can't make drmax large deep in model since causes feedback
*     oscillations with changes in heating or destruction rates
*     >>chng 96 Oct 15, change from 5 to 10
      if( nzone.lt.11 ) then
        if( nzone.lt.5 ) then
*         >>chng 96 nov 11, had been 4 * drad up to 11, change to following
*         to be similar to c90.01, max of 1.3 between 5 and 11
          drmax = 4. * drad / AngleIllum
        else
          drmax = 1.3 * drad / AngleIllum
        endif
      else
*       >>chng 96 Oct 15, do not let zones increase if oscillations present
        lgOscil = .false.
*       this routine called before tauinc stores variables
*       >>chng 96 oct 31, error to declare oscillation propto toler, the 
*heating cooling tolerance
        error = toler*toler
        do k=nzone-9,min(nzlim,nzone-2)
*         small residiual is to allow 0.01 rel error
          if( (testr(k-1)-testr(k))/testr(k)*(testr(k)-
     1      testr(k+1))/testr(k).lt.-error ) then
            lgOscil = .true.
          endif
*         small residiual is to allow 0.01 rel error
          if((ednstr(k-1)-ednstr(k))/ednstr(k)*(ednstr(k)-
     1      ednstr(k+1))/ednstr(k).lt.-error )then
            lgOscil = .true.
          endif
        end do
        if( lgOscil ) then
*         >>chng 96 Oct 15, do not let zones increase if oscillations present
          drmax = drad
        else
*         >>chng 96 jan 15 was 1.15 - why so small?
          drmax = 1.3 * drad
        endif
      endif
*
*     is current pressure ok?
      if(lgPresOK) then
        drPressure = BigRadius
      else if(nzone.gt.0 ) then
*       first zone usually has pressure fail due to bug in ptot
        drPressure = drad / 2.
      else
        drPressure = BigRadius
      endif
*
      if(lgTeFail) then
        drFail = drad / 2.
      else
        drFail = BigRadius
      endif
*
*     change in electron density
      if( nzone.le.1 ) OldEden = eden
      if( eden/hden.le.1. ) then
        dEden = abs( eden - OldEden ) / eden
        if( dEden.gt. 0. ) then
*         >>chng 96 may 15, down to .03 from 0.04
*         >>chng 96 may 17, up to 0.1 from .03
          drEden = drad * max( 0.7 , 0.10/dEden )
        else
          drEden = BigRadius
        endif
      else
        drEden = BigRadius
      endif
      OldEden = eden
*
*     do not let thickness get too large
*    1    '' NextDR keys from relative depth'',e11.3)')
      if( nzone.gt.20 ) then
        drDepth = depth / 5.
      else
        drDepth = BigRadius
      endif
*
*     spherical models, do not want delta R/R big
      drSphere = radius * 0.03
      drSphere = radius * 0.04
*
*     optical depth to electron scattering
      dRTaue = drChange / (eden * 6.65e-25)
*
      if( flong.ne.0. ) then
*     FacAbunSav = (cfirst * cos( depth*flong ) + csecnd)
*       this is option for rapid density fluctuations
*       set DR to roughly 0.1 of fluctuation length
*       read flcsub first parameter (log of period) is used to get flong
*       flong = 6.2831853 / period in flcsub
        drFluc = 0.628/2. / flong
      else
        drFluc = BigRadius
      endif
*
*     if density fluctuations in place then override change in heat
*     for dr set
      if( chCPres.eq.'SINE' .and. lgDenFluc ) then
        drdHdStep = BigRadius
      endif

*=======active dr sets
*
*     >>chng 97 mar 11, ms powerstation 4 could not handle too many args to min
      drNext = min( drmax,drInter , drLineHeat , winddr ,drFluc, GlobDr,
     1 DrGrainHeat )
      drNext = min( drNext ,
     1 SpecDr , drFail , drSphere , sdrmax , drPressure , dRTaue )
      drNext = min( drNext ,
     2 drH2Band , drDest , drdTdStep , drdHdStep , drConPres , drTab )
      drNext = min( drNext ,
     3 drOutFrac , drHion , drHe1ion , drDepth , drEden, drHMase)
*
*     option to force min drad
      if( drNext.lt.sdrmin ) then
        drNext = sdrmin
      endif
*
*     dr = zero is a logical mistake
      if( drNext.le.0. ) then
        write(qq,'('' NextDR finds insane drNext:'',1p,e10.2)') drNext
        write(qq,'('' all drs follow:'',1p,5e10.2)')
     1  drmax,drInter , drLineHeat , winddr ,drFluc, GlobDr, 
     1  SpecDr , drFail , drSphere , sdrmax , drPressure , dRTaue ,
     2  drH2Band , drOutFrac , drDepth
        stop
      endif
*
      savedr = drNext
*
*     all this is to only punch on last iteration
*     the punch dr command is not really a punch command, making this necessary
*     lgDRon is set true if "punch dr" entered
      if( lgDROn ) then
        if( lgDRPLst ) then
*         lgDRPLst was set true if "punch" had "last" on it
          if( lgLastIt ) then
            lgDoPun = .true.
          else
            lgDoPun = .false.
          endif
        else
          lgDoPun = .true.
        endif
      else
        lgDoPun = .false.
      endif
      if(lgTrace.and.lgDrBug .or. lgDoPun ) then
        k = ipDRout
        if(lgTeFail .and. nzone.gt.0 ) then
          write(k,'('' >>>> A temperature failure occured.'')')
        endif
        if(.not.lgPresOK .and. nzone.gt.0 ) then
          write(k,'('' >>>> A pressure failure occured.'')')
        endif
*
*=======begin active dr sets
*
        if( drNext.eq.drLineHeat  ) then
          if( level.eq. 1) then
            chLbl =  chLineLbl(TauLines(1,ipStrong))
            write(k,'(1X,I4,1P,E11.3,'' NextDR keys from level 1 '',
     1      ''line heating,'',a10,'' TauIn'',3e10.2)')
     2      nzone,drNext, chLbl,TauInwd,TauLines(ipLnPump,ipStrong),
     3      TauLines(ipLnEscP,ipStrong)
          else if( level.eq.2 ) then
            chLbl =  chLineLbl(WindLine(1,ipStrong))
            write(k,'(1X,I4,1P,E11.3,'' NextDR keys from level 2 '',
     1      ''line heating,'',a10,'' TauIn'',3e10.2)')
     2      nzone,drNext, chLbl,TauInwd,WindLine(ipLnPump,ipStrong),
     3      WindLine(ipLnEscP,ipStrong)
          else
            write(qq,'('' insanity pr line heat'')')
            stop
          endif
*
        else if( drNext.eq.drDepth  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from relative depth'',e11.3)')
     2    nzone,drNext
*
        else if( drNext.eq.drTab  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from spec den law, new old den'',
     1    2e10.2)') nzone,drNext,hdnew,hden
*
        else if( drNext.eq.drHMase  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from H maser, dt, ij='',e10.2,i5)')
     2    nzone,drNext,dTauMase , ijMase
*
        else if( drNext.eq.drHion  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from change in H ionization fm to'',2e11.3)')
     2    nzone,drNext , SaveOHIIoHI , OHIIoHI
*
        else if( drNext.eq.drEden  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from change in elec den'',e11.3)')
     2    nzone,drNext, dEden
*
        else if( drNext.eq.drHe1ion  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from change in He1 ionization'',2e11.3,
     2    '' FrLya'',e11.3)')
     2    nzone,drNext, OHe2oHe1 ,SvHe2oHe1, He3FrLya
*
        else if( drNext.eq.drDest  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from change in dest rates, atom='',a8,i3)')
     2    nzone,drNext, chDestAtom,istage
*
        else if( drNext.eq.drOutFrac  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from ratio out2 tot continuua'',2e10.2,i7,
     1    2(1x,a4))')
     2    nzone,drNext, Out2Tot, SumOutMax,ipSumOutMax ,
     3    chLineLabel(ipSumOutMax), chContLabel(ipSumOutMax)
*         in above SumOutMax is anu where peak occured
*
        else if( drNext.eq.drdHdStep  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from change in heating; current, delta='',
     2    1p,2e10.3)')
     2    nzone,drNext, htot, dHdStep
*
        else if( drNext.eq.drConPres  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from change in con accel'')')
     2    nzone,drNext
*
        else if( drNext.eq.drdTdStep  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from change in temperature; current, delta='',
     2    1p,2e10.3)')
     2    nzone,drNext, te, dTdStep
*
        else if( drNext.eq.sdrmin  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from sdrmin'')') nzone,drNext
*
        else if( drNext.eq.drH2Band  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from H2 Lyman Band - opacity='',1p,e10.2)')
     2    nzone,drNext, htwo*H2Opacity
*
        else if( drNext.eq.sdrmax  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from sdrmax'')') nzone,drNext
*
        else if( drNext.eq.drSphere  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from sphericity'')') nzone,drNext
*
        else if( drNext.eq.dRTaue  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from optical depth to electron scattering'')')
     2     nzone,drNext
*
        else if( drNext.eq.drPressure  ) then
          write(k,'(1X,I4,1P,E11.3,'' NextDR key from pressure failure''
     1    )') nzone, drNext
*
        else if( drNext.eq.drFail  ) then
          write(k,'(1X,I4,1P,E11.3,
     1   '' NextDR key from temperature failure.'')') nzone, drNext
*
        else if( drNext.eq.drmax  ) then
          write(k,'(1X,I4,1P,E11.3,
     1  '' NextDR key from DRMAX; nu opc dr='',1p,3e9.2,'' oscil='',l2
     1   )') nzone , 
     1   drNext, freqm , opacm , drChange / opacm , lgOscil
*
        else if( drNext.eq.drInter  ) then
          write(k,'(1X,I4,1P,E11.3,
     1  '' NextDR keys from cont inter nu='',e9.2,
     1  '' opac='',e9.2)') nzone,drNext, freqm, opacm
*
        else if( drNext.eq. DrGrainHeat ) then
          write(k,'(1X,I4,1P,E11.3,
     1  '' NextDR keys from grain heating nu='',e9.2,
     1  '' opac='',e9.2)') nzone,drNext, grfreqm, gropacm
*
        else if( drNext.eq.winddr ) then
          write(k,'(1X,I4,1P,E11.3,
     1  '' NextDR key from Wind, dVeldRad='',E10.3)') nzone , winddr ,
     2  dVeldRad
*
        else if( drNext.eq.drFluc )  then
          write(k,'(1X,I4,1P,E11.3,
     1  '' NextDR key from density fluctuations'')') nzone , drNext
*
        else if( drNext.eq.GlobDr  ) then
          write(k,'(1X,I4,1P,
     1  '' NextDR keys from GLOB law new dr='',E9.2,'' HDEN='',
     1  E9.2)') nzone ,drNext,hden
*
        else if( drNext.eq.SpecDr  ) then 
          write(k,'(1X,I4,1P,
     1  '' NextDR keys from special law new dr='',E10.2,
     2  '' HDEN='',E10.2)') nzone,drNext,hden
        else
          write(k,'(1X,I4,1P,'' NextDR keys from insanity '',E10.2,
     1    E10.2)') nzone,drNext
          stop
        endif
*
*======end active dr sets
*
      endif
*
*     remember what drNext is, the do test for zones too thin
      drchk = drNext
*
*     this is general code that prevents zone thickness drNext from
*     becoming too thin, something that can happen for various bad reasons
*     HOWEVER we do not want to do this test for certain density laws,
*     for which very small zone thicknesses are unavoidable
*     the special cases are:
*     special density law,
*     globule density law,
*     not at carbon +-0 i front
*     not flucuations command
*     drMinimum was set in FirstDR to either sdrmin (set drmin) or
*     some fraction of the initial radius - it is always set
*     to something non-trivial.  
*     sdrmin is only set wih the "set dr" command
      if( chCPres.ne.'DLW1' .and. chCPres.ne.'GLOB' .and.
     1  xIonFracs(6,1)/xIonFracs(6,0).lt.0.05 .and. (flong.eq.0.) ) then
*       don't let dr get smaller than drMinimum, if this resets drNext
*       then code stops with warning that zones got too thin
        if( drNext.lt.drMinimum ) then
          drNext = drMinimum
*         leaving this at true will cause the model to stop with a warning
*         that the zone thickness is too small
          lgDrMinUsed = .true.
        endif
      endif
*
*     following is to make thickness of model exact
*     n.b., on last zone, drNext can be NEGATIVE!!
*     DEPTH was incremented at start of zone calc in newrad,
*     has been outer edge of zone all throughout
      drNext = min( drNext , real(router(iter)-depth)*z)
*     this means outer limit exceeded
      if( drNext.lt.0. ) then
        lgDrNeg = .true.
      else
        lgDrNeg = .false.
      endif
*
      if( HColStop.lt.5e29 ) then
        coleff = hden * FillFac
        drNext = min( drNext,(HColStop-colden-real(drad)*coleff)*z/
     1  coleff)
      else if( colpls.lt.5e29 ) then
        coleff = hii * FillFac
        drNext = min( drNext , (colpls-chii-real(drad)*coleff)*z/coleff)
      else if( colnut.lt.5e29 ) then
        coleff = hi * FillFac
        if((colnut-chi-real(drad)*coleff).lt.coleff*drNext ) then
          drNext = (colnut-chi-real(drad)*coleff)*z/coleff 
        endif
      endif
*
      if( iptnu.ne.ncell ) then
*       end optical depth has been specified
        dt = opac(iptnu) * FillFac
        drNext = min( drNext , (tauend-tauabs(iptnu,1)-real(drad)*dt)/
     1  dt)
      endif
*
      if( lgTrace ) write(qq,'('' NextDR chooses next drad='',1P,E12.4,
     1 ''; this drad was'',E12.4)') drNext, drad
*
*     this flag is used here to test where sub is initialized yet
*     not off, so on
      lgNxtDROff = .false.
*
      end
