******************************************************************************
      subroutine nitcol
      implicit none
*evaluate total cooling due to nitrogen
      include "ipLnArry.par"
      include "limelm.par"
      include "limLevelN.par"
      include "ndfst.par"
      include "nta.par"
      include "dcool.com"
      include "cooln.com"
      include "fslev.com"
      include "TLineEXP.com"
      include "TePowers.com"
      include "p2ovp1.com"
      include "phycon.com"
      include "logte.com"
      include "TauDmmy.com"
      include "PopLevls.com"
      include "IonFracs.com"
      include "embesq.com"
*
*     local variables
      real pop3 , pop2, cs,
     1 cs2s2p,cs2s3p, cs21 , cs31 , cs32 , a21,a31,a32,p3,p2
*
*     following not currently used for cooling
* 666 error! put all these in cooling
      t671(ipLnPopOpc) = xIonFracs(7,2)
      t671(ipLnPopl) = xIonFracs(7,2)
      t671(ipLnPopu) = 0.
      t315(ipLnPopOpc) = xIonFracs(7,3)
      t315(ipLnPopl) = xIonFracs(7,3)
      t315(ipLnPopu) = 0.
      t333(ipLnPopOpc) = xIonFracs(7,3)
      t333(ipLnPopl) = xIonFracs(7,3)
      t333(ipLnPopu) = 0.
      t324(ipLnPopOpc) = xIonFracs(7,3)
      t324(ipLnPopl) = xIonFracs(7,3)
      t324(ipLnPopu) = 0.
*
*     Nitrogen I 5200, CS and A from 
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     trans prob from 
*     >>refer Butler, K., & Zeippen, C.J. 1984, A&A, 141, 274
*     collision strengths from 
*     >>refer Dopita, M.A., Mason, D.J., Robb, W.D. 1976, ApJ, 207, 102
*
*     N.B. following CS also appears in nitrogen ionization balance
      cs21 = 1.32e-4 * te/(te10*te01)
      cs31 = 3.60e-5 * te/te10*te02
      cs32 = 5.23e-4 * te70*te10/te02
*     following does not have photoionization from excited state
*     since already counted in photo balance equation
* 666 error! use level3
      a21 = 1.28e-5
      a31 = 5.31e-3
      a32 = 6.81e-2
      p3 = pop3(4.,10.,6.,cs21,cs31,cs32,a21,a31,a32,2.769E4,
     1 1.38e4,p2,xIonFracs(7,1),0.)
      c5200 = p2 * a21 * 3.83e-12
      dCooldT = dCooldT + c5200* ( 2.769e4*tsq1 + halfte )
      call coladd( 'N  1' , 5200 , c5200 )
*
      c10400 = p3 * a32 * 1.91e-12
      call coladd( 'N  1' , 10400 , c10400 )
      c3466 = p3 * a31 * 5.74e-12
      dCooldT = dCooldT + (c10400+c3466)* ( 4.15e4 *tsq1 + halfte )
      call coladd( 'N  1' , 3466 , c3466 )
*
*     N I 1200, CS from trans procb
      call PutCS( 4.1 , t1200 )
      call level2( t1200 )
*
*     N II 1084, CS from trans prob
      call PutCS( 5.5 , t1085 )
      call level2( t1085 )
*
*     coll data from 
*     >>refer Stafford, R.P., Bell, K.L, Hibbert, A. & Wijesundera, W.P.,
*     >>refer MN 1994 268, 816,
*     at 10,000K (v weak T dep)
*     transit prob from 
*     >>refer Nussbaumer, H., & Rusca, C. 1979, A&A, 72, 129
*     As from 96 nist
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      c5755 = pop3( 9.,5.,1., 3.02 ,0.372,0.505 , 3.65E-3,0.0316,1.17 ,
     1 21955. , 24982. , pop2 , xIonFracs(7,2) ,0. ) * 1.17 * 3.46E-12
      c6584 = pop2 * 3.65e-3 * 3.03e-12
      dCooldT = dCooldT + c6584 * ( 2.2e4*tsq1 - halfte )
      call coladd( 'N  2' , 5755 , c5755 )
      call coladd( 'N  2' , 6584 , c6584 )
*
*     N II fine structure lines,
      call PutCS( 0.429 , t205 )
      call PutCS( 1.13 , t122 )
      call PutCS( 0.265 , TauDummy )
      call level3( t205,t122,TauDummy)
*
*     N II 2140, data 
*     >>refer Stafford, R.P., Bell, K.L, Hibbert, A. & Wijesundera, W.P. 1994,
*     >>refer MNRAS, 268, 816
*     A from 
*     >>refer Brage, T., Hibbert, A., Leckrone, D.S. 1997, ApJ, 478, 423
      call PutCS( 1.15 , t2140 )
      call level2( t2140 )
*
*     N III 1750, cs from 
*     >>refer Blum, R.D., & Pradhan, A.K. 1992, ApJS 80, 425
*     trans prob from
*     >>refer Stafford, R.P., Hibbert, A., Bell, K.L. 1993, MNRAS, 260, L11
      call PutCS( 2.09 , t1750 )
      call level2( t1750 )
*
*     N III 989.8, CS from 
*     >>refer Blum, R.D., & Pradhan, A.K. 1992, ApJS 80, 425
      call PutCS( 7.12 , t990 )
      call level2( t990 )
*
*     57 micron N III, A=
*     >>refer Froese Fischer, C. 1983, JPhB, 16, 157
*     collision strength from 
*     >>refer Blum, R.D., & Pradhan, A.K. 1992, ApJS 80, 425
      cs = min(1.90 , 0.2291 * te10 * te10 )
      call PutCS( cs , t57 )
      call level2( t57 )
*     save total populations for 374 optical depth
      t374g(ipLnPopl) = PopLevels(0)
      t374x(ipLnPopl) = PopLevels(1)
      t374g(ipLnPopOpc) = PopLevels(0)
      t374x(ipLnPopOpc) = PopLevels(1)
*
*     N IV 1486, collisions within 3P just guess
*     cs to ground from 
*     >>refer Ramsbottom, C.A., Berrington, K.A., Hibbert, A., Bell, K.L. 1994,
*     >>refer PhyS, 50, 246
      if( te.gt.1.584e4 ) then
        cs = 21.346/(te10*te10*te10*te02)
      else
        cs = 75.221 / (sqrte/te03/te02)
      endif
      cs = max( 0.01, cs )
      call PutCS( cs , t1486 )
*     BESEQ(CS23,CS24,CS34,tarray,A41)
      call beseq(.9,.9,3.0,t1486,.0115)
      em1486 = PopLevels(3) * 0.0115 * 1.34e-11
*
*     N IV 765, CS from 
*     >>refer Ramsbottom, C.A., Berrington, K.A., Hibbert, A., Bell, K.L. 1994,
*     >>refer PhyS, 50, 246
      cs = min( 4.0, 1.864*te03*te03 )
      call PutCS( cs , t765 )
      call level2( t765 )
*
*     N V 1240
*     >>refer Cochrane, D.M., & McWhirter, R.W.P. 1983, PhyS, 28, 25
      call ligbar( 7 , t1239, t209, cs2s2p , cs2s3p )
      call PutCS( cs2s2p , t1239 )
      call PutCS( cs2s2p*0.5 , t1243 )
      call PutCS(  1.0 , TauDummy )
      call level3( t1243,TauDummy, t1239)
      call PutCS( cs2s3p , t209 )
      call level2( t209 )
*
      end
