******************************************************************************
      subroutine nitrog
      implicit none
*ionization balance for nitrogen
      include "limelm.par"
      include "te1ryd.par"
      include "elmton.com"
      include "he.com"
      include "heat.com"
      include "chrex.com"
      include "nitexc.com"
      include "logte.com"
      include "shullc.com"
      include "timed.com"
      include "TePowers.com"
      include "IonFracs.com"
      include "h.com"
      include "chargt.com"
      include "phycon.com"
      include "trace.com"
      include "PhotRate.com"
      include "DoPhoto.com"
      include "TrHeav.com"
      include "IOqq.com"
*
*     local variables
      real aeff , d5200r , cs5200 , gamfun , popexc
      integer i
      integer ndim , nelem 
      parameter ( ndim=8)
      parameter (nelem=7)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     real grdeff(7)  , yyield(5)
*     real CollidRate(nelem,2)
*
*     nitrogen nelem=7
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /7.08E-11,4.55E-11,1.83E-11,7.16E-12,2.30E-12,1.44E-13,
     1 4.93E-14/
      data (cion(i,2),i=1,ndim-1)
     1 /1.68e5,3.43e5,5.50e5,8.99e5,1.14e6,6.41e6,7.74e6/
*
*     rec from +5, +4 from Arnaud et al 85
      data rec , pl
     1/1.11E-10 , 7.91E-10 , 2.53E-9  , 1.08E-8  , 2.07E-8 , 2.90E-8,
     2 -0.608   , -0.639   , -0.676   , -0.765   , -0.780  , -0.750 /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/2*0./
*
      data (dicoef(i,1),i=1,ndim-1)
     1/2.98E-3 , 7.41E-3 , 1.13E-2 , 2.62E-3 , 7.5E-2 , 4.61E-2 , 0./
      data (dicoef(i,2),i=1,ndim-1)
     1 /0.,.0764,.164,.243,.35,.309,0./
      data (dite(i,1),i=1,ndim-1)
     2/2.2E5  , 2.01E5  , 1.72E5  , 1.02E5  , 4.75E6  , 5.44E6  , 0./
      data (dite(i,2),i=1,ndim-1)
     1 /0., 7.37E4, 2.25E5, 1.25E5, 8.35E5, 1.14E6, 0./
      data ditcrt
     3/1.8E4  , 1.8E4  , 2.4E4  , 1.5E4  , 6.8E5  , 1.0E6  , 1E20/
*
      data aa/0.0    , 0.0320, -0.8806, 0.4134  ,0.,0.,0./
     1 ,   bb/0.6310 ,-0.6624, 11.2406, -4.6319 ,0.,0.,0./
     2 ,   cc/0.1990 , 4.3191, 30.7066, 25.9172 ,0.,0.,0./
     3 ,   dd/-0.0197, 0.0003, -1.1721, -2.2290 ,0.,0.,0./
     4 ,   ff/0.4398 , 0.5946, 0.6127 , 0.2360  ,0.1,0.,0./
*
*     nitrogen, atomic number 7
      if( .not.lgElmtOn(7) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
*     N+2 => N+ Butler and Dalgarno 1980B
*     ct with he now from Sun, Sadeghpour, Kirby, Dalgarno, and Lafyatis,
*     cfa preprint 4208
*     this agrees with exp Fand&Kwong, ApJ 474, 529
      CTHeavy(2,2) = CTHeavy(2,2) + hei*0.8e-10
*     N+3 => N+2 Butler and Dalgarno 1980B
      CTHeavy(3,2) = CTHeavy(3,2) +hei * 1.5e-10
*     ce rate from quantal calc of ce, Ap.J. in press,
*     Feickert, Blint, Surratt, and Watson, (preprint Sep 84).
*     also Rittby et al J Phys B 17, L677, 1984.
*     CR = 1.E-9 + 8E-12 * TE10 * SQRTE
      CTHeavy(4,2) = CTHeavy(4,2) + hei*2E-9
*
*     photoionization from 2D of NI
      if( xIonFracs(7,1).gt.0. ) then
        d5200r = gamfun(in1(1),in1(2),in1(3))
        aeff = d5200r + 1.28e-5
        cs5200 = 1.32e-4 * te/(te10*te01)
*       uses 1 for total pop of atom - so is normalized to unity
        p2nit = popexc(cs5200,4.,10.,aeff,2.769e4,1.)/aeff
        if( lgDoPhoto ) then
          PhotoRate(7,1,3,1) = PhotoRate(7,1,3,1)*(1.-p2nit) +
     1    p2nit*d5200r
          PhotoRate(7,1,3,2) = PhotoRate(7,1,3,2)*(1.-p2nit) + h*p2nit
        endif
      else
        p2nit = 0.
      endif
*
      if( itime.eq.-1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
*     charge exchange destruction-creation of hydrogen
*     CTHrec(1) = CTHrec(1) + xIonFracs(7,1) * c1
*     CTHionAgnt(2) = xIonFracs(7,2) * c2
*     CTHion(1) = CTHion(1) + CTHionAgnt(2)
*     chrener = chrener +
*     (hi*xIonFracs(7,2)*c2-hii*xIonFracs(7,1)*c1)*1.084e4/te1ryd
*
      if( lgTrace.and.lgHeavyBug ) then
        write(qq,'(5X,''NITROGEN retun; frac='',1P,9E10.3)')
     1  (xIonFracs(7,i)/xIonFracs(7,0),i=1,8)
      endif
*
      end
