**************************************************************************
      subroutine ofit(e,otot,opart)
      implicit none
*compute cross sections for all shells of atomic oxygen
* Photoionization of OI
* Input parameter:   e - photon energy, eV
* Output parameters: otot - total photoionization cross section, Mb
*    opart(1) - 2p-shell photoionization, goes to 4So
*    opart(2) - 2p-shell photoionization, goes to 2Do
*    opart(3) - 2p-shell photoionization, goes to 2Po
*    opart(4) - 2s-shell photoionization
*    opart(5) - double photoionization, goes to O++
*    opart(6) - triple photoionization, goes to O+++
*    opart(7) - 1s-shell photoionization
      real y(5,7),eth(7),opart(7),otot,e,q,x
      integer l(7),i
      data eth/13.62,16.94,18.79,28.48,50.,110.5,538./
      data (y(i,1),i=1,5)/8.915,3995.,3.242,10.44,0.0/
      data (y(i,2),i=1,5)/11.31,1498.,5.27,7.319,0.0/
      data (y(i,3),i=1,5)/10.5,1.059E+05,1.263,13.04,0.0/
      data (y(i,4),i=1,5)/19.49,48.47,8.806,5.983,0.0/
      data (y(i,5),i=1,5)/50.,4.244E+04,0.1913,7.012,4.454E-02/
      data (y(i,6),i=1,5)/110.5,0.1588,148.3,-3.38,3.589E-02/
      data (y(i,7),i=1,5)/177.4,32.37,381.2,1.083,0.0/
      data l/1,1,1,0,1,1,0/
      otot=0.0
      do i=1,7
         opart(i)=0.0
      end do
      do i=1,7
         if(e.ge.eth(i))then
            q=5.5-0.5*y(4,i)+l(i)
            x=e/y(1,i)
            opart(i)=y(2,i)*((x-1.0)**2+y(5,i)**2)/x**q/
     &           (1.0+sqrt(x/y(3,i)))**y(4,i)
            otot=otot+opart(i)
         endif
      end do
*
      end
