******************************************************************************
      subroutine opac0
      implicit none
*compute initial set of opacities for all species
      include "ncell.par"
      include "limelm.par"
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "nopsv.par"
      include "evryd.par"
      include "widflx.com"
      include "anusave.com"
      include "NumUpper.com"
      include "opsv.com"
      include "iphl.com"
      include "iphop.com"
      include "iophe1.com"
      include "iophe2.com"
      include "trace.com"
      include "i3727.com"
      include "opac.com"
      include "photo.com"
      include "rfield.com"
      include "he.com"
      include "nhe1.com"
      include "o3exc.com"
      include "iphmin.com"
      include "iopo.com"
      include "em2nu.com"
      include "nh.com"
      include "nhe2.com"
      include "iprayl.com"
      include "ipbrms.com"
      include "iphmra.com"
      include "iphmop.com"
      include "ioptri.com"
      include "noptot.com"
      include "ipair.com"
      include "iopcom.com"
      include "nxray.com"
      include "ca2ex.com"
      include "h2ppnt.com"
      include "iphe1l.com"
      include "iphe2l.com"
      include "tauend.com"
      include "mgexc.com"
      include "nitexc.com"
      include "ipElement.com"
      include "PhFitOn.com"
      include "IOqq.com"
*
*     local variables
*
      integer i,n , ipoint
      real eps,x,hbf,rayleh,eva2nu,ehe12p,ehe22p,thom,hmiopc,
     1 z,crs,thres 
      logical lgOpEval
      integer ncsh2p
      parameter (ncsh2p=10)
      real csh2p(ncsh2p) , opart(7)
*
      double precision dx
*
      save lgOpEval
      data lgOpEval/.false./
*
*     H2+ h2plus h2+
      data csh2p/6.75,0.24 , 8.68,2.5, 10.54,7.1, 12.46,6.0,
     1 14.28,2.7/
*
*     free statement labels >=92
*
*     this is option to stop at certain optical depth
      if( taunu.gt.0. ) then
        iptnu = ipoint( taunu )
        iptnu = min( iptnu , ncell-1 )
      else
        iptnu = ncell
        tauend = 1e30
      endif
*
*     make and print dust opacities
*     fill in dstab and dstsc, totals, zero if no dust
*     may be different if different grains are turned on
      call dustop
*
      if( lgOpEval ) then
*       this is not the first time code called
        if(lgTrace) write(qq,'('' OPAC0 called but NOT evaluated.'')')
        return
      endif
*
      lgOpEval = .true.
      if(lgTrace) write(qq,'('' OPAC0 called.'')')
*
*     zero out opac since this array sometimes addressed before AddOpac called
      do i=1,ncell
        opac(i) = 0.
      end do
*
*     NOPTOT is number of opacity cells OPSV filled so far by OPAC0
      noptot = 0
*
*     hydrogen Lyman continuum
      iphop(1) = noptot + 1
      do i=ipHn(1),nupper
*       >>chng 96 oct 8, from analytic to phfit for cs, diff less than 1%
*       eps = sqrt(abs( AnuOrg(i) - 1.) ) + 1e-3
*       OpacStack(i-ipHn(1)+iphop(1)) = 6.3e-18/anu2(i)/anu2(i)*exp(4.*
*    1  (1.-atan(eps)/eps)) / (1.-exp(-6.283185/eps))
        thres = max( AnuOrg(i)*evryd , PH1(1,1,1,1) )
        call phfit(1,1,1,thres ,crs,lgPhFit)
        OpacStack(i-ipHn(1)+iphop(1)) = crs * 1e-18
      end do
      noptot = noptot + nupper - ipHn(1) + 1
*
*     Balmer, Paschen, etc  continua, hbf only goes up to 10
      do n=2,min(10,nhlvl)
        iphop(n) = noptot + 1
        do i=ipHn(n),ipHn(1)
          x = anulog(i) - anulog(ipHn(n))
          OpacStack(i-ipHn(n)+iphop(n)) = hbf(x ,n,1.)
        end do
        noptot = noptot + ipHn(1) - ipHn(n) + 1
      end do
*
      do n=11,nhlvl
        iphop(n) = noptot + 1
*       this routine can do ANY level, but is probably very slow
        call SigmaSet( AnuOrg(ipHn(n)) , OpacStack(iphop(n)), n ,
     1  ipHn(1)-ipHn(n)+1 )
        noptot = noptot + ipHn(1) - ipHn(n) + 1
      end do
*
*     Lyman alpha damping wings - Rayleigh scattering
      ipRayScat = noptot + 1
      do i=1,ipHn(1)
        OpacStack( i-1+ipRayScat ) = rayleh( AnuOrg(i) )
      end do
      noptot = noptot + ipHn(1) - 1 + 1
*
*     hydrogen two photon emission
*     sum = 0.
      do i=1,iphl(2,1)
        Hy2nu(i) = eva2nu( AnuOrg(i)) * widflx(i)
*       sum = sum + Hy2nu(i)
      end do
*
*     HeI two photon emission
*     sum = 0.
      do i=1,iphe1l(2,1)
        he12nu(i) = ehe12p( AnuOrg(i)) * widflx(i)
*       sum = sum + he12nu(i)
      end do
*
*     sum = 0.
*     HeII two photon emission
      do i=1,iphe2l(2,1)
        he22nu(i) = ehe22p( AnuOrg(i)) * widflx(i)
*       sum = sum + he22nu(i)
      end do
*
*     assume Thomson scattering up to NXRAY, 20.6 Ryd=0.3 keV
      thom = 6.65e-25
      iopcom = noptot + 1
      do i=1,nxray
        OpacStack(i-1+iopcom) = thom
      end do
*
*     Klein-Nishina from eqn 7.5, Rybicki and Lightman
      do i=nxray+1,nupper
        dx = AnuOrg(i) / 3.7573d4
        OpacStack(i-1+iopcom) = thom *
     1  3.d0/4.d0*( (1.d0+dx)/dx**3 * (
     2  2.d0*dx*(1.d0+dx)/(1.d0+2.d0*dx) - log( 1.d0+2.d0*dx ) ) +
     3  1.d0/2.d0/dx*log(1.d0+2.d0*dx) - 
     4  (1.d0+3.d0*dx)/(1.d0+2.d0*dx)**3 )
      end do
      noptot = noptot + nupper - 1 + 1
*
*     pair production
      ioppr = noptot + 1
      do i=ippr,nupper
*       pair production heating rate for unscreened H + He
*       fit to figure 41 of Experimental Nuclear Physics,
*       Vol1, E.Segre, ed
        x = AnuOrg(i) / 7.512e4 * 2.
        OpacStack(i-ippr+ioppr) = 5.793e-28 *
     1  ((-0.46737118 + x*(0.349255416+x*0.002179893))/
     2  (1.+x*(0.130471301+x*0.000524906)))**2
      end do
      noptot = noptot + nupper - ippr + 1
*
*     brems (free-free) opacity
      ipBrems = noptot + 1
      do i=1,nupper
*       missing factor of 1E-20 to avoid underflow
*       free free opacity needs g(ff)*(1-exp(hn/kT))/sqrt(T)*1E-20
        OpacStack(i-1+ipBrems) = 1.03680e-18 / (AnuOrg(i)**3)
      end do
      noptot = noptot + nupper - 1 + 1
*
      iphmra = noptot + 1
      do i=1,nupper
*       following is ratio of h minus to neut h opacity
        OpacStack(i-1+iphmra) = 0.1175 * anusqr(i)
      end do
      noptot = noptot + nupper - 1 + 1
*
      iphmop = noptot + 1
      do i=iphmin,nhe1(1)
*       H- hminus H minus bound-free opacity
        OpacStack(i-iphmin+iphmop) = hmiopc( AnuOrg(i) )
      end do
      noptot = noptot + nhe1(1) - iphmin + 1
*
*     H2+ H2P h2plus photoabsorption
*     cs from Buckingham Reid and Spence, MN 112m 382, 0 K temp
      call opacrm( ih2pnt(1),ih2pnt(2) , csh2p, ncsh2p , ih2pof,'H2+ ')
*
*     Helium, triplet 23S from Steward 1979, quoted in Mathisen compendium
      call opacpl( nhei3,nhe1(1) ,5.5e-18,1.35,ioptri )
*
*     HeI singlet neutral helium ground
      iophe1(1) = noptot + 1
      do i=nhe1(1),nupper
*       following was brown values, bad at high energies
*       if( AnuOrg(i) .le. 4.809 ) then
*         x = 3.61 * AnuOrg(i) - 0.22
*       else
*         x = 37. - 63. * AnuOrg(i) ** (-0.76)
*       endif
        call phfit(2,2,1,AnuOrg(i)*evryd,crs,lgPhFit)
        OpacStack(i-nhe1(1)+iophe1(1)) = crs*1e-18
      end do
      noptot = noptot + nupper - nhe1(1) + 1
*
*     HeI neutral Helium 21s from Stewart JPhysB 11, L431
      call opacpl( nhe1(2),nhe1(1),0.4*8.7e-18,1.5,iophe1(2))
*
*     HeI helium singlet bound free excited states
      z = 1.
      do n=3,nhe1lvl
        crs = 7.906e-18 * float(n) / (z*z)
        call opacpl( nhe1(n),nhe1(1),crs ,3.0,iophe1(n))
      end do
*
*     HeII ionized helium bound free ground state
      iophe2(1) = noptot + 1
      do i=nhe2(1),nupper
*       >>chng 96 oct 8, from analytic to phfit for cs, diff less than 1%
*       eps = sqrt( abs( AnuOrg(i)/4. - 1.) ) + 1e-3
*       OpacStack(i-nhe2(1)+iophe2(1)) = 4.032e-16/anu2(i)/anu2(i)*
*    1  exp(4.* (1.-atan(eps)/eps)) / (1.-exp(-6.283185/eps))
        thres = max( AnuOrg(i)*evryd , PH1(1,2,1,1) )
        call phfit(2,1,1,thres ,crs,lgPhFit)
        OpacStack(i-nhe2(1)+iophe2(1)) = crs*1e-18
      end do
      noptot = noptot + nupper - nhe2(1) + 1
*
*     HeII ionized helium bound free excited states
      z = 2.
      do n=2,nhe2lvl
        crs = 7.906e-18 * float(n) / (z*z)
        iophe2(n) = noptot + 1
        do i=nhe2(n),nhe2(1)
          x = anulog(i) - anulog(nhe2(n))
          OpacStack(i-nhe2(n)+iophe2(n)) = hbf(x ,n,2.)
        end do
        noptot = noptot + nhe2(1) - nhe2(n) + 1
      end do
*
*     lithium opacity
      call MakeOpacity( 3)
*
*     beryllium opacity
      call MakeOpacity( 4)
*
*     boron opacity
      call MakeOpacity( 5)
*
*     carbon opacity
      call MakeOpacity( 6 )
*
*     Nitrogen
      call MakeOpacity( 7 )
*     Henry ApJ 161, 1153.
*     photoionization of excited level of N+
      call opacpl( in1(1) , in1(2) , 9e-18,1.75,in1(3) )
*
*     Oxygen
      call MakeOpacity( 8 )
*     only do this is 1996 Verner results are used
      if( .not.lgPhFit ) then
        do i=ipElement(8,1,3,1),ipElement(8,1,3,2)
          eps = AnuOrg(i) * evryd
          call ofit(eps,crs,opart)
*         this is total cs of all processes leaving shell 3
          crs = opart(1)
          do n=2,6
            crs = crs + opart(n)
          end do
          crs = crs * 1e-18
          OpacStack(i-ipElement(8,1,3,1)+ipElement(8,1,3,3) ) = crs
        end do
      endif
*     Henry nubmers for 1S excit state of OI, OP data very sparse
      call opacpl( ipo1exc(1),ipo1exc(2),4.64e-18,0.,ipo1exc(3) )
*     photoionization of excited level of O2+ 1D making 5007
*     fit to TopBase Opacity Project cs
      call opacpl( ipo3exc(1) , ipo3exc(2),3.8e-18,0.,ipo3exc(3) )
*     photoionization of excited level of O2+ 1S making 4363
      call opacpl( ipo3exc3(1) , ipo3exc3(2),5.5e-18,0.01,ipo3exc3(3) )
*
*     photoionization to excited states of O+
      iopo2d = noptot + 1
      thres = AnuOrg(i2d)
      do i=i2d,nhe2(1)
        crs = 3.85e-18 * (4.4*(AnuOrg(i)/thres)**(-1.5)  -
     1  3.38 * (AnuOrg(i) / thres) ** (-2.5) )
        OpacStack(i-i2d+iopo2d) = crs
      end do
      noptot = noptot + nhe2(1) - i2d + 1
*
*     Fluorine opacity
      call MakeOpacity( 9)
*
*     Neon
      call MakeOpacity( 10 )
*
*     Sodium
      call MakeOpacity( 11 )
*
*     Magnesium
      call MakeOpacity( 12 )
*     photoionization of excited level of Mg+
*     fit to opacity project data Dima got
      ipOpMgEx = noptot + 1
      do i=ipmgex,ipHn(1)
        OpacStack( i-ipmgex+ipOpMgEx ) = (0.2602325880970085 + 
     1  445.8558249365131*exp(-AnuOrg(i)/0.1009243952792674))*1e-18
      end do
      noptot = noptot + ipHn(1) - ipmgex + 1
*
*     Aluminum
      call MakeOpacity( 13 )
*
*     Silicon
      call MakeOpacity( 14 )
* 
*     phosphorus
      call MakeOpacity( 15 )
*
*     Sulphur
      call MakeOpacity( 16 )
*
*     Chlorine
      call MakeOpacity( 17 )
*
*     Argon
      call MakeOpacity( 18 )
*
*     potassium
      call MakeOpacity( 19 )
*
*     Calcium
      call MakeOpacity( 20 )
*     excited states of Ca+
      call opacpl( ica2ex(1) , ica2ex(2) , 4e-18 , 1. , ica2op )
*
*     scandium
      call MakeOpacity( 21 )
*
*     titanium
      call MakeOpacity( 22 )
*
*     vanadium
      call MakeOpacity( 23 )
*
*     chromium
      call MakeOpacity( 24 )
*
*     Manganese
      call MakeOpacity( 25 )
*
*     Iron
      call MakeOpacity( 26 )
*
*     Cobalt
      call MakeOpacity( 27 )
*
*     nickel
      call MakeOpacity( 28 )
*
*     copper
      call MakeOpacity( 29 )
*
*     zinc
      call MakeOpacity( 30 )
*
      if( lgTrace ) write(qq,'('' OPAC0 return OK, number of opacity'',
     1 '' cells used in OPSC='',I7,'' and OPSV is dimensioned'',I7)')
     2 noptot , NOPSV 
*
      if( NOPSV - noptot .lt.ncell ) write(qq,'('' Warning, only'',
     1I4,'' cells left in OPSV.  Increase NOPSV.'')') NOPSV - noptot
*
      end
