******************************************************************************
      subroutine opinb( ipOpac , low , ihi , a , b )
      implicit none
*add opacity of individual species, including stimulated emission
*     a is the density of the lower level (cm^-3)
*     b is its departure coefficient, can be zero
      integer ipOpac , low , ihi 
      real a , b
      include "ncell.par"
      include "nhlvl.par"
      include "nopsv.par"
      include "corind.com"
      include "opac.com"
      include "rfield.com"
      include "fluors.com"
      include "opsv.com"
      include "HPhoto.com"
      include "IOqq.com"
*
*     local variables
      real binv
      integer iup , i , k
*
*begin sanity check
      if( ipOpac.le.0 ) then
        write(qq,'('' bad pointer to OPINB'')')
        stop
      endif
*end sanity check
*
*     b is dep coef, lgFluor is turned off with 'no indcued' command
*     >> chng 97 sep 01, add k to save speed
      k = ipOpac-low
*     >>chng 97 sep 01, added check on lgHInducImmp
      if( b.gt.1e-35 .and. lgFluor .and. lgHInducImp ) then
        iup = min( ihi , nflux )
        iup = max( low , iup )
        binv = 1. / b
        do i=low,iup
*         >>chng 97 sep 01, changed b to binv=1/b
*         >>chng 97 sep 01, added check on lgHInducImmp
*         opac(i) = opac(i) + OpacStack(i-low+ipOpac)*a*
          opac(i) = opac(i) + OpacStack(i+k)*a*
     1    max(0.,1.-ContBoltz(i)*binv )
        end do
      else
*       B is the departure coef, which can go to zero, neglect stim emin
        iup = min( ihi , nflux )
        iup = max( low , iup )
        do i=low,iup
*         opac(i) = opac(i) + OpacStack(i-low+ipOpac) * a
*         >>chng 97 sep 01, added check on lgHInducImmp
          opac(i) = opac(i) + OpacStack(i+k) * a
        end do
      endif
*
      end
