******************************************************************************
      subroutine optred( chCard )
      implicit none
*parse the optimize command line
      character*80  chCard
*
      include "limpar.par"
      include "rincrm.com"
      include "nvary.com"
      include "whtopm.com"
      include "varang.com"
      include "oprout.com"
      include "iooptm.com"
      include "itoptm.com"
      include "intopn.com"
      include "vtoler.com"
      include "tropt.com"
      include "OptmFlow.com"
      include "IOqq.com"
*
*     local variables
      logical lgMatch , lgEOL
      real deferr , fread
      integer i
      parameter (deferr=0.05)
*
*     free statement numbers all
*
      if( lgMatch('AMOE',chCard) ) THEN
*       use AMOEBA to optimize parameters
        chOptRtn = 'AMOE'
*
      else if( lgMatch('COLU',chCard) ) THEN
*       optimize column density
        lgOptCol = .true.
*       read lcolumn densities to match
        call colred( chCard )
*
      else if( lgMatch('INCR',chCard) ) then
*       scan off increments for the previously selected paramter
        if( nparm.gt.0 ) then
*         also called during optimization process, ignore then
          i = 5
          rincrm(nparm) = fread( chCard , i , 76 , lgEOL )
        endif
*
      else if( lgMatch('LUMI',chCard) .or. lgMatch('INTE',chCard) ) then
*       scan off intensity or luminosity of normalization line
        i = 5
        optint = fread( chCard , i , 76 , lgEOL )
        optier = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          optier = deferr
        endif
*       set flag to say that intentity or luminosity of line set
        lgOptLum = .true.
*
      else if( lgMatch('ITER',chCard) ) then
*       scan off number of iterations
        i = 5
        itoptm = fread( chCard , i , 76 , lgEOL )
*
      else if( lgMatch('LINE',chCard) ) then
*       read lines to match
        call obsred( chCard )
*       set flag saying that something has been set
        lgOptLin = .true.
*
      else if( lgMatch('POWE',chCard) ) then
*       use POWELL to optimize parameters
        chOptRtn = 'POWE'
*
      else if( lgMatch('PUNC',chCard) ) then
*       scan off fortran I/O unit number for final line images, default is 9
        i = 5
        iooptm = fread( chCard , i , 76 , lgEOL )
        if( iooptm.le.0 ) then
          write(qq,'('' This fortran unit number not allowed, sorry.''
     1    )')
          stop
        endif
*
      else if( lgMatch('RANG',chCard) ) then
*       scan off range for the previously selected variable
        if( nparm.gt.0 ) then
          i = 5
          varang(1,nparm) = fread( chCard , i , 76 , lgEOL )
          if(lgEOL) varang(1,nparm) = -1e38
          varang(2,nparm) = fread( chCard , i , 76 , lgEOL )
          if(lgEOL) varang(2,nparm) = 1e38
        endif
*
      else if( lgMatch('SUBP',chCard) ) then
*       use SUBPLEX to optimize parameters
        chOptRtn = 'SUBP'
*
      else if( lgMatch('TOLE',chCard) ) then
*       scan off tolerance of fit, sum of residuals must be smaller than this
*       default is 0.10
        i = 5
        OptGlobalErr = fread( chCard , i , 76 , lgEOL )
*
      else if( lgMatch('TRAC',chCard) ) then
        if( lgMatch('STAR' , chCard ) ) then
*         trace start iteration number
*         turn on trace printout starting on nth call to cloudy
          i = 5
          nTrOpt = fread( chCard , i , 76 , lgEOL )
          if( lgEOL ) then
            write(qq,'('' optimize trace start command:'')')
            write(qq,'('' The iteration number must appear.'')')
            stop
          endif
          lgTrOpt = .true.
        else if( lgMatch('FLOW' , chCard ) ) then
*         trace flow
*         follow logical flow within code
          lgOptimFlow = .true.
        else
          write(qq,'('' optimize trace flow command:'')')
          write(qq,'('' One of the sub keys START or FLOW must appear.''
     1    )')
          stop
        endif
*
      else
        write(qq,'('' Unrecognized keyword, consult HAZY.'')')
        stop
      endif
*
      end
