******************************************************************************
      subroutine outer(iz,in,imax,ig0,ig1)
      implicit none
*determine outer shell for some species
      integer iz,in,imax,ig0,ig1
      include "IOqq.com"
******************************************************************************
*** Input parameters:  iz - atomic number from 1 to 30 (integer) 
***                    in - number of electrons from 1 to iz (integer)
*** Output parameters: imax - number of the outer shell
***                    ig0  - statistical weight of (iz,in) ground state
***                    ig1  - statistical weight of (iz,in-1) ground state
******************************************************************************
      integer in1 , kg
      integer iss(30),igl(30),iga(12)
      data iss/1,1,2,2,3,3,3,3,3,3,4,4,5,5,5,5,5,5,
     &6,6,6,6,6,6,6,6,6,6,7,7/
      data igl/2,1,2,1,2,1,4,5,4,1,2,1,2,1,4,5,4,1,
     &4,5,4,1,6,9,10,9,6,1,2,1/
      data iga/2,1,4,5,4,7,6,9,10,9,2,1/
*
      if(iz.lt.1.or.iz.gt.30) then
        write(qq,'('' ***ERROR: wrong atomic number'')')
        return      
      endif
      if(in.lt.1.or.in.gt.iz) then
        write(qq,'('' ***ERROR: wrong number of electrons'')')
        return      
      endif
*** Number of the outer shell and statistical weight
      imax=iss(in)
      ig0=igl(in)
      in1=in-1
      if(in.eq.1) then
         ig1=1
      else
         ig1=igl(in1)
      endif
      if(in.gt.18.and.iz.eq.in) then
        imax=7
        kg=iz-18
        ig0=iga(kg)
        if(iz.eq.20) ig1=2
        if(iz.eq.21) ig1=3
        if(iz.eq.22) ig1=4
        if(iz.eq.25) ig1=7
        if(iz.eq.26) ig1=10
        if(iz.eq.30) ig1=2
      endif
      if(in.gt.18.and.(iz-in).eq.1) then
          if(iz.eq.20) then
             imax=7
             ig0=2
          endif
          if(iz.eq.21) then 
             imax=7
             ig0=3
          endif
          if(iz.eq.22) then
             imax=7
             ig0=4
          endif
          if(iz.eq.25) then
             imax=7
             ig0=7
          endif
          if(iz.eq.26) then
             imax=7
             ig0=10
          endif
          if(iz.eq.30) then
             imax=7
             ig0=2
          endif
      endif
*
      end
