******************************************************************************
      subroutine pcontn
      implicit none
*print information about continuum if requested with PRINT CONTINUUM command
      include "ncell.par"
      include "condif.com"
      include "rfield.com"
      include "reflec.com"
      include "widflx.com"
      include "r1r0sq.com"
      include "nxray.com"
      include "pconon.com"
      include "nhlvl.par"
      include "nh.com"
      include "flxsav.com"
      include "ots.com"
      include "IOqq.com"
      include "en1ryd.par"
      integer i ,  j , ninc , nxbd,i1,nline,nfluxsv
      parameter (nfluxsv=360)
      real fluxsv(nfluxsv)
*     this is number of ranges for adding x-ray bands
      parameter (nxbd=9)
*
      real xraybd(nxbd+1) , xbdsav(nxbd)
      data xraybd/ 7.3498, 36.8 , 73.5 , 110.3 , 147.1 , 183.8,
     1  220.6 ,  367.6 ,   551.5 ,735.3 /
*
*     following was always printed before version 84, now an option
*     to turn on information with PRINT CONTINUUM command
*
      if( .not.lgPrtCont ) return
*
*     derive x-ray fluxes in various bands for later printout
*
*     >>chng 97 june 8, get rid of statement labels
      if( xraybd(1) .lt. anu(nflux) ) then
        i1 = nxray - 10
*       get out to lower bound of first range
        do while( anu(i1).lt.xraybd(1) .and. i1.lt.nflux )
          i1 = i1 + 1
        end do
*       now add up over that range
        do i=1,nxbd
          xbdsav(i) = 0.
          do while( anu(i1).lt.xraybd(i+1) .and. i1.lt.nflux )
            xbdsav(i) = xbdsav(i) + 
     1      flux(i1) + ContDiff(i1) + outlin(i1) + outcon(i1)
            i1 = i1 + 1
          end do
          xbdsav(i) = xbdsav(i) * r1r0sq
        end do
      else
*       continuum not defined at x-ray energies, but zero it for safety
        do i=1,nxbd
          xbdsav(i) = 0.
        end do
      endif
*
*     now print x-ray flux (photons s^-1, flux or lum) in various bands
      if( xbdsav(1).gt.0 ) write(qq,'(/,'' 0.1-0.5kev:'',1p,e8.2,
     1 '' 0.5-1.0kev:'',e8.2,'' 1.0-1.5:'',
     1e8.2,'' 1.5-2.0:'',e8.2,'' 2.0-2.5:'',e8.2,'' 2.5-3:'',e8.2,
     2'' 3-5:'',e8.2/''      5-7.5:'',e8.2,''     7.5-10:'',e8.2)')
     3 xbdsav
*
*     renorm fLUX array before printing it
      if( ipHn(1)-ipHn(2)+1.gt.nfluxsv ) then
        write(qq,'('' PCONTN: not enough cells in FluxSave, need'',i4)')
     1  ipHn(1)-ipHn(2)+1
        stop
      endif
      do i=ipHn(2),ipHn(1)
        if( FluxSave(i).gt.0. ) then
          fluxsv(i-ipHn(2)+1) = (flux(i)+outlin(i)+outcon(i)+
     1    ContDiff(i)) * r1r0sq/ FluxSave(i)
        else
          fluxsv(i-ipHn(2)+1) = 0.
        endif
      end do
*     renormalize whole continuum
      do i=1,nflux
        flux(i) = ((flux(i)+ContDiff(i)+outcon(i))/widflx(i)+
     1  outlin(i)/anu(i) ) * r1r0sq 
      end do
      write(qq,'(//56X,''Normalised continuum'')')
      write(qq,'(10(F7.3,F6.3))') (anu(i),fluxsv(i-ipHn(2)+1),
     1i=ipHn(2),ipHn(1),3)
*
      write(qq,'(/,50X,''Emergent continuum - phot/ryd/cm2/s (r in)''
     1)')
*
      nline = ( ( nflux-ipHn(2) -1 ) /4 + 7 ) / 7
      ninc = nline * 4
      do j=1,nline
        i1 = (j-1) * 4 + 1 + ipHn(2)
        write(qq,'(1X,3(0P,F6.3,1P,E9.2),2(2X,0P,F6.1,1P,E9.2),
     1  2(3x,1p,e9.2,1p,e9.2))')
     1  (anu(i),(flux(i)+outlin(i)+outcon(i)+ContDiff(i)),i=i1,nflux,
     1  ninc)
      end do
*
      end
