******************************************************************************
      subroutine pfeii( io )
      implicit none
*create punch output describing pumping of FeII by Lya
      integer io
*
      include "ncell.par"
      include "nfeii.par"
      include "nhlvl.par"
      include "nta.par"
      include "limelm.par"
      include "DoppVel.com"
      include "ipfe2.com"
      include "IonFracs.com"
      include "fe2pmp.com"
      include "fe2tau.com"
      include "phycon.com"
      include "phlevl.com"
      include "h.com"
      include "dstfe2.com"
      include "fe2on.com"
      include "TLineEXP.com"
      include "IOqq.com"
*
*     local variables
      integer i
      real hopc , rate
*
*     compute efficiency of FeII emission overlapping with Ly-alpha
*     implemented with Fred Hamann
*
      if( xIonFracs(26,2).le.0. .or. .not.lgFe2On .or. dstfe2lya.le.0. 
     1  ) then
        write(io,'('' No Fe II in this zone'')')
        return
      endif
*
      do i=1,nfeii
*       Ly-alpha line-center opacity
        if( hii.gt.0. ) then
          hopc = 7.60e-8 * hn(1)*hii/doppler(1)
        else
          hopc = 7.60e-8 * hi/doppler(1)
        endif
        rate = (feopc(i)/(feopc(i)+hopc) ) * (doppler(26)/doppler(1))*
     1  (1. - 1./(1.+1.6* Fe2TauLte(i) ) )
*       dstfe2lya is total Lya deexcitation probability due to line overlap
        write(io,'(1p,e15.5,5e10.2)')fe2lam(i),rate/dstfe2lya
      end do
*
      end
