******************************************************************************
      subroutine phosi
      implicit none
*derive ionization balance for phosphorus
      include "limelm.par"
      include "elmton.com"
      include "he.com"
      include "h.com"
      include "timed.com"
      include "phycon.com"
      include "TePowers.com"
      include "IOqq.com"
*
*     local variables
      integer i 
      integer ndim , nelem
      parameter (ndim=16)
      parameter (nelem=15)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     REAL GRDEFF(16)
*
*     phosphorus nelem=15
*     data from sulphus
*
*     real CollidRate(nelem,2) 
*
*     DATA GRDEFF/16*0.2/
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.45E-10,7.11E-11,2.12E-11,6.39E-12,6.43E-12,1.85E-12,
     1 1.71E-12,1.01E-12,6.97E-13,4.75E-13,2.90E-13,1.63E-13,1.04E-13,
     2 4.42E-14,4.25E-15/
      data (cion(i,2),i=1,ndim-1)
     1 /1.20E5,2.71E5,4.06E5,5.49E5,8.47E5,1.02E6,3.26E6,3.81E6,
     2 4.40E6,5.19E6,5.86E6,6.55E6,7.56E6,8.02E6,3.74E7/
*
      data aa/nelem*0./,bb/nelem*0./,cc/nelem*0./,dd/nelem*0./,
     1 ff/nelem*0./
*
*     rec from +13 14 15 from Arnauld et al 85 
      data rec , pl
     1/1.54E-10 , 13.4E-10 , 3.37E-9 , 7.36E-9 , 7.64E-9 , 4.23E-8 ,
     2 2.31E-8  , 2.43E-8  , 3.84E-8 , 5.41E-8 , 6.60E-8 , 1.47E-7 ,
     2 3.35E-7  , 6.67E-7  ,
     3 -0.63    , -0.686   , -0.745  , -0.755  , -0.701  , -0.849  ,
     3 -0.733   , -0.696   , -0.711  , -0.716  , -0.714  , -0.755  ,
     3 -0.806   , -0.840   /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.23e-10 , -0.593 /
*
      data (dicoef(i,1),i=1,ndim-1)
     1/1.62E-3, 1.09E-2, 3.35E-2, 3.14E-2, 1.27E-2, 1.47E-2, 1.34E-2,
     2 2.38E-2, 3.19E-2, 7.13E-2, .08, .0796, .0134, .402,0./
      data (dicoef(i,2),i=1,ndim-1)
     1/0., 1.20E-2, 6.59E-2, 6.89E-2, .187, .129, 1.04, 1.12, 1.40,
     2 1.00, .555, 1.63, .304, .298, 0./
      data (dite(i,1),i=1,ndim-1)
     1/1.25E+5, 1.92E+5, 1.89E+5, 1.68E+5, 1.38E+5, 1.80E+6, 6.90E+5,
     2 5.84E+5, 5.17E+5, 6.66E+5, 6.00E+5, 5.09E+5, 2.91E+5, 2.41E+7,
     3 0./
      data (dite(i,2),i=1,ndim-1)
     1/0., 1.80E+4, 1.59E+5, 8.04E+4, 1.71E+5, 1.75E+6, 2.15E+6,
     1 2.59E+6, 2.91E+6, 2.32E+6, 2.41E+6, 6.37E+6, 1.04E+6, 4.67E+6,
     2 0./
      data ditcrt
     3/2.2E4  , 1.2E4  , 1.4E4  , 1.5E4  , 1.4E4  , 2.9E5  , 1.3E5
     3,1.1E5  , 9.0E4  , 9.0E4  , 9.0E4  , 8.3E4  , 6.0E4  , 5.0E6
     3, 1E20  /
*
*     phosphorus, atomic number 15
      IF( .NOT.lgElmtOn(nelem) ) THEN
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
