******************************************************************************
      subroutine pldata( io )
      implicit none
*punches selected line data for all lines transferred in code
      integer io
      include "rydlam.par"
      include "limelm.par"
      include "ipLnArry.par"
      include "nta.par"
      include "nwindline.par"
      include "TLineARR.com"
      include "hmi.com"
      include "WindData.com"
      include "phycon.com"
      include "IonFracs.com"
      include "ElmntSym.com"
      include "h.com"
      include "tseton.com"
      include "forcte.com"
      include "RecCNO.com"
      include "IOqq.com"
*
*     local variables
      integer i,j , nelem , iWavLen
      real tot , dc
      character chLineLbl*10 , chLbl*10
*
*     routine punches out (on unit io) line data
*     for all recombination lines, and all transitions that are transferred
*
*     say what is happening so we know why we stopped
      write(qq,'('' punching line data, then stopping'')')
*
*     evaluate rec coef at constant temperature if this is set, else
*     use 10,000K
      if( lgTSetOn ) then
        te = ForceTemp
      else
        te = 1e4
      endif
*     this is set of Dima's recombination lines
      call LineFit( te , RecCoefCNO )
      nelem = 2
      write(io,'(/7x,''Recombination lines of C, N, O'')')
      write(io,'(4x,''Ion  WL(A)   Coef     Ion   WL(A)  Coef'')')
      do i=1,471,nelem
        write(io,'(2(4x,a2,i2,i6,f8.3))')
     1  (chElementSym(int(RecCoefCNO(j,1))),
     2  int(RecCoefCNO(j,1)-RecCoefCNO(j,2)+1.01),
     3  int(RecCoefCNO(j,3)+0.5),
     3  log10(MAX(1e-37,RecCoefCNO(j,4))),j=i,min(471,i+nelem-1))
      end do
      write(io,'(/)')
*
      eden = 1.
      hden = 1.
*     want very small neutral fractions so get mostly e- cs
      hi = 1.e-5
      htwo = 0.
      hii = 1.
      do i=1,nTauLines
        TauLines(ipLnPopl,i) = 1.
      end do
      do i=1,NWINDLINE
        WindLine(ipLnPopl,i) = 1.
      end do
      do i=1,limelm
        do j=1,limelm
          xIonFracs(i,j) = 1.
        end do
      end do
      call coolr( tot , dc )
*
      write(io,'(7x,''Level 1 transferred lines'')')
      write(io,'(''Ion label   WL '',
     1'' gl gu    gf       A       CS'')')
      do i=1,nTauLines
        chLbl = chLineLbl(TauLines(1,i) )
*       following logic must be kept parallel with that in putline
        iWavLen = TauLines( ipLnWlAng ,i)
        if(iWavLen.gt.1 000 000 ) then
          iWavLen = iWavLen / 10000
        else if(iWavLen.gt.10 000 ) then
          iWavLen = iWavLen / 1000
        else if( iWavLen.lt.10 ) then
          iWavLen = TauLines( ipLnWlAng ,i) * 10.
        endif
*       check because some CS are huge, others small, but avoid exp notation
        if( TauLines(ipLnCS,i).gt.1. ) then
*         write(io,'(a10,i5,1p,2i3,2e9.2,0p,f7.3)')
          write(io,'(a4,i5,a6,1p,2i3,2e9.2,0p,f7.3)')
     1    chLbl(1:4) ,iWavLen, chLbl(5:10),
     2    int(TauLines(ipLnGl,i)),
     3    int(TauLines(ipLnGu,i)) ,
     3    TauLines(ipLnGF,i),
     3    TauLines(ipLnAul,i),TauLines(ipLnCS,i)
        else
*         write(io,'(a10,i5,1p,2i3,2e9.2,0p,f7.4)')
          write(io,'(a4,i5,a6,1p,2i3,2e9.2,0p,f7.4)')
     1    chLbl(1:4) ,iWavLen, chLbl(5:10),
     2    int(TauLines(ipLnGl,i)),
     3    int(TauLines(ipLnGu,i)) ,
     3    TauLines(ipLnGF,i),
     3    TauLines(ipLnAul,i),TauLines(ipLnCS,i)
        endif
      end do
*
      write(io,'(//)')
      write(io,'(7x,''end level 1, start level 2'')')
      write(io,'(''Ion label   WL '',
     1'' gl gu    gf       A       CS'')')
      do i=1,NWINDLINE
        nelem = WindLine(ipLnNelem,i)
        iWavLen = WindLine( ipLnWlAng ,i)
*       following logic must be kept parallel with that in putline
        if(iWavLen.gt.1 000 000 ) then
          iWavLen = iWavLen / 10000
        else if(iWavLen.gt.10 000 ) then
          iWavLen = iWavLen / 1000
        else if( iWavLen.lt.10 ) then
          iWavLen = WindLine( ipLnWlAng ,i) * 10.
        endif
        chLbl = chLineLbl(WindLine(1,i) )
        if( WindLine(ipLnCS,i).gt.1. ) then
*         write(io,'(a10,i5,1p,2i3,2e9.2,0p,f7.3)')
          write(io,'(a4,i5,a6,1p,2i3,2e9.2,0p,f7.3)')
*         write(io,'(i5,1x,a4,i5,a6,1p,2i3,2e9.2,0p,f7.3)')
     1    chLbl(1:4) ,iWavLen,chLbl(5:10),
*    1    int(WindLine(ipLnipCont,i)),chLbl(1:4) ,iWavLen,chLbl(5:10),
     2    int(WindLine(ipLnGl,i)),
     3    int(WindLine(ipLnGu,i)) ,
     3    WindLine(ipLnGF,i),
     3    WindLine(ipLnAul,i),WindLine(ipLnCS,i)
        else
*         write(io,'(a10,i5,1p,1x,2i3,2e9.2,0p,f7.4)')
          write(io,'(a4,i5,a6,1p,2i3,2e9.2,0p,f7.4)')
*         write(io,'(i5,1x,a4,i5,a6,1p,2i3,2e9.2,0p,f7.4)')
     1    chLbl(1:4) ,iWavLen,chLbl(5:10),
*    1    int(WindLine(ipLnipCont,i)),chLbl(1:4) ,iWavLen,chLbl(5:10),
     2    int(WindLine(ipLnGl,i)),
     3    int(WindLine(ipLnGu,i)) ,
     3    WindLine(ipLnGF,i),
     3    WindLine(ipLnAul,i),WindLine(ipLnCS,i)
        endif
      end do
*
*     stop when done, we have done some serious damage to the code
      write(qq,'('' stopping in pldata'')')
      stop
*
      end
