******************************************************************************
      subroutine pltr( x , y , npnts , xmin , xmax , ymin , ymax ,
     1 chSym , chXtitle , itim , lgTrace )
      implicit none
*core plotting routine for generating line printer plots
      integer npnts , itim
      real x(npnts) , y(npnts)
      real xmax,xmin,ymin,ymax
      character chSym*1 , chXtitle*22
      logical lgTrace
*
      include "ncell.par"
      include "nkrd.par"
      include "input.com"
      include "IOqq.com"
*
*     local variables
      integer ndecad,i,j,nc,lx,iy,ix,lowx
      real ydown,yinc,xdec,xinc
      parameter (ndecad=14)
      integer jpnt(ndecad) , ihi , iwid
      parameter (ihi=59 , iwid=121 )
      character chPage(59)*121 , chLab(ndecad)*4
      save chPage , yinc , ydown , lx , xdec , lowx , xinc , jpnt
      data chLab/'1E-4','.001','0.01',' 0.1','  1 ',' 10 ',' 100','1000'
     1          ,'1E4 ','1E5 ','1E6 ','1E7 ','1E8 ','1E9 '/
*
*     ITIM=1, first call, =2 intermediate calls, =3 for last call
*
      if( itim.eq.1 ) then
*       first call, set left border of plot and clear out array
        do i=2,ihi
           chPage(i)(1:1) = 'l'
           do j=2,iwid
              chPage(i)(j:j) = ' '
           end do
        end do
*
*       centered label for plot
        chPage(2)(47:iwid) = chTitle
        chPage(2)(25:46) = chXtitle
*
*       one dex increments in x and y marked special
        i = 1
        ydown = 0.
        yinc = float(ihi-2) / (ymax - ymin)
        nc = 0
*3      continue
*     >>chng 97 may 24, to do while from go to loop
        do while( i.le.ihi .and. nc.lt.200 ) 
           chPage(i)(2:2) = '-'
           ydown = ydown + yinc
           i = ydown + 1
           nc = nc + 1
        end do
*       if( i.le.ihi .and. nc.lt.200 ) go to3
*
*       bottom increments of plot
        do i=1,iwid
           chPage(ihi)(i:i) = '-'
        end do
*
*       LX is pointer to label for number in x-axis in chLab
        if( xmin.lt.0. ) then
           lx = max( 0. , 4.999 - abs(xmin) )
           xdec = -int(abs( xmin ) + 1e-5 )
        else
           lx = max( 0. , 4. + xmin )
           xdec = int( xmin + 1e-5 )
        endif
        lowx = lx + 1
        xinc = float(iwid-1) / (xmax-xmin)
        i = max(1. , (xdec - xmin ) * xinc + 1. )
        nc = 0
*5      continue
*     >>chng 97 may 24, to do while from go to loop
        do while( i.lt.iwid .and. nc.lt.100 )
           chPage(ihi-1) (i:i) = 'l'
*          fix position of x labels
           lx = min( lx+1 , ndecad)
*          slight offset to center label
           jpnt(lx) = max( 0 , i - 3 )
           jpnt(lx) = min( iwid-4 , jpnt(lx) )
           xdec = xdec + 1.
           i = max( 1. , (xdec-xmin) * xinc + 1. )
           nc = nc + 1
*       if( i.lt.iwid .and. nc.lt.100 ) go to5
        end do
      endif
* 
*     now fill in data, symbol is chSym
      do i=1,npnts
        if( x(i).gt.xmin .and. x(i).lt.xmax ) then
          iy = ihi - max( y(i)-ymin , 0. ) * yinc 
          iy = max(1,iy)
          ix = (x(i) - xmin) * xinc + 1
          if(lgTrace)write(qq,'('' x, y, ix, iy='',2f7.3,2i4)')
     1    x(i),y(i),ix,iy
          chPage(iy)(ix:ix) = chSym
        endif
      end do
*
      if( itim.eq. 3 ) then
*       make the plot
        write(qq,'(''1'')')
        write(qq,'(5X,A121)') (chPage(i),i=2,ihi)
*       now put on label for X-axis
        do i=1,iwid
          chPage(1)(i:i) = ' '
        end do
        do i=lowx,lx
          do j=1,4
            chPage(1) ( (jpnt(i)+j):(jpnt(i)+j) ) = chLab(i)(j:j)
          end do
        end do
        write(qq,'(5X,A121)') chPage(1)
      endif
*
      end
