******************************************************************************
      subroutine pread( chCard )
      implicit none
*parse the plot command
      character chCard*80
*
      include "ndplot.par"
      include "ploton.com"
      include "pltrce.com"
      include "ptype.com"
      include "bounds.com"
      include "IOqq.com"
*
      logical lgMatch
*
      nplot = nplot + 1
      lgPlotON = .true.
      if( nplot.gt.ndplot ) then
         write(qq,'('' Too many plots; the limit is'',I3,
     1   '' This one ignored.'')') ndplot
         nplot = ndplot
      endif
*
      if( lgMatch( ' MAP' , chCard ) ) then
*        option to make plot of heating - cooling map
        chPType(nplot) = ' MAP'
      else if( lgMatch( 'CONT' , chCard ) ) then
*       option to make "raw" plot, in internal units
        if( lgMatch( ' RAW' , chCard ) ) then
          chPType(nplot) = 'CRAW'
*       option to make diffuse continuum plot
        else if( lgMatch( 'DIFF' , chCard ) ) then
          chPType(nplot) = 'DIFF'
*       this is emitted continuum
        else if( lgMatch( 'EMIT' , chCard ) ) then
          chPType(nplot) = 'EMIT'
*       this is outward and attenuated continuum
        else if( lgMatch( 'OUTW' , chCard ) ) then
          chPType(nplot) = 'OUTW'
*       this is reflected continuum
        else if( lgMatch( 'REFL' , chCard ) ) then
          chPType(nplot) = 'REFL'
*       this is continuum in photons
        else if( lgMatch( 'PHOT' , chCard ) ) then
          chPType(nplot) = 'CPHT'
        else
          chPType(nplot) = 'CONT'
        endif
      else if( lgMatch( 'OPAC' , chCard ) ) then
         if( lgMatch( 'ABSO' , chCard ) ) then
*           plot absorption opacity
            chPType(nplot) = 'OPAA'
         else if( lgMatch( 'SCAT' , chCard ) ) then
*           plot scattering opacity
            chPType(nplot) = 'OPAS'
         else if( lgMatch( 'TOTA' , chCard ) ) then
*           plot total opacity
            chPType(nplot) = 'OPAT'
         else
*           plot total opacity for default
            chPType(nplot) = 'OPAT'
         endif
      else
         write(qq,'('' The second keyword on the PLOT command must'',
     1   '' be CONTINUUM, _MAP, or OPACITY.'')')
         stop
      endif
*
*     option to turn on trace of plot logic
      if( lgMatch('TRAC' , chCard ) ) then
         lgPltTrace(nplot) = .true.
      else
         lgPltTrace(nplot) = .false.
      endif
*
*     option to set min and max x-axis
      if(chPType(nplot).eq.' MAP' ) then
*       this will be map of cooling and heating vs temp
        call pmprng( chCard )
      else
*       continuum map
        call pcnrng( chCard )
      endif
*
      end
