******************************************************************************
      subroutine presur(loop)
      implicit none
*evaluate the current pressure, and change needed to get it to PressureInit
*     sets presok true if good pressure, false if pressure change capped
      integer loop
      include "solarm.par"
      include "itrdim.par"
      include "limelm.par"
      include "ndust.par"
      include "AbunTablLG.com"
      include "presok.com"
      include "ZoneCnt.com"
      include "called.com"
      include "hmi.com"
      include "trace.com"
      include "prad.com"
      include "pwind.com"
      include "wind.com"
      include "prspow.com"
      include "timefc.com"
      include "fluct.com"
      include "filfac.com"
      include "dRdVeff.com"
      include "denpow.com"
      include "radius.com"
      include "phycon.com"
      include "PresInit.com"
      include "cpres.com"
      include "h.com"
      include "he.com"
      include "IonFracs.com"
      include "dvdr.com"
      include "densty.com"
      include "aclbar.com"
      include "globul.com"
      include "pnow.com"
      include "velpos.com"
      include "prslim.com"
      include "cldnEXP.com"
      include "dndt.com"
      include "r1r0sq.com"
      include "pinteg.com"
      include "conprs.com"
      include "hehp.com"
      include "hvmolEXP.com"
      include "chrex.com"
      include "EdenOther.com"
      include "nebug.com"
      include "IOqq.com"
*
*     local variables
      real factor ,  pold , dold,TotalPressure,abun ,tababun,
     1 hold,term,poldd,pnew,dnew,pneed,fabden,tabden
      integer nelem , ion 
      double precision vold , windnw
      real pdelta , perror , edensave
      parameter (pdelta=0.07 , perror=0.02)
      real OldAbun , FacAbun , FacAbunSav
      save OldAbun , FacAbun , FacAbunSav
*
      logical lgDppos
      double precision rsave
      save factor , pold , rsave , dold , lgDppos
      data factor/1./, pold/0./, rsave/0./,
     1 dold/0./ , lgDppos/.true./
*
      edensave = eden
      if( nzone.eq.1 ) then
*       this is first zone, lock onto pressure
        PressureInit = TotalPressure()
        plow = 1e36
        phi = -1e36
        pnow = PressureInit
        if( lgTrace ) then
          write(qq,'('' PRESUR called, this is first zone, so''
     1    ,'' reseting pressure to'',1P,E10.3)') PressureInit
        end if
      else
*       pnow is just sum of gas plus local line radiation pressure
        pnow = TotalPressure()
      endif
      hold = hden
*
*     inside out globule
      if( chCPres.eq.'GLOB' ) then
*       GLBDST is distance from globule, or glbrad-DEPTH
        if( glbdst.lt.0. ) then
          write(qq,'('' Globule distance is negative, internal '',
     1    ''overflow has occured,  sorry.'')')
          write(qq,'('' This is routine PRESUR, GLBDST is'',1P,E10.2)'
     1    ) glbdst
          stop
        endif
        factor = ( glbden * (glbrad/(glbdst ) )**glbpow)/hden
*
      else if( chCPres.eq.'WIND' ) then
*       this is logic for wind solution
*       following makes sure wind v only updated once per zone
        if( depth.ne.rsave ) then
          rsave = depth
*         evaluate radiative acceleration
          call radacl
*         Wind model
*         G, COMASS = mass of star in solar masses
          agrav = (6.67e-8 * comass) * (solarm / radius ) / radius
*         is this the first zone?
          if( nzone.gt.2 ) then
*           acceleration due to grad P(rad), xMassDensity is gm per cc
            AccelPres = -(RadPres-pold)/drad/xMassDensity
          else
            AccelPres = 0.
          endif
*         this is numerically unstable
          AccelPres = 0.
*         AccelXXX is computed in radinc, is continuum and line acceleration
*         AccelCont is continuum accel 
*         AccelLine is line accel 
*         AccelPres is gradient of local gas pressure
          AccelTot = AccelCont + AccelLine + AccelPres
*         remember largest radiative acceleration
          AccelMax = max( AccelMax , AccelTot )
*         keep track of average acceleration
          AccelAver = AccelAver + AccelTot * dReff
          acldr = acldr + dReff
*
*         following is form of energy equation, only used to check if neg vel
          term = windv**2+2.*(AccelTot-agrav)*drad
*
*         remember the current wind velocity
          vold = windv
          if( term.le.1e3 ) then
*           wind vel is way below sonic point, give up, do not change vel
            lgVelPos = .false.
          else
*           square of new wind velocity for outer edge of this zone
            windnw = dble(windv*windv) + dble(2.*(AccelTot-agrav))*drad
*           WINDV is velocity at OUTER edge of this zone
            windv = sqrt(windnw)
            lgVelPos = .true.
          endif

*         following needed for expansion cooling
          dDensityDT = AccelTot/windv + 2.*windv/radius
*
*         following used to control new DRAD
          dVeldRad = abs( windv-vold ) / windv / drad
*
        else
          factor = 1.
        endif
        factor = emdot / (windv*hden ) / r1r0sq
        poldd = pold
        pnew = RadPres
        pold = RadPres
*
      else if( chCPres.eq. 'TIME' ) then
*       called by TIMER for N = N(T)
        write(qq,'('' TIME does not now work.  Sorry.'')')
        factor = timefc
        stop
*
      else if( chCPres.eq.'SINE' ) then
*       rapid density fluctuation
        factor = (cfirst * cos( depth*flong + flcPhase ) + csecnd)/hden
*
      else if( chCPres.eq.'POWR' ) then
*       power law function of radius
        dnew = den0 * (radius/rinner)**DensityPower
        factor = dnew / hden
*
      else if( chCPres.eq.'POWD' ) then
*       power law function of depth
        dnew = den0 * (1.+depth/rscale)**DensityPower
        factor = dnew / hden
*
      else if( chCPres.eq.'POWC' ) then
*       power law function of column density
        dnew = den0 * (1.+ colden /rscale)**DensityPower
        factor = dnew / hden
*
      else if( chCPres.eq.'CPRE' ) then
*       constant pressure
        if( lgConPres ) then
*         this has pressure due to incident continuum
          pneed = PressureInit + pinteg
          factor = pneed / pnow
        else
*         this does not
          pneed = PressureInit * (radius/rinner)**prspow
          factor = pneed / pnow
        endif
        if( loop.gt.0 ) then
*         just want sign of following
          if( (pold-pnow)*(dold-hden).gt.0. ) then
            lgDppos = .true.
          else
            lgDppos = .false.
          endif
        else
           lgDppos = .true.
        endif
        pold = pnow
        dold = hden
*
      else if( chCPres(1:3).eq.'DLW' ) then
        if( chCPres.eq.'DLW1' ) then
*         call ACF sub
          factor = fabden( radius , depth ) / hden
        else if( chCPres.eq.'DLW2' ) then
*         call table interpolation subroutine
*         >>chng 96 nov 29, added tabden
          factor = tabden( radius , depth ) / hden
        else
          write(qq,'('' Insanity, presur gets chCPres='',a4)') chCPres
          stop
        endif
*
      else if( chCPres.eq.'CDEN' ) then
*       constant density
        factor = 1.
      else
        write(qq,'('' Unknown pressure law='',A4,'' STOP.'')')chCPres
        stop
      endif
*
*     save correct pressure
      pcorec = pnow * factor
*
      if( factor.gt.1.+perror .or. factor.lt.1.-perror ) then
        lgPresOK = .false.
      else
        lgPresOK = .true.
      endif
*
*     make sure that change is not too extreme
      factor = min( factor , 1. + pdelta )
      factor = max( factor , 1. - pdelta )
*
*     >>chng 97 jun 3, added variable abundances for element table command
*     option to get abundances off a table with element read command
      if( lgAbTaON ) then
        do nelem=2,limelm
          if( lgAbunTabl(nelem) ) then
            abun = tababun( radius , depth , nelem ) * hden
*            write(66,*) depth , abun
            hold = abun / xIonFracs(nelem,0)
            xIonFracs(nelem,0) = abun
            do ion=1,nelem+1
              xIonFracs(nelem,ion) = xIonFracs(nelem,ion) * hold
            end do
          endif
        end do
      endif
*
*     this happens if fluctuations abundances command entered
      if(  .not.lgDenFluc ) then
        if( nzone.le.1 ) then
          OldAbun = 1.
          FacAbun = 1.
          FacAbunSav = cfirst * cos( depth*flong + flcPhase ) + csecnd
        else
          OldAbun = FacAbunSav
*         rapid abundances fluctuation
          FacAbunSav = cfirst * cos( depth*flong + flcPhase ) + csecnd
          FacAbun = FacAbunSav/OldAbun
        endif
      else
        FacAbun = 1.
      endif
*
      if( factor*FacAbun.ne.1. ) then
*       nelem,0 is abundance of nelem
*       H, He not affected by abundance fluctuations
        do nelem=1,2
          do ion=0,nelem+1
*           >>chng 96 july 12 had only multiplied total abun, not ions
            xIonFracs(nelem,ion) = xIonFracs(nelem,ion) * factor
          end do
        end do
*       Lit on up is, so with FacAbun
        do nelem=3,limelm
          do ion=0,nelem+1
*           >>chng 96 july 12 had only multiplied total abun, not ions
            xIonFracs(nelem,ion) = xIonFracs(nelem,ion)*factor*FacAbun
          end do
        end do
        eden = eden * factor
        EdenMet = EdenMet * factor
        EdenNotH = EdenNotH * factor
*       >>chng 96 oct 25 update some te-ne variables
        call tfidle
        hden = hden * factor
        hi = hi * factor
        hii = hii * factor
        ahe = ahe * factor
        hei = hei * factor
        heii = heii * factor
        heiii = heiii * factor
        hei1 = hei1 * factor
        hei3 = hei3 * factor
*       alith = alith * factor * FacAbun
*       aberyl = aberyl * factor * FacAbun
*       aboron = aboron  * factor * FacAbun
*       acarb = acarb * factor * FacAbun
*       an = an * factor * FacAbun
*       aoxy = aoxy * factor * FacAbun
*       afluorine = afluorine  * factor * FacAbun
*       ane = ane * factor * FacAbun
*       ana = ana * factor * FacAbun
*       amg = amg * factor * FacAbun
*       aal = aal * factor * FacAbun
*       asil = asil * factor * FacAbun
*       aphos = aphos * factor * FacAbun
*       asul = asul * factor * FacAbun
*       aclor = aclor * factor * FacAbun
*       aargon = aargon * factor * FacAbun
*       apotas = apotas * factor * FacAbun
*       aca = aca * factor * FacAbun
*       ascand = ascand * factor * FacAbun
*       atitan = atitan  * factor * FacAbun
*       avana = avana  * factor * FacAbun
*       achrom = achrom  * factor * FacAbun
*       amanga = amanga  * factor * FacAbun
*       afe = afe * factor * FacAbun
*       acobl = acobl * factor * FacAbun
*       ani = ani * factor * FacAbun
*       acopp = acopp * factor * FacAbun
*       azinc = azinc  * factor * FacAbun
*       charge transfer rates
        CTHion(1) = CTHion(1) * factor
        CTHion(2) = CTHion(2) * factor
        CTHrec(1) = CTHrec(1) * factor
        CTHrec(2) = CTHrec(2) * factor
        chrener = chrener * factor
*       molecules done in hmole
        htwo = htwo * factor
        h2plus = h2plus * factor
        hminus = hminus * factor
        hehp = hehp * factor
*       molecules done in comole
        ch = ch * factor * FacAbun
        chp = chp * factor  * FacAbun
        oh = oh * factor  * FacAbun
        ohp = ohp * factor  * FacAbun
        otwo = otwo * factor  * FacAbun
        ctwo = ctwo * factor  * FacAbun
        co = co * factor  * FacAbun
        cop = cop * factor  * FacAbun
        h2o = h2o * factor  * FacAbun
        h2op = h2op * factor  * FacAbun
        o2p = o2p * factor  * FacAbun
        c2p = c2p * factor  * FacAbun
        h3p = h3p * factor 
        h3op = h3op * factor 
        ch2p = ch2p * factor  * FacAbun
        ch2 = ch2 * factor  * FacAbun
        ch3 = ch3 * factor  * FacAbun
        cp = cp * factor * FacAbun
      endif
*
      if( lgTrace ) then
        write(qq,'('' PRESUR called, changing HDEN from'',1P,
     1  e10.3,'' TO'',E10.3,'' Set fill fac to'',E10.3)') 
     2  hold,hden,FillFac
        if(lgNeBug ) write(qq,'('' EDEN change PRESUR from to'',1p,
     1  3e10.3)') edensave , eden , edensave/eden
      endif
*
      end
