******************************************************************************
      subroutine PrtAllTau
      implicit none
*master routine controlling printout of optical depths at end of calculation
      include "ndfst.par"
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "ncell.par"
      include "nta.par"
      include "ipLnArry.par"
      include "he.com"
      include "nhe1.com"
      include "nhe2.com"
      include "nh.com"
      include "iphl.com"
      include "tautot.com"
      include "htau.com"
      include "he1tau.com"
      include "he2tau.com"
      include "he3tuEXP.com"
      include "cldnEXP.com"
      include "sphere.com"
      include "static.com"
      include "taucon.com"
      include "IOqq.com"
*
*     local variables
      integer i
      real fcon,flin
*
*     optical depths used by code are total through model,
*     when sphere is set, this is twice optical depth through
*     computed structure
      if( lgSphere ) then
        fcon = 2.
        if( lgStatic ) then
          flin = 2.
        else
          flin = 1.
        endif
      else
        fcon = 1.
        flin = 1.
      endif
*
*     print out optical depths and column densities
*
*     R(1300) is Rayleigh scattering
      write(qq,'(/'' Contin Optical Depths: COMP:'',1P,E9.2,''    H-:'',
     1E9.2,'' R(1300):'',E9.2,'' H2+'',E9.2,''  HeTri:'',E8.2)') 
     2 telec , thmin , chi*6.71e-24 , ch2pls*7e-18 ,
     3 tautot(nhei3,1)/fcon
*
      write(qq,'(''  Pfa:'',1P,E8.2,''   Pa:'',E8.2,''   Ba:'',E8.2,
     1''   Hb:'',E8.2,''  La:'',E8.2,
     1''   1r:'',E9.3,''  1.8:'',E8.2,''  4.:'',E9.3)')
     3 tautot(iphl(5,4),1)/fcon,tautot(iphl(4,3),1)/fcon,
     3 tautot(iphl(3,2),1)/fcon, tautot(iphl(4,2),1)/fcon,
     4 tautot(iphl(2,1),1)/fcon, tautot(ipHn(1),1)/fcon,
     5 tautot(nhe1(1),1)/fcon, tautot(nhe2(1),1)/fcon
*
*     print optical depths of previous iteration
      write(qq,'('' Line Optical Depths: 10830:'',1P,E9.2,''  3889:'',
     1 E9.2,''  5876:'',E9.2,''  7065:'',E9.2,'' 2.06m'',E9.2)')
     2 t10830(ipLnTauIn)/flin,t3889(ipLnTauIn)/flin,
     3 t5876(ipLnTauIn)/flin, t7065(ipLnTauIn)/flin ,
     3 t206(ipLnTauIn)/flin
*
      call prtmet
*
      write(qq,'(/'' Old hydro optical depths:'',8(I4,1P,E9.2))')
     2 (i,tauabs(ipHn(i),2)/fcon,i=1,8)
      write(qq,'('' New hydro optical depths:'',8(I4,1P,E9.2))')
     2 (i,tauabs(ipHn(i),1)/fcon,i=1,8)
*
      write(qq,'(14X,''Old H Lines:'',8(I2,''-'',I1,1p,E9.2))')
     2 (i+1,i,htlim(i+1,i)/flin,i=1,8)
      write(qq,'(14X,''New H Lines:'',8(I2,''-'',I1,1p,E9.2))')
     2 (i+1,i,htau(i+1,i)/flin,i=1,8)
*
      write(qq,'('' Old He Is optical depths:'',8(I4,1P,E9.2))')
     2 (i,tauabs(nhe1(i),2)/fcon,i=1,8)
      write(qq,'('' New He Is optical depths:'',8(I4,1P,E9.2))')
     2 (i,tauabs(nhe1(i),1)/fcon,i=1,8)
*
      write(qq,'(10X,''Old He Is Lines:'',8(I2,''-'',I1,1p,E9.2))')
     2 (i+1,i,he1lim(i+1,i)/flin,i=1,8)
      write(qq,'(10X,''New He Is Lines:'',8(I2,''-'',I1,1p,E9.2))')
     2 (i+1,i,he1tau(i+1,i)/flin,i=1,8)
*
      write(qq,'('' Old He II optical depths:'',8(I4,1P,E9.2))')
     2 (i,tauabs(nhe2(i),2)/fcon,i=1,8)
      write(qq,'('' New HE II optical depths:'',8(I4,1P,E9.2))')
     2 (i,tauabs(nhe2(i),1)/fcon,i=1,8)
*
      write(qq,'(10X,''Old He II Lines:'',8(I2,''-'',I1,1p,E9.2))')
     2 (i+1,i,he2lim(i+1,i)/flin,i=1,8)
      write(qq,'(10X,''New He II Lines:'',8(I2,''-'',I1,1p,E9.2))')
     2 (i+1,i,he2tau(i+1,i)/flin,i=1,8)
*
      end
