******************************************************************************
      subroutine PrtLinePres
      implicit none
*print line radiation pressures for current conditions
      include "amu.par"
      include "bltzman.par"
      include "nta.par"
      include "limelm.par"
      include "ipLnArry.par"
      include "nwindline.par"
      include "prdcap.com"
      include "radpon.com"
      include "prad.com"
      include "iprdmx.com"
      include "IterCnt.com"
      include "phycon.com"
      include "h.com"
      include "he.com"
      include "hmi.com"
      include "densty.com"
      include "conprs.com"
      include "pinteg.com"
      include "hvmolEXP.com"
      include "totnuc.com"
      include "IonFracs.com"
      include "AtomcWgt.com"
      include "TLineARR.com"
      include "WindData.com"
      include "IOqq.com"
*
*     local variables
      real WidthLine , RadPres1, thresh
      integer i,ip , nline 
      parameter (thresh=0.05 , nline=20)
      integer iwl(nline) , iWavLen
      character chLab(nline)*4 , chIonLbl*4
      real frac(nline)
*
*     this routine only called if printout of contributors to line
*     radiation pressure is desired
*
*     plines(1)=l-alpha,          in hlevel(ionize)
*     plines(2) = hign n lyman ;   plines(3)=excit h lines iN HLEVEL
*     plines(4) = he i 10830
*     plines(5)= HeII 304 plines(11)=HeI La (in helium) 
*     plines(6)= HeI 584

*     compute radiation pressure due to special H and He lines
      ip = 0
      if( RadPres.gt.1e-30 ) then
        do i=1,20
          if( plines(i).gt.RadPres*thresh ) then
            ip = ip + 1
            if( i.eq.1 ) then
              iwl(ip) = 1216
              chLab(ip) = 'H  1'
              frac(ip) = plines(i)/RadPres
            else if( i.eq.2 ) then
              iwl(ip) = 1034
              chLab(ip) = 'H  1'
              frac(ip) = plines(i)/RadPres
            else if( i.eq.3 ) then
              iwl(ip) = 6563
              chLab(ip) = 'H  1'
              frac(ip) = plines(i)/RadPres
            else if( i.eq.4 ) then
              iwl(ip) = 10830
              chLab(ip) = 'He 1'
              frac(ip) = plines(i)/RadPres
            else if( i.eq.5 ) then
              iwl(ip) = 304
              chLab(ip) = 'He 2'
              frac(ip) = plines(i)/RadPres
            else if( i.eq.6 ) then
              iwl(ip) = 584
              chLab(ip) = 'He 1'
              frac(ip) = plines(i)/RadPres
            else
              write(qq,'('' PrtLinePres insanity'')')
              stop
            endif
          endif
        end do
*
*       line radiation pressure from large set of level 1 lines
        do i=1,nTauLines
          if( TauLines(ipLnPopu,i).gt.1e-30 ) then
            RadPres1 = 5.551e-2*((TauLines(ipLnEnrWN,i)/1.e6)**4)*
     1      ( TauLines(ipLnPopu,i) / TauLines(ipLnGu,i) ) /
     2      ( TauLines(ipLnPopl,i) / TauLines(ipLnGl,i) ) *
     2      WidthLine(TauLines(1,i)) * 2.
          else
            RadPres1 = 0.
          endif
          if( RadPres1.gt.RadPres*thresh ) then
            ip = min(20 , ip+1 )
            iwl(ip) = iWavLen( TauLines(1,i) )
            chLab(ip) = chIonLbl(TauLines(1,i))
            frac(ip) = RadPres1/RadPres
          endif
        end do
        do i=1,NWINDLINE*nWindOn
          if( WindLine(ipLnPopu,i).gt.1e-30 ) then
            RadPres1 = 5.551e-2*((WindLine(ipLnEnrWN,i)/1.e6)**4)*
     1      ( WindLine(ipLnPopu,i) / WindLine(ipLnGu,i) ) /
     2      ( WindLine(ipLnPopl,i) / WindLine(ipLnGl,i) ) *
     2      WidthLine(WindLine(1,i)) * 2.
          else
            RadPres1 = 0.
          endif
          if( RadPres1.gt.RadPres*thresh ) then
            ip = min(20 , ip+1 )
            iwl(ip) = iWavLen( WindLine(1,i) )
            chLab(ip) = chIonLbl(WindLine(1,i))
            frac(ip) = RadPres1/RadPres
          endif
        end do
*
*       now print them
        write(qq,'('' P(Lines):'',6(0p,f8.2,1x,a4,i5,'',''))')
     1   (frac(i),chLab(i),iwl(i),i=1,ip)
      end if
*
      end
