**************************************************************
      subroutine qheat1(ndust1,tmean,ted1)
      implicit none
*one of Kevin Volk's quantum heating routines for grains
      integer ndust1
      real tmean, ted1
      include "ndust.par"
      include "ncell.par"
      include "nqgrid.par"
      include "ndems.par"
      include "qheat2.com"
      include "dstop.com"
      include "rfield.com"
      include "ots.com"
      include "phycon.com"
      include "dustems.com"
      include "corind.com"
      include "dstbug.com"
      include "trace.com"
      include "SummdCon.com"
      include "dstfac.com"
      include "IOqq.com"
*
*     local variables
      real bval(nqgrid,nqgrid),prob(nqgrid),u1(nqgrid)
      real aval(nqgrid),delu(nqgrid),tval(nqgrid) , qtmax1
      real corsav(ncell),conv,value,fract,x,convi
      integer j,k,l,i1,i
      logical lgHit
      real pmax,term,sum,sum1,umax,umin,ufunct,y,
     1 dintg,scale
*
      if( lgTrace.and.lgDustBug) then
        write(qq,'(''    qheat1 called grain'',i3)')
     1  ndust1
      endif
*
      scale=qhnrat(ndust1)/qdep(ndust1)
*
      do j=1,ncell
        corsav(j) = ContBoltz(j)
      end do
*
      conv=4.5911e+10
* conversion from ergs to rydberg energy units
      convi=1./conv
*
* total collisional heating in rydb/s/h atom
*          etot=qcu1/4.
*
*          do j=1,nflux
*          value=(flux(j)+otslin(j)+outcon(j)+otscon(j))*
*     c           dstab1(j,ndust1)*anu(j)
*          etot=etot+value*hden*dstAbund(j)
*          end do
*
*     do j=1,nflux-1
*     >>chng 97 july 17, restructure to get rid of go to
      qdudt0 = qcu1
      j = 1
      do while( anu(j).lt.qwavec )
*       if (anu(j).lt.qwavec) then
*         value = (flux(j)+otslin(j)+outcon(j)+otscon(j))*
*         >>chng 97 July 17, to summed continuum
          value = SummedCon(j) * dstab1(j,ndust1)*anu(j)
          qdudt0 = qdudt0+value*hden*4.
*       end if
        j = j + 1
      end do
*
*     j now points to above qwavec
      value = SummedCon(j) * dstab1(j,ndust1)*anu(j)
      fract = (qwavec-anu(j-1))/(anu(j)-anu(j-1))
      value = value*fract
      qdudt0 = qdudt0+value*hden*4. * dstAbund(ndust1)
*
*     >>chng 97 july 17, divide out variable abundances
      x =log10(convi*qdudt0/hden/dstAbund(ndust1) )
      call splint(dstems(1,ndust1),dsttmp,dstslp(1,ndust1),
     c            ndems,x,y)
      qtmin =10.**y
*
      qtmax1 =min(20.*ted1,qtmax)
      if (qtmin.gt.qtmax) then
* error condition -- set temperature to the equilibrium value and exit
          qhprob(ndust1,1)=1.0
          qtemp(ndust1,1)=ted1
*
          do j=2,nqhg1
            qtemp(ndust1,j)=ted1
            qhprob(ndust1,j)=1.e-08
          end do
*     >>chng 97 mar 1, had not returned anything
          tmean = ted1
          if( lgTrace.and.lgDustBug)
     1    write(qq,'(''    qheat1 error returns too hot'')')
*
          return
      end if
      x=log(qtmax1/qtmin)/float(nqhg1-1)
      i=0
      prob(1)=qdudt0*scale
      tval(1)=qtmin
      u1(1)=ufunct(qtmin,ndust1)
*
      do j=2,nqhg1
      tval(j)=qtmin*exp(x*float(j-1))
      prob(j)=4.*conv*dintg(tval(j),ndust1,i)*scale
      u1(j)=ufunct(tval(j),ndust1)
      end do
*
      delu(1)=u1(2)-u1(1)
      delu(nqhg1)=u1(nqhg1)-u1(nqhg1-1)
      bval(nqhg1-1,nqhg1)=prob(nqhg1)-prob(1)
*
      do j=2,nqhg1-1
      bval(j-1,j)=prob(j)-prob(1)
      delu(j)=(u1(j+1)-u1(j-1))/2.
      end do
*
      do j=1,nqhg1-1
        do k=j+1,nqhg1
          umin=u1(k)-delu(k)/2.-u1(j)
          umax=u1(k)+delu(k)/2.-u1(j)
          if (k.eq.nqhg1) umax=100000.
          call nphot(umin,umax,bval(k,j),ndust1)
        end do
      end do
*
      do k=1,nqhg1
        term =log10(tval(k))
* interpolate to find the energy loss value at t = tval(k)
*
        i1=0
        lgHit = .false.
        j = 1
        do while( .not.lgHit .and. j.lt.ndems )
*     >>chng 97 jan 3, by gjf, to get rid of statement number
*       do j=1,ndems-1
          if (term.gt.dsttmp(j).and.term.le.dsttmp(j+1)) then
            fract =(term-dsttmp(j))/(dsttmp(j+1)-dsttmp(j))
            value =dstems(j,ndust1)+fract*(dstems(j+1,ndust1)-
     c      dstems(j,ndust1))
            i1 = 1
            lgHit = .true.
          end if
          j = j + 1
        end do
*
        if (i1.eq.1) then
          aval(k) =scale*conv*(10.**value)
        else
          aval(k) =scale*conv*(10.**dstems(1,ndust1))
        end if
      end do
*
      do j=nqhg1,2,-1
        aval(j)=aval(j)-aval(1)
        aval(j)=delu(j)/aval(j)
      end do
*
      aval(1)=0.
*
      do j=1,nqhg1-2
        do k=nqhg1-1,j+1,-1
          bval(k,j)=bval(k,j)+bval(k+1,j)
        end do
      end do
*
      prob(1)=1.0
      pmax=1.0
      sum=prob(1)
*
      do k=2,nqhg1
        prob(k)=0.
        do j=1,k-1
          prob(k)=prob(k)+prob(j)*bval(k,j)
        end do
        prob(k)=prob(k)*aval(k)
        sum=sum+prob(k)
        if (prob(k).gt.pmax) pmax=prob(k)
        if (pmax.gt.1.e+06) then
          value=1./pmax
          do l=1,k
            prob(l)=prob(l)*value
          end do
          sum=sum*value
          pmax=1.0
        end if
      end do
*
      sum=1./sum
*
      do j=1,nqhg1
        prob(j)=prob(j)*sum
      end do
*
      sum=0.
      sum1=0.
*
      do j=1,nqhg1
        sum=sum+prob(j)
        sum1=sum1+prob(j)*(tval(j)**4)
      end do
*
      tmean=(sum1**0.25)
*
      do j=1,nqhg1
        qtemp(ndust1,j)=tval(j)
        qhprob(ndust1,j)=prob(j)
* debugging aid
*      write(42,398) qtemp(ndust1,j),qhprob(ndust1,j)
* 398  format(1x,0pf8.3,1x,1pe12.5)
      end do
      do j=1,ncell
        ContBoltz(j)=corsav(j)
      end do
*
      if( lgTrace.and.lgDustBug)
     1 write(qq,'(''    qheat1 returns'',1p,2e10.2)') tmean,ted1
*
      end
