*****************************************************************************
      subroutine radinc
      implicit none
*do work associated with geometry increments of this zone
      include "pi.par"
      include "nta.par"
      include "SpeedLgt.par"
      include "itrdim.par"
      include "nopsv.par"
      include "bltzman.par"
      include "ncell.par"
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "rfield.com"
      include "diffus.com"
      include "ots.com"
      include "reflec.com"
      include "condif.com"
      include "occnum.com"
      include "tmn.com"
      include "exptau.com"
      include "e2tau.com"
      include "LineLabl.com"
      include "pnow.com"
      include "opac.com"
      include "tautot.com"
      include "deptau.com"
      include "scatop.com"
      include "timesc.com"
      include "PresInit.com"
      include "htau.com"
      include "iphl.com"
      include "he1tau.com"
      include "he2tau.com"
      include "drnxt.com"
      include "crsnut.com"
      include "ffheat.com"
      include "r1r0sq.com"
      include "scaton.com"
      include "hlmax.com"
      include "hcbr.com"
      include "phlevl.com"
      include "phe1lv.com"
      include "phe2lv.com"
      include "uspher.com"
      include "conbug.com"
      include "neutrn.com"
      include "hebug.com"
      include "opcbug.com"
      include "trace.com"
      include "nebug.com"
      include "sphere.com"
      include "TePowers.com"
      include "pwind.com"
      include "ZoneCnt.com"
      include "he.com"
      include "heat.com"
      include "h.com"
      include "phycon.com"
      include "radius.com"
      include "hcolrt.com"
      include "en1ryd.par"
      include "densty.com"
      include "pbowen.com"
      include "prad.com"
      include "nh.com"
      include "thlo.com"
      include "the1lo.com"
      include "the2lo.com"
      include "iphop.com"
      include "opsv.com"
      include "cover.com"
      include "dRdVeff.com"
      include "pinteg.com"
      include "drsign.com"
      include "ednbad.com"
      include "called.com"
      include "iondun.com"
      include "opcneg.com"
      include "facexp.com"
      include "erredn.com"
      include "IterCnt.com"
      include "TrueEden.com"
      include "prslim.com"
      include "Angllum.com"
      include "tcool.com"
      include "tfail.com"
      include "nustbl.com"
      include "HPhoto.com"
      include "IOqq.com"
*
*     local variables
      integer i,n
      real aa,rfac,rforce,escatc,tnew,sexp,
     1 flx,crs,hlrate , relec,e2,opfac,t,forlin
*     real bscat
      real dReffAver , drTau
      save dReffAver
      save rfac
      real scatsv(ncell) , tmnold
      logical lgFlxNeg
*---------------------------------------------------------------------
*
*     when this sub is called RADIUS is the outer edge of zone
*
      if( lgTrace ) write(qq,'('' radinc called; radius='',1P,E10.3,
     1'' rinner='',
     1E10.3,'' DRAD='',E10.3,'' drNext='',E10.3,'' ROUTER='',E10.3,
     2'' DEPTH='',E10.3)') radius,rinner,drad,drNext,router(iter),depth
*
*     check whether temp ever drops below lowest for matrix
      if( te.le.thlo ) nhlo = nhlo + 1
      if( te.le.the1lo ) nhe1lo = nhe1lo + 1
      if( te.le.the2lo ) nhe2lo = nhe2lo + 1
*
*     check cooling time for this zone, remember longest
      aa = ttherm
      ttherm = max( ttherm, 1.5*pden*Boltzmann*te/ctot)
*
*     keep track of high and low deviations of pressures
      plow = min( plow , (PressureInit+pinteg)/pnow )
      phi = max( phi , (PressureInit+pinteg)/pnow )
*
*     increment counter if this zone possibly thermally unstable
*     this flag was set in ionte, deriv of heating and cooling negative
      if( lgUnstable ) nUnstable = nUnstable + 1
*
*     this is a redundant check that electron density is converged
      if( lgTrace.and.lgNeBug ) then
        write(qq,'('' radinc the correct electron density was'',
     1  1P,E11.4,'' and the assumed value was'',E11.4)') EdenTrue , eden
      endif
*     check on IONDON since somethings get here with trouble after
*     a temperature failure
      if( abs(EdenTrue-eden)/eden .gt.EdenError ) then
        if( lgIonDone .and. (.not.lgTeFail) ) then
*         this is a serious error, both ionizaiton and temperature were
*         converged but electron density is incorrect
          if(lgTalk)write(qq,'('' In radinc the correct electron '',
     1    ''density was'',1P,E11.4,'' but the assumed value was'',E11.4,
     2    '' zone='',i3)') EdenTrue , eden , nzone
          lgEdenBad = .true.
*         remember first bad electron density zone number
          if(nzEdenBad.eq.0) nzEdenBad = nzone
        else
*         electron density wrong but either ionizaiton or temperature
*         failure was detected
          if(lgTalk) then
            write(qq,'('' In radinc the correct electron '',
     1      ''density was'',1P,E11.4,'' but the assumed value was'',
     2      E11.4,'' zone='',I3,''.'')')
     3      EdenTrue , eden , nzone
            if(lgTeFail)write(qq,'('' Due to temperature failure??'')')
            if(.not.lgIonDone)
     1      write(qq,'('' Due to ionization failure??'')')
          endif
        endif
      endif
*
*     find Stromgren radius
      if( .not.lgUSphON .and. hi/hden.gt.0.49 ) then
         rstrom = radius
         lgUSphON = .true.
      endif
*
*     ratio of inner to outer radii, at this point
*     radius is the outer radius of this zone
      rfac = ( (radius-drad*dRadSign) / radius ) ** 2
*
      if( nzone.le. 1 ) then
        dReffAver = dRNeff
      else
*       this is to damp out feedback between nextdr and tmn
*       caused heating and dr to oscillate
        dReffAver = 0.8 * dReffAver + 0.2 * dRNeff
      endif
*
      relec = 0.
      rforce = 0.
*
*     print out arrays if TRACE OPACITIES is true
      if( lgTrace.and.lgOpacBug ) then
        write(qq,'(/1X,''Energy, TMN(old), flux, opacity:'')')
        write(qq,'(3(I5,1P,4E9.2))') (i,anu(i),tmn(i),flux(i),opac(i)
     1  ,i=1,nflux)
      else if( lgTrace.and.lgConBug ) then
        write(qq,'(1X,''Energy, flux, OTS:'')')
        write(qq,'(1P,4(I6,3E9.2))') (i,anu(i),
     1  flux(i)+outlin(i)+outcon(i),
     1  otscon(i)+ otslin(i),i=1, nflux)
      endif
*
*     diffuse continua factor
*     if lgSphere then all diffuse radiation is outward (COVRT=1)
*     lgSphere not set then COVRT=0.0
*
*begin sanity check
      lgFlxNeg = .false.
      do i=1,nflux
        if( flux(i).lt.0. ) then
          write(qq,'('' radinc finds negative intensity in flux.'')')
          write(qq,'('' Intensity, frequency, pointer='',1P,2E11.3,I6)')
     1    flux(i), anu(i), i
          lgFlxNeg = .true.
        endif
        if( otscon(i).lt.0. ) then
          write(qq,'('' radinc finds negative intensity in otscon.'')')
          write(qq,'('' Intensity, frequency, pointer='',1P,2E11.3,I6)')
     1    otscon(i), anu(i), i
          lgFlxNeg = .true.
        endif
        if( tmn(i).lt.0. ) then
          write(qq,'('' radinc finds negative tmn.'')')
          write(qq,'('' value, frequency, pointer='',1p,2e11.3,
     1    i6,1x,a4)') tmn(i), anu(i), i , chLineLabel(i)
          lgFlxNeg = .true.
        endif
        if( otslin(i).lt.0. ) then
          write(qq,'('' radinc finds negative intensity in otslin.'')')
          write(qq,'('' Intensity, frequency, pointer='',1p,2e11.3,
     1    i6,1x,a4)') otslin(i), anu(i), i , chLineLabel(i)
          lgFlxNeg = .true.
        endif
        if( outlin(i).lt.0. ) then
          write(qq,'('' radinc finds negative intensity in outlin.'')')
          write(qq,'('' Intensity, frequency, pointer='',1p,2e11.3,
     1    i6,1x,a4)') outlin(i), anu(i), i , chLineLabel(i)
          lgFlxNeg = .true.
        endif
        if( outcon(i).lt.0. ) then
          write(qq,'('' radinc finds negative intensity in outcon.'')')
          write(qq,'('' Intensity, frequency, pointer='',1p,2e11.3,
     1    i6,1x,a4)') outcon(i), anu(i), i , chContLabel(i)
          lgFlxNeg = .true.
        endif
        if(opac(i).lt.0.)  then
          lgOpacNeg = .true.
*         this sub will punch negative opacities on io unit,
*         iff 'set negopc' command was given
          call pnegopc
        endif
      end do
      if(lgFlxNeg) then
        write(qq,'('' Insanity has occurred, this is zone'',i4)')nzone
        call ShowMe
        stop
      endif
*end sanity check
*
*     attenuate the flux array after doing radiative acceleration
      escatc = 6.65e-25 * eden
*     AngleIllum is 1/cos(theta)
      drTau = dReff * AngleIllum
      do i=1,nflux
*       sum total continuous optical depths
        tauabs(i,1) = tauabs(i,1) + opac(i) * dReff
*       following only depth to illuminated face
        depabs(i) = depabs(i) + opac(i) * dReff
        tausct(i,1) = tausct(i,1) + scatop(i) * dReff
        depsct(i) = depsct(i) + scatop(i) * dReff
        tautot(i,1) = tauabs(i,1) + tausct(i,1)
*
*       TMN is array of scale factors which account for attenuation
*       of continuum across the zone (necessary to conserve energy
*       at the 1% - 5% level.) sphere effects in
*       drNext was set by NEXTDR and will be next dr
*       compute both total and thompson scat rad acceleration
        rforce = rforce +
     1  (flux(i)+outlin(i)+outcon(i)+ContDiff(i))*anu(i)*
     1  (opac(i)+scatop(i))
        relec = relec  + ((flux(i)+outlin(i)+outcon(i)+ContDiff(i))*
     1  escatc) * anu(i)
*       this will be the optical thickness of the next zone
*       >>chng 97 apr 10, added AngleIllum, usually 1,
*       reset with illuminate command
        tnew = opac(i) * dReffAver * AngleIllum
        tmnold = tmn(i)
        if( tnew.lt.0.10 ) then
*       >>chng 96 march 20, make no larger than 0.99 to avoid oscillations
*         following is third order expansion of (1-EXP(-TNEW))/TNEW
*         off by 1% at .3
          tmn(i) = (1. - tnew/24.*(12.-tnew*(4.-tnew)) )
*         tmn(i) = max(0.99, (1. - tnew/24.*(12.-tnew*(4.-tnew)) ) )
        else if( tnew.gt.5. ) then
          tmn(i) = 1. / tnew
        else
          tmn(i) = (1. - exp(-tnew) ) / tnew
        endif
*       approximate correction for sphericity
        tmn(i) = tmn(i) * radius/(radius+dReffAver)
*       attenuation of flux by optical depths IN THIS ZONE
*       >>chng 97 apr 3, from dReff to drTau, with AngleIllum
*       ExpZone(i) = sexp(opac(i)*dReff)
        ExpZone(i) = sexp(opac(i)*drTau)
*       e(-tau) in inward direction, up to illuminated face
        ExpmTau(i) = ExpmTau(i) * ExpZone(i)
*       e2(tau) in inward direction, up to illuminated face
        e2TauAbs(i) = e2( depabs(i)  , ExpmTau(i) )
*       rfac is square of ratio of inner to outer radius
*       opfac = ExpZone(i) *tmn(i)/tmnold*rfac
        opfac = ExpZone(i) *rfac * tmn(i) / tmnold
        flux(i) = flux(i) * opfac
        ContDiff(i) = ContDiff(i) * opfac
*       rec scale is shifted by one so as to not pick up rec twice
*       >>chng 96 may 8, had been max(1,i-1) so i=1 was hit twice
*       >>chng 96 aug 22, removed shift of one, don't remember why it was there
*       if( i.ge.2 ) then
*         outcon(i-1) = outcon(i-1) * opfac
*         outlin(i-1) = outlin(i-1) * opfac
*       endif
        outcon(i) = outcon(i) * opfac
        outlin(i) = outlin(i) * opfac
*
*       reset occupation numbers
        occnum(i) = flux(i) * convoc(i)
      end do
*     >>chng 96 aug 22, removed shift of one, don't remember why it was there
*     outcon(nflux) = outcon(nflux) * opfac
*     outlin(nflux) = outlin(nflux) * opfac
*
*     do scattering opacity, intensity goes as 1/(1+tau)
      if( lgScatON ) then
        do i=1,nflux
*         assume half forward scattering
*         opfac = 1. / ( 1. + dReff*0.5 * scatop(i) )
*         >>chng 97 Apr 25, remove .5 to get agreement with
*         Lightman and White formula
          opfac = 1. / ( 1. + dReff * scatop(i) )
          flux(i) = flux(i) * opfac
          ContDiff(i) = ContDiff(i) * opfac
          outcon(i) = outcon(i) * opfac
          outlin(i) = outlin(i) * opfac
*         dReff for following appears when it is used
*         >>chng 96 aug 21, extra factor of two in below
          scatsv(i) = (flux(i)+outcon(i))*scatop(i)
        end do
      else
        do i=1,nflux
          scatsv(i) = 0.
        end do
      endif
*
*     now do slight reshuffling of energy due to compton scattering
      call cmshft
*
      relec = relec * en1ryd
*     radiative acceleration; xMassDensity is gm per cc, eval when PTOT called
      t = 1. / SpeedLight / xMassDensity
      AccelLine = forlin() * t
      AccelCont = rforce * en1ryd * t
      AccelTot = AccelCont + AccelLine
      AccelMax = max( AccelMax , AccelTot )
*666  write(6,*) AccelCont /AccelTot,AccelLine /AccelTot
*     force multiplier; RELEC*T can be zero for N=10^5 and low rad field
      if( relec*t .gt.0. ) then
        fmul = ( AccelLine + AccelCont ) / (relec*t)
      else
        fmul = 0.
      endif
*
*     following is integral of radiative force
      pinzon = AccelTot * xMassDensity * drTau
      pinteg = pinteg + pinzon
*
*     attenuate neutrons if they are present
      if( lgNeutrnHeatOn ) then
*       correct for optical depth effects
        totneu = totneu * sexp( CrsSecNeutron*hden * drTau)
*       correct for spherical effects
        totneu = totneu * rfac
      endif
*
*     following rad factors are extinguished by 1/r**2 and e- opacity
*     also bound electrons
*     if( lgScatON ) then
*       following has bound electrons, for use above 2kev
*       bscat = 1. / ( 1. + dReff * (eden+hi) * 3e-25 )
*     else
*       bscat = 1.
*     endif
*
*---------------------------------------------------------------------
*
*     do all emergent continua if model is NOT spherical
      if( .not.lgSphere ) then
        do i=1,nflux
          if( tauabs(i,1).lt.30. ) then
*           DiffCont is diffuse emission per unit vol, fill fac
*           the 1/2 comes from isotropic emission
*           scatsv(i) = (flux(i)+outcon(i))*0.5*scatop(i)
*           >>chng 97 apr 25, remove fac of 2 to
*           get agreement wth lightman&white
*           flx = (DiffCont(i)+scatsv(i)) * dReff *e2TauAbs(i)
*           >>chng 97 may 8, needed 1/2 in front of DiffCont 
*           had been there, but also with scatsv, and lost both
*           when /2 removed to get agreement with lightman and white
            flx = (DiffCont(i)/2.+scatsv(i)) * dReff *e2TauAbs(i)
*           flx = (DiffCont(i)+scatsv(i)) * dReff/2. *e2TauAbs(i)
*           refcon - reflected diffuse plus back-scattered incident cont
            refcon(i) = refcon(i) + flx * r1r0sq
*           >>chng 97 apr 25, remove fac of 2 to get
*           agreement wth lightman&white
            reflin(i) = reflin(i) + 
     1      outlin(i)*scatop(i)*dReff*e2TauAbs(i)*r1r0sq
*    1      outlin(i)*0.5*scatop(i)*dReff*e2TauAbs(i)*r1r0sq
            reflux(i) = reflux(i) + 
     1        flux(i)*scatop(i)*dReff*e2TauAbs(i)*r1r0sq
*    1        flux(i)*0.5*scatop(i)*dReff*e2TauAbs(i)*r1r0sq
          endif
        end do
      endif
*
*     remember largest line photoionization rate for COMNT
      do n=2,nhlvl-3
        crs = OpacStack( iphl(n,n-1)-ipHn(n+1)+iphop(n+1) )
        hlrate = otslin( iphl(n,n-1) ) * crs
        hlmax(n) = max( hlmax(n) , hlrate/max(1e-30,hgamnc(n) +
     1  eden*hcoldn(n) + hradn(n) ) )
      end do
*
      ffhtot = ffhtot + FreeFreeHeat * dVeff
*
*     diffuse fields of heavy elements, outward beams
*     NB this one only can be evaluated once per zone, since phtons
*     added to outward beam!
*     >>chng 97 jul 30, moved out to cloudy
*     call metdif
*
      if( lgTrace ) write(qq,'('' radinc returns'')')
*
      end
