******************************************************************************
      subroutine readck( nqh )
      implicit none
*check for sanity after commands all read in
      integer nqh
*
      include "itrdim.par"
      include "limspc.par"
      include "spec.com"
      include "radius.com"
      include "ninput.com"
      include "phycon.com"
      include "called.com"
      include "IOqq.com"
*
*     lgPstop says that not enough info for model, so stop
      logical lgStop , lgPstop
      real ck
*
      lgStop = .false.
*
*     NSAVE is number of lines saved, =0 if no commands entered
      if( nSave.le.0 ) then
        write(qq,'('' No commands were entered - whats up?'')')
        stop
      endif
*
      lgPstop = .false.
*     check hden within range.
      if( hden.eq.-99. ) then
        write(qq,'('' Hydrogen density MUST be specified.'')')
        lgPstop = .true.
        lgStop = .true.
      else
        if( lgTalk.and. (hden.lt.-4. .or. hden.gt.15.)) then
          write(qq,'(/'' Is this value of the H-density reasonable?'')')
          write(qq,'(''  The code may not run for extreme densities'')')
        endif
      endif
*
*     is the model going to crash?
      if( lgTalk.and. .not. lgStop ) then 
        ck = 1e-37
        ck = ck / 1e30
        if( ck.eq.0. .and.((hden.lt.-5.3).or.(hden.gt.19.2)) ) then
          write(qq,'('' Simulation may crash because of extreme''
     2    ,'' density.  Do not use a 32-bit machine, or make '',
     3    ''everything double precision.'')')
          write(qq,'(''   '')')
        endif
      endif
*
      if( lgTalk.and. hden.gt.24. ) then
        write(qq,'('' You must be kidding about this density. '',
     1  '' Use ATLAS instead.'')')
      endif
*
      if( nspec.eq.0  ) then
        write(qq,'('' Type of continuum MUST be specified.'')')
        lgStop = .true.
        lgPstop = .true.
      endif
*
      if( nqh.eq.0  ) then
        write(qq,'('' Luminosity of continuum MUST be specified.'')')
        lgStop = .true.
        lgPstop = .true.
      endif
*
      if( radius.eq.0. ) then
        write(qq,'('' Starting radius MUST be specified.'')')
        lgStop = .true.
        lgPstop = .true.
      endif
*
      if( nspec.ne.nqh ) then
         write(qq,'('' There were not the same number of continuum '',
     1   ''shapes and luminosities entered.'')')
         lgStop = .true.
      endif
*
      if( lgPstop ) then
        write(qq,'('' Insufficient information for model, STOP.'')')
        stop
      endif
*
      if( lgStop ) then
        stop
      else
        return
      endif
*
      end
