******************************************************************************
      subroutine readr
      implicit none
*main command line parser, decode command, then call other routines to read
      include "ndplot.par"
      include "itrdim.par"
      include "nfudgc.par"
      include "ndust.par"
      include "limext.par"
      include "nqgrid.par"
      include "limpar.par"
      include "nkrd.par"
      include "limspc.par"
      include "pi.par"
      include "windok.com"
      include "abnslr.com"
      include "supdie.com"
      include "out2in.com"
      include "tropt.com"
      include "noptim.com"
      include "ploton.com"
      include "trovrd.com"
      include "cludon.com"
      include "bounds.com"
      include "physok.com"
      include "double.com"
      include "trace.com"
      include "forcte.com"
      include "casbhs.com"
      include "called.com"
      include "cover.com"
      include "extinc.com"
      include "toler.com"
      include "taumin.com"
      include "wind.com"
      include "prad.com"
      include "turhet.com"
      include "hextra.com"
      include "sdrmin.com"
      include "telow.com"
      include "cylind.com"
      include "cyclot.com"
      include "limfal.com"
      include "IterCnt.com"
      include "autoit.com"
      include "turb.com"
      include "timed.com"
      include "caseb.com"
      include "thigh.com"
      include "radius.com"
      include "ninput.com"
      include "input.com"
      include "cpres.com"
      include "qs.com"
      include "edxtra.com"
      include "phycon.com"
      include "range.com"
      include "spnorm.com"
      include "spec.com"
      include "sptype.com"
      include "filfac.com"
      include "fudgec.com"
      include "redis.com"
      include "date.com"
      include "rdfalt.com"
      include "neutrn.com"
      include "nvary.com"
      include "vformt.com"
      include "varang.com"
      include "nvfpnt.com"
      include "vparm.com"
      include "readin.com"
      include "varon.com"
      include "dtrans.com"
      include "cextra.com"
      include "vrrfit.com"
      include "BetaVer.com"
      include "qheat.com"
      include "qheat2.com"
      include "OrgCard.com"
      include "Angllum.com"
      include "IOqq.com"
*
*     local variables
      integer i , nqh , j , nTabRead,iopt
      real fread , ar1,teset,a,z,fabden,tabden
      logical lgEOL , lgMatch , lgEOF , lgDSet ,lgQHet
      logical lgNu2
      logical lgNoInit
      character  chCard*80, chKey4*4 , chKey3*3 , chKey5*5,chK1*1
      save lgNoInit
      data lgNoInit/.true./
*
*     check if lgScanar is false, if not return
*     lgScanar is set by cdinit, the first step in calling
*     the code as a subroutine
*     if( .not.lgScanar ) return
*
*     following says abundances are solar 
      lgAbnSolar = .true.
      lgPlotON = .false.
      nplot = 0
      lgDSet = .false.
      radius = 0.
      rinner = 0.
      nqh = 0
      nspec = 0
*     this is check that two table reads are not entered
      nTabRead = 0
      do i=1,limspc
        chRSpec(i) = 'UNKN'
      end do
      nparm = 0
*
*     this is an option to turn on trace printout on the nth
*     call from the optimizer
      if( lgTrOpt ) then
*       nTrOpt was set with "optimize trace" command,
*       is iteration to turn on trace
        if( nTrOpt.eq.noptim ) then
          lgTrace = .true.
          lgTalk = .true.
          lgTrOvrd = .true.
          write(qq,'('' READR turns on trace from optimize option.'')'
     1    )
        endif
      endif
*
      if( nBetaVer.gt.0 ) write(qq,'(/24x,''This is a beta test '',
     1''version of the code, and should not be used for publications.''/
     2)')
*
      if( lgTalk ) write(qq,'(57X,''Cloudy '',a7//23X,38(''*''),a7,
     1 38(''*''),/23X,''*'',81X,''*'')') chVersion , chDate
*
*     following signals which read is in progress,
*     1 is forward read, of input commands
*     -1 is reverse read from bottom of line array, of cloudy.ini file
      iReadWay = 1
*     initialize array reader, this sub does nothing but set
*     initial value of a variable, depending on value of iReadWay
      call rdinit
*
*     read until eof or blank line, than branch to 999
      call readar( chCard , lgEOF )
*     line starting with blank is eof
      do while( .not.lgEOF .and. chCard(1:1).ne.' ')
*       echo the line before we cap it, and trim it
        if(lgTalk) write(qq,'(23X,''*'',1X,A80,''*'')') chCard
*       change chCard to all caps after saving it
        call caps( chCard )
*       kill any part of line after one of end of line characters
*       do not do this if keyword no eol is no card
        if( .not. lgMatch('O EO',chCard) ) call TrimCard( chCard )
        chK1 = chCard(1:1)
        chKey4 = chCard(1:4)
        chKey3 = chCard(1:3)
        chKey5 = chCard(1:5)
*
*       check whether VARY is on line
        if( lgMatch( 'VARY' , chCard ) ) then
          lgVarOn = .true.
          if( nparm+1.gt.limpar ) then
            write(qq,'('' Too many VARY lines entered; the limit is'',
     1      i4)') limpar
            stop
          endif
        else
          lgVarOn = .false.
        endif
*
*     totally ignore lines starting with 'c ' and assert commands
      if( (chCard(1:2).eq.'C ') .or. (chKey4.eq.'ASSE') ) then
*       this is null test
        i = 1
*
*     start to look for keywords
      else IF( chKey4.eq.'ABSO' ) then
*       enter luminosity in absolute magnitudes, in reads2
        call absmag( chCard , nqh )
*
      else if( chKey3.eq.'AGE' ) then
*       enter age of cloud so we can check for time-steady reads2
        call GetAge( chCard )
*
      else if( chKey4.eq.'AGN ' ) then
*       enter generic style agn continuum, in reads2
        call GetAgn( chCard )
*
      else if( chKey4.eq.'ABUN' ) then
*       chemical composition, readsun
        call compos( chCard , lgDSet )
*       abundances no longer solar
        lgAbnSolar = .false.
*
      else if( chKey4.eq.'BACK' ) then
*       cosmic background, in readsun
        call backgr( nqh , chCard , ar1 )
*
      else if( chKey4.eq.'BLAC' ) then
*       black body, in reads2
        call blacfx( chCard , nqh , ar1 )
*       vary option
        if( lgVarOn ) then
          nparm = nparm + 1
*         no luminosity options on vary
          nvarxt(nparm) = 1
          chVarFmt(nparm) = '(''BLACKbody='',F15.5)'
*         pointer to where to write
          nvfpnt(nparm) = nRead
*         log of temp will be pointer
          vparm(nparm,1) = log10( slope(nspec) )
          vincr(nparm) = 0.5
        endif
*
      else if( chKey4.eq.'BREM' ) then
*       brems continuum from central object
        nspec = nspec + 1
        if( nspec.gt.limspc) call TooManCon
        chSpType(nspec) = 'BREMS'
        i = 5
        slope(nspec) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
*       t can be entered either as t or log(t)
        if( slope(nspec).le.10. ) slope(nspec)=10.**slope(nspec)
        cutoff(nspec,1) = 0.
        if( lgVarOn ) then
           nparm = nparm + 1
*          only one parameter
           nvarxt(nparm) = 1
           chVarFmt(nparm) = '(''BREMS, T='',F9.5)'
*          pointer to where to write
           nvfpnt(nparm) = nRead
*          log of temp will be pointer
           vparm(nparm,1) = log10( slope(nspec) )
           vincr(nparm) = 0.5
         endif
*
      else if( chKey4.eq.'CASE' ) then
*       do case b - set tau-La to 10**9 if not specified
        lgCaseb = .true.
        i = 5
        tlamin = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          tlamin = 1e9
        else
          tlamin = 10. ** tlamin
        endif
*       Hummer and Storey case B; no collisions from n=1, 2 (usually in)
        if( lgMatch('HUMM',chCard ) ) lgCasBhs = .true.
*
      else if( chKey4.eq.'CEXT' ) then
*       add "extra" cooling, power law temp dependence
        lgCExtraOn = .true.
        i = 5
        CoolExtra = 10.**fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
        cextpw = fread( chCard , i , 76 , lgEOL )
*
      else if( chKey4.eq.'COMP' ) then
*       compile ascii version of stellar atmosphere continua in volk
        call compil( chCard )
*
      else if( chKey4.eq.'CONS' ) then
*       constant temperature, pressure, density, or gas pressure
*       in readsun
        call constn( chCard )
*
      else if( chKey4.eq.'CORO' ) then
*        coronal equilibrium; set constant temperature to number on line
*        in readsun
         call coronl( chCard , nqh , ar1 )
*
      else if( chKey4.eq.'COSM' ) then
*        C.R. heating, log of density of rel. electrons
         i = 5
         cryden = 10.** fread( chCard , i , 76 , lgEOL )
         if( lgEOL ) then
            if( lgMatch( 'BACK' , chCard ) ) then
*              galactic background cosmic ray density to produce
*              secondary ionization rate quoted by Tielens and Hollenbach
*              cryden = 2e-9
*              >>chng 99 jun 24, slight change to value
*              of 2.5e-17 s^-1 quoted by McKee, Astro-ph 9901370
               cryden = 2.65e-9
               crtemp = 2.6e9
            else
               call NoNumb(chCard )
            endif
         else
*           optional power law density 
            crpowr = fread( chCard , i , 76 , lgEOL )
*           option to specify a temp for non-rel electrons
            crtemp = fread( chCard , i , 76 , lgEOL )
            if( lgEOL ) then
*              relavistic limit (Balbus and McKee)
               crtemp = 2.6e9
            else
               crtemp = min( 10.**crtemp , 2.6e9 )
            endif
         endif
*
      else if( chKey4.eq.'COVE' ) then
*        covering factor for gas
         i = 5
         covgeo = fread( chCard , i , 76 , lgEOL )
         if( lgEOL ) call NoNumb(chCard )
         if( covgeo.le.0. ) covgeo = 10.** covgeo
         if( covgeo.gt.1. ) then
            write(qq,'('' A covering factor greater than 1 makes'',
     1      '' no physical sense.  Sorry.'')')
            stop
         endif
         covrt = covgeo
*
      else if( chKey4.eq.'CYLI' ) then
*       height of cylinder in cm
        i = 5
        lgCylnOn = .true.
        CylindHigh = 10.**fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
*
      else if( chKey4.eq.'DIEL' ) then
*       change various factors for dielectronic recombination
        if( lgMatch( 'KLUD' , chCard ) ) then
*       option to turn off guess of diel rec coef for 3rd row elements
          i = 3
          GuessDiel = fread( chCard , i , 76 , lgEOL )
        else if( lgMatch( 'BURG' , chCard ) ) then
*         modify suppression of burgess dielectronic recombinations
          if( lgMatch(' ON ' , chCard ) ) then
*           leave suppression on - this is default state
            lgSupDie(1) = .true.
          else if( lgMatch(' OFF' , chCard ) ) then
*           turn suppression off
            lgSupDie(1) = .false.
          else
            write(qq,'('' flag ON or OFF must appear.'')')
            stop
          endif
        else if( lgMatch( 'NUSS' , chCard ) ) then
*         modify suppression of nussbaumer and storey dielectronic recomb
          if( lgMatch(' ON ' , chCard ) ) then
*           turn suppression on
            lgSupDie(2) = .true.
          else if( lgMatch(' OFF' , chCard ) ) then
*           leave suppression off - this is default state
            lgSupDie(2) = .false.
          else
            write(qq,'('' flag ON or OFF must appear.'')')
            stop
          endif
        else
          write(qq,'('' key KLUDge, BURGess, or NUSSbaumer must '',
     1    ''appear.'')')
          stop
        endif
*
      else if( chKey4.eq.'DIFF' ) then
*        set method of transferring diffuse fields
         if( lgMatch( ' OTS' , chCard ) ) then
           chDffTrns = 'OTS'
         else if( lgMatch( ' OUT' , chCard ) ) then
           i = 4
           j = fread( chCard , i , 76 , lgEOL )
           if( lgEOL ) then
*            this is the default set in block data
             chDffTrns = 'OU2'
           else
             if( j.gt.0 .and. j.lt.10 ) then
               write(chDffTrns,'(''OU'',i1)') j
             else
               write(qq,'('' must be between 1 and 9 '')')
               stop
             endif
           endif
         else
           write(qq,'('' There should have been OUTward or OTS on '',
     1     ''this line.  Sorry.'')')
           stop
         endif
*
      else if( chKey4.eq.'DLAW' ) then
*       either use fabden routine, or read in table of points
*       >>chng 96 dec 12, broken out to routine
        call GetDLaw( chCard )
*
      else if( chKey4.eq.'DOUB' ) then
*       double optical depth scale after each iteration
        DoubleTau = 2.
*
      else if( chKey4.eq.'DRIV' ) then
*       call one of several drivers, readsun
        call driver( chCard )
*
      else if( chKey4.eq.'GRAI' ) then
*       read parameters dealing with grains, in reads2
        call GetGrain( chCard , lgDSet )
*
      else if( chKey4.eq.'EDEN' ) then
*       option to add "extra" electrons, to test compton limit
*       for very low T(star) - option is log of eden
        i = 5
        EdenExtra = 10.**fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
*       warn that this model is meaningless
        lgPhysOK = .false.
*
      else if( chKey4.eq.'ELEM' ) then
*       change abundance of specific element
*       in reads2.f
        call rdelem( chCard )
*
      else if( chKey4.eq.'ENER' ) then
*       energy density (degrees K) of this continuum source
        i = 5
        nqh = nqh + 1
        if( nqh.gt.limspc ) call TooManCon
        chRSpec(nqh) = 'SQCM'
        teset = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
        if( radius.eq.0. ) then
*         set radius to large value
          ar1 = rdfalt
          radius = 10.**ar1
        endif
*       convert temp to log, recognize linear option
        if( lgMatch( 'LINE' , chCard ).or.teset .gt.10. ) then
*         option for linear temperature, must store log
          teset = log10( teset )
        endif
        if(teset.gt.5. ) write(qq,'('' This intensity may be too '',
     1  ''large.  The code may crash due to overflow.  Was log '',
     2  ''intended?'')')
*       teset is not log of temp, now get log of total luminosity
        chSpNorm(nqh) = 'LUMI'
*       full range of continuum will be used
        range(nqh,1) = emm
        range(nqh,2) = egamry
        totpow(nqh) = 4. * teset - 4.2464476 + 0.60206
*       vary option
        if( lgVarOn ) then
          nparm = nparm + 1
          chVarFmt(nparm) =
     1    '(''ENERGY DENSITY'',F9.5,'' log '')'
*         pointer to where to write
          nvfpnt(nparm) = nRead
          vparm(nparm,1) = log10( totpow(nqh) )
          vincr(nparm) = 0.1
          nvarxt(nparm) = 1
        endif
*
      else if( chKey4.eq.'ESCA' ) then
*       option to change escape probabilities, in reads2
        call esread( chCard )
*
      else if( chKey4.eq.'EXTI' ) then
*       extinguish ionizing continuum by absorbing column AFTER
*       setting luminosity or Q(H).  First number is the column
*       density (log), second number is leakage (def=0%)
*       last number is lowest energy (ryd), last two may be omitted
*       from right to left
        i = 5
        excolm = 10. ** fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
*       option to set leakage - default is 0.
        exleak = fread( chCard , i , 76 , lgEOL ) 
        if( lgEOL ) exleak = 0.
        if( exleak.lt.0. ) exleak = 10.**exleak
        if( exleak.gt.1. ) then
          if(lgTalk)write(qq,'('' A leakage of'',F9.0,''% was entered'',
     1     '' - this must be less than 100%'')') exleak*100.
          stop
        endif
*       option to set lowest energy for absorber
        exlow = fread( chCard , i , 76 , lgEOL ) 
        if( lgEOL ) then
          exlow = 0.99946
        else
          if(exlow.le.0. ) exlow=10.**exlow
          if( exlow.lt.0.99946 )
     1    write(qq,'('' Energy less than 1 Ryd!!'')')
        endif
*
      else if( chKey4.eq.'FAIL' ) then
*       reset number of temp failures allowed, default=20
        i = 5
*       save previous value
        j = limfal
        limfal = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
*       'no map' flag, fail without mapping
        if( lgMatch( 'NO M' , chCard ) ) then
          lgNoMap = .true.
        endif
*       complain if failures was increased above default
        if( limfal.gt.j ) then
          write(qq,'('' Cloudy should not have problems making '',
     1    ''this command necessary.'')')
          write(qq,'('' Please show this input stream to Gary Ferland''
     1    ,'' if this command is really needed for this model.'')')
        endif
*
      else if( chKey4.eq.'FEII' ) then
        call GetFeII( chCard )
*
      else if( chKey4.eq.'FILL' ) then
*       filling factor, power law exponent (default=1., 0.)
        i = 5
        a = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
        if( a.le.0. ) then
*          number less than or equal to 0, must have been entered as log
           FillFac = 10. ** a
        else
*          number greater than zero, must have been the real thing
           FillFac = a
           if( FillFac.gt.1.0 ) then
              if(lgTalk) then
                write(qq,'('' Filling factor > 1, reset to 1'')')
              endif
              FillFac = 1.
           endif
        endif
        fiscal = FillFac
*       option to have power law dependence
        filpow = fread( chCard , i , 76  , lgEOL )
*       vary option
        if( lgVarOn ) then
          nparm = nparm + 1
          chVarFmt(nparm) =
     1    '(''FILLING FACTOR='',F9.5,'' power='',F9.5)'
*         pointer to where to write
          nvfpnt(nparm) = nRead
          vparm(nparm,1) = log10( FillFac )
          vincr(nparm) = 0.5
*         power law dependence here, but cannot be varied
          vparm(nparm,2) = filpow
          nvarxt(nparm) = 2
*         do not allow filling factor to go positive
          varang(1,nparm) = -1e38
          varang(2,nparm) = 0.
        endif
*
      else if( chKey4.eq.'FIRE' ) then
*       cosmic thermal background radiation, argument is redshift
        i = 5
*       if no number on line then FREAD returns z=0; i.e., now
        z = fread( chCard , i , 76 , lgEOL )
*       in readsun
        call firebl( z  , nqh , ar1 )
*
      else if( chKey4.eq.'FLUC' ) then
*       rapid density fluctuations, in readsun
        call GetFluc( chCard )
*
      else if( chKey4.eq.'F(NU' ) then
*       this is the specific flux at nu
*       following says n(nu) not nuF(nu)
        lgNu2 = .false.
*       in reads2
        call setflx( chCard , nqh , ar1 , 'SQCM' , lgNu2 )
*
      else if( chKey4.eq.'FORC' ) then
*       set temperature of first zone, but don't keep constant
*       log if < 10
        i = 5
        ForceTemp = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
        if( lgMatch( ' LOG' , chCard ) .or. 
     1  (ForceTemp.le.10. .and. .not. lgMatch('LINE',chCard ))) then
          ForceTemp = 10.**ForceTemp
        endif
        if( ForceTemp.lt.3. ) then
          write(qq,'('' TE reset to 3K: entered number too small.'')')
          ForceTemp = 3.
        endif
*
      else if( chKey4.eq.'FUDG' ) then
*       enter a fudge factor
        i = 5
        do j=1,nfudgc
          fudgea(j) = fread( chCard , i , 76 , lgEOL )
          if( .not.lgEOL ) nfudge = j
        end do
*
      else if( chKey4.eq.'GLOB' ) then
*       globule with density increasing inward
*       parameters are outer density, radius of globule, and density power
        call globsb( chCard )
*
      else if( chKey4.eq.'HDEN' ) then
*       hydrogen density, in reads2
        call hdread( chCard )
*
      else if( chKey4.eq.'HELI' ) then
*       stuff to do with helium, in reads2
        call heatom( chCard )
*
      else if( chKey4.eq.'HEXT' ) then
*       turbulent heating rate, so that first= log(erg(cm-3, s-1))
*       second is scale radius, so that HXTOT = TURHET*SEXP(TURRAD/
*    1  DEPTH)
        i = 5
        turhet = 10.** fread( chCard , i , 76 , lgEOL )
        a = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          turrad = 0.
        else
          turrad = 10. ** a
        endif
*       >>chng 97 feb 24, removed set of lgPhysOK to false since extra heat
*       is intended
*
      else if( chKey4.eq.'HIGH' ) then
*       approach equilibrium from high te
        lgTeHigh = .true.
*
      else if( chCard(1:8).eq.'HYDROGEN' ) then
*       stuff to do with hydrogen atom, in reads2
        call hatom( chCard )
*
      else if( chKey4.eq.'ILLU' ) then
*       illumination angle
        i = 5
        AngleIllum = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
*       default is degrees, but radian key also there
        if( lgMatch( 'RADI' , chCard ) ) then
*         entered as radians, convert to degrees first
          AngleIllum = AngleIllum / ( pi / 180. )
        endif
*       we now have degrees, make sure between 0 and 90
        if( AngleIllum.lt.0. .or. AngleIllum.ge.90. ) then
          write(qq,'('' Angle of illumination must be between 0 and'',
     1    '' 90.'')')
          stop
        endif
*       we really want 1. / cos( theta ) with theta in radians
        AngleIllum = AngleIllum * pi / 180.
        AngleIllum = 1. / cos( AngleIllum )
*
      else if( chKey4.eq.'INIT' ) then
*       read cloudy.ini initialization file
*       following is set to false after first pass through this sub
*       so that init file only read one time in multi run jobs
        if(lgNoInit) call GetInit(chCard)
*       both in reads2.f
        iReadWay = -1
*       initialize array reader, this sub does nothing but set
*       initial value of a variable, depending on value of iReadWay
        call rdinit
*
      else if( chKey5.eq.'INTEN' ) then
*       intensity of this continuum source
        i = 5
        nqh = nqh + 1
        if( nqh.gt.limspc ) call TooManCon
        chRSpec(nqh) = 'SQCM'
        totpow(nqh) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
        if( radius.eq.0. ) then
*         set radius to large value
          ar1 = rdfalt
          radius = 10.**ar1
        endif
        if( lgMatch( 'LINE' , chCard ) ) then
*         option for linear input parameter
          totpow(nqh) = log10( totpow(nqh) )
        endif
        chSpNorm(nqh) = 'LUMI'
*       rangr in readsun
        call rangr( nqh , chCard )
*       vary option
        if( lgVarOn ) then
          nparm = nparm + 1
          chVarFmt(nparm) =
     1    '(''INTENSITY'',F9.5,'' log range'',2F9.5)'
*         pointer to where to write
          nvfpnt(nparm) = nRead
          vparm(nparm,1) = totpow(nqh)
          vincr(nparm) = 0.5
*         range option, but cannot be varied
          vparm(nparm,2) = log10( range(nqh,1) )
          vparm(nparm,3) = log10( range(nqh,2) )
          nvarxt(nparm) = 3
        endif
*
      else if( chKey5.eq.'INTER' ) then
*       interpolate on input tables for continuum, set of power  laws used
*       input ordered pairs nu( ryd or log(hz) ), log(fnu)
*       additional lines begin CONTINUE
*       first check that this is the one and only INTERP command
*       in readsun
        call GetInter( chCard , lgEOF )
*       >>chng 97 dec 23, part of fix to stop problem with ini files - this is now done in readar
*       if( .not.lgEOF ) then
*         back up one line since this sub reads until unrecognized command
*         nRead = nRead - 1
*       endif
*
      else if( chKey4.eq.'IONI' ) then
*       inter ionization parameter U=Q/12 R*R N C;
*       defined per hydrogen, not per electron (as before)
*       radius must also be entered if spherical, but not needed if plane
        i = 5
        nqh = nqh + 1
        if( nqh.gt.limspc ) call TooManCon
        chRSpec(nqh) = 'SQCM'
        chSpNorm(nqh) = 'IONI'
        totpow(nqh) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
*       vary option
        if( lgVarOn ) then
          nparm = nparm + 1
          chVarFmt(nparm) = '(''IONIZATION PARAMETER='',F9.5)'
*         pointer to where to write
          nvfpnt(nparm) = nRead
          vparm(nparm,1) = totpow(nqh)
          vincr(nparm) = 0.5
          nvarxt(nparm) = 1
        endif
*       set R to large value if U specified.
        if( radius.eq.0. ) then
          ar1 = rdfalt
          radius = 10.**ar1
        endif
*
      else if( chKey4.eq.'ITER' ) then
*       iterate to get optical depths and diffuse field properly
        i = 5
        itermx = fread( chCard , i , 76 , lgEOL ) - 1
        itermx = max( itermx , 1 )
        if( itermx.gt.itrdim-1 ) then
          write(qq,'('' No more than'',I3,'' can be performed ''
     1    ,''because of vector sizes; reduce ITER or increase '',
     2    ''itrdim in code.'')')itrdim
          stop
        endif
        if( lgMatch('CONV',chCard) ) then
*         option to keep iterating until it converges
          lgAutoIt = .true.
*         above would have been legitimite setting of ITERMX, set to default 10
          if( lgEOL ) itermx = 10 - 1
          a = fread( chCard , i , 76 , lgEOL )
*         change convergence criteria, preset in zero
          if( .not.lgEOL ) autocv = a
        endif
*
      else if( chKey4.eq.'L(NU' ) then
*       this is the specific luminositiy at nu
*       following says n(nu) not nuF(nu)
        lgNu2 = .false.
*       in reads2
        call setflx( chCard , nqh , ar1 , '4 PI' , lgNu2 )
*
      else if( chKey4.eq.'LASE' ) then
*       mostly one frequency (a laser) to check gamma's
        nspec = nspec + 1
        if( nspec.gt.limspc ) call TooManCon
        chSpType(nspec) = 'LASER'
        i = 5
        slope(nspec) = fread( chCard , i , 76 , lgEOL )
        if( slope(nspec).le.0. ) slope(nspec) = 10.**slope(nspec)
        if( lgEOL ) call NoNumb(chCard )
*
      else if( chKey4.eq.'LUMI' ) then
*       luminosity of this continuum source
        i = 5
        nqh = nqh + 1
        if( nqh.gt.limspc ) call TooManCon
        chRSpec(nqh) = '4 PI'
        totpow(nqh) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
        if( lgMatch( 'LINE' , chCard ) ) then
*          option for linear input parameter
           totpow(nqh) = log10( totpow(nqh) )
        endif
        chSpNorm(nqh) = 'LUMI'
        if( lgMatch( 'SOLA' , chCard ) ) then
*          option to use log of total lumin in solar units
           range(nqh,1) = emm
           range(nqh,2) = egamry
           totpow(nqh) = totpow(nqh) + 33.5827
        else
*          rangr in readsun
           call rangr( nqh , chCard )
        endif
*       vary option
        if( lgVarOn ) then
           nparm = nparm + 1
           chVarFmt(nparm) =
     1     '(''LUMINOSITY'',F9.5,'' log range'',2F9.5)'
*          pointer to where to write
           nvfpnt(nparm) = nRead
           vparm(nparm,1) = totpow(nqh)
           vincr(nparm) = 0.5
*          range option in, but cannot be varied
           vparm(nparm,2) = log10( range(nqh,1) )
           vparm(nparm,3) = log10( range(nqh,2) )
           nvarxt(nparm) = 3
        endif
*
      else if( chKey4.eq.'MAGN' ) then
*       log of magnetic field (gauss) to turn on cyclotron cooling
        i = 5
        CycloCoolCoef = 10.**( 2.*fread( chCard , i , 76 , lgEOL ) )
        if( lgEOL ) call NoNumb(chCard )
*       coef is 4/3 /8pi /c * vtherm(elec)
        CycloCoolCoef = CycloCoolCoef * 4.5433e-25
*
      else if( chKey4.eq.'MAP ' ) then
*       do cooling space map for specified zones, in reads2
        call maprng( chCard )
*
      else if( chKey4.eq.'META' ) then
*       read depletion for metals, all elements heavier than He
*       in reads2
        call rmetal( chCard )
*       abundances no longer solar
        lgAbnSolar = .false.
*
      else if( chKey4.eq.'NEUT' ) then
*       heating and ionization due to fast neutrons, arg is total luminosity
*       in neutrons rel to boblmetric lumin; sec number is efficiency
        i = 5
        frcneu = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
        if( frcneu.gt.0. ) frcneu = log10( frcneu )
        lgNeutrnHeatOn = .true.
        effneu = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          effneu = 1.0
        else
          if( effneu.le.0. ) effneu = 10.**effneu
        endif
*
      else if( chKey3.eq.'NO ' ) then
*       don't do something, in readsun
        call dont( chCard )
*
      else if( chKey4.eq.'NORM' ) then
        call GetNorm( chCard )
*        normalise lines to this rather than h-b, sec number is scale factor
*        i = 5
*        norm = -fread( chCard , i , 76 , lgEOL )
*        if( lgEOL ) call NoNumb(chCard )
*        sclnrm = fread( chCard , i , 76 , lgEOL )
*        if( lgEOL ) sclnrm = 1.
*
      else if( chKey4.eq.'NUF(' ) then
*       flux density of this continuum source, at optional frequency
*       expressed as product nu*f_nu
        lgNu2 = .true.
*       in reads2
        call setflx( chCard , nqh , ar1 , 'SQCM' , lgNu2 )
*
      else if( chKey4.eq.'NUL(' ) then
*       specific luminosity density of this continuum source, at opt freq
*       expressed as product nu*f_nu
        lgNu2 = .true.
*       in reads2
        call setflx( chCard , nqh , ar1 , '4 PI' , lgNu2 )
*
      else if( chKey4.eq.'OPTI' ) then
*       option to optimize the model by varying certain parameters
*       in reads2
        call optred( chCard )
*
      else if( chKey4.eq.'PHI(' ) then
*       enter phi(h), the number of h-ionizing photons/cm2
        i = 5
        nqh = nqh + 1
        if( nqh.gt.limspc)  call TooManCon
        chRSpec(nqh) = 'SQCM'
        chSpNorm(nqh) = 'PHI '
        totpow(nqh) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
        if( radius.eq.0. ) then
*         set radius to large value
          ar1 = rdfalt
          radius = 10.**ar1
        endif
*       check if continuum so intense that crash is likely
        if( totpow(nqh).gt.29. ) then
          write(qq,'('' Is the flux for this continuum correct?'')')
          write(qq,'('' It appears too bright to me.'')')
        endif
*       rangr in readsun
        call rangr( nqh , chCard )
*       vary option
        if( lgVarOn ) then
           nparm = nparm + 1
           chVarFmt(nparm) =
     1     '(''phi(h)'',F9.5,'' log range'',2F9.5)'
*          pointer to where to write
           nvfpnt(nparm) = nRead
           vparm(nparm,1) = totpow(nqh)
           vincr(nparm) = 0.5
*          range option in, but cannot be varied
           vparm(nparm,2) = log10( range(nqh,1) )
           vparm(nparm,3) = log10( range(nqh,2) )
           nvarxt(nparm) = 3
        endif
*
      else if( chKey4.eq.'PLOT' ) then
*       make plot of log(nu.f(nu)) vs log(nu) or opacity
*       in file plot
        call pread( chCard )
*
      else if( chKey4.eq.'POWE' ) then
*       power law with cutoff, in reads2
        call plwcon( chCard )
*
      else if( chKey4.eq.'PRIN' ) then
*       adjust print schedule, in readsun
        call GetPrint( chCard , lgEOL )
*
      else if( chKey4.eq.'PUNC' ) then
*       punch something, in punch
        call GetPunch( chCard )
*
      else if( chKey4.eq.'Q(H)' ) then
*       log of number of ionizing photons
        i = 5
        nqh = nqh + 1
        if( nqh.gt.limspc ) call TooManCon
        chRSpec(nqh) = '4 PI'
        chSpNorm(nqh) = 'Q(H)'
        totpow(nqh) = fread( chCard , i , 76 , lgEOL )
        if( totpow(nqh).gt.100..and.lgTalk )
     1   write(qq,'('' Is this reasonable?'')')
        if( lgEOL ) call NoNumb(chCard )
*       rangr in readsun
        call rangr( nqh , chCard )
*       vary option
        if( lgVarOn ) then
          nparm = nparm + 1
          chVarFmt(nparm) =
     1    '(''Q(H)'',F9.5,'' log range'',2F9.5)'
*         pointer to where to write
          nvfpnt(nparm) = nRead
          vparm(nparm,1) = totpow(nqh)
          vincr(nparm) = 0.5
*         range option in, but cannot be varied
          vparm(nparm,2) = log10( range(nqh,1) )
          vparm(nparm,3) = log10( range(nqh,2) )
          nvarxt(nparm) = 3
        endif
*
      else if ( chKey4.eq.'QHEA' ) then
*        (K Volk) added QHEAT here
         iopt=0
*        Turn on quantum heating heating (ignored if grains are not PAHs unless
*        they have the qheat keyword on the card)
         call setqhe(chCard, lgQHeat, iopt)
*
      else if( chKey4.eq.'RATI' ) then
*       enter a continuum luminosity as a ratio of
*       nuFnu for this continuum relative to a previous continuum
*       format; first number is ratio of second to first continuum
*       second number is energy for this ratio
*       if third numbewr on line, then 2nd number is energy of
*       first continuum, while 3rd number is energy of second continuum
*       in reads2
        call cratio( chCard , nqh )
*
      else if( chKey4.eq.'RADI' ) then
*       log of inner and outer radii, default second=infinity,
*       if R2<R1 then R2=R1+R2
*       there is an optional keyword, "PARSEC" on the line
*       to use PC as units, reads2
        call radi( chCard , ar1 )
*
      else if( chKey4.eq.'ROBE' ) then
        lgOut2In = .true.
*
      else if( chKey4.eq.'SET ' ) then
*       set something, in reads2
        call GetSet( chCard )
*
      else if( chKey4.eq.'SPEC' ) then
*       special key, can do anything
        lgVrrFit = .false.
*
      else if( chKey4.eq.'SPHE' ) then
*       compute a spherical model, diffuse field from other side in
*       in reads2
        call sphset( chCard )
*
      else if( chKey4.eq.'STOP' ) then
*       stop model at desired zone, temperature, column density or tau-912
*       in readsun
        call stopr( chCard )
*
      else if( chKey4.eq.'TABL' ) then
*       interpolate on input tables for continuum, set of power  laws used
*       input stored in big BLOCK data
*       first check that this is the one and only INTERP command
*       in readsun
        call GetTable( nqh , chCard , ar1 , nTabRead )
*
      else if( chKey4.eq.'TAUM' ) then
*       minimum optical depths for lines (normally 1e-20)
*       (used in STARTER to set lines up)
        i = 5
        taumin = 10.**fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
*
      else if( chKey4.eq.'TIME' ) then
        write(qq,'('' This command not now implemented.'')')
*       following will stop things here
        call NoNumb( chCard )
        i = 5
        itime = fread( chCard , i , 76 , lgEOL )
        tmt1 = 10. ** fread( chCard , i , 76 , lgEOL )
        tmpwr = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          tmpwr = 0.
          tmt1 = 0.
        endif
*
      else if( chKey4 .eq. 'TITL' ) then
*       read in title of model
        chTitle = chOrgCard(6:80)
*
      else if( chKey4.eq.'TOLE' ) then
*       tolerance in heating cooling match, number is error/total
        i = 5
        toler = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
*       >>chng 96 dec 31, added below so negative is log
        if( toler.le.0. ) toler = 10.** toler
*
      else if( chKey4.eq.'TRAC' ) then
*       turn on trace output, in reads2
        call GetTrace( chCard )
*
      else if( chKey4.eq.'TURB' ) then
*       turbulent velocity in km/sec
        i = 5
        TurbVel = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
        if( lgMatch( ' LOG' , chCard ) ) TurbVel = 10. ** TurbVel
*       convert to cm/sec
        TurbVel = TurbVel * 1e5
*       vary option
        if( lgVarOn ) then
          nparm = nparm + 1
*         only one parameter to vary
          nvarxt(nparm) = 1
          chVarFmt(nparm) = '(''TURBULENCE='',F9.5,'' log'')'
*         pointer to where to write
          nvfpnt(nparm) = nRead
*         turbulent velocity
          vparm(nparm,1) = log10( TurbVel/1e5 )
          vincr(nparm) = 0.5
        endif
*
      else if( chKey4.eq.'WIND' ) then
*       wind structure, parameters are initial velocity and optional mass
*       v in km/sec, mass in solar masses
        i = 5
        windv0 = fread( chCard , i , 76 , lgEOL ) * 1e5
        if( windv0.le.0. ) then
          write(qq,'('' The initial wind velocity must be positive.'',
     1    ''  Sorry.'')')
          stop
        else if( windv0.le.1.e6 ) then
*         speed of sound roughly 10 km/s
          write(qq,'('' >>>>Initial wind velocity should be greater'',
     1    '' than speed of sound; calculation only valid above sonic'',
     2    '' point.'')')
          lgWindOK = .false.
        endif
        if( lgEOL ) call NoNumb(chCard )
        windv = windv0
        comass = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) comass = 1.
        chCPres = 'WIND'
*       used for line width
        chRedis = 'WIND'
*
*       end end end end end end end end end end end end end end end end
*       these are first col characters that mean line totally
*       ignored.  usually stripped out in fillar, but could
*       be input here is code called as sub
        else if(chK1.ne.'#' .and. chK1.ne.'*' .and. chK1.ne.'%' ) then
*         end of keys - if we get here key is unrecognized----------
          write(qq,'(''  Unrecognized command. Key="'',A4,
     1    ''".  This is routine readr.'')')
     1    chKey4
          write(qq,'('' The line image was='',A80)') chCard
          write(qq,'('' Sorry.'')')
          stop
        endif
        call readar( chCard , lgEOF )
      end do
*
*-------------------------------------------------------------------
*
*     hit lgEOL or blank line
*     free statement numbers after here, >=204
*
*     K Volk check for qheat option from a "grains" command without the "QHEAT"
*     command -- if so, pretend the card has been put in
      lgQHet = .false.
      do i=1,ndust
        if (lgQHeat(i)) lgQHet = .true.
      end do
*     if qheat command ever appeared then qtmax is non-zero
      if (qtmax.eq.0.) then
*       there were not qheat commands, but qheat was turned on, on a grains line
*       generate dummy command line and call setqhe to get defaults
        chCard='QHEAT'
*
        do j=6,80
          chCard(j:j)=' '
        end do
*
        iopt=1
        call setqhe(chCard,lgQHeat,iopt)
      end if
*     end of changes (K Volk)
*
*
      do i=1,80
        chCard(i:i) = ' ' 
      end do
      if( lgTalk ) then
        write(qq,'(23X,''*'',1X,A80,''*'')') chCard 
        write(qq,'(23X,83(''*'')///)')
      endif
*
*     set flag so that we will not actually read cards in again
      lgNoInit = .false.
*
      if( chCPres.eq.'DLW1' ) then
        hden = log10(fabden(radius,depth))
      else if( chCPres.eq.'DLW2' ) then
*       >>chng 96 nov 29, added tabden, based on Kevin Volk code
        hden = log10(tabden(radius,depth))
      endif
*
*     sanity checks for some of the things read in, in reads2
      call readck( nqh )
      hden = 10. ** hden
      rinner = radius
*     mass loss rate for wind model, normally WINDV0=0
      emdot = hden * windv0
*
*     iterate to convergence and wind models are mutually exclusive
      if( windv0.gt.0. .and. lgAutoIt ) then
        write(qq,'('' Due to the nature of the Sobolev'',
     1  '' approximation, it makes no sense to converge a windy model.''
     2  )')
        write(qq,'('' Iterate to convergence is turned off'')')
        lgAutoIt = .false.
        itermx = 0.
      endif
*
*     this is an option to turn on trace printout on the nth
*     call from the optimizer - only allow trace if
*     this is the case and NOPTIM 1 below nTrOpt
      if( lgTrOpt ) then
*       nTrOpt was set with "optimize trace" command,
*       is iteration to turn on trace
        if( nTrOpt.ne.noptim ) then
          lgTrace = .false.
*         following overrides turning on trace elsewhere
          lgTrOvrd = .false.
        else
          lgTrace = .true.
          lgTalk = .true.
          lgTrOvrd = .true.
          write(qq,'('' READR turns on trace from optimize option.'')'
     1    )
        endif
      endif
*
      end
