******************************************************************************
      subroutine reset
      implicit none
*reset many variables at the start of a new iteration
      include "nhe3lvl.par"
      include "itrdim.par"
      include "nkrd.par"
      include "limelm.par"
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "ndust.par"
      include "ncell.par"
      include "HHePopSv.com"
      include "toiii.com"
      include "pwind.com"
      include "dstdft.com"
      include "LaMase.com"
      include "xry.com"
      include "globul.com"
      include "hvmolEXP.com"
      include "EdError.com"
      include "hevmls.com"
      include "ndroff.com"
      include "nustbl.com"
      include "dndt.com"
      include "h2max.com"
      include "TrueEden.com"
      include "cmfrac.com"
      include "jmin.com"
*     include "filfac.com"
      include "kapots.com"
      include "tgrmax.com"
      include "opac.com"
      include "opacsv.com"
      include "scatop.com"
      include "sctsav.com"
      include "oldcla.com"
      include "lotsco.com"
      include "he1bn.com"
      include "he2bn.com"
      include "he3bn.com"
      include "hebnsv.com"
      include "heots.com"
      include "smbeta.com"
      include "totlum.com"
      include "sv4861.com"
      include "qs.com"
      include "hmihet.com"
      include "hlmax.com"
      include "heopfr.com"
      include "ophf.com"
      include "ophs.com"
      include "ffheat.com"
      include "occnum.com"
      include "htau.com"
      include "input.com"
      include "iontot.com"
      include "dhla.com"
      include "prdcap.com"
      include "drminu.com"
      include "velpos.com"
      include "negdrg.com"
      include "uspher.com"
      include "aclbar.com"
      include "prad.com"
      include "taumin.com"
      include "tmn.com"
      include "exptau.com"
      include "e2tau.com"
      include "shullc.com"
      include "x12.com"
      include "supsav.com"
      include "IterCnt.com"
      include "u.com"
      include "lfes.com"
      include "IonFracs.com"
      include "IonFsave.com"
      include "heating.com"
      include "solar.com"
      include "he.com"
      include "phycon.com"
      include "radius.com"
      include "dRdVeff.com"
      include "ZoneCnt.com"
      include "he1cin.com"
      include "he2cin.com"
      include "phlevl.com"
      include "phe1lv.com"
      include "phe2lv.com"
      include "h.com"
      include "ots.com"
      include "otssav.com"
      include "rfield.com"
      include "reflec.com"
      include "flxsav.com"
      include "save.com"
      include "hmi.com"
      include "hmisav.com"
      include "drsv.com"
      include "drnxt.com"
      include "called.com"
      include "nebug.com"
      include "tff.com"
      include "trace.com"
      include "hesav.com"
      include "NumUpper.com"
      include "trovrd.com"
      include "pca2ex.com"
      include "he12on.com"
      include "stimax.com"
      include "nhe2.com"
      include "EdenOther.com"
      include "SumOutInc.com"
      include "wind.com"
      include "MtrxOff.com"
      include "GrainPot.com"
      include "OldOpac.com"
      include "ednbad.com"
      include "IonRange.com"
      include "HPhoto.com"
      include "IOqq.com"
*
*     local variables
      real pintig
      integer n,i,nelem,ion,nd
*
*     free statement labels >=36
*
      lgEdenBad = .false.
      nzEdenBad = 0
*     these are variables to remember the biggest error in the
*     electron density, and the zone in qhich it occurred
      BigEdenError  = 0.
      AccelMax = 0.
      ipEdenError = 0
      SumOutCon = 0.
      SumIncCon = 0.
      dDensityDT = dndtSave
      windv = windv0
*
      BiggestH2 = -1.
*
*     lgNxtDROff is flag saying to reinit DR logic in NEXTDR
      lgNxtDROff = .true.
*
*     turn H matrix back on
      lgHMtrxOff = .false.
*
      lgVelPos = .true.
      lgBusted = .false.
*
      rjnmin = 1e37
      ajmmin = 1e37
*
      xLaMase = 0.
      stimax(1) = 0.
      stimax(2) = 0.
*
      oldcla = 0.
      CarMolFrac = -1.
*     reset molecular fractions
      ch = chs
      chp = chps
      oh = ohs
      ohp = ohps
      otwo = otwos
      ctwo = ctwos
      co = cos
      cop = cops
      h2o = h2os
      h2op = h2ops
      o2p = o2ps
      c2p = c2ps
      h3p = h3ps
      h3op = h3ops
      ch2p = ch2ps
      ch2 = ch2s
      ch3 = ch3s
      cp = cps
*
      htwo = h2sav
      h2plus = h2psav
      h3plus = h3psav
      hminus = hmisav
*
*     dont call HE1, HE2, or HE3 routines if no ionizing radiation
*     must reset this since he++ turned off at depth
      if( nflux.lt.nhe2(1) ) then
        lgHe2ON = .false.
      else
        lgHe2ON = .true.
      endif
      lgHe1ON = .true.
*
      ntff = 1
      tff = 0.
      pintig = 0.
      glbdst = 0.
*     zone thickness, and next zone thickness
      drad = drSave
      drNext = drnsv
      lgUSphON = .false.
      lgPradCap = .false.
      lgPradDen = .false.
      lgDrMinUsed = .false.
      lgNegGrnDrg = .false.
      lgLotsCO = .false.
*
*     simple estimate of H-beta intensity
      smbeta = qhtot * 4.75e-13
      cn4861 = sv4861
      cn1216 = sv1216
*
*     total luminosity
      totlsv = totlum 
*
*     set debugger on now if NZONE desired is 0
      if( nznbug.eq.0 .and. iter.ge.npsbug .and. lgTrOvrd) then
        lgTrace = .true.
        write(qq,'('' RESET called.'')')
      else
        lgTrace = .false.
      endif
*
*     zero secondary suptrathermals variables for first ionization attem
      secion = savion
      secla = savla
      csupra = supsav
      x12 = x12sav
      heatef = hetsav
      efionz = savefi
      AccelAver = 0.
      acldr = 0.
      pbeta = 0.
      kapots = 0
      kap911 = 0
      nUnstable = 0
      lgUnstable = .false.
      RadBetaMax = 0.
      pca2ex = 0.
*
*     these are opacity factors needed for recombination coef
      do n=1,nhlvl
        ophf(n) = ophs(n)
      end do
      do n=1,nhe1lvl
        ophe1f(n) = ophe1s(n)
      end do
      do n=1,nhe2lvl
        ophe2f(n) = ophe2s(n)
      end do
      do n=1,nhlvl+1
        hn(n) = hnsav(n)
      end do
      do n=1,nhe1lvl+1
        he1n(n) = he1nsav(n) 
      end do
      do n=1,nhe2lvl+1
        he2n(n) = he2nsav(n) 
      end do
*
      iontot = 0
      esc626 = 0.
      esc584 = 0.
      esc304 = 0.
      esc660 = 0.
      esc911 = 0.
      esc228 = 0.
*
      do i=1,nhlvl
        hlmax(i) = 0.
      end do
*
      hden = hsv
      eden = edsav
      EdenNotH = EDOthSav
      EdenMet = EDMSav
*     reset correct electron density to saved electron density
      EdenTrue = edsav
      ahe = solar(2) * hden
      heiii = heisav
      heii = he2sav
      hei = he1sav
      hei1 = hei
      hei3 = he3sav
*
      do i=1,nhlvl+1
        cinduc(i) = 0.
      end do
*
      do i=1,10
        he1cin(i) = 0.
        he2cin(i) = 0.
        he1bn(i) = heb1sv(i)
        he2bn(i) = heb2sv(i)
      end do
*
      do i=1,nhe3lvl
        he3bn(i) = heb3sv(i)
      end do
*
      if( lgTrace.and.lgNeBug ) write(qq,'(5X,''EDEN set to'',1P,E12.4,
     1'' by RESET.'')') eden
*
      do nelem=1,limelm
        xIonFracs(nelem,0) = solar(nelem) * hden
        do ion=1,nelem+1
          xIonFracs(nelem,ion) = xIonFsave(nelem,ion)
        end do
        do i=1,limelm
          heating(nelem,i) = HeatSave(nelem,i)
        end do
      end do
*
      hmihet = 0.
      hmitot = 0.
*
      DustHeatLya = 0.
      dhcol = 0.
      dincon = 0.
      HDustDif = 0.
      dstpow = 0.
      dstsum = 0.
      dstotl = 0.
      do nd=1,ndust
*       >>chng 97 july 5, reset grain potential
*       reset grain to pential to initial value from previous iteration
        dstpot(nd) = dstpotsav(nd)
        avdust(nd) = 0.
        avdpot(nd) = 0.
         avdft(nd) = 0.
        tgrmax(nd) = -1.
      end do
*
      hi = hisv
      hii = hiisv
      hn(1) = hi / hii
*
*     fix number of stages of ionization
      do i=1,limelm
        IonLow(i) = IonLowSave(i)
        IonHigh(i) = IonHighSave(i)
      end do
*
*     continuum was saved in FluxSave
      do i=1,nupper
        flux(i) = FluxSave(i)
        lgOTSOn(i) = .true.
        occnum(i) = flux(i) * convoc(i)
        otscon(i) = otssav(i,1)
        otslin(i) = otssav(i,2)
        outcon(i) = 0.
        outlin(i) = 0.
        opac(i) = opacsv(i)
        scatop(i) = sctsav(i)
        albedo(i) = scatop(i) / max( 1e-30 , scatop(i)+opac(i) )
        tmn(i) = 1.
        ExpmTau(i) = 1.
        e2TauAbs(i) = 1.
        reflin(i) = 0.
        refcon(i) = 0.
        reflux(i) = 0.
      end do
*     update continuum
      call SumContinuum
*
      FreeFreeHeat = 0.
      ffhtot = 0.
*
      if( lgTalk ) write(qq,'(''1''/10X,''Start Iteration Number'',I2,
     13X,A75//)') iter, chTitle
*
      end
