******************************************************************************
      subroutine rmetal( chCard )
      implicit none
*parse parameters on metal command
      character chCard*80
*
      include "ninput.com"
      include "nvary.com"
      include "varon.com"
      include "ndust.par"
      include "dstfac.com"
      include "dmetal.com"
      include "limext.par"
      include "limpar.par"
      include "vformt.com"
      include "nvfpnt.com"
      include "grmetl.com"
      include "called.com"
      include "vparm.com"
      include "limelm.par"
      include "deplon.com"
      include "IOqq.com"
*
*     local variables
      logical lgEOL , lgLogOn , lgMatch , lgGrains
      integer i
      real fread , dmlog
*
*     this routine called when metals command entered
*
*     metal depletion factor, if negative then it is the log
      i = 5
      ScaleMetals = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
        if( lgMatch( 'DEPL' , chCard ) ) then
*         this option - no numbers on line but keyword depletion is
*         deplete by set of scale factors
          lgDepln = .true.
          do i=1,limelm
            depset(i) = Depletion(i)
          end do
          ScaleMetals = 1.
          return
        else
*         no number, so keyword, punch out
          if( .not.lgTalk ) write(qq,'(1X,A80)') chCard
          write(qq,'('' There must be a number on this line.  Sorry.''
     1    )')
          stop
        endif
      endif
*
*     sort out whether log
      lgLogOn = .false.
      if( lgMatch( ' LOG' , chCard ) ) then
        lgLogOn = .true.
      else if( lgMatch( 'LINE' , chCard ) ) then
        lgLogOn = .false.
      endif
*
      if( ScaleMetals.le.0. .or. lgLogOn ) then
        dmlog = ScaleMetals
        ScaleMetals = 10.**ScaleMetals
      else
        dmlog = log10( ScaleMetals )
      endif
*
*     option to vary grain abundance as well
      if( lgMatch( 'GRAI' , chCard ) ) then
        lgGrains = .true.
        GrainMetal = ScaleMetals
      else
        lgGrains = .false.
        GrainMetal = 1.
      endif
*
*     vary option
      if( lgVarOn ) then
        nparm = nparm + 1
        if( lgGrains ) then
          chVarFmt(nparm) = '(''METALS LOG='',F9.5,'' GRAINS'')'
        else
          chVarFmt(nparm) = '(''METALS LOG='',F9.5)'
        endif
*       pointer to where to write
        nvfpnt(nparm) = nRead
        vparm(nparm,1) = dmlog
        vincr(nparm) = 0.5
        nvarxt(nparm) = 1
      endif
*
      end
