******************************************************************************
      subroutine silicn
      implicit none
*determine ionization balance of Silicon
      include "limelm.par"
      include "itrdim.par"
      include "trace.com"
      include "elmton.com"
      include "he.com"
      include "pmp2s.com"
      include "timed.com"
      include "TePowers.com"
      include "DestCrt.com"
      include "h.com"
      include "chargt.com"
      include "phycon.com"
      include "PhotRate.com"
      include "ZoneCnt.com"
      include "DoPhoto.com"
      include "TrHeav.com"
      include "IonFracs.com"
      include "IOqq.com"
*
*     local variables
      integer i 
      integer ndim , nelem
      parameter (ndim=15)
      parameter (nelem=14)
      real OldRate
      integer nzUsed
      save OldRate , nzUsed
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     REAL GRDEFF(14)  , yYIELD(12) , yYIELDL(4)
*     real CollidRate(nelem,2)
      data nzUsed/-1/ , OldRate/0./
*
*     DATA GRDEFF/14*0.2/ , yYIELD/12*0./,yYIELDL/4*0./
*
*     silicon nelem=14
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /3.92E-10,4.87E-11,2.32E-11,6.20E-12,4.86E-12,2.60E-12,
     1 1.65E-12,1.03E-12,6.02E-13,3.23E-13,1.95E-13,8.08E-14,7.44E-15,
     2 3.09E-15/
      data (cion(i,2),i=1,ndim-1)
     1 /9.46E4,1.90E5,3.88E5,5.24E5,1.93E6,2.38E6,2.86E6,3.52E6,4.07E6,
     2 4.66E6,5.52E6,6.07E6,2.83E7,3.10E7/
*
*     rec fro +11, 12 13 from Arnauld et al 85
      data rec , pl
     1/1.64E-10 , 2.00E-9 , 2.19E-9 , 1.41E-8 , 1.05E-8 , 1.54E-8 ,
     2 1.93E-8  , 2.43E-8 , 3.76E-8 , 5.53E-8 , 2.80E-7 , 5.81E-8 ,
     3 5.99E-7  ,
     3 -0.601  , -0.786  , -0.693  , -0.821  , -0.735  , -0.716  ,
     4 -0.703  , -0.688  ,  -0.703  , -0.714  , -0.823 , -0.858  ,
     5 -0.818  /
*     Pequignot and Aldrovandi Ast Ap 161, 169., scaled to smoothly fit
*     onto high temp coef
      data tlow/ 1.64e-10 , -0.617 /
*
      data (dicoef(i,1),i=1,ndim-1)
     1 /1.10E-3,5.87E-3, 5.03E-3, 5.43E-3, 8.86E-3, 1.68E-2, 2.49E-2,
     2 3.13E-2, 4.25E-2, 6.18E-2, 1.38E-2, .327, .189, 0./
      data (dicoef(i,2),i=1,ndim-1)
     1/0., .753, .188, .450, 0., 1.80, 1.88, 2.01, 1.22, .303, 1.42,
     2 .306, .286, 0./
      data (dite(i,1),i=1,ndim-1)
     1/7.70E+4, 9.63E+4, 8.75E+4, 1.05E+6, 1.14E+6, 4.85E+5, 4.15E+5,
     2 3.66E+5, 3.63E+5, 3.88E+5, 2.51E+5, 1.88E+7, 1.99E+7, 0./
      data (dite(i,2),i=1,ndim-1)
     1/0., 6.46E+4, 4.71E+4, 7.98E+5, 0., 1.03E+6, 1.91E+6, 2.11E+6,
     2 2.14E+6, 1.12E+6, 3.93E+6, 3.60E+6, 4.14E+6, 0./
      data ditcrt
     3/1.1E4  , 1.1E4  , 1.1E4  , 1.7E5  , 9.5E4  , 8.0E4  , 7.4E4
     3,6.8E4  , 6.6E4  , 6.5E4  , 4.5E4  , 3.7E6  , 6.3E6  , 1E20/
*
*     from nuss+storey, who say that =>si iv is very small
      data aa/-0.0219 , 3.2163 , 0.1203 , 11*0./,
     1     bb/ 0.4364 ,-12.0571,-2.6900 , 11*0./,
     2     cc/ 0.0684 , 16.2118,19.1943 , 11*0./,
     3     dd/-0.0032 ,-0.5886 ,-0.1479 , 11*0./,
     4     ff/ 0.1342 , 0.5613 , 0.1118 , 0.1,10*0./
*
*     silicon, atomic number 14
      if( .not.lgElmtOn(14) ) then
        p1895 = 0.
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
      if( nzone.gt.1 .and. OldRate.gt.0. ) then
        if( nzone.ne.nzUsed ) then
          PhotoRate(nelem,1,5,1) = (PhotoRate(nelem,1,5,1) +
     1    OldRate) / 2.
          nzUsed = nzone
        else
          PhotoRate(nelem,1,5,1) = OldRate
        endif
      endif
      OldRate = PhotoRate(nelem,1,5,1)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
*     pumping to 3p of Si III
      p1895 = PhotoRate(nelem,2,3,1)
*
*     SI ++ - SI+ CH EXCH FROM GARGAUD ET AL., 82, AST AP 106, 197
*     RATE = 2.53E-10 * TE/TE70*TE03
*     >>chng 96 Oct 1, moved all H ct to bidiag
*     CTHeavy(2,2) = CTHeavy(2,2) + HI * RATE
*     CTHeavy(2,1) = CTHeavy(2,1) + HII*RATE*0.262 * SEXP(2.943E4/TE)
*     SI+3 => SI+2 BUTLER AND DALGARNO 1980B
*     CTHeavy(3,2) = CTHeavy(3,2) + 4E-10 * HI + HEI*SQRTE*TE10*TE10*
*     >>refer Butler, S.E., &Dalgarno, A. 1980, ApJ 241, 838
*     scale by 1.3 to bring into agreement with
*     >>refer Fang, Z., & Kwong, H.S. 1997 ApJ 483, 527
      CTHeavy(3,2) = CTHeavy(3,2) + hei*sqrte*te10*te10*1.3*1.5e-12
*     SI+4 => SI+3 BUTLER AND DALGARNO 1980B
*     CTHeavy(4,2) = CTHeavy(4,2) + 2.3E-9 * HI
*     Si+4 + Heo => Si+3 (Opradolce et al. 1985, AstAp. 148, 229.)
      CTHeavy(4,2) = CTHeavy(4,2) + 2.54E-11 * sqrte/te03/te01/te01*hei
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
*     get pmp rate cm-3 s-1
      p1895 = p1895 * xIonFracs(nelem,2) * 0.85
*
      if(lgTrace.and.lgHeavyBug) then
        write(qq,'(5X,''SILICN returns; frac='',1P,10E10.3)')
     1  (xIonFracs(nelem,i)/xIonFracs(nelem,0),i=1,10)
      endif
*
      end
