******************************************************************************
      real function smeets(n)
      implicit none
*generate hydrogenic collisional ionization rate coefficients
      integer n
      include "phycon.com"
*
*     local variables
      real tryd,eps,denom,coef,sexp
*
*     a function written to calculate the rate coefficients 
*     for hydrogen collisional ionizations from
*     Jason Ferguson, summer 94
*     valid for all n
*     Vriens & Smeets 1980. Phys Rev A 22, 940.
*
      tryd = 8.617e-5 * te
      eps = 1.57890e+5 / te / n / n
      denom = eps**2.33 + 4.38*eps**1.72 + 1.32*eps
      coef = 9.56e-6 / tryd**1.5 / denom * sexp(eps)
      smeets = coef
*
      end 
