******************************************************************************
      subroutine spline(x,y,n,yp1,ypn,y2a)
      implicit none
*spline interpolation routine
      integer n
      real x(n),y(n) , y2a(n) , yp1,ypn
*     returns array Y2 needed for SPLINT
      include "IOqq.com"
*
*     local variables
      integer nlim
      parameter (nlim=160)
      double precision u(nlim) , sig , p , qn  , un
      integer i , k
*
*     check that not too many points
      if( n.gt.nlim ) then
        write(qq,'('' Too many points for SPLINE.  Increase NLIM'')')
        stop
      endif
*
      if (yp1.gt..99e30) then
        y2a(1)=0.
        u(1)=0.
      else
        y2a(1)=-0.5
        u(1)=(3.d0/(dble(x(2))-dble(x(1))))*((dble(y(2))-dble(y(1)))/
     1   (dble(x(2))-dble(x(1)))-dble(yp1))
      endif
*
      do i=2,n-1
        if(x(i+1).eq.x(i-1) .or. x(i+1).eq.x(i) .or. x(i).eq.x(i-1))then
          u(i) = u(i-1)
        else
          sig=(dble(x(i))-dble(x(i-1)))/(dble(x(i+1))-dble(x(i-1)))
          p=sig*y2a(i-1)+2.d0
          y2a(i)=(sig-1.d0)/p
          u(i)=(6.d0*((dble(y(i+1))-dble(y(i)))/
     1    (dble(x(i+1))-dble(x(i)))-
     1    (dble(y(i))-dble(y(i-1))) / (dble(x(i))-dble(x(i-1))))/
     2    (dble(x(i+1))-dble(x(i-1)))-sig*u(i-1))/p
        endif
      end do
*
      if (ypn.gt..99e30) then
        qn=0.
        un=0.
      else
        qn=0.5
        un=(3.d0/(dble(x(n))-dble(x(n-1))))*(dble(ypn)-(dble(y(n))-
     1  dble(y(n-1)))/ (dble(x(n))-dble(x(n-1))))
      endif
*
      y2a(n)=(un-qn*u(n-1))/(qn*y2a(n-1)+1.d0)
      do k=n-1,1,-1
        y2a(k)=y2a(k)*y2a(k+1)+u(k)
      end do
*
      end
