******************************************************************************
      subroutine VolMean( nelem , n , arlog )
      implicit none
*do volume mean of ionization fractions over volumn of any element
      include "limelm.par"
      real arlog(limelm+1) 
      integer nelem , n
*
*     local variables
      real abund , normalize
      integer i
      include "IonMeans.com"
      include "IOqq.com"
*
*     fills in array arlog with log of ionization fractions
*     N is set to highest stage with non-zero abundance
*     N set to 0 if element turned off
*
*     first call zmean to sero out save arrays
*     next call mean in zone calc to enter ionziation fractions
*     finally this routine computes actual means
*
      if( xIonMeans(nelem,0,2) .le.0. ) then
*       no ionization for this element
        do i=1,nelem+1
          arlog(i) = -30.
        end do
        n = 0
        return
      endif
*
      n = nelem+1
      do while(n.gt.1.and. xIonMeans(nelem,n,2) .le.0. )
        arlog(n) = -30.
        n = n - 1
      end do
*
      normalize = xIonMeans(nelem,0,2)
      do i=1,n
        if( xIonMeans(nelem,i,2).gt.0. ) then
          abund = xIonMeans(nelem,i,2)
          arlog(i) = log10( max(1E-30,abund)/normalize )
        else
          arlog(i) = -30.
        endif
      end do
*
      end
