******************************************************************************
      real function widla( tauin , tauout , a , vth )
      implicit none
*determine Lya line width for radiation pressure
      real tauin , tauout , a , vth
      include "prdcap.com"
      include "touton.com"
      include "redis.com"
      include "phycon.com"
*
*     local variables
      logical lgTonSav
      save lgTonSav
      real widlin , tau , t , therm , escinc
*
*     optical depth in outer direction is always defined for la
      lgTonSav = lgTauOutOn
      lgTauOutOn = .true.
*
*     compute width of la with either complete or incomplete redistribution
      if( chRedis.eq.'INCO' .or. chRedis.eq.'WIND' ) then
        widla = widlin( tauin , tauout , a , vth )
      else
*
        tau = tauout / 2.
        t = max( 0. , min(tauin,(tauout-tauin)) )
*
*       max optical depth is thermalization length
        therm = (3e14 / eden ) ** 2
        if( tau.gt.therm ) then
          tau = therm
          lgPradDen = .true.
        endif
*
*       1st fac in () is sqrt(2*pi); sec is 2/(pi^.25)
        widla = vth * (2.5066 + 1.5023*sqrt(a*tau))* (1.-escinc(t,a))
      endif
      lgTauOutOn = lgTonSav
*
      end
