******************************************************************************
      real function widlin( tauin , tauout , a , vth )
      implicit none
*determine half width of any line with known optical depths
      real tauin , tauout , a , vth
      include "redis.com"
      include "phycon.com"
      include "prdcap.com"
      include "touton.com"
      include "wind.com"
      include "pi.par"
*
      real tau , t , therm,atau,aa,b,escinc,r
*
*     lgTauOutOn=.TRUE. if optical depth in outer direction is defined
*     smaller of inner and outer optical depths is chosen for esc prob
*     thermal broadening alone follows, lvg at 99
*     following uses line width from Bonilha et al. Ap.J. (1979) 233 649
*     return value is half width*(1-ESC PROB)
*     TAU is used for width of source function
*     T is used for escape probability
*     this assumes incompl redis, a.tau^1/3 width
*
      if( lgTauOutOn ) then
         tau = tauout / 2.
         t = max(tauin/100.,min(tauin,(tauout-tauin)))
      else
         tau = tauin
         t = tauin
      endif
*
*     max optical depth is thermalization length
      therm = 5.3e16/eden
      if( tau.gt.therm ) then
         lgPradDen = .true.
         tau = therm
      endif
*
      if( chRedis.ne.'WIND' ) then
*       converted from go-to 15 june 95
*
        atau = log( max(0.0001,tau) )
        if( tau.le.20. ) then
          aa = (4.8+5.2*tau+(4.*tau-1.)*atau)
          b = (6.5*tau-atau )
        else
          aa = 1. + 2.*atau/(1.+0.3*a*tau)**0.6667 +
     1     (6.5*a*tau)**0.333
          b = 1.6 + 1.5 / (1.+0.20*a*tau)
        endif
*
*       this is half width of line
        widlin = vth * 0.8862 * aa / b * (1. - escinc(t,a) )
*
      else
*       WIND
        r = a * tau / pi
        if( r.le.1. ) then
           widlin = vth * sqrt( log(max(1.,tau) )*.2821)
           return
        endif
*
        widlin = 2.*windv0
        if( r*vth .gt. widlin ) return
*
        widlin = vth *r* log( widlin/(r*vth) )
      endif
*
      end
