******************************************************************************
      subroutine zero1
      implicit none
*zero out some variables at start of calculation
      include "ipLnArry.par"
      include "nta.par"
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "nhe3lvl.par"
      include "ndust.par"
      include "nlines.par"
      include "nwindline.par"
      include "sum.com"
      include "phycon.com"
      include "CHMax.com"
      include "dtMase.com"
      include "Testit.com"
      include "dstdft.com"
      include "DstWght.com"
      include "HCTMin.com"
      include "dustheat.com"
      include "qheat.com"
      include "tgrmax.com"
      include "dstfac.com"
      include "tedust.com"
      include "LevTrace.com"
      include "WindData.com"
      include "taumin.com"
      include "he1ind.com"
      include "he2ind.com"
      include "he1cin.com"
      include "he2cin.com"
      include "he1bn.com"
      include "he2bn.com"
      include "he3bn.com"
      include "he3n.com"
      include "he3pht.com"
      include "he2dmp.com"
      include "he1dmp.com"
      include "IOqq.com"
*
*     local variables
      character*10 chLineLbl , chLbl
      integer i , nd
*
      nWindOn = 1
      nLevTrace = 0
*     weight to give new destruction probability for lines
      DestWght = 0.25
      DestWghtSave = 0.25
      dTauMase = 0.
      lgTestIt = .false.
      lgTestOn = .false.
      CoolHeatMax = 0.
      ipCoolHeatMax = 0
      te = 1e4
*
*     this is array of line energies, only defined for some lines
      do i=1,NLINES
        xLineEnergy(i) = 0.
      end do
*
*     >>chng 97 jan 6, from 0 to 8.5e-10*q as per Alex Dalgarno e-mail
*     >>chng 97 feb 6, from 8.5e-10*q 1.92e-9x as per Alex Dalgarno e-mail
      HCTAlex = 1.92e-9
*
*     some grain variables
      do nd=1,ndust
        lgQHeat(nd) = .false.
        lgDustVary(nd) = .false.
        DustDftVel(nd) = 1.
        avdft(nd) = 0.
        tgrmax(nd) = -1.
        lgDustOn1(nd) = .false.
        dheat(nd) = 0.
        dstfactor(nd) = 1.
        tedust(nd) = 0.
      end do
      lgDustOn = .false.
*
*     lines in cooling function with Mewe approximate collision strengths
      do i=1,NWINDLINE
*       these are line optical depth arrays
*       inward optical depth
        WindLine(ipLnTauIn,i) = taumin
        WindLine(ipLnTauCon,i) = taumin
        WindLine(ipLnColovTOT,i) = 0.
*       outward optical depth
        WindLine(ipLnTauTot,i) = 1e20
*       escape probability
        WindLine(ipLnEscP,i) = 1.
*       inward part of line
        WindLine(ipLnInwd,i) = 1.
*       destruction probability
        WindLine(ipLnDesP,i) = 0.
*       line pumping rate
        WindLine(ipLnPump,i) = 0.
*       population of lower level
        WindLine(ipLnPopl,i) = 0.
*       population of upper level
        WindLine(ipLnPopu,i) = 0.
*       population of lower level with correction for stim emission
        WindLine(ipLnPopOpc,i) = 0.
*       following two heat exchange excitation, deexcitation
        WindLine(ipLnCool,i) = 0.
        WindLine(ipLnHeat,i) = 0.
*       intensity of line
        WindLine(ipLnInten,i) = 0.
*       number of photons emitted in line
        WindLine(ipLnNPhots,i) = 0.
*       opacity in line
        WindLine(ipLnDTau,i) = 0.
*begin sanity check
        if( WindLine(ipLnCS1,i).le.0. ) then
          chLbl = chLineLbl( WindLine(1,i) )
          write(qq,'('' Zero1, insane Type for WindLine line,'',a10)')
     1    chLbl
        endif
*end sanity check
      end do
*
      he3pht = 0.
      he3lya = 0.
*
      do i=1,nhe1lvl+1
        he1cin(i) = 0.
        he1bn(i) = 1.
      end do
      do i=1,nhe2lvl+1
        he2cin(i) = 0.
        he2bn(i) = 1.
      end do
      do i=1,nhe3lvl
        he3n(i) = 0.
        he3bn(i) = 1.
      end do
*
      end
